/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.blas;
import java.lang.*;
import org.netlib.util.*;



public class Daxpy {

// c
// c     constant times a vector plus a vector.
// c     uses unrolled loops for increments equal to one.
// c     jack dongarra, linpack, 3/11/78.
// c     modified 12/3/93, array(1) declarations changed to array(*)
// c
static int i= 0;
static int ix= 0;
static int iy= 0;
static int m= 0;
static int mp1= 0;
// c

public static void daxpy (int n,
double da,
double [] dx, int _dx_offset,
int incx,
double [] dy, int _dy_offset,
int incy)  {

if (n <= 0)  
    Dummy.go_to("Daxpy",999999);
if (da == 0.0e0)  
    Dummy.go_to("Daxpy",999999);
if (incx == 1 && incy == 1)  
    Dummy.go_to("Daxpy",20);
// c
// c        code for unequal increments or equal increments
// c          not equal to 1
// c
ix = 1;
iy = 1;
if (incx < 0)  
    ix = (-n+1)*incx+1;
if (incy < 0)  
    iy = (-n+1)*incy+1;
{
forloop10:
for (i = 1; i <= n; i++) {
dy[(iy)- 1+ _dy_offset] = dy[(iy)- 1+ _dy_offset]+da*dx[(ix)- 1+ _dx_offset];
ix = ix+incx;
iy = iy+incy;
Dummy.label("Daxpy",10);
}              //  Close for() loop. 
}
Dummy.go_to("Daxpy",999999);
// c
// c        code for both increments equal to 1
// c
// c
// c        clean-up loop
// c
label20:
   Dummy.label("Daxpy",20);
m = (n)%(4) ;
if (m == 0)  
    Dummy.go_to("Daxpy",40);
{
forloop30:
for (i = 1; i <= m; i++) {
dy[(i)- 1+ _dy_offset] = dy[(i)- 1+ _dy_offset]+da*dx[(i)- 1+ _dx_offset];
Dummy.label("Daxpy",30);
}              //  Close for() loop. 
}
if (n < 4)  
    Dummy.go_to("Daxpy",999999);
label40:
   Dummy.label("Daxpy",40);
mp1 = m+1;
{
int _i_inc = 4;
forloop50:
for (i = mp1; i <= n; i += _i_inc) {
dy[(i)- 1+ _dy_offset] = dy[(i)- 1+ _dy_offset]+da*dx[(i)- 1+ _dx_offset];
dy[(i+1)- 1+ _dy_offset] = dy[(i+1)- 1+ _dy_offset]+da*dx[(i+1)- 1+ _dx_offset];
dy[(i+2)- 1+ _dy_offset] = dy[(i+2)- 1+ _dy_offset]+da*dx[(i+2)- 1+ _dx_offset];
dy[(i+3)- 1+ _dy_offset] = dy[(i+3)- 1+ _dy_offset]+da*dx[(i+3)- 1+ _dx_offset];
Dummy.label("Daxpy",50);
}              //  Close for() loop. 
}
Dummy.go_to("Daxpy",999999);
Dummy.label("Daxpy",999999);
return;
   }
} // End class.
