/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.blas;
import java.lang.*;
import org.netlib.util.*;



public class Ddot {

// c
// c     forms the dot product of two vectors.
// c     uses unrolled loops for increments equal to one.
// c     jack dongarra, linpack, 3/11/78.
// c     modified 12/3/93, array(1) declarations changed to array(*)
// c
static double dtemp= 0.0;
static int i= 0;
static int ix= 0;
static int iy= 0;
static int m= 0;
static int mp1= 0;
// c
static double ddot = 0.0;


public static double ddot (int n,
double [] dx, int _dx_offset,
int incx,
double [] dy, int _dy_offset,
int incy)  {

ddot = 0.0e0;
dtemp = 0.0e0;
if (n <= 0)  
    Dummy.go_to("Ddot",999999);
if (incx == 1 && incy == 1)  
    Dummy.go_to("Ddot",20);
// c
// c        code for unequal increments or equal increments
// c          not equal to 1
// c
ix = 1;
iy = 1;
if (incx < 0)  
    ix = (-n+1)*incx+1;
if (incy < 0)  
    iy = (-n+1)*incy+1;
{
forloop10:
for (i = 1; i <= n; i++) {
dtemp = dtemp+dx[(ix)- 1+ _dx_offset]*dy[(iy)- 1+ _dy_offset];
ix = ix+incx;
iy = iy+incy;
Dummy.label("Ddot",10);
}              //  Close for() loop. 
}
ddot = dtemp;
Dummy.go_to("Ddot",999999);
// c
// c        code for both increments equal to 1
// c
// c
// c        clean-up loop
// c
label20:
   Dummy.label("Ddot",20);
m = (n)%(5) ;
if (m == 0)  
    Dummy.go_to("Ddot",40);
{
forloop30:
for (i = 1; i <= m; i++) {
dtemp = dtemp+dx[(i)- 1+ _dx_offset]*dy[(i)- 1+ _dy_offset];
Dummy.label("Ddot",30);
}              //  Close for() loop. 
}
if (n < 5)  
    Dummy.go_to("Ddot",60);
label40:
   Dummy.label("Ddot",40);
mp1 = m+1;
{
int _i_inc = 5;
forloop50:
for (i = mp1; i <= n; i += _i_inc) {
dtemp = dtemp+dx[(i)- 1+ _dx_offset]*dy[(i)- 1+ _dy_offset]+dx[(i+1)- 1+ _dx_offset]*dy[(i+1)- 1+ _dy_offset]+dx[(i+2)- 1+ _dx_offset]*dy[(i+2)- 1+ _dy_offset]+dx[(i+3)- 1+ _dx_offset]*dy[(i+3)- 1+ _dy_offset]+dx[(i+4)- 1+ _dx_offset]*dy[(i+4)- 1+ _dy_offset];
Dummy.label("Ddot",50);
}              //  Close for() loop. 
}
label60:
   Dummy.label("Ddot",60);
ddot = dtemp;
Dummy.go_to("Ddot",999999);
Dummy.label("Ddot",999999);
return ddot;
   }
} // End class.
