/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.blas;
import java.lang.*;
import org.netlib.util.*;



public class Dnrm2 {

// *     .. Scalar Arguments ..
// *     .. Array Arguments ..
// *     ..
// *
// *  DNRM2 returns the euclidean norm of a vector via the function
// *  name, so that
// *
// *     DNRM2 := sqrt( x'*x )
// *
// *
// *
// *  -- This version written on 25-October-1982.
// *     Modified on 14-October-1993 to inline the call to DLASSQ.
// *     Sven Hammarling, Nag Ltd.
// *
// *
// *     .. Parameters ..
static double one= 1.0e+0;
static double zero= 0.0e+0;
// *     .. Local Scalars ..
static int ix= 0;
static double absxi= 0.0;
static double norm= 0.0;
static double scale= 0.0;
static double ssq= 0.0;
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
static double dnrm2 = 0.0;


public static double dnrm2 (int n,
double [] x, int _x_offset,
int incx)  {

if (n < 1 || incx < 1)  {
    norm = zero;
}              // Close if()
else if (n == 1)  {
    norm = Math.abs(x[(1)- 1+ _x_offset]);
}              // Close else if()
else  {
  scale = zero;
ssq = one;
// *        The following loop is equivalent to this call to the LAPACK
// *        auxiliary routine:
// *        CALL DLASSQ( N, X, INCX, SCALE, SSQ )
// *
{
int _ix_inc = incx;
forloop10:
for (ix = 1; (_ix_inc < 0) ? ix >= 1+(n-1)*incx : ix <= 1+(n-1)*incx; ix += _ix_inc) {
if (x[(ix)- 1+ _x_offset] != zero)  {
    absxi = Math.abs(x[(ix)- 1+ _x_offset]);
if (scale < absxi)  {
    ssq = one+ssq*Math.pow((scale/absxi), 2);
scale = absxi;
}              // Close if()
else  {
  ssq = ssq+Math.pow((absxi/scale), 2);
}              //  Close else.
}              // Close if()
Dummy.label("Dnrm2",10);
}              //  Close for() loop. 
}
norm = scale*Math.sqrt(ssq);
}              //  Close else.
// *
dnrm2 = norm;
Dummy.go_to("Dnrm2",999999);
// *
// *     End of DNRM2.
// *
Dummy.label("Dnrm2",999999);
return dnrm2;
   }
} // End class.
