/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.blas;
import java.lang.*;
import org.netlib.util.*;



public class Drot {

// c
// c     applies a plane rotation.
// c     jack dongarra, linpack, 3/11/78.
// c     modified 12/3/93, array(1) declarations changed to array(*)
// c
static double dtemp= 0.0;
static int i= 0;
static int ix= 0;
static int iy= 0;
// c

public static void drot (int n,
double [] dx, int _dx_offset,
int incx,
double [] dy, int _dy_offset,
int incy,
double c,
double s)  {

if (n <= 0)  
    Dummy.go_to("Drot",999999);
if (incx == 1 && incy == 1)  
    Dummy.go_to("Drot",20);
// c
// c       code for unequal increments or equal increments not equal
// c         to 1
// c
ix = 1;
iy = 1;
if (incx < 0)  
    ix = (-n+1)*incx+1;
if (incy < 0)  
    iy = (-n+1)*incy+1;
{
forloop10:
for (i = 1; i <= n; i++) {
dtemp = c*dx[(ix)- 1+ _dx_offset]+s*dy[(iy)- 1+ _dy_offset];
dy[(iy)- 1+ _dy_offset] = c*dy[(iy)- 1+ _dy_offset]-s*dx[(ix)- 1+ _dx_offset];
dx[(ix)- 1+ _dx_offset] = dtemp;
ix = ix+incx;
iy = iy+incy;
Dummy.label("Drot",10);
}              //  Close for() loop. 
}
Dummy.go_to("Drot",999999);
// c
// c       code for both increments equal to 1
// c
label20:
   Dummy.label("Drot",20);
{
forloop30:
for (i = 1; i <= n; i++) {
dtemp = c*dx[(i)- 1+ _dx_offset]+s*dy[(i)- 1+ _dy_offset];
dy[(i)- 1+ _dy_offset] = c*dy[(i)- 1+ _dy_offset]-s*dx[(i)- 1+ _dx_offset];
dx[(i)- 1+ _dx_offset] = dtemp;
Dummy.label("Drot",30);
}              //  Close for() loop. 
}
Dummy.go_to("Drot",999999);
Dummy.label("Drot",999999);
return;
   }
} // End class.
