/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.blas;
import java.lang.*;
import org.netlib.util.*;



public class Drotg {

// c
// c     construct givens plane rotation.
// c     jack dongarra, linpack, 3/11/78.
// c
static double roe= 0.0;
static double scale= 0.0;
static double r= 0.0;
static double z= 0.0;
// c

public static void drotg (doubleW da,
doubleW db,
doubleW c,
doubleW s)  {

roe = db.val;
if (Math.abs(da.val) > Math.abs(db.val))  
    roe = da.val;
scale = Math.abs(da.val)+Math.abs(db.val);
if (scale != 0.0e0)  
    Dummy.go_to("Drotg",10);
c.val = 1.0e0;
s.val = 0.0e0;
r = 0.0e0;
z = 0.0e0;
Dummy.go_to("Drotg",20);
label10:
   Dummy.label("Drotg",10);
r = scale*Math.sqrt(Math.pow((da.val/scale), 2)+Math.pow((db.val/scale), 2));
r = Dsign.dsign(1.0e0,roe)*r;
c.val = da.val/r;
s.val = db.val/r;
z = 1.0e0;
if (Math.abs(da.val) > Math.abs(db.val))  
    z = s.val;
if (Math.abs(db.val) >= Math.abs(da.val) && c.val != 0.0e0)  
    z = 1.0e0/c.val;
label20:
   Dummy.label("Drotg",20);
da.val = r;
db.val = z;
Dummy.go_to("Drotg",999999);
Dummy.label("Drotg",999999);
return;
   }
} // End class.
