/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.blas;
import java.lang.*;
import org.netlib.util.*;



public class Dscal {

// c
// c     scales a vector by a constant.
// c     uses unrolled loops for increment equal to one.
// c     jack dongarra, linpack, 3/11/78.
// c     modified 3/93 to return if incx .le. 0.
// c     modified 12/3/93, array(1) declarations changed to array(*)
// c
static int i= 0;
static int m= 0;
static int mp1= 0;
static int nincx= 0;
// c

public static void dscal (int n,
double da,
double [] dx, int _dx_offset,
int incx)  {

if (n <= 0 || incx <= 0)  
    Dummy.go_to("Dscal",999999);
if (incx == 1)  
    Dummy.go_to("Dscal",20);
// c
// c        code for increment not equal to 1
// c
nincx = n*incx;
{
int _i_inc = incx;
forloop10:
for (i = 1; (_i_inc < 0) ? i >= nincx : i <= nincx; i += _i_inc) {
dx[(i)- 1+ _dx_offset] = da*dx[(i)- 1+ _dx_offset];
Dummy.label("Dscal",10);
}              //  Close for() loop. 
}
Dummy.go_to("Dscal",999999);
// c
// c        code for increment equal to 1
// c
// c
// c        clean-up loop
// c
label20:
   Dummy.label("Dscal",20);
m = (n)%(5) ;
if (m == 0)  
    Dummy.go_to("Dscal",40);
{
forloop30:
for (i = 1; i <= m; i++) {
dx[(i)- 1+ _dx_offset] = da*dx[(i)- 1+ _dx_offset];
Dummy.label("Dscal",30);
}              //  Close for() loop. 
}
if (n < 5)  
    Dummy.go_to("Dscal",999999);
label40:
   Dummy.label("Dscal",40);
mp1 = m+1;
{
int _i_inc = 5;
forloop50:
for (i = mp1; i <= n; i += _i_inc) {
dx[(i)- 1+ _dx_offset] = da*dx[(i)- 1+ _dx_offset];
dx[(i+1)- 1+ _dx_offset] = da*dx[(i+1)- 1+ _dx_offset];
dx[(i+2)- 1+ _dx_offset] = da*dx[(i+2)- 1+ _dx_offset];
dx[(i+3)- 1+ _dx_offset] = da*dx[(i+3)- 1+ _dx_offset];
dx[(i+4)- 1+ _dx_offset] = da*dx[(i+4)- 1+ _dx_offset];
Dummy.label("Dscal",50);
}              //  Close for() loop. 
}
Dummy.go_to("Dscal",999999);
Dummy.label("Dscal",999999);
return;
   }
} // End class.
