/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.blas;
import java.lang.*;
import org.netlib.util.*;



public class Dsymm {

// *     .. Scalar Arguments ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DSYMM  performs one of the matrix-matrix operations
// *
// *     C := alpha*A*B + beta*C,
// *
// *  or
// *
// *     C := alpha*B*A + beta*C,
// *
// *  where alpha and beta are scalars,  A is a symmetric matrix and  B and
// *  C are  m by n matrices.
// *
// *  Parameters
// *  ==========
// *
// *  SIDE   - CHARACTER*1.
// *           On entry,  SIDE  specifies whether  the  symmetric matrix  A
// *           appears on the  left or right  in the  operation as follows:
// *
// *              SIDE = 'L' or 'l'   C := alpha*A*B + beta*C,
// *
// *              SIDE = 'R' or 'r'   C := alpha*B*A + beta*C,
// *
// *           Unchanged on exit.
// *
// *  UPLO   - CHARACTER*1.
// *           On  entry,   UPLO  specifies  whether  the  upper  or  lower
// *           triangular  part  of  the  symmetric  matrix   A  is  to  be
// *           referenced as follows:
// *
// *              UPLO = 'U' or 'u'   Only the upper triangular part of the
// *                                  symmetric matrix is to be referenced.
// *
// *              UPLO = 'L' or 'l'   Only the lower triangular part of the
// *                                  symmetric matrix is to be referenced.
// *
// *           Unchanged on exit.
// *
// *  M      - INTEGER.
// *           On entry,  M  specifies the number of rows of the matrix  C.
// *           M  must be at least zero.
// *           Unchanged on exit.
// *
// *  N      - INTEGER.
// *           On entry, N specifies the number of columns of the matrix C.
// *           N  must be at least zero.
// *           Unchanged on exit.
// *
// *  ALPHA  - DOUBLE PRECISION.
// *           On entry, ALPHA specifies the scalar alpha.
// *           Unchanged on exit.
// *
// *  A      - DOUBLE PRECISION array of DIMENSION ( LDA, ka ), where ka is
// *           m  when  SIDE = 'L' or 'l'  and is  n otherwise.
// *           Before entry  with  SIDE = 'L' or 'l',  the  m by m  part of
// *           the array  A  must contain the  symmetric matrix,  such that
// *           when  UPLO = 'U' or 'u', the leading m by m upper triangular
// *           part of the array  A  must contain the upper triangular part
// *           of the  symmetric matrix and the  strictly  lower triangular
// *           part of  A  is not referenced,  and when  UPLO = 'L' or 'l',
// *           the leading  m by m  lower triangular part  of the  array  A
// *           must  contain  the  lower triangular part  of the  symmetric
// *           matrix and the  strictly upper triangular part of  A  is not
// *           referenced.
// *           Before entry  with  SIDE = 'R' or 'r',  the  n by n  part of
// *           the array  A  must contain the  symmetric matrix,  such that
// *           when  UPLO = 'U' or 'u', the leading n by n upper triangular
// *           part of the array  A  must contain the upper triangular part
// *           of the  symmetric matrix and the  strictly  lower triangular
// *           part of  A  is not referenced,  and when  UPLO = 'L' or 'l',
// *           the leading  n by n  lower triangular part  of the  array  A
// *           must  contain  the  lower triangular part  of the  symmetric
// *           matrix and the  strictly upper triangular part of  A  is not
// *           referenced.
// *           Unchanged on exit.
// *
// *  LDA    - INTEGER.
// *           On entry, LDA specifies the first dimension of A as declared
// *           in the calling (sub) program.  When  SIDE = 'L' or 'l'  then
// *           LDA must be at least  max( 1, m ), otherwise  LDA must be at
// *           least  max( 1, n ).
// *           Unchanged on exit.
// *
// *  B      - DOUBLE PRECISION array of DIMENSION ( LDB, n ).
// *           Before entry, the leading  m by n part of the array  B  must
// *           contain the matrix B.
// *           Unchanged on exit.
// *
// *  LDB    - INTEGER.
// *           On entry, LDB specifies the first dimension of B as declared
// *           in  the  calling  (sub)  program.   LDB  must  be  at  least
// *           max( 1, m ).
// *           Unchanged on exit.
// *
// *  BETA   - DOUBLE PRECISION.
// *           On entry,  BETA  specifies the scalar  beta.  When  BETA  is
// *           supplied as zero then C need not be set on input.
// *           Unchanged on exit.
// *
// *  C      - DOUBLE PRECISION array of DIMENSION ( LDC, n ).
// *           Before entry, the leading  m by n  part of the array  C must
// *           contain the matrix  C,  except when  beta  is zero, in which
// *           case C need not be set on entry.
// *           On exit, the array  C  is overwritten by the  m by n updated
// *           matrix.
// *
// *  LDC    - INTEGER.
// *           On entry, LDC specifies the first dimension of C as declared
// *           in  the  calling  (sub)  program.   LDC  must  be  at  least
// *           max( 1, m ).
// *           Unchanged on exit.
// *
// *
// *  Level 3 Blas routine.
// *
// *  -- Written on 8-February-1989.
// *     Jack Dongarra, Argonne National Laboratory.
// *     Iain Duff, AERE Harwell.
// *     Jeremy Du Croz, Numerical Algorithms Group Ltd.
// *     Sven Hammarling, Numerical Algorithms Group Ltd.
// *
// *
// *     .. External Functions ..
// *     .. External Subroutines ..
// *     .. Intrinsic Functions ..
// *     .. Local Scalars ..
static boolean upper= false;
static int i= 0;
static int info= 0;
static int j= 0;
static int k= 0;
static int nrowa= 0;
static double temp1= 0.0;
static double temp2= 0.0;
// *     .. Parameters ..
static double one= 1.0e+0;
static double zero= 0.0e+0;
// *     ..
// *     .. Executable Statements ..
// *
// *     Set NROWA as the number of rows of A.
// *

public static void dsymm (String side,
String uplo,
int m,
int n,
double alpha,
double [] a, int _a_offset,
int lda,
double [] b, int _b_offset,
int ldb,
double beta,
double [] c, int _c_offset,
int Ldc)  {

if ((side.toLowerCase().charAt(0) == "L".toLowerCase().charAt(0)))  {
    nrowa = m;
}              // Close if()
else  {
  nrowa = n;
}              //  Close else.
upper = (uplo.toLowerCase().charAt(0) == "U".toLowerCase().charAt(0));
// *
// *     Test the input parameters.
// *
info = 0;
if ((!(side.toLowerCase().charAt(0) == "L".toLowerCase().charAt(0))) && (!(side.toLowerCase().charAt(0) == "R".toLowerCase().charAt(0))))  {
    info = 1;
}              // Close if()
else if ((!upper) && (!(uplo.toLowerCase().charAt(0) == "L".toLowerCase().charAt(0))))  {
    info = 2;
}              // Close else if()
else if (m < 0)  {
    info = 3;
}              // Close else if()
else if (n < 0)  {
    info = 4;
}              // Close else if()
else if (lda < Math.max(1, nrowa) )  {
    info = 7;
}              // Close else if()
else if (ldb < Math.max(1, m) )  {
    info = 9;
}              // Close else if()
else if (Ldc < Math.max(1, m) )  {
    info = 12;
}              // Close else if()
if (info != 0)  {
    Xerbla.xerbla("DSYMM ",info);
Dummy.go_to("Dsymm",999999);
}              // Close if()
// *
// *     Quick return if possible.
// *
if ((m == 0) || (n == 0) || ((alpha == zero) && (beta == one)))  
    Dummy.go_to("Dsymm",999999);
// *
// *     And when  alpha.eq.zero.
// *
if (alpha == zero)  {
    if (beta == zero)  {
    {
forloop20:
for (j = 1; j <= n; j++) {
{
forloop10:
for (i = 1; i <= m; i++) {
c[(i)- 1+(j- 1)*Ldc+ _c_offset] = zero;
Dummy.label("Dsymm",10);
}              //  Close for() loop. 
}
Dummy.label("Dsymm",20);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  {
forloop40:
for (j = 1; j <= n; j++) {
{
forloop30:
for (i = 1; i <= m; i++) {
c[(i)- 1+(j- 1)*Ldc+ _c_offset] = beta*c[(i)- 1+(j- 1)*Ldc+ _c_offset];
Dummy.label("Dsymm",30);
}              //  Close for() loop. 
}
Dummy.label("Dsymm",40);
}              //  Close for() loop. 
}
}              //  Close else.
Dummy.go_to("Dsymm",999999);
}              // Close if()
// *
// *     Start the operations.
// *
if ((side.toLowerCase().charAt(0) == "L".toLowerCase().charAt(0)))  {
    // *
// *        Form  C := alpha*A*B + beta*C.
// *
if (upper)  {
    {
forloop70:
for (j = 1; j <= n; j++) {
{
forloop60:
for (i = 1; i <= m; i++) {
temp1 = alpha*b[(i)- 1+(j- 1)*ldb+ _b_offset];
temp2 = zero;
{
forloop50:
for (k = 1; k <= i-1; k++) {
c[(k)- 1+(j- 1)*Ldc+ _c_offset] = c[(k)- 1+(j- 1)*Ldc+ _c_offset]+temp1*a[(k)- 1+(i- 1)*lda+ _a_offset];
temp2 = temp2+b[(k)- 1+(j- 1)*ldb+ _b_offset]*a[(k)- 1+(i- 1)*lda+ _a_offset];
Dummy.label("Dsymm",50);
}              //  Close for() loop. 
}
if (beta == zero)  {
    c[(i)- 1+(j- 1)*Ldc+ _c_offset] = temp1*a[(i)- 1+(i- 1)*lda+ _a_offset]+alpha*temp2;
}              // Close if()
else  {
  c[(i)- 1+(j- 1)*Ldc+ _c_offset] = beta*c[(i)- 1+(j- 1)*Ldc+ _c_offset]+temp1*a[(i)- 1+(i- 1)*lda+ _a_offset]+alpha*temp2;
}              //  Close else.
Dummy.label("Dsymm",60);
}              //  Close for() loop. 
}
Dummy.label("Dsymm",70);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  {
forloop100:
for (j = 1; j <= n; j++) {
{
int _i_inc = -1;
forloop90:
for (i = m; i >= 1; i += _i_inc) {
temp1 = alpha*b[(i)- 1+(j- 1)*ldb+ _b_offset];
temp2 = zero;
{
forloop80:
for (k = i+1; k <= m; k++) {
c[(k)- 1+(j- 1)*Ldc+ _c_offset] = c[(k)- 1+(j- 1)*Ldc+ _c_offset]+temp1*a[(k)- 1+(i- 1)*lda+ _a_offset];
temp2 = temp2+b[(k)- 1+(j- 1)*ldb+ _b_offset]*a[(k)- 1+(i- 1)*lda+ _a_offset];
Dummy.label("Dsymm",80);
}              //  Close for() loop. 
}
if (beta == zero)  {
    c[(i)- 1+(j- 1)*Ldc+ _c_offset] = temp1*a[(i)- 1+(i- 1)*lda+ _a_offset]+alpha*temp2;
}              // Close if()
else  {
  c[(i)- 1+(j- 1)*Ldc+ _c_offset] = beta*c[(i)- 1+(j- 1)*Ldc+ _c_offset]+temp1*a[(i)- 1+(i- 1)*lda+ _a_offset]+alpha*temp2;
}              //  Close else.
Dummy.label("Dsymm",90);
}              //  Close for() loop. 
}
Dummy.label("Dsymm",100);
}              //  Close for() loop. 
}
}              //  Close else.
}              // Close if()
else  {
  // *
// *        Form  C := alpha*B*A + beta*C.
// *
{
forloop170:
for (j = 1; j <= n; j++) {
temp1 = alpha*a[(j)- 1+(j- 1)*lda+ _a_offset];
if (beta == zero)  {
    {
forloop110:
for (i = 1; i <= m; i++) {
c[(i)- 1+(j- 1)*Ldc+ _c_offset] = temp1*b[(i)- 1+(j- 1)*ldb+ _b_offset];
Dummy.label("Dsymm",110);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  {
forloop120:
for (i = 1; i <= m; i++) {
c[(i)- 1+(j- 1)*Ldc+ _c_offset] = beta*c[(i)- 1+(j- 1)*Ldc+ _c_offset]+temp1*b[(i)- 1+(j- 1)*ldb+ _b_offset];
Dummy.label("Dsymm",120);
}              //  Close for() loop. 
}
}              //  Close else.
{
forloop140:
for (k = 1; k <= j-1; k++) {
if (upper)  {
    temp1 = alpha*a[(k)- 1+(j- 1)*lda+ _a_offset];
}              // Close if()
else  {
  temp1 = alpha*a[(j)- 1+(k- 1)*lda+ _a_offset];
}              //  Close else.
{
forloop130:
for (i = 1; i <= m; i++) {
c[(i)- 1+(j- 1)*Ldc+ _c_offset] = c[(i)- 1+(j- 1)*Ldc+ _c_offset]+temp1*b[(i)- 1+(k- 1)*ldb+ _b_offset];
Dummy.label("Dsymm",130);
}              //  Close for() loop. 
}
Dummy.label("Dsymm",140);
}              //  Close for() loop. 
}
{
forloop160:
for (k = j+1; k <= n; k++) {
if (upper)  {
    temp1 = alpha*a[(j)- 1+(k- 1)*lda+ _a_offset];
}              // Close if()
else  {
  temp1 = alpha*a[(k)- 1+(j- 1)*lda+ _a_offset];
}              //  Close else.
{
forloop150:
for (i = 1; i <= m; i++) {
c[(i)- 1+(j- 1)*Ldc+ _c_offset] = c[(i)- 1+(j- 1)*Ldc+ _c_offset]+temp1*b[(i)- 1+(k- 1)*ldb+ _b_offset];
Dummy.label("Dsymm",150);
}              //  Close for() loop. 
}
Dummy.label("Dsymm",160);
}              //  Close for() loop. 
}
Dummy.label("Dsymm",170);
}              //  Close for() loop. 
}
}              //  Close else.
// *
Dummy.go_to("Dsymm",999999);
// *
// *     End of DSYMM .
// *
Dummy.label("Dsymm",999999);
return;
   }
} // End class.
