/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.blas;
import java.lang.*;
import org.netlib.util.*;



public class Dsyr2k {

// *     .. Scalar Arguments ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DSYR2K  performs one of the symmetric rank 2k operations
// *
// *     C := alpha*A*B' + alpha*B*A' + beta*C,
// *
// *  or
// *
// *     C := alpha*A'*B + alpha*B'*A + beta*C,
// *
// *  where  alpha and beta  are scalars, C is an  n by n  symmetric matrix
// *  and  A and B  are  n by k  matrices  in the  first  case  and  k by n
// *  matrices in the second case.
// *
// *  Parameters
// *  ==========
// *
// *  UPLO   - CHARACTER*1.
// *           On  entry,   UPLO  specifies  whether  the  upper  or  lower
// *           triangular  part  of the  array  C  is to be  referenced  as
// *           follows:
// *
// *              UPLO = 'U' or 'u'   Only the  upper triangular part of  C
// *                                  is to be referenced.
// *
// *              UPLO = 'L' or 'l'   Only the  lower triangular part of  C
// *                                  is to be referenced.
// *
// *           Unchanged on exit.
// *
// *  TRANS  - CHARACTER*1.
// *           On entry,  TRANS  specifies the operation to be performed as
// *           follows:
// *
// *              TRANS = 'N' or 'n'   C := alpha*A*B' + alpha*B*A' +
// *                                        beta*C.
// *
// *              TRANS = 'T' or 't'   C := alpha*A'*B + alpha*B'*A +
// *                                        beta*C.
// *
// *              TRANS = 'C' or 'c'   C := alpha*A'*B + alpha*B'*A +
// *                                        beta*C.
// *
// *           Unchanged on exit.
// *
// *  N      - INTEGER.
// *           On entry,  N specifies the order of the matrix C.  N must be
// *           at least zero.
// *           Unchanged on exit.
// *
// *  K      - INTEGER.
// *           On entry with  TRANS = 'N' or 'n',  K  specifies  the number
// *           of  columns  of the  matrices  A and B,  and on  entry  with
// *           TRANS = 'T' or 't' or 'C' or 'c',  K  specifies  the  number
// *           of rows of the matrices  A and B.  K must be at least  zero.
// *           Unchanged on exit.
// *
// *  ALPHA  - DOUBLE PRECISION.
// *           On entry, ALPHA specifies the scalar alpha.
// *           Unchanged on exit.
// *
// *  A      - DOUBLE PRECISION array of DIMENSION ( LDA, ka ), where ka is
// *           k  when  TRANS = 'N' or 'n',  and is  n  otherwise.
// *           Before entry with  TRANS = 'N' or 'n',  the  leading  n by k
// *           part of the array  A  must contain the matrix  A,  otherwise
// *           the leading  k by n  part of the array  A  must contain  the
// *           matrix A.
// *           Unchanged on exit.
// *
// *  LDA    - INTEGER.
// *           On entry, LDA specifies the first dimension of A as declared
// *           in  the  calling  (sub)  program.   When  TRANS = 'N' or 'n'
// *           then  LDA must be at least  max( 1, n ), otherwise  LDA must
// *           be at least  max( 1, k ).
// *           Unchanged on exit.
// *
// *  B      - DOUBLE PRECISION array of DIMENSION ( LDB, kb ), where kb is
// *           k  when  TRANS = 'N' or 'n',  and is  n  otherwise.
// *           Before entry with  TRANS = 'N' or 'n',  the  leading  n by k
// *           part of the array  B  must contain the matrix  B,  otherwise
// *           the leading  k by n  part of the array  B  must contain  the
// *           matrix B.
// *           Unchanged on exit.
// *
// *  LDB    - INTEGER.
// *           On entry, LDB specifies the first dimension of B as declared
// *           in  the  calling  (sub)  program.   When  TRANS = 'N' or 'n'
// *           then  LDB must be at least  max( 1, n ), otherwise  LDB must
// *           be at least  max( 1, k ).
// *           Unchanged on exit.
// *
// *  BETA   - DOUBLE PRECISION.
// *           On entry, BETA specifies the scalar beta.
// *           Unchanged on exit.
// *
// *  C      - DOUBLE PRECISION array of DIMENSION ( LDC, n ).
// *           Before entry  with  UPLO = 'U' or 'u',  the leading  n by n
// *           upper triangular part of the array C must contain the upper
// *           triangular part  of the  symmetric matrix  and the strictly
// *           lower triangular part of C is not referenced.  On exit, the
// *           upper triangular part of the array  C is overwritten by the
// *           upper triangular part of the updated matrix.
// *           Before entry  with  UPLO = 'L' or 'l',  the leading  n by n
// *           lower triangular part of the array C must contain the lower
// *           triangular part  of the  symmetric matrix  and the strictly
// *           upper triangular part of C is not referenced.  On exit, the
// *           lower triangular part of the array  C is overwritten by the
// *           lower triangular part of the updated matrix.
// *
// *  LDC    - INTEGER.
// *           On entry, LDC specifies the first dimension of C as declared
// *           in  the  calling  (sub)  program.   LDC  must  be  at  least
// *           max( 1, n ).
// *           Unchanged on exit.
// *
// *
// *  Level 3 Blas routine.
// *
// *
// *  -- Written on 8-February-1989.
// *     Jack Dongarra, Argonne National Laboratory.
// *     Iain Duff, AERE Harwell.
// *     Jeremy Du Croz, Numerical Algorithms Group Ltd.
// *     Sven Hammarling, Numerical Algorithms Group Ltd.
// *
// *
// *     .. External Functions ..
// *     .. External Subroutines ..
// *     .. Intrinsic Functions ..
// *     .. Local Scalars ..
static boolean upper= false;
static int i= 0;
static int info= 0;
static int j= 0;
static int l= 0;
static int nrowa= 0;
static double temp1= 0.0;
static double temp2= 0.0;
// *     .. Parameters ..
static double one= 1.0e+0;
static double zero= 0.0e+0;
// *     ..
// *     .. Executable Statements ..
// *
// *     Test the input parameters.
// *

public static void dsyr2k (String uplo,
String trans,
int n,
int k,
double alpha,
double [] a, int _a_offset,
int lda,
double [] b, int _b_offset,
int ldb,
double beta,
double [] c, int _c_offset,
int Ldc)  {

if ((trans.toLowerCase().charAt(0) == "N".toLowerCase().charAt(0)))  {
    nrowa = n;
}              // Close if()
else  {
  nrowa = k;
}              //  Close else.
upper = (uplo.toLowerCase().charAt(0) == "U".toLowerCase().charAt(0));
// *
info = 0;
if ((!upper) && (!(uplo.toLowerCase().charAt(0) == "L".toLowerCase().charAt(0))))  {
    info = 1;
}              // Close if()
else if ((!(trans.toLowerCase().charAt(0) == "N".toLowerCase().charAt(0))) && (!(trans.toLowerCase().charAt(0) == "T".toLowerCase().charAt(0))) && (!(trans.toLowerCase().charAt(0) == "C".toLowerCase().charAt(0))))  {
    info = 2;
}              // Close else if()
else if (n < 0)  {
    info = 3;
}              // Close else if()
else if (k < 0)  {
    info = 4;
}              // Close else if()
else if (lda < Math.max(1, nrowa) )  {
    info = 7;
}              // Close else if()
else if (ldb < Math.max(1, nrowa) )  {
    info = 9;
}              // Close else if()
else if (Ldc < Math.max(1, n) )  {
    info = 12;
}              // Close else if()
if (info != 0)  {
    Xerbla.xerbla("DSYR2K",info);
Dummy.go_to("Dsyr2k",999999);
}              // Close if()
// *
// *     Quick return if possible.
// *
if ((n == 0) || (((alpha == zero) || (k == 0)) && (beta == one)))  
    Dummy.go_to("Dsyr2k",999999);
// *
// *     And when  alpha.eq.zero.
// *
if (alpha == zero)  {
    if (upper)  {
    if (beta == zero)  {
    {
forloop20:
for (j = 1; j <= n; j++) {
{
forloop10:
for (i = 1; i <= j; i++) {
c[(i)- 1+(j- 1)*Ldc+ _c_offset] = zero;
Dummy.label("Dsyr2k",10);
}              //  Close for() loop. 
}
Dummy.label("Dsyr2k",20);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  {
forloop40:
for (j = 1; j <= n; j++) {
{
forloop30:
for (i = 1; i <= j; i++) {
c[(i)- 1+(j- 1)*Ldc+ _c_offset] = beta*c[(i)- 1+(j- 1)*Ldc+ _c_offset];
Dummy.label("Dsyr2k",30);
}              //  Close for() loop. 
}
Dummy.label("Dsyr2k",40);
}              //  Close for() loop. 
}
}              //  Close else.
}              // Close if()
else  {
  if (beta == zero)  {
    {
forloop60:
for (j = 1; j <= n; j++) {
{
forloop50:
for (i = j; i <= n; i++) {
c[(i)- 1+(j- 1)*Ldc+ _c_offset] = zero;
Dummy.label("Dsyr2k",50);
}              //  Close for() loop. 
}
Dummy.label("Dsyr2k",60);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  {
forloop80:
for (j = 1; j <= n; j++) {
{
forloop70:
for (i = j; i <= n; i++) {
c[(i)- 1+(j- 1)*Ldc+ _c_offset] = beta*c[(i)- 1+(j- 1)*Ldc+ _c_offset];
Dummy.label("Dsyr2k",70);
}              //  Close for() loop. 
}
Dummy.label("Dsyr2k",80);
}              //  Close for() loop. 
}
}              //  Close else.
}              //  Close else.
Dummy.go_to("Dsyr2k",999999);
}              // Close if()
// *
// *     Start the operations.
// *
if ((trans.toLowerCase().charAt(0) == "N".toLowerCase().charAt(0)))  {
    // *
// *        Form  C := alpha*A*B' + alpha*B*A' + C.
// *
if (upper)  {
    {
forloop130:
for (j = 1; j <= n; j++) {
if (beta == zero)  {
    {
forloop90:
for (i = 1; i <= j; i++) {
c[(i)- 1+(j- 1)*Ldc+ _c_offset] = zero;
Dummy.label("Dsyr2k",90);
}              //  Close for() loop. 
}
}              // Close if()
else if (beta != one)  {
    {
forloop100:
for (i = 1; i <= j; i++) {
c[(i)- 1+(j- 1)*Ldc+ _c_offset] = beta*c[(i)- 1+(j- 1)*Ldc+ _c_offset];
Dummy.label("Dsyr2k",100);
}              //  Close for() loop. 
}
}              // Close else if()
{
forloop120:
for (l = 1; l <= k; l++) {
if ((a[(j)- 1+(l- 1)*lda+ _a_offset] != zero) || (b[(j)- 1+(l- 1)*ldb+ _b_offset] != zero))  {
    temp1 = alpha*b[(j)- 1+(l- 1)*ldb+ _b_offset];
temp2 = alpha*a[(j)- 1+(l- 1)*lda+ _a_offset];
{
forloop110:
for (i = 1; i <= j; i++) {
c[(i)- 1+(j- 1)*Ldc+ _c_offset] = c[(i)- 1+(j- 1)*Ldc+ _c_offset]+a[(i)- 1+(l- 1)*lda+ _a_offset]*temp1+b[(i)- 1+(l- 1)*ldb+ _b_offset]*temp2;
Dummy.label("Dsyr2k",110);
}              //  Close for() loop. 
}
}              // Close if()
Dummy.label("Dsyr2k",120);
}              //  Close for() loop. 
}
Dummy.label("Dsyr2k",130);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  {
forloop180:
for (j = 1; j <= n; j++) {
if (beta == zero)  {
    {
forloop140:
for (i = j; i <= n; i++) {
c[(i)- 1+(j- 1)*Ldc+ _c_offset] = zero;
Dummy.label("Dsyr2k",140);
}              //  Close for() loop. 
}
}              // Close if()
else if (beta != one)  {
    {
forloop150:
for (i = j; i <= n; i++) {
c[(i)- 1+(j- 1)*Ldc+ _c_offset] = beta*c[(i)- 1+(j- 1)*Ldc+ _c_offset];
Dummy.label("Dsyr2k",150);
}              //  Close for() loop. 
}
}              // Close else if()
{
forloop170:
for (l = 1; l <= k; l++) {
if ((a[(j)- 1+(l- 1)*lda+ _a_offset] != zero) || (b[(j)- 1+(l- 1)*ldb+ _b_offset] != zero))  {
    temp1 = alpha*b[(j)- 1+(l- 1)*ldb+ _b_offset];
temp2 = alpha*a[(j)- 1+(l- 1)*lda+ _a_offset];
{
forloop160:
for (i = j; i <= n; i++) {
c[(i)- 1+(j- 1)*Ldc+ _c_offset] = c[(i)- 1+(j- 1)*Ldc+ _c_offset]+a[(i)- 1+(l- 1)*lda+ _a_offset]*temp1+b[(i)- 1+(l- 1)*ldb+ _b_offset]*temp2;
Dummy.label("Dsyr2k",160);
}              //  Close for() loop. 
}
}              // Close if()
Dummy.label("Dsyr2k",170);
}              //  Close for() loop. 
}
Dummy.label("Dsyr2k",180);
}              //  Close for() loop. 
}
}              //  Close else.
}              // Close if()
else  {
  // *
// *        Form  C := alpha*A'*B + alpha*B'*A + C.
// *
if (upper)  {
    {
forloop210:
for (j = 1; j <= n; j++) {
{
forloop200:
for (i = 1; i <= j; i++) {
temp1 = zero;
temp2 = zero;
{
forloop190:
for (l = 1; l <= k; l++) {
temp1 = temp1+a[(l)- 1+(i- 1)*lda+ _a_offset]*b[(l)- 1+(j- 1)*ldb+ _b_offset];
temp2 = temp2+b[(l)- 1+(i- 1)*ldb+ _b_offset]*a[(l)- 1+(j- 1)*lda+ _a_offset];
Dummy.label("Dsyr2k",190);
}              //  Close for() loop. 
}
if (beta == zero)  {
    c[(i)- 1+(j- 1)*Ldc+ _c_offset] = alpha*temp1+alpha*temp2;
}              // Close if()
else  {
  c[(i)- 1+(j- 1)*Ldc+ _c_offset] = beta*c[(i)- 1+(j- 1)*Ldc+ _c_offset]+alpha*temp1+alpha*temp2;
}              //  Close else.
Dummy.label("Dsyr2k",200);
}              //  Close for() loop. 
}
Dummy.label("Dsyr2k",210);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  {
forloop240:
for (j = 1; j <= n; j++) {
{
forloop230:
for (i = j; i <= n; i++) {
temp1 = zero;
temp2 = zero;
{
forloop220:
for (l = 1; l <= k; l++) {
temp1 = temp1+a[(l)- 1+(i- 1)*lda+ _a_offset]*b[(l)- 1+(j- 1)*ldb+ _b_offset];
temp2 = temp2+b[(l)- 1+(i- 1)*ldb+ _b_offset]*a[(l)- 1+(j- 1)*lda+ _a_offset];
Dummy.label("Dsyr2k",220);
}              //  Close for() loop. 
}
if (beta == zero)  {
    c[(i)- 1+(j- 1)*Ldc+ _c_offset] = alpha*temp1+alpha*temp2;
}              // Close if()
else  {
  c[(i)- 1+(j- 1)*Ldc+ _c_offset] = beta*c[(i)- 1+(j- 1)*Ldc+ _c_offset]+alpha*temp1+alpha*temp2;
}              //  Close else.
Dummy.label("Dsyr2k",230);
}              //  Close for() loop. 
}
Dummy.label("Dsyr2k",240);
}              //  Close for() loop. 
}
}              //  Close else.
}              //  Close else.
// *
Dummy.go_to("Dsyr2k",999999);
// *
// *     End of DSYR2K.
// *
Dummy.label("Dsyr2k",999999);
return;
   }
} // End class.
