/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.blas;
import java.lang.*;
import org.netlib.util.*;



public class Idamax {

// c
// c     finds the index of element having max. absolute value.
// c     jack dongarra, linpack, 3/11/78.
// c     modified 3/93 to return if incx .le. 0.
// c     modified 12/3/93, array(1) declarations changed to array(*)
// c
static double dmax= 0.0;
static int i= 0;
static int ix= 0;
// c
static int idamax = 0;


public static int idamax (int n,
double [] dx, int _dx_offset,
int incx)  {

idamax = 0;
if (n < 1 || incx <= 0)  
    Dummy.go_to("Idamax",999999);
idamax = 1;
if (n == 1)  
    Dummy.go_to("Idamax",999999);
if (incx == 1)  
    Dummy.go_to("Idamax",20);
// c
// c        code for increment not equal to 1
// c
ix = 1;
dmax = Math.abs(dx[(1)- 1+ _dx_offset]);
ix = ix+incx;
{
forloop10:
for (i = 2; i <= n; i++) {
if (Math.abs(dx[(ix)- 1+ _dx_offset]) <= dmax)  
    Dummy.go_to("Idamax",5);
idamax = i;
dmax = Math.abs(dx[(ix)- 1+ _dx_offset]);
label5:
   Dummy.label("Idamax",5);
ix = ix+incx;
Dummy.label("Idamax",10);
}              //  Close for() loop. 
}
Dummy.go_to("Idamax",999999);
// c
// c        code for increment equal to 1
// c
label20:
   Dummy.label("Idamax",20);
dmax = Math.abs(dx[(1)- 1+ _dx_offset]);
{
forloop30:
for (i = 2; i <= n; i++) {
if (Math.abs(dx[(i)- 1+ _dx_offset]) <= dmax)  
    continue forloop30;
idamax = i;
dmax = Math.abs(dx[(i)- 1+ _dx_offset]);
Dummy.label("Idamax",30);
}              //  Close for() loop. 
}
Dummy.go_to("Idamax",999999);
Dummy.label("Idamax",999999);
return idamax;
   }
} // End class.
