/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;

import org.netlib.blas.*;


public class Dgebrd {

// *
// *  -- LAPACK routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DGEBRD reduces a general real M-by-N matrix A to upper or lower
// *  bidiagonal form B by an orthogonal transformation: Q**T * A * P = B.
// *
// *  If m >= n, B is upper bidiagonal; if m < n, B is lower bidiagonal.
// *
// *  Arguments
// *  =========
// *
// *  M       (input) INTEGER
// *          The number of rows in the matrix A.  M >= 0.
// *
// *  N       (input) INTEGER
// *          The number of columns in the matrix A.  N >= 0.
// *
// *  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
// *          On entry, the M-by-N general matrix to be reduced.
// *          On exit,
// *          if m >= n, the diagonal and the first superdiagonal are
// *            overwritten with the upper bidiagonal matrix B; the
// *            elements below the diagonal, with the array TAUQ, represent
// *            the orthogonal matrix Q as a product of elementary
// *            reflectors, and the elements above the first superdiagonal,
// *            with the array TAUP, represent the orthogonal matrix P as
// *            a product of elementary reflectors;
// *          if m < n, the diagonal and the first subdiagonal are
// *            overwritten with the lower bidiagonal matrix B; the
// *            elements below the first subdiagonal, with the array TAUQ,
// *            represent the orthogonal matrix Q as a product of
// *            elementary reflectors, and the elements above the diagonal,
// *            with the array TAUP, represent the orthogonal matrix P as
// *            a product of elementary reflectors.
// *          See Further Details.
// *
// *  LDA     (input) INTEGER
// *          The leading dimension of the array A.  LDA >= max(1,M).
// *
// *  D       (output) DOUBLE PRECISION array, dimension (min(M,N))
// *          The diagonal elements of the bidiagonal matrix B:
// *          D(i) = A(i,i).
// *
// *  E       (output) DOUBLE PRECISION array, dimension (min(M,N)-1)
// *          The off-diagonal elements of the bidiagonal matrix B:
// *          if m >= n, E(i) = A(i,i+1) for i = 1,2,...,n-1;
// *          if m < n, E(i) = A(i+1,i) for i = 1,2,...,m-1.
// *
// *  TAUQ    (output) DOUBLE PRECISION array dimension (min(M,N))
// *          The scalar factors of the elementary reflectors which
// *          represent the orthogonal matrix Q. See Further Details.
// *
// *  TAUP    (output) DOUBLE PRECISION array, dimension (min(M,N))
// *          The scalar factors of the elementary reflectors which
// *          represent the orthogonal matrix P. See Further Details.
// *
// *  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
// *          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
// *
// *  LWORK   (input) INTEGER
// *          The length of the array WORK.  LWORK >= max(1,M,N).
// *          For optimum performance LWORK >= (M+N)*NB, where NB
// *          is the optimal blocksize.
// *
// *  INFO    (output) INTEGER
// *          = 0:  successful exit
// *          < 0:  if INFO = -i, the i-th argument had an illegal value.
// *
// *  Further Details
// *  ===============
// *
// *  The matrices Q and P are represented as products of elementary
// *  reflectors:
// *
// *  If m >= n,
// *
// *     Q = H(1) H(2) . . . H(n)  and  P = G(1) G(2) . . . G(n-1)
// *
// *  Each H(i) and G(i) has the form:
// *
// *     H(i) = I - tauq * v * v'  and G(i) = I - taup * u * u'
// *
// *  where tauq and taup are real scalars, and v and u are real vectors;
// *  v(1:i-1) = 0, v(i) = 1, and v(i+1:m) is stored on exit in A(i+1:m,i);
// *  u(1:i) = 0, u(i+1) = 1, and u(i+2:n) is stored on exit in A(i,i+2:n);
// *  tauq is stored in TAUQ(i) and taup in TAUP(i).
// *
// *  If m < n,
// *
// *     Q = H(1) H(2) . . . H(m-1)  and  P = G(1) G(2) . . . G(m)
// *
// *  Each H(i) and G(i) has the form:
// *
// *     H(i) = I - tauq * v * v'  and G(i) = I - taup * u * u'
// *
// *  where tauq and taup are real scalars, and v and u are real vectors;
// *  v(1:i) = 0, v(i+1) = 1, and v(i+2:m) is stored on exit in A(i+2:m,i);
// *  u(1:i-1) = 0, u(i) = 1, and u(i+1:n) is stored on exit in A(i,i+1:n);
// *  tauq is stored in TAUQ(i) and taup in TAUP(i).
// *
// *  The contents of A on exit are illustrated by the following examples:
// *
// *  m = 6 and n = 5 (m > n):          m = 5 and n = 6 (m < n):
// *
// *    (  d   e   u1  u1  u1 )           (  d   u1  u1  u1  u1  u1 )
// *    (  v1  d   e   u2  u2 )           (  e   d   u2  u2  u2  u2 )
// *    (  v1  v2  d   e   u3 )           (  v1  e   d   u3  u3  u3 )
// *    (  v1  v2  v3  d   e  )           (  v1  v2  e   d   u4  u4 )
// *    (  v1  v2  v3  v4  d  )           (  v1  v2  v3  e   d   u5 )
// *    (  v1  v2  v3  v4  v5 )
// *
// *  where d and e denote diagonal and off-diagonal elements of B, vi
// *  denotes an element of the vector defining H(i), and ui an element of
// *  the vector defining G(i).
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double one= 1.0e+0;
// *     ..
// *     .. Local Scalars ..
static int i= 0;
static intW iinfo= new intW(0);
static int j= 0;
static int ldwrkx= 0;
static int ldwrky= 0;
static int minmn= 0;
static int nb= 0;
static int nbmin= 0;
static int nx= 0;
static double ws= 0.0;
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Test the input parameters
// *

public static void dgebrd (int m,
int n,
double [] a, int _a_offset,
int lda,
double [] d, int _d_offset,
double [] e, int _e_offset,
double [] tauq, int _tauq_offset,
double [] taup, int _taup_offset,
double [] work, int _work_offset,
int lwork,
intW info)  {

info.val = 0;
if (m < 0)  {
    info.val = -1;
}              // Close if()
else if (n < 0)  {
    info.val = -2;
}              // Close else if()
else if (lda < Math.max(1, m) )  {
    info.val = -4;
}              // Close else if()
else if (lwork < Math.max((1) > (m) ? (1) : (m), n))  {
    info.val = -10;
}              // Close else if()
if (info.val < 0)  {
    Xerbla.xerbla("DGEBRD",-info.val);
Dummy.go_to("Dgebrd",999999);
}              // Close if()
// *
// *     Quick return if possible
// *
minmn = (int)(Math.min(m, n) );
if (minmn == 0)  {
    work[(1)- 1+ _work_offset] = (double)(1);
Dummy.go_to("Dgebrd",999999);
}              // Close if()
// *
ws = Math.max(m, n) ;
ldwrkx = m;
ldwrky = n;
// *
// *     Set the block size NB and the crossover point NX.
// *
nb = (int)(Math.max(1, Ilaenv.ilaenv(1,"DGEBRD"," ",m,n,-1,-1)) );
// *
if (nb > 1 && nb < minmn)  {
    // *
// *        Determine when to switch from blocked to unblocked code.
// *
nx = (int)(Math.max(nb, Ilaenv.ilaenv(3,"DGEBRD"," ",m,n,-1,-1)) );
if (nx < minmn)  {
    ws = (double)((m+n)*nb);
if (lwork < ws)  {
    // *
// *              Not enough work space for the optimal NB, consider using
// *              a smaller block size.
// *
nbmin = Ilaenv.ilaenv(2,"DGEBRD"," ",m,n,-1,-1);
if (lwork >= (m+n)*nbmin)  {
    nb = lwork/(m+n);
}              // Close if()
else  {
  nb = 1;
nx = minmn;
}              //  Close else.
}              // Close if()
}              // Close if()
}              // Close if()
else  {
  nx = minmn;
}              //  Close else.
// *
{
int _i_inc = nb;
forloop30:
for (i = 1; (_i_inc < 0) ? i >= minmn-nx : i <= minmn-nx; i += _i_inc) {
// *
// *        Reduce rows and columns i:i+nb-1 to bidiagonal form and return
// *        the matrices X and Y which are needed to update the unreduced
// *        part of the matrix
// *
Dlabrd.dlabrd(m-i+1,n-i+1,nb,a,(i)- 1+(i- 1)*lda+ _a_offset,lda,d,(i)- 1+ _d_offset,e,(i)- 1+ _e_offset,tauq,(i)- 1+ _tauq_offset,taup,(i)- 1+ _taup_offset,work,_work_offset,ldwrkx,work,(ldwrkx*nb+1)- 1+ _work_offset,ldwrky);
// *
// *        Update the trailing submatrix A(i+nb:m,i+nb:n), using an update
// *        of the form  A := A - V*Y' - X*U'
// *
Dgemm.dgemm("No transpose","Transpose",m-i-nb+1,n-i-nb+1,nb,-one,a,(i+nb)- 1+(i- 1)*lda+ _a_offset,lda,work,(ldwrkx*nb+nb+1)- 1+ _work_offset,ldwrky,one,a,(i+nb)- 1+(i+nb- 1)*lda+ _a_offset,lda);
Dgemm.dgemm("No transpose","No transpose",m-i-nb+1,n-i-nb+1,nb,-one,work,(nb+1)- 1+ _work_offset,ldwrkx,a,(i)- 1+(i+nb- 1)*lda+ _a_offset,lda,one,a,(i+nb)- 1+(i+nb- 1)*lda+ _a_offset,lda);
// *
// *        Copy diagonal and off-diagonal elements of B back into A
// *
if (m >= n)  {
    {
forloop10:
for (j = i; j <= i+nb-1; j++) {
a[(j)- 1+(j- 1)*lda+ _a_offset] = d[(j)- 1+ _d_offset];
a[(j)- 1+(j+1- 1)*lda+ _a_offset] = e[(j)- 1+ _e_offset];
Dummy.label("Dgebrd",10);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  {
forloop20:
for (j = i; j <= i+nb-1; j++) {
a[(j)- 1+(j- 1)*lda+ _a_offset] = d[(j)- 1+ _d_offset];
a[(j+1)- 1+(j- 1)*lda+ _a_offset] = e[(j)- 1+ _e_offset];
Dummy.label("Dgebrd",20);
}              //  Close for() loop. 
}
}              //  Close else.
Dummy.label("Dgebrd",30);
}              //  Close for() loop. 
}
// *
// *     Use unblocked code to reduce the remainder of the matrix
// *
Dgebd2.dgebd2(m-i+1,n-i+1,a,(i)- 1+(i- 1)*lda+ _a_offset,lda,d,(i)- 1+ _d_offset,e,(i)- 1+ _e_offset,tauq,(i)- 1+ _tauq_offset,taup,(i)- 1+ _taup_offset,work,_work_offset,iinfo);
work[(1)- 1+ _work_offset] = ws;
Dummy.go_to("Dgebrd",999999);
// *
// *     End of DGEBRD
// *
Dummy.label("Dgebrd",999999);
return;
   }
} // End class.
