/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;



public class Dlangt {

// *
// *  -- LAPACK auxiliary routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     February 29, 1992
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DLANGT  returns the value of the one norm,  or the Frobenius norm, or
// *  the  infinity norm,  or the  element of  largest absolute value  of a
// *  real tridiagonal matrix A.
// *
// *  Description
// *  ===========
// *
// *  DLANGT returns the value
// *
// *     DLANGT = ( max(abs(A(i,j))), NORM = 'M' or 'm'
// *              (
// *              ( norm1(A),         NORM = '1', 'O' or 'o'
// *              (
// *              ( normI(A),         NORM = 'I' or 'i'
// *              (
// *              ( normF(A),         NORM = 'F', 'f', 'E' or 'e'
// *
// *  where  norm1  denotes the  one norm of a matrix (maximum column sum),
// *  normI  denotes the  infinity norm  of a matrix  (maximum row sum) and
// *  normF  denotes the  Frobenius norm of a matrix (square root of sum of
// *  squares).  Note that  max(abs(A(i,j)))  is not a  matrix norm.
// *
// *  Arguments
// *  =========
// *
// *  NORM    (input) CHARACTER*1
// *          Specifies the value to be returned in DLANGT as described
// *          above.
// *
// *  N       (input) INTEGER
// *          The order of the matrix A.  N >= 0.  When N = 0, DLANGT is
// *          set to zero.
// *
// *  DL      (input) DOUBLE PRECISION array, dimension (N-1)
// *          The (n-1) sub-diagonal elements of A.
// *
// *  D       (input) DOUBLE PRECISION array, dimension (N)
// *          The diagonal elements of A.
// *
// *  DU      (input) DOUBLE PRECISION array, dimension (N-1)
// *          The (n-1) super-diagonal elements of A.
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double one= 1.0e+0;
static double zero= 0.0e+0;
// *     ..
// *     .. Local Scalars ..
static int i= 0;
static double anorm= 0.0;
static doubleW scale= new doubleW(0.0);
static doubleW sum= new doubleW(0.0);
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
static double dlangt = 0.0;


public static double dlangt (String norm,
int n,
double [] dl, int _dl_offset,
double [] d, int _d_offset,
double [] du, int _du_offset)  {

if (n <= 0)  {
    anorm = zero;
}              // Close if()
else if ((norm.toLowerCase().charAt(0) == "M".toLowerCase().charAt(0)))  {
    // *
// *        Find max(abs(A(i,j))).
// *
anorm = Math.abs(d[(n)- 1+ _d_offset]);
{
forloop10:
for (i = 1; i <= n-1; i++) {
anorm = Math.max(anorm, Math.abs(dl[(i)- 1+ _dl_offset])) ;
anorm = Math.max(anorm, Math.abs(d[(i)- 1+ _d_offset])) ;
anorm = Math.max(anorm, Math.abs(du[(i)- 1+ _du_offset])) ;
Dummy.label("Dlangt",10);
}              //  Close for() loop. 
}
}              // Close else if()
else if ((norm.toLowerCase().charAt(0) == "O".toLowerCase().charAt(0)) || norm.trim().equalsIgnoreCase("1".trim()))  {
    // *
// *        Find norm1(A).
// *
if (n == 1)  {
    anorm = Math.abs(d[(1)- 1+ _d_offset]);
}              // Close if()
else  {
  anorm = Math.max(Math.abs(d[(1)- 1+ _d_offset])+Math.abs(dl[(1)- 1+ _dl_offset]), Math.abs(d[(n)- 1+ _d_offset])+Math.abs(du[(n-1)- 1+ _du_offset])) ;
{
forloop20:
for (i = 2; i <= n-1; i++) {
anorm = Math.max(anorm, Math.abs(d[(i)- 1+ _d_offset])+Math.abs(dl[(i)- 1+ _dl_offset])+Math.abs(du[(i-1)- 1+ _du_offset])) ;
Dummy.label("Dlangt",20);
}              //  Close for() loop. 
}
}              //  Close else.
}              // Close else if()
else if ((norm.toLowerCase().charAt(0) == "I".toLowerCase().charAt(0)))  {
    // *
// *        Find normI(A).
// *
if (n == 1)  {
    anorm = Math.abs(d[(1)- 1+ _d_offset]);
}              // Close if()
else  {
  anorm = Math.max(Math.abs(d[(1)- 1+ _d_offset])+Math.abs(du[(1)- 1+ _du_offset]), Math.abs(d[(n)- 1+ _d_offset])+Math.abs(dl[(n-1)- 1+ _dl_offset])) ;
{
forloop30:
for (i = 2; i <= n-1; i++) {
anorm = Math.max(anorm, Math.abs(d[(i)- 1+ _d_offset])+Math.abs(du[(i)- 1+ _du_offset])+Math.abs(dl[(i-1)- 1+ _dl_offset])) ;
Dummy.label("Dlangt",30);
}              //  Close for() loop. 
}
}              //  Close else.
}              // Close else if()
else if (((norm.toLowerCase().charAt(0) == "F".toLowerCase().charAt(0))) || ((norm.toLowerCase().charAt(0) == "E".toLowerCase().charAt(0))))  {
    // *
// *        Find normF(A).
// *
scale.val = zero;
sum.val = one;
Dlassq.dlassq(n,d,_d_offset,1,scale,sum);
if (n > 1)  {
    Dlassq.dlassq(n-1,dl,_dl_offset,1,scale,sum);
Dlassq.dlassq(n-1,du,_du_offset,1,scale,sum);
}              // Close if()
anorm = scale.val*Math.sqrt(sum.val);
}              // Close else if()
// *
dlangt = anorm;
Dummy.go_to("Dlangt",999999);
// *
// *     End of DLANGT
// *
Dummy.label("Dlangt",999999);
return dlangt;
   }
} // End class.
