/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;



public class Dlansy {

// *
// *  -- LAPACK auxiliary routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     October 31, 1992
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DLANSY  returns the value of the one norm,  or the Frobenius norm, or
// *  the  infinity norm,  or the  element of  largest absolute value  of a
// *  real symmetric matrix A.
// *
// *  Description
// *  ===========
// *
// *  DLANSY returns the value
// *
// *     DLANSY = ( max(abs(A(i,j))), NORM = 'M' or 'm'
// *              (
// *              ( norm1(A),         NORM = '1', 'O' or 'o'
// *              (
// *              ( normI(A),         NORM = 'I' or 'i'
// *              (
// *              ( normF(A),         NORM = 'F', 'f', 'E' or 'e'
// *
// *  where  norm1  denotes the  one norm of a matrix (maximum column sum),
// *  normI  denotes the  infinity norm  of a matrix  (maximum row sum) and
// *  normF  denotes the  Frobenius norm of a matrix (square root of sum of
// *  squares).  Note that  max(abs(A(i,j)))  is not a  matrix norm.
// *
// *  Arguments
// *  =========
// *
// *  NORM    (input) CHARACTER*1
// *          Specifies the value to be returned in DLANSY as described
// *          above.
// *
// *  UPLO    (input) CHARACTER*1
// *          Specifies whether the upper or lower triangular part of the
// *          symmetric matrix A is to be referenced.
// *          = 'U':  Upper triangular part of A is referenced
// *          = 'L':  Lower triangular part of A is referenced
// *
// *  N       (input) INTEGER
// *          The order of the matrix A.  N >= 0.  When N = 0, DLANSY is
// *          set to zero.
// *
// *  A       (input) DOUBLE PRECISION array, dimension (LDA,N)
// *          The symmetric matrix A.  If UPLO = 'U', the leading n by n
// *          upper triangular part of A contains the upper triangular part
// *          of the matrix A, and the strictly lower triangular part of A
// *          is not referenced.  If UPLO = 'L', the leading n by n lower
// *          triangular part of A contains the lower triangular part of
// *          the matrix A, and the strictly upper triangular part of A is
// *          not referenced.
// *
// *  LDA     (input) INTEGER
// *          The leading dimension of the array A.  LDA >= max(N,1).
// *
// *  WORK    (workspace) DOUBLE PRECISION array, dimension (LWORK),
// *          where LWORK >= N when NORM = 'I' or '1' or 'O'; otherwise,
// *          WORK is not referenced.
// *
// * =====================================================================
// *
// *     .. Parameters ..
static double one= 1.0e+0;
static double zero= 0.0e+0;
// *     ..
// *     .. Local Scalars ..
static int i= 0;
static int j= 0;
static double absa= 0.0;
static doubleW scale= new doubleW(0.0);
static doubleW sum= new doubleW(0.0);
static double value= 0.0;
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
static double dlansy = 0.0;


public static double dlansy (String norm,
String uplo,
int n,
double [] a, int _a_offset,
int lda,
double [] work, int _work_offset)  {

if (n == 0)  {
    value = zero;
}              // Close if()
else if ((norm.toLowerCase().charAt(0) == "M".toLowerCase().charAt(0)))  {
    // *
// *        Find max(abs(A(i,j))).
// *
value = zero;
if ((uplo.toLowerCase().charAt(0) == "U".toLowerCase().charAt(0)))  {
    {
forloop20:
for (j = 1; j <= n; j++) {
{
forloop10:
for (i = 1; i <= j; i++) {
value = Math.max(value, Math.abs(a[(i)- 1+(j- 1)*lda+ _a_offset])) ;
Dummy.label("Dlansy",10);
}              //  Close for() loop. 
}
Dummy.label("Dlansy",20);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  {
forloop40:
for (j = 1; j <= n; j++) {
{
forloop30:
for (i = j; i <= n; i++) {
value = Math.max(value, Math.abs(a[(i)- 1+(j- 1)*lda+ _a_offset])) ;
Dummy.label("Dlansy",30);
}              //  Close for() loop. 
}
Dummy.label("Dlansy",40);
}              //  Close for() loop. 
}
}              //  Close else.
}              // Close else if()
else if (((norm.toLowerCase().charAt(0) == "I".toLowerCase().charAt(0))) || ((norm.toLowerCase().charAt(0) == "O".toLowerCase().charAt(0))) || (norm.trim().equalsIgnoreCase("1".trim())))  {
    // *
// *        Find normI(A) ( = norm1(A), since A is symmetric).
// *
value = zero;
if ((uplo.toLowerCase().charAt(0) == "U".toLowerCase().charAt(0)))  {
    {
forloop60:
for (j = 1; j <= n; j++) {
sum.val = zero;
{
forloop50:
for (i = 1; i <= j-1; i++) {
absa = Math.abs(a[(i)- 1+(j- 1)*lda+ _a_offset]);
sum.val = sum.val+absa;
work[(i)- 1+ _work_offset] = work[(i)- 1+ _work_offset]+absa;
Dummy.label("Dlansy",50);
}              //  Close for() loop. 
}
work[(j)- 1+ _work_offset] = sum.val+Math.abs(a[(j)- 1+(j- 1)*lda+ _a_offset]);
Dummy.label("Dlansy",60);
}              //  Close for() loop. 
}
{
forloop70:
for (i = 1; i <= n; i++) {
value = Math.max(value, work[(i)- 1+ _work_offset]) ;
Dummy.label("Dlansy",70);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  {
forloop80:
for (i = 1; i <= n; i++) {
work[(i)- 1+ _work_offset] = zero;
Dummy.label("Dlansy",80);
}              //  Close for() loop. 
}
{
forloop100:
for (j = 1; j <= n; j++) {
sum.val = work[(j)- 1+ _work_offset]+Math.abs(a[(j)- 1+(j- 1)*lda+ _a_offset]);
{
forloop90:
for (i = j+1; i <= n; i++) {
absa = Math.abs(a[(i)- 1+(j- 1)*lda+ _a_offset]);
sum.val = sum.val+absa;
work[(i)- 1+ _work_offset] = work[(i)- 1+ _work_offset]+absa;
Dummy.label("Dlansy",90);
}              //  Close for() loop. 
}
value = Math.max(value, sum.val) ;
Dummy.label("Dlansy",100);
}              //  Close for() loop. 
}
}              //  Close else.
}              // Close else if()
else if (((norm.toLowerCase().charAt(0) == "F".toLowerCase().charAt(0))) || ((norm.toLowerCase().charAt(0) == "E".toLowerCase().charAt(0))))  {
    // *
// *        Find normF(A).
// *
scale.val = zero;
sum.val = one;
if ((uplo.toLowerCase().charAt(0) == "U".toLowerCase().charAt(0)))  {
    {
forloop110:
for (j = 2; j <= n; j++) {
Dlassq.dlassq(j-1,a,(1)- 1+(j- 1)*lda+ _a_offset,1,scale,sum);
Dummy.label("Dlansy",110);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  {
forloop120:
for (j = 1; j <= n-1; j++) {
Dlassq.dlassq(n-j,a,(j+1)- 1+(j- 1)*lda+ _a_offset,1,scale,sum);
Dummy.label("Dlansy",120);
}              //  Close for() loop. 
}
}              //  Close else.
sum.val = 2*sum.val;
Dlassq.dlassq(n,a,_a_offset,lda+1,scale,sum);
value = scale.val*Math.sqrt(sum.val);
}              // Close else if()
// *
dlansy = value;
Dummy.go_to("Dlansy",999999);
// *
// *     End of DLANSY
// *
Dummy.label("Dlansy",999999);
return dlansy;
   }
} // End class.
