/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;



public class Dlar2v {

// *
// *  -- LAPACK auxiliary routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     February 29, 1992
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DLAR2V applies a vector of real plane rotations from both sides to
// *  a sequence of 2-by-2 real symmetric matrices, defined by the elements
// *  of the vectors x, y and z. For i = 1,2,...,n
// *
// *     ( x(i)  z(i) ) := (  c(i)  s(i) ) ( x(i)  z(i) ) ( c(i) -s(i) )
// *     ( z(i)  y(i) )    ( -s(i)  c(i) ) ( z(i)  y(i) ) ( s(i)  c(i) )
// *
// *  Arguments
// *  =========
// *
// *  N       (input) INTEGER
// *          The number of plane rotations to be applied.
// *
// *  X       (input/output) DOUBLE PRECISION array,
// *                         dimension (1+(N-1)*INCX)
// *          The vector x.
// *
// *  Y       (input/output) DOUBLE PRECISION array,
// *                         dimension (1+(N-1)*INCX)
// *          The vector y.
// *
// *  Z       (input/output) DOUBLE PRECISION array,
// *                         dimension (1+(N-1)*INCX)
// *          The vector z.
// *
// *  INCX    (input) INTEGER
// *          The increment between elements of X, Y and Z. INCX > 0.
// *
// *  C       (input) DOUBLE PRECISION array, dimension (1+(N-1)*INCC)
// *          The cosines of the plane rotations.
// *
// *  S       (input) DOUBLE PRECISION array, dimension (1+(N-1)*INCC)
// *          The sines of the plane rotations.
// *
// *  INCC    (input) INTEGER
// *          The increment between elements of C and S. INCC > 0.
// *
// *  =====================================================================
// *
// *     .. Local Scalars ..
static int i= 0;
static int ic= 0;
static int ix= 0;
static double ci= 0.0;
static double si= 0.0;
static double t1= 0.0;
static double t2= 0.0;
static double t3= 0.0;
static double t4= 0.0;
static double t5= 0.0;
static double t6= 0.0;
static double xi= 0.0;
static double yi= 0.0;
static double zi= 0.0;
// *     ..
// *     .. Executable Statements ..
// *

public static void dlar2v (int n,
double [] x, int _x_offset,
double [] y, int _y_offset,
double [] z, int _z_offset,
int incx,
double [] c, int _c_offset,
double [] s, int _s_offset,
int incc)  {

ix = 1;
ic = 1;
{
forloop10:
for (i = 1; i <= n; i++) {
xi = x[(ix)- 1+ _x_offset];
yi = y[(ix)- 1+ _y_offset];
zi = z[(ix)- 1+ _z_offset];
ci = c[(ic)- 1+ _c_offset];
si = s[(ic)- 1+ _s_offset];
t1 = si*zi;
t2 = ci*zi;
t3 = t2-si*xi;
t4 = t2+si*yi;
t5 = ci*xi+t1;
t6 = ci*yi-t1;
x[(ix)- 1+ _x_offset] = ci*t5+si*t4;
y[(ix)- 1+ _y_offset] = ci*t6-si*t3;
z[(ix)- 1+ _z_offset] = ci*t4-si*t5;
ix = ix+incx;
ic = ic+incc;
Dummy.label("Dlar2v",10);
}              //  Close for() loop. 
}
// *
// *     End of DLAR2V
// *
Dummy.go_to("Dlar2v",999999);
Dummy.label("Dlar2v",999999);
return;
   }
} // End class.
