/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;



public class Dlarnd {

// *
// *  -- LAPACK auxiliary routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DLARND returns a random real number from a uniform or normal
// *  distribution.
// *
// *  Arguments
// *  =========
// *
// *  IDIST   (input) INTEGER
// *          Specifies the distribution of the random numbers:
// *          = 1:  uniform (0,1)
// *          = 2:  uniform (-1,1)
// *          = 3:  normal (0,1)
// *
// *  ISEED   (input/output) INTEGER array, dimension (4)
// *          On entry, the seed of the random number generator; the array
// *          elements must be between 0 and 4095, and ISEED(4) must be
// *          odd.
// *          On exit, the seed is updated.
// *
// *  Further Details
// *  ===============
// *
// *  This routine calls the auxiliary routine DLARAN to generate a random
// *  real number from a uniform (0,1) distribution. The Box-Muller method
// *  is used to transform numbers from a uniform to a normal distribution.
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double one= 1.0e+0;
static double two= 2.0e+0;
static double twopi= 6.2831853071795864769252867663e+0;
// *     ..
// *     .. Local Scalars ..
static double t1= 0.0;
static double t2= 0.0;
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Generate a real random number from a uniform (0,1) distribution
// *
static double dlarnd = 0.0;


public static double dlarnd (int idist,
int [] iseed, int _iseed_offset)  {

t1 = Dlaran.dlaran(iseed,_iseed_offset);
// *
if (idist == 1)  {
    // *
// *        uniform (0,1)
// *
dlarnd = t1;
}              // Close if()
else if (idist == 2)  {
    // *
// *        uniform (-1,1)
// *
dlarnd = two*t1-one;
}              // Close else if()
else if (idist == 3)  {
    // *
// *        normal (0,1)
// *
t2 = Dlaran.dlaran(iseed,_iseed_offset);
dlarnd = Math.sqrt(-two*Math.log(t1))*Math.cos(twopi*t2);
}              // Close else if()
Dummy.go_to("Dlarnd",999999);
// *
// *     End of DLARND
// *
Dummy.label("Dlarnd",999999);
return dlarnd;
   }
} // End class.
