/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;



public class Dlaruv {

// *
// *  -- LAPACK auxiliary routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     October 31, 1992
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DLARUV returns a vector of n random real numbers from a uniform (0,1)
// *  distribution (n <= 128).
// *
// *  This is an auxiliary routine called by DLARNV and ZLARNV.
// *
// *  Arguments
// *  =========
// *
// *  ISEED   (input/output) INTEGER array, dimension (4)
// *          On entry, the seed of the random number generator; the array
// *          elements must be between 0 and 4095, and ISEED(4) must be
// *          odd.
// *          On exit, the seed is updated.
// *
// *  N       (input) INTEGER
// *          The number of random numbers to be generated. N <= 128.
// *
// *  X       (output) DOUBLE PRECISION array, dimension (N)
// *          The generated random numbers.
// *
// *  Further Details
// *  ===============
// *
// *  This routine uses a multiplicative congruential method with modulus
// *  2**48 and multiplier 33952834046453 (see G.S.Fishman,
// *  'Multiplicative congruential random number generators with modulus
// *  2**b: an exhaustive analysis for b = 32 and a partial analysis for
// *  b = 48', Math. Comp. 189, pp 331-344, 1990).
// *
// *  48-bit integers are stored in 4 integer array elements with 12 bits
// *  per element. Hence the routine is portable across machines with
// *  integers of 32 bits or more.
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double one= 1.0e0;
static int lv= 128;
static int ipw2= 4096;
static double r= one/ipw2;
// *     ..
// *     .. Local Scalars ..
static int i= 0;
static int i1= 0;
static int i2= 0;
static int i3= 0;
static int i4= 0;
static int it1= 0;
static int it2= 0;
static int it3= 0;
static int it4= 0;
// *     ..
// *     .. Local Arrays ..
static int [] mm= new int[(lv) * (4)];
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Data statements ..
static {
mm[(1)- 1+( 1 - 1)*lv] = 494;
mm[(1)- 1+( 2 - 1)*lv] = 322;
mm[(1)- 1+( 3 - 1)*lv] = 2508;
mm[(1)- 1+( 4 - 1)*lv] = 2549;
}
static {
mm[(2)- 1+( 1 - 1)*lv] = 2637;
mm[(2)- 1+( 2 - 1)*lv] = 789;
mm[(2)- 1+( 3 - 1)*lv] = 3754;
mm[(2)- 1+( 4 - 1)*lv] = 1145;
}
static {
mm[(3)- 1+( 1 - 1)*lv] = 255;
mm[(3)- 1+( 2 - 1)*lv] = 1440;
mm[(3)- 1+( 3 - 1)*lv] = 1766;
mm[(3)- 1+( 4 - 1)*lv] = 2253;
}
static {
mm[(4)- 1+( 1 - 1)*lv] = 2008;
mm[(4)- 1+( 2 - 1)*lv] = 752;
mm[(4)- 1+( 3 - 1)*lv] = 3572;
mm[(4)- 1+( 4 - 1)*lv] = 305;
}
static {
mm[(5)- 1+( 1 - 1)*lv] = 1253;
mm[(5)- 1+( 2 - 1)*lv] = 2859;
mm[(5)- 1+( 3 - 1)*lv] = 2893;
mm[(5)- 1+( 4 - 1)*lv] = 3301;
}
static {
mm[(6)- 1+( 1 - 1)*lv] = 3344;
mm[(6)- 1+( 2 - 1)*lv] = 123;
mm[(6)- 1+( 3 - 1)*lv] = 307;
mm[(6)- 1+( 4 - 1)*lv] = 1065;
}
static {
mm[(7)- 1+( 1 - 1)*lv] = 4084;
mm[(7)- 1+( 2 - 1)*lv] = 1848;
mm[(7)- 1+( 3 - 1)*lv] = 1297;
mm[(7)- 1+( 4 - 1)*lv] = 3133;
}
static {
mm[(8)- 1+( 1 - 1)*lv] = 1739;
mm[(8)- 1+( 2 - 1)*lv] = 643;
mm[(8)- 1+( 3 - 1)*lv] = 3966;
mm[(8)- 1+( 4 - 1)*lv] = 2913;
}
static {
mm[(9)- 1+( 1 - 1)*lv] = 3143;
mm[(9)- 1+( 2 - 1)*lv] = 2405;
mm[(9)- 1+( 3 - 1)*lv] = 758;
mm[(9)- 1+( 4 - 1)*lv] = 3285;
}
static {
mm[(10)- 1+( 1 - 1)*lv] = 3468;
mm[(10)- 1+( 2 - 1)*lv] = 2638;
mm[(10)- 1+( 3 - 1)*lv] = 2598;
mm[(10)- 1+( 4 - 1)*lv] = 1241;
}
static {
mm[(11)- 1+( 1 - 1)*lv] = 688;
mm[(11)- 1+( 2 - 1)*lv] = 2344;
mm[(11)- 1+( 3 - 1)*lv] = 3406;
mm[(11)- 1+( 4 - 1)*lv] = 1197;
}
static {
mm[(12)- 1+( 1 - 1)*lv] = 1657;
mm[(12)- 1+( 2 - 1)*lv] = 46;
mm[(12)- 1+( 3 - 1)*lv] = 2922;
mm[(12)- 1+( 4 - 1)*lv] = 3729;
}
static {
mm[(13)- 1+( 1 - 1)*lv] = 1238;
mm[(13)- 1+( 2 - 1)*lv] = 3814;
mm[(13)- 1+( 3 - 1)*lv] = 1038;
mm[(13)- 1+( 4 - 1)*lv] = 2501;
}
static {
mm[(14)- 1+( 1 - 1)*lv] = 3166;
mm[(14)- 1+( 2 - 1)*lv] = 913;
mm[(14)- 1+( 3 - 1)*lv] = 2934;
mm[(14)- 1+( 4 - 1)*lv] = 1673;
}
static {
mm[(15)- 1+( 1 - 1)*lv] = 1292;
mm[(15)- 1+( 2 - 1)*lv] = 3649;
mm[(15)- 1+( 3 - 1)*lv] = 2091;
mm[(15)- 1+( 4 - 1)*lv] = 541;
}
static {
mm[(16)- 1+( 1 - 1)*lv] = 3422;
mm[(16)- 1+( 2 - 1)*lv] = 339;
mm[(16)- 1+( 3 - 1)*lv] = 2451;
mm[(16)- 1+( 4 - 1)*lv] = 2753;
}
static {
mm[(17)- 1+( 1 - 1)*lv] = 1270;
mm[(17)- 1+( 2 - 1)*lv] = 3808;
mm[(17)- 1+( 3 - 1)*lv] = 1580;
mm[(17)- 1+( 4 - 1)*lv] = 949;
}
static {
mm[(18)- 1+( 1 - 1)*lv] = 2016;
mm[(18)- 1+( 2 - 1)*lv] = 822;
mm[(18)- 1+( 3 - 1)*lv] = 1958;
mm[(18)- 1+( 4 - 1)*lv] = 2361;
}
static {
mm[(19)- 1+( 1 - 1)*lv] = 154;
mm[(19)- 1+( 2 - 1)*lv] = 2832;
mm[(19)- 1+( 3 - 1)*lv] = 2055;
mm[(19)- 1+( 4 - 1)*lv] = 1165;
}
static {
mm[(20)- 1+( 1 - 1)*lv] = 2862;
mm[(20)- 1+( 2 - 1)*lv] = 3078;
mm[(20)- 1+( 3 - 1)*lv] = 1507;
mm[(20)- 1+( 4 - 1)*lv] = 4081;
}
static {
mm[(21)- 1+( 1 - 1)*lv] = 697;
mm[(21)- 1+( 2 - 1)*lv] = 3633;
mm[(21)- 1+( 3 - 1)*lv] = 1078;
mm[(21)- 1+( 4 - 1)*lv] = 2725;
}
static {
mm[(22)- 1+( 1 - 1)*lv] = 1706;
mm[(22)- 1+( 2 - 1)*lv] = 2970;
mm[(22)- 1+( 3 - 1)*lv] = 3273;
mm[(22)- 1+( 4 - 1)*lv] = 3305;
}
static {
mm[(23)- 1+( 1 - 1)*lv] = 491;
mm[(23)- 1+( 2 - 1)*lv] = 637;
mm[(23)- 1+( 3 - 1)*lv] = 17;
mm[(23)- 1+( 4 - 1)*lv] = 3069;
}
static {
mm[(24)- 1+( 1 - 1)*lv] = 931;
mm[(24)- 1+( 2 - 1)*lv] = 2249;
mm[(24)- 1+( 3 - 1)*lv] = 854;
mm[(24)- 1+( 4 - 1)*lv] = 3617;
}
static {
mm[(25)- 1+( 1 - 1)*lv] = 1444;
mm[(25)- 1+( 2 - 1)*lv] = 2081;
mm[(25)- 1+( 3 - 1)*lv] = 2916;
mm[(25)- 1+( 4 - 1)*lv] = 3733;
}
static {
mm[(26)- 1+( 1 - 1)*lv] = 444;
mm[(26)- 1+( 2 - 1)*lv] = 4019;
mm[(26)- 1+( 3 - 1)*lv] = 3971;
mm[(26)- 1+( 4 - 1)*lv] = 409;
}
static {
mm[(27)- 1+( 1 - 1)*lv] = 3577;
mm[(27)- 1+( 2 - 1)*lv] = 1478;
mm[(27)- 1+( 3 - 1)*lv] = 2889;
mm[(27)- 1+( 4 - 1)*lv] = 2157;
}
static {
mm[(28)- 1+( 1 - 1)*lv] = 3944;
mm[(28)- 1+( 2 - 1)*lv] = 242;
mm[(28)- 1+( 3 - 1)*lv] = 3831;
mm[(28)- 1+( 4 - 1)*lv] = 1361;
}
static {
mm[(29)- 1+( 1 - 1)*lv] = 2184;
mm[(29)- 1+( 2 - 1)*lv] = 481;
mm[(29)- 1+( 3 - 1)*lv] = 2621;
mm[(29)- 1+( 4 - 1)*lv] = 3973;
}
static {
mm[(30)- 1+( 1 - 1)*lv] = 1661;
mm[(30)- 1+( 2 - 1)*lv] = 2075;
mm[(30)- 1+( 3 - 1)*lv] = 1541;
mm[(30)- 1+( 4 - 1)*lv] = 1865;
}
static {
mm[(31)- 1+( 1 - 1)*lv] = 3482;
mm[(31)- 1+( 2 - 1)*lv] = 4058;
mm[(31)- 1+( 3 - 1)*lv] = 893;
mm[(31)- 1+( 4 - 1)*lv] = 2525;
}
static {
mm[(32)- 1+( 1 - 1)*lv] = 657;
mm[(32)- 1+( 2 - 1)*lv] = 622;
mm[(32)- 1+( 3 - 1)*lv] = 736;
mm[(32)- 1+( 4 - 1)*lv] = 1409;
}
static {
mm[(33)- 1+( 1 - 1)*lv] = 3023;
mm[(33)- 1+( 2 - 1)*lv] = 3376;
mm[(33)- 1+( 3 - 1)*lv] = 3992;
mm[(33)- 1+( 4 - 1)*lv] = 3445;
}
static {
mm[(34)- 1+( 1 - 1)*lv] = 3618;
mm[(34)- 1+( 2 - 1)*lv] = 812;
mm[(34)- 1+( 3 - 1)*lv] = 787;
mm[(34)- 1+( 4 - 1)*lv] = 3577;
}
static {
mm[(35)- 1+( 1 - 1)*lv] = 1267;
mm[(35)- 1+( 2 - 1)*lv] = 234;
mm[(35)- 1+( 3 - 1)*lv] = 2125;
mm[(35)- 1+( 4 - 1)*lv] = 77;
}
static {
mm[(36)- 1+( 1 - 1)*lv] = 1828;
mm[(36)- 1+( 2 - 1)*lv] = 641;
mm[(36)- 1+( 3 - 1)*lv] = 2364;
mm[(36)- 1+( 4 - 1)*lv] = 3761;
}
static {
mm[(37)- 1+( 1 - 1)*lv] = 164;
mm[(37)- 1+( 2 - 1)*lv] = 4005;
mm[(37)- 1+( 3 - 1)*lv] = 2460;
mm[(37)- 1+( 4 - 1)*lv] = 2149;
}
static {
mm[(38)- 1+( 1 - 1)*lv] = 3798;
mm[(38)- 1+( 2 - 1)*lv] = 1122;
mm[(38)- 1+( 3 - 1)*lv] = 257;
mm[(38)- 1+( 4 - 1)*lv] = 1449;
}
static {
mm[(39)- 1+( 1 - 1)*lv] = 3087;
mm[(39)- 1+( 2 - 1)*lv] = 3135;
mm[(39)- 1+( 3 - 1)*lv] = 1574;
mm[(39)- 1+( 4 - 1)*lv] = 3005;
}
static {
mm[(40)- 1+( 1 - 1)*lv] = 2400;
mm[(40)- 1+( 2 - 1)*lv] = 2640;
mm[(40)- 1+( 3 - 1)*lv] = 3912;
mm[(40)- 1+( 4 - 1)*lv] = 225;
}
static {
mm[(41)- 1+( 1 - 1)*lv] = 2870;
mm[(41)- 1+( 2 - 1)*lv] = 2302;
mm[(41)- 1+( 3 - 1)*lv] = 1216;
mm[(41)- 1+( 4 - 1)*lv] = 85;
}
static {
mm[(42)- 1+( 1 - 1)*lv] = 3876;
mm[(42)- 1+( 2 - 1)*lv] = 40;
mm[(42)- 1+( 3 - 1)*lv] = 3248;
mm[(42)- 1+( 4 - 1)*lv] = 3673;
}
static {
mm[(43)- 1+( 1 - 1)*lv] = 1905;
mm[(43)- 1+( 2 - 1)*lv] = 1832;
mm[(43)- 1+( 3 - 1)*lv] = 3401;
mm[(43)- 1+( 4 - 1)*lv] = 3117;
}
static {
mm[(44)- 1+( 1 - 1)*lv] = 1593;
mm[(44)- 1+( 2 - 1)*lv] = 2247;
mm[(44)- 1+( 3 - 1)*lv] = 2124;
mm[(44)- 1+( 4 - 1)*lv] = 3089;
}
static {
mm[(45)- 1+( 1 - 1)*lv] = 1797;
mm[(45)- 1+( 2 - 1)*lv] = 2034;
mm[(45)- 1+( 3 - 1)*lv] = 2762;
mm[(45)- 1+( 4 - 1)*lv] = 1349;
}
static {
mm[(46)- 1+( 1 - 1)*lv] = 1234;
mm[(46)- 1+( 2 - 1)*lv] = 2637;
mm[(46)- 1+( 3 - 1)*lv] = 149;
mm[(46)- 1+( 4 - 1)*lv] = 2057;
}
static {
mm[(47)- 1+( 1 - 1)*lv] = 3460;
mm[(47)- 1+( 2 - 1)*lv] = 1287;
mm[(47)- 1+( 3 - 1)*lv] = 2245;
mm[(47)- 1+( 4 - 1)*lv] = 413;
}
static {
mm[(48)- 1+( 1 - 1)*lv] = 328;
mm[(48)- 1+( 2 - 1)*lv] = 1691;
mm[(48)- 1+( 3 - 1)*lv] = 166;
mm[(48)- 1+( 4 - 1)*lv] = 65;
}
static {
mm[(49)- 1+( 1 - 1)*lv] = 2861;
mm[(49)- 1+( 2 - 1)*lv] = 496;
mm[(49)- 1+( 3 - 1)*lv] = 466;
mm[(49)- 1+( 4 - 1)*lv] = 1845;
}
static {
mm[(50)- 1+( 1 - 1)*lv] = 1950;
mm[(50)- 1+( 2 - 1)*lv] = 1597;
mm[(50)- 1+( 3 - 1)*lv] = 4018;
mm[(50)- 1+( 4 - 1)*lv] = 697;
}
static {
mm[(51)- 1+( 1 - 1)*lv] = 617;
mm[(51)- 1+( 2 - 1)*lv] = 2394;
mm[(51)- 1+( 3 - 1)*lv] = 1399;
mm[(51)- 1+( 4 - 1)*lv] = 3085;
}
static {
mm[(52)- 1+( 1 - 1)*lv] = 2070;
mm[(52)- 1+( 2 - 1)*lv] = 2584;
mm[(52)- 1+( 3 - 1)*lv] = 190;
mm[(52)- 1+( 4 - 1)*lv] = 3441;
}
static {
mm[(53)- 1+( 1 - 1)*lv] = 3331;
mm[(53)- 1+( 2 - 1)*lv] = 1843;
mm[(53)- 1+( 3 - 1)*lv] = 2879;
mm[(53)- 1+( 4 - 1)*lv] = 1573;
}
static {
mm[(54)- 1+( 1 - 1)*lv] = 769;
mm[(54)- 1+( 2 - 1)*lv] = 336;
mm[(54)- 1+( 3 - 1)*lv] = 153;
mm[(54)- 1+( 4 - 1)*lv] = 3689;
}
static {
mm[(55)- 1+( 1 - 1)*lv] = 1558;
mm[(55)- 1+( 2 - 1)*lv] = 1472;
mm[(55)- 1+( 3 - 1)*lv] = 2320;
mm[(55)- 1+( 4 - 1)*lv] = 2941;
}
static {
mm[(56)- 1+( 1 - 1)*lv] = 2412;
mm[(56)- 1+( 2 - 1)*lv] = 2407;
mm[(56)- 1+( 3 - 1)*lv] = 18;
mm[(56)- 1+( 4 - 1)*lv] = 929;
}
static {
mm[(57)- 1+( 1 - 1)*lv] = 2800;
mm[(57)- 1+( 2 - 1)*lv] = 433;
mm[(57)- 1+( 3 - 1)*lv] = 712;
mm[(57)- 1+( 4 - 1)*lv] = 533;
}
static {
mm[(58)- 1+( 1 - 1)*lv] = 189;
mm[(58)- 1+( 2 - 1)*lv] = 2096;
mm[(58)- 1+( 3 - 1)*lv] = 2159;
mm[(58)- 1+( 4 - 1)*lv] = 2841;
}
static {
mm[(59)- 1+( 1 - 1)*lv] = 287;
mm[(59)- 1+( 2 - 1)*lv] = 1761;
mm[(59)- 1+( 3 - 1)*lv] = 2318;
mm[(59)- 1+( 4 - 1)*lv] = 4077;
}
static {
mm[(60)- 1+( 1 - 1)*lv] = 2045;
mm[(60)- 1+( 2 - 1)*lv] = 2810;
mm[(60)- 1+( 3 - 1)*lv] = 2091;
mm[(60)- 1+( 4 - 1)*lv] = 721;
}
static {
mm[(61)- 1+( 1 - 1)*lv] = 1227;
mm[(61)- 1+( 2 - 1)*lv] = 566;
mm[(61)- 1+( 3 - 1)*lv] = 3443;
mm[(61)- 1+( 4 - 1)*lv] = 2821;
}
static {
mm[(62)- 1+( 1 - 1)*lv] = 2838;
mm[(62)- 1+( 2 - 1)*lv] = 442;
mm[(62)- 1+( 3 - 1)*lv] = 1510;
mm[(62)- 1+( 4 - 1)*lv] = 2249;
}
static {
mm[(63)- 1+( 1 - 1)*lv] = 209;
mm[(63)- 1+( 2 - 1)*lv] = 41;
mm[(63)- 1+( 3 - 1)*lv] = 449;
mm[(63)- 1+( 4 - 1)*lv] = 2397;
}
static {
mm[(64)- 1+( 1 - 1)*lv] = 2770;
mm[(64)- 1+( 2 - 1)*lv] = 1238;
mm[(64)- 1+( 3 - 1)*lv] = 1956;
mm[(64)- 1+( 4 - 1)*lv] = 2817;
}
static {
mm[(65)- 1+( 1 - 1)*lv] = 3654;
mm[(65)- 1+( 2 - 1)*lv] = 1086;
mm[(65)- 1+( 3 - 1)*lv] = 2201;
mm[(65)- 1+( 4 - 1)*lv] = 245;
}
static {
mm[(66)- 1+( 1 - 1)*lv] = 3993;
mm[(66)- 1+( 2 - 1)*lv] = 603;
mm[(66)- 1+( 3 - 1)*lv] = 3137;
mm[(66)- 1+( 4 - 1)*lv] = 1913;
}
static {
mm[(67)- 1+( 1 - 1)*lv] = 192;
mm[(67)- 1+( 2 - 1)*lv] = 840;
mm[(67)- 1+( 3 - 1)*lv] = 3399;
mm[(67)- 1+( 4 - 1)*lv] = 1997;
}
static {
mm[(68)- 1+( 1 - 1)*lv] = 2253;
mm[(68)- 1+( 2 - 1)*lv] = 3168;
mm[(68)- 1+( 3 - 1)*lv] = 1321;
mm[(68)- 1+( 4 - 1)*lv] = 3121;
}
static {
mm[(69)- 1+( 1 - 1)*lv] = 3491;
mm[(69)- 1+( 2 - 1)*lv] = 1499;
mm[(69)- 1+( 3 - 1)*lv] = 2271;
mm[(69)- 1+( 4 - 1)*lv] = 997;
}
static {
mm[(70)- 1+( 1 - 1)*lv] = 2889;
mm[(70)- 1+( 2 - 1)*lv] = 1084;
mm[(70)- 1+( 3 - 1)*lv] = 3667;
mm[(70)- 1+( 4 - 1)*lv] = 1833;
}
static {
mm[(71)- 1+( 1 - 1)*lv] = 2857;
mm[(71)- 1+( 2 - 1)*lv] = 3438;
mm[(71)- 1+( 3 - 1)*lv] = 2703;
mm[(71)- 1+( 4 - 1)*lv] = 2877;
}
static {
mm[(72)- 1+( 1 - 1)*lv] = 2094;
mm[(72)- 1+( 2 - 1)*lv] = 2408;
mm[(72)- 1+( 3 - 1)*lv] = 629;
mm[(72)- 1+( 4 - 1)*lv] = 1633;
}
static {
mm[(73)- 1+( 1 - 1)*lv] = 1818;
mm[(73)- 1+( 2 - 1)*lv] = 1589;
mm[(73)- 1+( 3 - 1)*lv] = 2365;
mm[(73)- 1+( 4 - 1)*lv] = 981;
}
static {
mm[(74)- 1+( 1 - 1)*lv] = 688;
mm[(74)- 1+( 2 - 1)*lv] = 2391;
mm[(74)- 1+( 3 - 1)*lv] = 2431;
mm[(74)- 1+( 4 - 1)*lv] = 2009;
}
static {
mm[(75)- 1+( 1 - 1)*lv] = 1407;
mm[(75)- 1+( 2 - 1)*lv] = 288;
mm[(75)- 1+( 3 - 1)*lv] = 1113;
mm[(75)- 1+( 4 - 1)*lv] = 941;
}
static {
mm[(76)- 1+( 1 - 1)*lv] = 634;
mm[(76)- 1+( 2 - 1)*lv] = 26;
mm[(76)- 1+( 3 - 1)*lv] = 3922;
mm[(76)- 1+( 4 - 1)*lv] = 2449;
}
static {
mm[(77)- 1+( 1 - 1)*lv] = 3231;
mm[(77)- 1+( 2 - 1)*lv] = 512;
mm[(77)- 1+( 3 - 1)*lv] = 2554;
mm[(77)- 1+( 4 - 1)*lv] = 197;
}
static {
mm[(78)- 1+( 1 - 1)*lv] = 815;
mm[(78)- 1+( 2 - 1)*lv] = 1456;
mm[(78)- 1+( 3 - 1)*lv] = 184;
mm[(78)- 1+( 4 - 1)*lv] = 2441;
}
static {
mm[(79)- 1+( 1 - 1)*lv] = 3524;
mm[(79)- 1+( 2 - 1)*lv] = 171;
mm[(79)- 1+( 3 - 1)*lv] = 2099;
mm[(79)- 1+( 4 - 1)*lv] = 285;
}
static {
mm[(80)- 1+( 1 - 1)*lv] = 1914;
mm[(80)- 1+( 2 - 1)*lv] = 1677;
mm[(80)- 1+( 3 - 1)*lv] = 3228;
mm[(80)- 1+( 4 - 1)*lv] = 1473;
}
static {
mm[(81)- 1+( 1 - 1)*lv] = 516;
mm[(81)- 1+( 2 - 1)*lv] = 2657;
mm[(81)- 1+( 3 - 1)*lv] = 4012;
mm[(81)- 1+( 4 - 1)*lv] = 2741;
}
static {
mm[(82)- 1+( 1 - 1)*lv] = 164;
mm[(82)- 1+( 2 - 1)*lv] = 2270;
mm[(82)- 1+( 3 - 1)*lv] = 1921;
mm[(82)- 1+( 4 - 1)*lv] = 3129;
}
static {
mm[(83)- 1+( 1 - 1)*lv] = 303;
mm[(83)- 1+( 2 - 1)*lv] = 2587;
mm[(83)- 1+( 3 - 1)*lv] = 3452;
mm[(83)- 1+( 4 - 1)*lv] = 909;
}
static {
mm[(84)- 1+( 1 - 1)*lv] = 2144;
mm[(84)- 1+( 2 - 1)*lv] = 2961;
mm[(84)- 1+( 3 - 1)*lv] = 3901;
mm[(84)- 1+( 4 - 1)*lv] = 2801;
}
static {
mm[(85)- 1+( 1 - 1)*lv] = 3480;
mm[(85)- 1+( 2 - 1)*lv] = 1970;
mm[(85)- 1+( 3 - 1)*lv] = 572;
mm[(85)- 1+( 4 - 1)*lv] = 421;
}
static {
mm[(86)- 1+( 1 - 1)*lv] = 119;
mm[(86)- 1+( 2 - 1)*lv] = 1817;
mm[(86)- 1+( 3 - 1)*lv] = 3309;
mm[(86)- 1+( 4 - 1)*lv] = 4073;
}
static {
mm[(87)- 1+( 1 - 1)*lv] = 3357;
mm[(87)- 1+( 2 - 1)*lv] = 676;
mm[(87)- 1+( 3 - 1)*lv] = 3171;
mm[(87)- 1+( 4 - 1)*lv] = 2813;
}
static {
mm[(88)- 1+( 1 - 1)*lv] = 837;
mm[(88)- 1+( 2 - 1)*lv] = 1410;
mm[(88)- 1+( 3 - 1)*lv] = 817;
mm[(88)- 1+( 4 - 1)*lv] = 2337;
}
static {
mm[(89)- 1+( 1 - 1)*lv] = 2826;
mm[(89)- 1+( 2 - 1)*lv] = 3723;
mm[(89)- 1+( 3 - 1)*lv] = 3039;
mm[(89)- 1+( 4 - 1)*lv] = 1429;
}
static {
mm[(90)- 1+( 1 - 1)*lv] = 2332;
mm[(90)- 1+( 2 - 1)*lv] = 2803;
mm[(90)- 1+( 3 - 1)*lv] = 1696;
mm[(90)- 1+( 4 - 1)*lv] = 1177;
}
static {
mm[(91)- 1+( 1 - 1)*lv] = 2089;
mm[(91)- 1+( 2 - 1)*lv] = 3185;
mm[(91)- 1+( 3 - 1)*lv] = 1256;
mm[(91)- 1+( 4 - 1)*lv] = 1901;
}
static {
mm[(92)- 1+( 1 - 1)*lv] = 3780;
mm[(92)- 1+( 2 - 1)*lv] = 184;
mm[(92)- 1+( 3 - 1)*lv] = 3715;
mm[(92)- 1+( 4 - 1)*lv] = 81;
}
static {
mm[(93)- 1+( 1 - 1)*lv] = 1700;
mm[(93)- 1+( 2 - 1)*lv] = 663;
mm[(93)- 1+( 3 - 1)*lv] = 2077;
mm[(93)- 1+( 4 - 1)*lv] = 1669;
}
static {
mm[(94)- 1+( 1 - 1)*lv] = 3712;
mm[(94)- 1+( 2 - 1)*lv] = 499;
mm[(94)- 1+( 3 - 1)*lv] = 3019;
mm[(94)- 1+( 4 - 1)*lv] = 2633;
}
static {
mm[(95)- 1+( 1 - 1)*lv] = 150;
mm[(95)- 1+( 2 - 1)*lv] = 3784;
mm[(95)- 1+( 3 - 1)*lv] = 1497;
mm[(95)- 1+( 4 - 1)*lv] = 2269;
}
static {
mm[(96)- 1+( 1 - 1)*lv] = 2000;
mm[(96)- 1+( 2 - 1)*lv] = 1631;
mm[(96)- 1+( 3 - 1)*lv] = 1101;
mm[(96)- 1+( 4 - 1)*lv] = 129;
}
static {
mm[(97)- 1+( 1 - 1)*lv] = 3375;
mm[(97)- 1+( 2 - 1)*lv] = 1925;
mm[(97)- 1+( 3 - 1)*lv] = 717;
mm[(97)- 1+( 4 - 1)*lv] = 1141;
}
static {
mm[(98)- 1+( 1 - 1)*lv] = 1621;
mm[(98)- 1+( 2 - 1)*lv] = 3912;
mm[(98)- 1+( 3 - 1)*lv] = 51;
mm[(98)- 1+( 4 - 1)*lv] = 249;
}
static {
mm[(99)- 1+( 1 - 1)*lv] = 3090;
mm[(99)- 1+( 2 - 1)*lv] = 1398;
mm[(99)- 1+( 3 - 1)*lv] = 981;
mm[(99)- 1+( 4 - 1)*lv] = 3917;
}
static {
mm[(100)- 1+( 1 - 1)*lv] = 3765;
mm[(100)- 1+( 2 - 1)*lv] = 1349;
mm[(100)- 1+( 3 - 1)*lv] = 1978;
mm[(100)- 1+( 4 - 1)*lv] = 2481;
}
static {
mm[(101)- 1+( 1 - 1)*lv] = 1149;
mm[(101)- 1+( 2 - 1)*lv] = 1441;
mm[(101)- 1+( 3 - 1)*lv] = 1813;
mm[(101)- 1+( 4 - 1)*lv] = 3941;
}
static {
mm[(102)- 1+( 1 - 1)*lv] = 3146;
mm[(102)- 1+( 2 - 1)*lv] = 2224;
mm[(102)- 1+( 3 - 1)*lv] = 3881;
mm[(102)- 1+( 4 - 1)*lv] = 2217;
}
static {
mm[(103)- 1+( 1 - 1)*lv] = 33;
mm[(103)- 1+( 2 - 1)*lv] = 2411;
mm[(103)- 1+( 3 - 1)*lv] = 76;
mm[(103)- 1+( 4 - 1)*lv] = 2749;
}
static {
mm[(104)- 1+( 1 - 1)*lv] = 3082;
mm[(104)- 1+( 2 - 1)*lv] = 1907;
mm[(104)- 1+( 3 - 1)*lv] = 3846;
mm[(104)- 1+( 4 - 1)*lv] = 3041;
}
static {
mm[(105)- 1+( 1 - 1)*lv] = 2741;
mm[(105)- 1+( 2 - 1)*lv] = 3192;
mm[(105)- 1+( 3 - 1)*lv] = 3694;
mm[(105)- 1+( 4 - 1)*lv] = 1877;
}
static {
mm[(106)- 1+( 1 - 1)*lv] = 359;
mm[(106)- 1+( 2 - 1)*lv] = 2786;
mm[(106)- 1+( 3 - 1)*lv] = 1682;
mm[(106)- 1+( 4 - 1)*lv] = 345;
}
static {
mm[(107)- 1+( 1 - 1)*lv] = 3316;
mm[(107)- 1+( 2 - 1)*lv] = 382;
mm[(107)- 1+( 3 - 1)*lv] = 124;
mm[(107)- 1+( 4 - 1)*lv] = 2861;
}
static {
mm[(108)- 1+( 1 - 1)*lv] = 1749;
mm[(108)- 1+( 2 - 1)*lv] = 37;
mm[(108)- 1+( 3 - 1)*lv] = 1660;
mm[(108)- 1+( 4 - 1)*lv] = 1809;
}
static {
mm[(109)- 1+( 1 - 1)*lv] = 185;
mm[(109)- 1+( 2 - 1)*lv] = 759;
mm[(109)- 1+( 3 - 1)*lv] = 3997;
mm[(109)- 1+( 4 - 1)*lv] = 3141;
}
static {
mm[(110)- 1+( 1 - 1)*lv] = 2784;
mm[(110)- 1+( 2 - 1)*lv] = 2948;
mm[(110)- 1+( 3 - 1)*lv] = 479;
mm[(110)- 1+( 4 - 1)*lv] = 2825;
}
static {
mm[(111)- 1+( 1 - 1)*lv] = 2202;
mm[(111)- 1+( 2 - 1)*lv] = 1862;
mm[(111)- 1+( 3 - 1)*lv] = 1141;
mm[(111)- 1+( 4 - 1)*lv] = 157;
}
static {
mm[(112)- 1+( 1 - 1)*lv] = 2199;
mm[(112)- 1+( 2 - 1)*lv] = 3802;
mm[(112)- 1+( 3 - 1)*lv] = 886;
mm[(112)- 1+( 4 - 1)*lv] = 2881;
}
static {
mm[(113)- 1+( 1 - 1)*lv] = 1364;
mm[(113)- 1+( 2 - 1)*lv] = 2423;
mm[(113)- 1+( 3 - 1)*lv] = 3514;
mm[(113)- 1+( 4 - 1)*lv] = 3637;
}
static {
mm[(114)- 1+( 1 - 1)*lv] = 1244;
mm[(114)- 1+( 2 - 1)*lv] = 2051;
mm[(114)- 1+( 3 - 1)*lv] = 1301;
mm[(114)- 1+( 4 - 1)*lv] = 1465;
}
static {
mm[(115)- 1+( 1 - 1)*lv] = 2020;
mm[(115)- 1+( 2 - 1)*lv] = 2295;
mm[(115)- 1+( 3 - 1)*lv] = 3604;
mm[(115)- 1+( 4 - 1)*lv] = 2829;
}
static {
mm[(116)- 1+( 1 - 1)*lv] = 3160;
mm[(116)- 1+( 2 - 1)*lv] = 1332;
mm[(116)- 1+( 3 - 1)*lv] = 1888;
mm[(116)- 1+( 4 - 1)*lv] = 2161;
}
static {
mm[(117)- 1+( 1 - 1)*lv] = 2785;
mm[(117)- 1+( 2 - 1)*lv] = 1832;
mm[(117)- 1+( 3 - 1)*lv] = 1836;
mm[(117)- 1+( 4 - 1)*lv] = 3365;
}
static {
mm[(118)- 1+( 1 - 1)*lv] = 2772;
mm[(118)- 1+( 2 - 1)*lv] = 2405;
mm[(118)- 1+( 3 - 1)*lv] = 1990;
mm[(118)- 1+( 4 - 1)*lv] = 361;
}
static {
mm[(119)- 1+( 1 - 1)*lv] = 1217;
mm[(119)- 1+( 2 - 1)*lv] = 3638;
mm[(119)- 1+( 3 - 1)*lv] = 2058;
mm[(119)- 1+( 4 - 1)*lv] = 2685;
}
static {
mm[(120)- 1+( 1 - 1)*lv] = 1822;
mm[(120)- 1+( 2 - 1)*lv] = 3661;
mm[(120)- 1+( 3 - 1)*lv] = 692;
mm[(120)- 1+( 4 - 1)*lv] = 3745;
}
static {
mm[(121)- 1+( 1 - 1)*lv] = 1245;
mm[(121)- 1+( 2 - 1)*lv] = 327;
mm[(121)- 1+( 3 - 1)*lv] = 1194;
mm[(121)- 1+( 4 - 1)*lv] = 2325;
}
static {
mm[(122)- 1+( 1 - 1)*lv] = 2252;
mm[(122)- 1+( 2 - 1)*lv] = 3660;
mm[(122)- 1+( 3 - 1)*lv] = 20;
mm[(122)- 1+( 4 - 1)*lv] = 3609;
}
static {
mm[(123)- 1+( 1 - 1)*lv] = 3904;
mm[(123)- 1+( 2 - 1)*lv] = 716;
mm[(123)- 1+( 3 - 1)*lv] = 3285;
mm[(123)- 1+( 4 - 1)*lv] = 3821;
}
static {
mm[(124)- 1+( 1 - 1)*lv] = 2774;
mm[(124)- 1+( 2 - 1)*lv] = 1842;
mm[(124)- 1+( 3 - 1)*lv] = 2046;
mm[(124)- 1+( 4 - 1)*lv] = 3537;
}
static {
mm[(125)- 1+( 1 - 1)*lv] = 997;
mm[(125)- 1+( 2 - 1)*lv] = 3987;
mm[(125)- 1+( 3 - 1)*lv] = 2107;
mm[(125)- 1+( 4 - 1)*lv] = 517;
}
static {
mm[(126)- 1+( 1 - 1)*lv] = 2573;
mm[(126)- 1+( 2 - 1)*lv] = 1368;
mm[(126)- 1+( 3 - 1)*lv] = 3508;
mm[(126)- 1+( 4 - 1)*lv] = 3017;
}
static {
mm[(127)- 1+( 1 - 1)*lv] = 1148;
mm[(127)- 1+( 2 - 1)*lv] = 1848;
mm[(127)- 1+( 3 - 1)*lv] = 3525;
mm[(127)- 1+( 4 - 1)*lv] = 2141;
}
static {
mm[(128)- 1+( 1 - 1)*lv] = 545;
mm[(128)- 1+( 2 - 1)*lv] = 2366;
mm[(128)- 1+( 3 - 1)*lv] = 3801;
mm[(128)- 1+( 4 - 1)*lv] = 1537;
}
// *     ..
// *     .. Executable Statements ..
// *

public static void dlaruv (int [] iseed, int _iseed_offset,
int n,
double [] x, int _x_offset)  {

i1 = iseed[(1)- 1+ _iseed_offset];
i2 = iseed[(2)- 1+ _iseed_offset];
i3 = iseed[(3)- 1+ _iseed_offset];
i4 = iseed[(4)- 1+ _iseed_offset];
// *
{
forloop10:
for (i = 1; i <= Math.min(n, lv) ; i++) {
// *
// *        Multiply the seed by i-th power of the multiplier modulo 2**48
// *
it4 = i4*mm[(i)- 1+(4- 1)*lv];
it3 = it4/ipw2;
it4 = it4-ipw2*it3;
it3 = it3+i3*mm[(i)- 1+(4- 1)*lv]+i4*mm[(i)- 1+(3- 1)*lv];
it2 = it3/ipw2;
it3 = it3-ipw2*it2;
it2 = it2+i2*mm[(i)- 1+(4- 1)*lv]+i3*mm[(i)- 1+(3- 1)*lv]+i4*mm[(i)- 1+(2- 1)*lv];
it1 = it2/ipw2;
it2 = it2-ipw2*it1;
it1 = it1+i1*mm[(i)- 1+(4- 1)*lv]+i2*mm[(i)- 1+(3- 1)*lv]+i3*mm[(i)- 1+(2- 1)*lv]+i4*mm[(i)- 1+(1- 1)*lv];
it1 = (it1)%(ipw2) ;
// *
// *        Convert 48-bit integer to a real number in the interval (0,1)
// *
x[(i)- 1+ _x_offset] = r*((double)(it1)+r*((double)(it2)+r*((double)(it3)+r*(double)(it4))));
Dummy.label("Dlaruv",10);
}              //  Close for() loop. 
}
// *
// *     Return final value of seed
// *
iseed[(1)- 1+ _iseed_offset] = it1;
iseed[(2)- 1+ _iseed_offset] = it2;
iseed[(3)- 1+ _iseed_offset] = it3;
iseed[(4)- 1+ _iseed_offset] = it4;
Dummy.go_to("Dlaruv",999999);
// *
// *     End of DLARUV
// *
Dummy.label("Dlaruv",999999);
return;
   }
} // End class.
