/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;



public class Dlasr {

// *
// *  -- LAPACK auxiliary routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     October 31, 1992
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DLASR   performs the transformation
// *
// *     A := P*A,   when SIDE = 'L' or 'l'  (  Left-hand side )
// *
// *     A := A*P',  when SIDE = 'R' or 'r'  ( Right-hand side )
// *
// *  where A is an m by n real matrix and P is an orthogonal matrix,
// *  consisting of a sequence of plane rotations determined by the
// *  parameters PIVOT and DIRECT as follows ( z = m when SIDE = 'L' or 'l'
// *  and z = n when SIDE = 'R' or 'r' ):
// *
// *  When  DIRECT = 'F' or 'f'  ( Forward sequence ) then
// *
// *     P = P( z - 1 )*...*P( 2 )*P( 1 ),
// *
// *  and when DIRECT = 'B' or 'b'  ( Backward sequence ) then
// *
// *     P = P( 1 )*P( 2 )*...*P( z - 1 ),
// *
// *  where  P( k ) is a plane rotation matrix for the following planes:
// *
// *     when  PIVOT = 'V' or 'v'  ( Variable pivot ),
// *        the plane ( k, k + 1 )
// *
// *     when  PIVOT = 'T' or 't'  ( Top pivot ),
// *        the plane ( 1, k + 1 )
// *
// *     when  PIVOT = 'B' or 'b'  ( Bottom pivot ),
// *        the plane ( k, z )
// *
// *  c( k ) and s( k )  must contain the  cosine and sine that define the
// *  matrix  P( k ).  The two by two plane rotation part of the matrix
// *  P( k ), R( k ), is assumed to be of the form
// *
// *     R( k ) = (  c( k )  s( k ) ).
// *              ( -s( k )  c( k ) )
// *
// *  This version vectorises across rows of the array A when SIDE = 'L'.
// *
// *  Arguments
// *  =========
// *
// *  SIDE    (input) CHARACTER*1
// *          Specifies whether the plane rotation matrix P is applied to
// *          A on the left or the right.
// *          = 'L':  Left, compute A := P*A
// *          = 'R':  Right, compute A:= A*P'
// *
// *  DIRECT  (input) CHARACTER*1
// *          Specifies whether P is a forward or backward sequence of
// *          plane rotations.
// *          = 'F':  Forward, P = P( z - 1 )*...*P( 2 )*P( 1 )
// *          = 'B':  Backward, P = P( 1 )*P( 2 )*...*P( z - 1 )
// *
// *  PIVOT   (input) CHARACTER*1
// *          Specifies the plane for which P(k) is a plane rotation
// *          matrix.
// *          = 'V':  Variable pivot, the plane (k,k+1)
// *          = 'T':  Top pivot, the plane (1,k+1)
// *          = 'B':  Bottom pivot, the plane (k,z)
// *
// *  M       (input) INTEGER
// *          The number of rows of the matrix A.  If m <= 1, an immediate
// *          return is effected.
// *
// *  N       (input) INTEGER
// *          The number of columns of the matrix A.  If n <= 1, an
// *          immediate return is effected.
// *
// *  C, S    (input) DOUBLE PRECISION arrays, dimension
// *                  (M-1) if SIDE = 'L'
// *                  (N-1) if SIDE = 'R'
// *          c(k) and s(k) contain the cosine and sine that define the
// *          matrix P(k).  The two by two plane rotation part of the
// *          matrix P(k), R(k), is assumed to be of the form
// *          R( k ) = (  c( k )  s( k ) ).
// *                   ( -s( k )  c( k ) )
// *
// *  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
// *          The m by n matrix A.  On exit, A is overwritten by P*A if
// *          SIDE = 'R' or by A*P' if SIDE = 'L'.
// *
// *  LDA     (input) INTEGER
// *          The leading dimension of the array A.  LDA >= max(1,M).
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double one= 1.0e+0;
static double zero= 0.0e+0;
// *     ..
// *     .. Local Scalars ..
static int i= 0;
static int info= 0;
static int j= 0;
static double ctemp= 0.0;
static double stemp= 0.0;
static double temp= 0.0;
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Test the input parameters
// *

public static void dlasr (String side,
String pivot,
String direct,
int m,
int n,
double [] c, int _c_offset,
double [] s, int _s_offset,
double [] a, int _a_offset,
int lda)  {

info = 0;
if (!((side.toLowerCase().charAt(0) == "L".toLowerCase().charAt(0)) || (side.toLowerCase().charAt(0) == "R".toLowerCase().charAt(0))))  {
    info = 1;
}              // Close if()
else if (!((pivot.toLowerCase().charAt(0) == "V".toLowerCase().charAt(0)) || (pivot.toLowerCase().charAt(0) == "T".toLowerCase().charAt(0)) || (pivot.toLowerCase().charAt(0) == "B".toLowerCase().charAt(0))))  {
    info = 2;
}              // Close else if()
else if (!((direct.toLowerCase().charAt(0) == "F".toLowerCase().charAt(0)) || (direct.toLowerCase().charAt(0) == "B".toLowerCase().charAt(0))))  {
    info = 3;
}              // Close else if()
else if (m < 0)  {
    info = 4;
}              // Close else if()
else if (n < 0)  {
    info = 5;
}              // Close else if()
else if (lda < Math.max(1, m) )  {
    info = 9;
}              // Close else if()
if (info != 0)  {
    Xerbla.xerbla("DLASR ",info);
Dummy.go_to("Dlasr",999999);
}              // Close if()
// *
// *     Quick return if possible
// *
if ((m == 0) || (n == 0))  
    Dummy.go_to("Dlasr",999999);
if ((side.toLowerCase().charAt(0) == "L".toLowerCase().charAt(0)))  {
    // *
// *        Form  P * A
// *
if ((pivot.toLowerCase().charAt(0) == "V".toLowerCase().charAt(0)))  {
    if ((direct.toLowerCase().charAt(0) == "F".toLowerCase().charAt(0)))  {
    {
forloop20:
for (j = 1; j <= m-1; j++) {
ctemp = c[(j)- 1+ _c_offset];
stemp = s[(j)- 1+ _s_offset];
if ((ctemp != one) || (stemp != zero))  {
    {
forloop10:
for (i = 1; i <= n; i++) {
temp = a[(j+1)- 1+(i- 1)*lda+ _a_offset];
a[(j+1)- 1+(i- 1)*lda+ _a_offset] = ctemp*temp-stemp*a[(j)- 1+(i- 1)*lda+ _a_offset];
a[(j)- 1+(i- 1)*lda+ _a_offset] = stemp*temp+ctemp*a[(j)- 1+(i- 1)*lda+ _a_offset];
Dummy.label("Dlasr",10);
}              //  Close for() loop. 
}
}              // Close if()
Dummy.label("Dlasr",20);
}              //  Close for() loop. 
}
}              // Close if()
else if ((direct.toLowerCase().charAt(0) == "B".toLowerCase().charAt(0)))  {
    {
int _j_inc = -1;
forloop40:
for (j = m-1; j >= 1; j += _j_inc) {
ctemp = c[(j)- 1+ _c_offset];
stemp = s[(j)- 1+ _s_offset];
if ((ctemp != one) || (stemp != zero))  {
    {
forloop30:
for (i = 1; i <= n; i++) {
temp = a[(j+1)- 1+(i- 1)*lda+ _a_offset];
a[(j+1)- 1+(i- 1)*lda+ _a_offset] = ctemp*temp-stemp*a[(j)- 1+(i- 1)*lda+ _a_offset];
a[(j)- 1+(i- 1)*lda+ _a_offset] = stemp*temp+ctemp*a[(j)- 1+(i- 1)*lda+ _a_offset];
Dummy.label("Dlasr",30);
}              //  Close for() loop. 
}
}              // Close if()
Dummy.label("Dlasr",40);
}              //  Close for() loop. 
}
}              // Close else if()
}              // Close if()
else if ((pivot.toLowerCase().charAt(0) == "T".toLowerCase().charAt(0)))  {
    if ((direct.toLowerCase().charAt(0) == "F".toLowerCase().charAt(0)))  {
    {
forloop60:
for (j = 2; j <= m; j++) {
ctemp = c[(j-1)- 1+ _c_offset];
stemp = s[(j-1)- 1+ _s_offset];
if ((ctemp != one) || (stemp != zero))  {
    {
forloop50:
for (i = 1; i <= n; i++) {
temp = a[(j)- 1+(i- 1)*lda+ _a_offset];
a[(j)- 1+(i- 1)*lda+ _a_offset] = ctemp*temp-stemp*a[(1)- 1+(i- 1)*lda+ _a_offset];
a[(1)- 1+(i- 1)*lda+ _a_offset] = stemp*temp+ctemp*a[(1)- 1+(i- 1)*lda+ _a_offset];
Dummy.label("Dlasr",50);
}              //  Close for() loop. 
}
}              // Close if()
Dummy.label("Dlasr",60);
}              //  Close for() loop. 
}
}              // Close if()
else if ((direct.toLowerCase().charAt(0) == "B".toLowerCase().charAt(0)))  {
    {
int _j_inc = -1;
forloop80:
for (j = m; j >= 2; j += _j_inc) {
ctemp = c[(j-1)- 1+ _c_offset];
stemp = s[(j-1)- 1+ _s_offset];
if ((ctemp != one) || (stemp != zero))  {
    {
forloop70:
for (i = 1; i <= n; i++) {
temp = a[(j)- 1+(i- 1)*lda+ _a_offset];
a[(j)- 1+(i- 1)*lda+ _a_offset] = ctemp*temp-stemp*a[(1)- 1+(i- 1)*lda+ _a_offset];
a[(1)- 1+(i- 1)*lda+ _a_offset] = stemp*temp+ctemp*a[(1)- 1+(i- 1)*lda+ _a_offset];
Dummy.label("Dlasr",70);
}              //  Close for() loop. 
}
}              // Close if()
Dummy.label("Dlasr",80);
}              //  Close for() loop. 
}
}              // Close else if()
}              // Close else if()
else if ((pivot.toLowerCase().charAt(0) == "B".toLowerCase().charAt(0)))  {
    if ((direct.toLowerCase().charAt(0) == "F".toLowerCase().charAt(0)))  {
    {
forloop100:
for (j = 1; j <= m-1; j++) {
ctemp = c[(j)- 1+ _c_offset];
stemp = s[(j)- 1+ _s_offset];
if ((ctemp != one) || (stemp != zero))  {
    {
forloop90:
for (i = 1; i <= n; i++) {
temp = a[(j)- 1+(i- 1)*lda+ _a_offset];
a[(j)- 1+(i- 1)*lda+ _a_offset] = stemp*a[(m)- 1+(i- 1)*lda+ _a_offset]+ctemp*temp;
a[(m)- 1+(i- 1)*lda+ _a_offset] = ctemp*a[(m)- 1+(i- 1)*lda+ _a_offset]-stemp*temp;
Dummy.label("Dlasr",90);
}              //  Close for() loop. 
}
}              // Close if()
Dummy.label("Dlasr",100);
}              //  Close for() loop. 
}
}              // Close if()
else if ((direct.toLowerCase().charAt(0) == "B".toLowerCase().charAt(0)))  {
    {
int _j_inc = -1;
forloop120:
for (j = m-1; j >= 1; j += _j_inc) {
ctemp = c[(j)- 1+ _c_offset];
stemp = s[(j)- 1+ _s_offset];
if ((ctemp != one) || (stemp != zero))  {
    {
forloop110:
for (i = 1; i <= n; i++) {
temp = a[(j)- 1+(i- 1)*lda+ _a_offset];
a[(j)- 1+(i- 1)*lda+ _a_offset] = stemp*a[(m)- 1+(i- 1)*lda+ _a_offset]+ctemp*temp;
a[(m)- 1+(i- 1)*lda+ _a_offset] = ctemp*a[(m)- 1+(i- 1)*lda+ _a_offset]-stemp*temp;
Dummy.label("Dlasr",110);
}              //  Close for() loop. 
}
}              // Close if()
Dummy.label("Dlasr",120);
}              //  Close for() loop. 
}
}              // Close else if()
}              // Close else if()
}              // Close if()
else if ((side.toLowerCase().charAt(0) == "R".toLowerCase().charAt(0)))  {
    // *
// *        Form A * P'
// *
if ((pivot.toLowerCase().charAt(0) == "V".toLowerCase().charAt(0)))  {
    if ((direct.toLowerCase().charAt(0) == "F".toLowerCase().charAt(0)))  {
    {
forloop140:
for (j = 1; j <= n-1; j++) {
ctemp = c[(j)- 1+ _c_offset];
stemp = s[(j)- 1+ _s_offset];
if ((ctemp != one) || (stemp != zero))  {
    {
forloop130:
for (i = 1; i <= m; i++) {
temp = a[(i)- 1+(j+1- 1)*lda+ _a_offset];
a[(i)- 1+(j+1- 1)*lda+ _a_offset] = ctemp*temp-stemp*a[(i)- 1+(j- 1)*lda+ _a_offset];
a[(i)- 1+(j- 1)*lda+ _a_offset] = stemp*temp+ctemp*a[(i)- 1+(j- 1)*lda+ _a_offset];
Dummy.label("Dlasr",130);
}              //  Close for() loop. 
}
}              // Close if()
Dummy.label("Dlasr",140);
}              //  Close for() loop. 
}
}              // Close if()
else if ((direct.toLowerCase().charAt(0) == "B".toLowerCase().charAt(0)))  {
    {
int _j_inc = -1;
forloop160:
for (j = n-1; j >= 1; j += _j_inc) {
ctemp = c[(j)- 1+ _c_offset];
stemp = s[(j)- 1+ _s_offset];
if ((ctemp != one) || (stemp != zero))  {
    {
forloop150:
for (i = 1; i <= m; i++) {
temp = a[(i)- 1+(j+1- 1)*lda+ _a_offset];
a[(i)- 1+(j+1- 1)*lda+ _a_offset] = ctemp*temp-stemp*a[(i)- 1+(j- 1)*lda+ _a_offset];
a[(i)- 1+(j- 1)*lda+ _a_offset] = stemp*temp+ctemp*a[(i)- 1+(j- 1)*lda+ _a_offset];
Dummy.label("Dlasr",150);
}              //  Close for() loop. 
}
}              // Close if()
Dummy.label("Dlasr",160);
}              //  Close for() loop. 
}
}              // Close else if()
}              // Close if()
else if ((pivot.toLowerCase().charAt(0) == "T".toLowerCase().charAt(0)))  {
    if ((direct.toLowerCase().charAt(0) == "F".toLowerCase().charAt(0)))  {
    {
forloop180:
for (j = 2; j <= n; j++) {
ctemp = c[(j-1)- 1+ _c_offset];
stemp = s[(j-1)- 1+ _s_offset];
if ((ctemp != one) || (stemp != zero))  {
    {
forloop170:
for (i = 1; i <= m; i++) {
temp = a[(i)- 1+(j- 1)*lda+ _a_offset];
a[(i)- 1+(j- 1)*lda+ _a_offset] = ctemp*temp-stemp*a[(i)- 1+(1- 1)*lda+ _a_offset];
a[(i)- 1+(1- 1)*lda+ _a_offset] = stemp*temp+ctemp*a[(i)- 1+(1- 1)*lda+ _a_offset];
Dummy.label("Dlasr",170);
}              //  Close for() loop. 
}
}              // Close if()
Dummy.label("Dlasr",180);
}              //  Close for() loop. 
}
}              // Close if()
else if ((direct.toLowerCase().charAt(0) == "B".toLowerCase().charAt(0)))  {
    {
int _j_inc = -1;
forloop200:
for (j = n; j >= 2; j += _j_inc) {
ctemp = c[(j-1)- 1+ _c_offset];
stemp = s[(j-1)- 1+ _s_offset];
if ((ctemp != one) || (stemp != zero))  {
    {
forloop190:
for (i = 1; i <= m; i++) {
temp = a[(i)- 1+(j- 1)*lda+ _a_offset];
a[(i)- 1+(j- 1)*lda+ _a_offset] = ctemp*temp-stemp*a[(i)- 1+(1- 1)*lda+ _a_offset];
a[(i)- 1+(1- 1)*lda+ _a_offset] = stemp*temp+ctemp*a[(i)- 1+(1- 1)*lda+ _a_offset];
Dummy.label("Dlasr",190);
}              //  Close for() loop. 
}
}              // Close if()
Dummy.label("Dlasr",200);
}              //  Close for() loop. 
}
}              // Close else if()
}              // Close else if()
else if ((pivot.toLowerCase().charAt(0) == "B".toLowerCase().charAt(0)))  {
    if ((direct.toLowerCase().charAt(0) == "F".toLowerCase().charAt(0)))  {
    {
forloop220:
for (j = 1; j <= n-1; j++) {
ctemp = c[(j)- 1+ _c_offset];
stemp = s[(j)- 1+ _s_offset];
if ((ctemp != one) || (stemp != zero))  {
    {
forloop210:
for (i = 1; i <= m; i++) {
temp = a[(i)- 1+(j- 1)*lda+ _a_offset];
a[(i)- 1+(j- 1)*lda+ _a_offset] = stemp*a[(i)- 1+(n- 1)*lda+ _a_offset]+ctemp*temp;
a[(i)- 1+(n- 1)*lda+ _a_offset] = ctemp*a[(i)- 1+(n- 1)*lda+ _a_offset]-stemp*temp;
Dummy.label("Dlasr",210);
}              //  Close for() loop. 
}
}              // Close if()
Dummy.label("Dlasr",220);
}              //  Close for() loop. 
}
}              // Close if()
else if ((direct.toLowerCase().charAt(0) == "B".toLowerCase().charAt(0)))  {
    {
int _j_inc = -1;
forloop240:
for (j = n-1; j >= 1; j += _j_inc) {
ctemp = c[(j)- 1+ _c_offset];
stemp = s[(j)- 1+ _s_offset];
if ((ctemp != one) || (stemp != zero))  {
    {
forloop230:
for (i = 1; i <= m; i++) {
temp = a[(i)- 1+(j- 1)*lda+ _a_offset];
a[(i)- 1+(j- 1)*lda+ _a_offset] = stemp*a[(i)- 1+(n- 1)*lda+ _a_offset]+ctemp*temp;
a[(i)- 1+(n- 1)*lda+ _a_offset] = ctemp*a[(i)- 1+(n- 1)*lda+ _a_offset]-stemp*temp;
Dummy.label("Dlasr",230);
}              //  Close for() loop. 
}
}              // Close if()
Dummy.label("Dlasr",240);
}              //  Close for() loop. 
}
}              // Close else if()
}              // Close else if()
}              // Close else if()
// *
Dummy.go_to("Dlasr",999999);
// *
// *     End of DLASR
// *
Dummy.label("Dlasr",999999);
return;
   }
} // End class.
