/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;



public class Dormbr {

// *
// *  -- LAPACK routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  If VECT = 'Q', DORMBR overwrites the general real M-by-N matrix C
// *  with
// *                  SIDE = 'L'     SIDE = 'R'
// *  TRANS = 'N':      Q * C          C * Q
// *  TRANS = 'T':      Q**T * C       C * Q**T
// *
// *  If VECT = 'P', DORMBR overwrites the general real M-by-N matrix C
// *  with
// *                  SIDE = 'L'     SIDE = 'R'
// *  TRANS = 'N':      P * C          C * P
// *  TRANS = 'T':      P**T * C       C * P**T
// *
// *  Here Q and P**T are the orthogonal matrices determined by DGEBRD when
// *  reducing a real matrix A to bidiagonal form: A = Q * B * P**T. Q and
// *  P**T are defined as products of elementary reflectors H(i) and G(i)
// *  respectively.
// *
// *  Let nq = m if SIDE = 'L' and nq = n if SIDE = 'R'. Thus nq is the
// *  order of the orthogonal matrix Q or P**T that is applied.
// *
// *  If VECT = 'Q', A is assumed to have been an NQ-by-K matrix:
// *  if nq >= k, Q = H(1) H(2) . . . H(k);
// *  if nq < k, Q = H(1) H(2) . . . H(nq-1).
// *
// *  If VECT = 'P', A is assumed to have been a K-by-NQ matrix:
// *  if k < nq, P = G(1) G(2) . . . G(k);
// *  if k >= nq, P = G(1) G(2) . . . G(nq-1).
// *
// *  Arguments
// *  =========
// *
// *  VECT    (input) CHARACTER*1
// *          = 'Q': apply Q or Q**T;
// *          = 'P': apply P or P**T.
// *
// *  SIDE    (input) CHARACTER*1
// *          = 'L': apply Q, Q**T, P or P**T from the Left;
// *          = 'R': apply Q, Q**T, P or P**T from the Right.
// *
// *  TRANS   (input) CHARACTER*1
// *          = 'N':  No transpose, apply Q  or P;
// *          = 'T':  Transpose, apply Q**T or P**T.
// *
// *  M       (input) INTEGER
// *          The number of rows of the matrix C. M >= 0.
// *
// *  N       (input) INTEGER
// *          The number of columns of the matrix C. N >= 0.
// *
// *  K       (input) INTEGER
// *          If VECT = 'Q', the number of columns in the original
// *          matrix reduced by DGEBRD.
// *          If VECT = 'P', the number of rows in the original
// *          matrix reduced by DGEBRD.
// *          K >= 0.
// *
// *  A       (input) DOUBLE PRECISION array, dimension
// *                                (LDA,min(nq,K)) if VECT = 'Q'
// *                                (LDA,nq)        if VECT = 'P'
// *          The vectors which define the elementary reflectors H(i) and
// *          G(i), whose products determine the matrices Q and P, as
// *          returned by DGEBRD.
// *
// *  LDA     (input) INTEGER
// *          The leading dimension of the array A.
// *          If VECT = 'Q', LDA >= max(1,nq);
// *          if VECT = 'P', LDA >= max(1,min(nq,K)).
// *
// *  TAU     (input) DOUBLE PRECISION array, dimension (min(nq,K))
// *          TAU(i) must contain the scalar factor of the elementary
// *          reflector H(i) or G(i) which determines Q or P, as returned
// *          by DGEBRD in the array argument TAUQ or TAUP.
// *
// *  C       (input/output) DOUBLE PRECISION array, dimension (LDC,N)
// *          On entry, the M-by-N matrix C.
// *          On exit, C is overwritten by Q*C or Q**T*C or C*Q**T or C*Q
// *          or P*C or P**T*C or C*P or C*P**T.
// *
// *  LDC     (input) INTEGER
// *          The leading dimension of the array C. LDC >= max(1,M).
// *
// *  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
// *          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
// *
// *  LWORK   (input) INTEGER
// *          The dimension of the array WORK.
// *          If SIDE = 'L', LWORK >= max(1,N);
// *          if SIDE = 'R', LWORK >= max(1,M).
// *          For optimum performance LWORK >= N*NB if SIDE = 'L', and
// *          LWORK >= M*NB if SIDE = 'R', where NB is the optimal
// *          blocksize.
// *
// *  INFO    (output) INTEGER
// *          = 0:  successful exit
// *          < 0:  if INFO = -i, the i-th argument had an illegal value
// *
// *  =====================================================================
// *
// *     .. Local Scalars ..
static boolean applyq= false;
static boolean left= false;
static boolean notran= false;
static String transt= new String(" ");
static int i1= 0;
static int i2= 0;
static intW iinfo= new intW(0);
static int mi= 0;
static int ni= 0;
static int nq= 0;
static int nw= 0;
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Test the input arguments
// *

public static void dormbr (String vect,
String side,
String trans,
int m,
int n,
int k,
double [] a, int _a_offset,
int lda,
double [] tau, int _tau_offset,
double [] c, int _c_offset,
int Ldc,
double [] work, int _work_offset,
int lwork,
intW info)  {

info.val = 0;
applyq = (vect.toLowerCase().charAt(0) == "Q".toLowerCase().charAt(0));
left = (side.toLowerCase().charAt(0) == "L".toLowerCase().charAt(0));
notran = (trans.toLowerCase().charAt(0) == "N".toLowerCase().charAt(0));
// *
// *     NQ is the order of Q or P and NW is the minimum dimension of WORK
// *
if (left)  {
    nq = m;
nw = n;
}              // Close if()
else  {
  nq = n;
nw = m;
}              //  Close else.
if (!applyq && !(vect.toLowerCase().charAt(0) == "P".toLowerCase().charAt(0)))  {
    info.val = -1;
}              // Close if()
else if (!left && !(side.toLowerCase().charAt(0) == "R".toLowerCase().charAt(0)))  {
    info.val = -2;
}              // Close else if()
else if (!notran && !(trans.toLowerCase().charAt(0) == "T".toLowerCase().charAt(0)))  {
    info.val = -3;
}              // Close else if()
else if (m < 0)  {
    info.val = -4;
}              // Close else if()
else if (n < 0)  {
    info.val = -5;
}              // Close else if()
else if (k < 0)  {
    info.val = -6;
}              // Close else if()
else if ((applyq && lda < Math.max(1, nq) ) || (!applyq && lda < Math.max(1, Math.min(nq, k) ) ))  {
    info.val = -8;
}              // Close else if()
else if (Ldc < Math.max(1, m) )  {
    info.val = -11;
}              // Close else if()
else if (lwork < Math.max(1, nw) )  {
    info.val = -13;
}              // Close else if()
if (info.val != 0)  {
    Xerbla.xerbla("DORMBR",-info.val);
Dummy.go_to("Dormbr",999999);
}              // Close if()
// *
// *     Quick return if possible
// *
work[(1)- 1+ _work_offset] = (double)(1);
if (m == 0 || n == 0)  
    Dummy.go_to("Dormbr",999999);
// *
if (applyq)  {
    // *
// *        Apply Q
// *
if (nq >= k)  {
    // *
// *           Q was determined by a call to DGEBRD with nq >= k
// *
Dormqr.dormqr(side,trans,m,n,k,a,_a_offset,lda,tau,_tau_offset,c,_c_offset,Ldc,work,_work_offset,lwork,iinfo);
}              // Close if()
else if (nq > 1)  {
    // *
// *           Q was determined by a call to DGEBRD with nq < k
// *
if (left)  {
    mi = m-1;
ni = n;
i1 = 2;
i2 = 1;
}              // Close if()
else  {
  mi = m;
ni = n-1;
i1 = 1;
i2 = 2;
}              //  Close else.
Dormqr.dormqr(side,trans,mi,ni,nq-1,a,(2)- 1+(1- 1)*lda+ _a_offset,lda,tau,_tau_offset,c,(i1)- 1+(i2- 1)*Ldc+ _c_offset,Ldc,work,_work_offset,lwork,iinfo);
}              // Close else if()
}              // Close if()
else  {
  // *
// *        Apply P
// *
if (notran)  {
    transt = "T";
}              // Close if()
else  {
  transt = "N";
}              //  Close else.
if (nq > k)  {
    // *
// *           P was determined by a call to DGEBRD with nq > k
// *
Dormlq.dormlq(side,transt,m,n,k,a,_a_offset,lda,tau,_tau_offset,c,_c_offset,Ldc,work,_work_offset,lwork,iinfo);
}              // Close if()
else if (nq > 1)  {
    // *
// *           P was determined by a call to DGEBRD with nq <= k
// *
if (left)  {
    mi = m-1;
ni = n;
i1 = 2;
i2 = 1;
}              // Close if()
else  {
  mi = m;
ni = n-1;
i1 = 1;
i2 = 2;
}              //  Close else.
Dormlq.dormlq(side,transt,mi,ni,nq-1,a,(1)- 1+(2- 1)*lda+ _a_offset,lda,tau,_tau_offset,c,(i1)- 1+(i2- 1)*Ldc+ _c_offset,Ldc,work,_work_offset,lwork,iinfo);
}              // Close else if()
}              //  Close else.
Dummy.go_to("Dormbr",999999);
// *
// *     End of DORMBR
// *
Dummy.label("Dormbr",999999);
return;
   }
} // End class.
