/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;



public class Dpotri {

// *
// *  -- LAPACK routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     March 31, 1993
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DPOTRI computes the inverse of a real symmetric positive definite
// *  matrix A using the Cholesky factorization A = U**T*U or A = L*L**T
// *  computed by DPOTRF.
// *
// *  Arguments
// *  =========
// *
// *  UPLO    (input) CHARACTER*1
// *          = 'U':  Upper triangle of A is stored;
// *          = 'L':  Lower triangle of A is stored.
// *
// *  N       (input) INTEGER
// *          The order of the matrix A.  N >= 0.
// *
// *  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
// *          On entry, the triangular factor U or L from the Cholesky
// *          factorization A = U**T*U or A = L*L**T, as computed by
// *          DPOTRF.
// *          On exit, the upper or lower triangle of the (symmetric)
// *          inverse of A, overwriting the input factor U or L.
// *
// *  LDA     (input) INTEGER
// *          The leading dimension of the array A.  LDA >= max(1,N).
// *
// *  INFO    (output) INTEGER
// *          = 0:  successful exit
// *          < 0:  if INFO = -i, the i-th argument had an illegal value
// *          > 0:  if INFO = i, the (i,i) element of the factor U or L is
// *                zero, and the inverse could not be computed.
// *
// *  =====================================================================
// *
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Test the input parameters.
// *

public static void dpotri (String uplo,
int n,
double [] a, int _a_offset,
int lda,
intW info)  {

info.val = 0;
if (!(uplo.toLowerCase().charAt(0) == "U".toLowerCase().charAt(0)) && !(uplo.toLowerCase().charAt(0) == "L".toLowerCase().charAt(0)))  {
    info.val = -1;
}              // Close if()
else if (n < 0)  {
    info.val = -2;
}              // Close else if()
else if (lda < Math.max(1, n) )  {
    info.val = -4;
}              // Close else if()
if (info.val != 0)  {
    Xerbla.xerbla("DPOTRI",-info.val);
Dummy.go_to("Dpotri",999999);
}              // Close if()
// *
// *     Quick return if possible
// *
if (n == 0)  
    Dummy.go_to("Dpotri",999999);
// *
// *     Invert the triangular Cholesky factor U or L.
// *
Dtrtri.dtrtri(uplo,"Non-unit",n,a,_a_offset,lda,info);
if (info.val > 0)  
    Dummy.go_to("Dpotri",999999);
// *
// *     Form inv(U)*inv(U)' or inv(L)'*inv(L).
// *
Dlauum.dlauum(uplo,n,a,_a_offset,lda,info);
// *
Dummy.go_to("Dpotri",999999);
// *
// *     End of DPOTRI
// *
Dummy.label("Dpotri",999999);
return;
   }
} // End class.
