/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;

import org.netlib.blas.*;


public class Dpptri {

// *
// *  -- LAPACK routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     March 31, 1993
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DPPTRI computes the inverse of a real symmetric positive definite
// *  matrix A using the Cholesky factorization A = U**T*U or A = L*L**T
// *  computed by DPPTRF.
// *
// *  Arguments
// *  =========
// *
// *  UPLO    (input) CHARACTER*1
// *          = 'U':  Upper triangular factor is stored in AP;
// *          = 'L':  Lower triangular factor is stored in AP.
// *
// *  N       (input) INTEGER
// *          The order of the matrix A.  N >= 0.
// *
// *  AP      (input/output) DOUBLE PRECISION array, dimension (N*(N+1)/2)
// *          On entry, the triangular factor U or L from the Cholesky
// *          factorization A = U**T*U or A = L*L**T, packed columnwise as
// *          a linear array.  The j-th column of U or L is stored in the
// *          array AP as follows:
// *          if UPLO = 'U', AP(i + (j-1)*j/2) = U(i,j) for 1<=i<=j;
// *          if UPLO = 'L', AP(i + (j-1)*(2n-j)/2) = L(i,j) for j<=i<=n.
// *
// *          On exit, the upper or lower triangle of the (symmetric)
// *          inverse of A, overwriting the input factor U or L.
// *
// *  INFO    (output) INTEGER
// *          = 0:  successful exit
// *          < 0:  if INFO = -i, the i-th argument had an illegal value
// *          > 0:  if INFO = i, the (i,i) element of the factor U or L is
// *                zero, and the inverse could not be computed.
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double one= 1.0e+0;
// *     ..
// *     .. Local Scalars ..
static boolean upper= false;
static int j= 0;
static int jc= 0;
static int jj= 0;
static int jjn= 0;
static double ajj= 0.0;
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Test the input parameters.
// *

public static void dpptri (String uplo,
int n,
double [] ap, int _ap_offset,
intW info)  {

info.val = 0;
upper = (uplo.toLowerCase().charAt(0) == "U".toLowerCase().charAt(0));
if (!upper && !(uplo.toLowerCase().charAt(0) == "L".toLowerCase().charAt(0)))  {
    info.val = -1;
}              // Close if()
else if (n < 0)  {
    info.val = -2;
}              // Close else if()
if (info.val != 0)  {
    Xerbla.xerbla("DPPTRI",-info.val);
Dummy.go_to("Dpptri",999999);
}              // Close if()
// *
// *     Quick return if possible
// *
if (n == 0)  
    Dummy.go_to("Dpptri",999999);
// *
// *     Invert the triangular Cholesky factor U or L.
// *
Dtptri.dtptri(uplo,"Non-unit",n,ap,_ap_offset,info);
if (info.val > 0)  
    Dummy.go_to("Dpptri",999999);
// *
if (upper)  {
    // *
// *        Compute the product inv(U) * inv(U)'.
// *
jj = 0;
{
forloop10:
for (j = 1; j <= n; j++) {
jc = jj+1;
jj = jj+j;
if (j > 1)  
    Dspr.dspr("Upper",j-1,one,ap,(jc)- 1+ _ap_offset,1,ap,_ap_offset);
ajj = ap[(jj)- 1+ _ap_offset];
Dscal.dscal(j,ajj,ap,(jc)- 1+ _ap_offset,1);
Dummy.label("Dpptri",10);
}              //  Close for() loop. 
}
// *
}              // Close if()
else  {
  // *
// *        Compute the product inv(L)' * inv(L).
// *
jj = 1;
{
forloop20:
for (j = 1; j <= n; j++) {
jjn = jj+n-j+1;
ap[(jj)- 1+ _ap_offset] = Ddot.ddot(n-j+1,ap,(jj)- 1+ _ap_offset,1,ap,(jj)- 1+ _ap_offset,1);
if (j < n)  
    Dtpmv.dtpmv("Lower","Transpose","Non-unit",n-j,ap,(jjn)- 1+ _ap_offset,ap,(jj+1)- 1+ _ap_offset,1);
jj = jjn;
Dummy.label("Dpptri",20);
}              //  Close for() loop. 
}
}              //  Close else.
// *
Dummy.go_to("Dpptri",999999);
// *
// *     End of DPPTRI
// *
Dummy.label("Dpptri",999999);
return;
   }
} // End class.
