/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;

import org.netlib.blas.*;


public class Dptsvx {

// *
// *  -- LAPACK routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DPTSVX uses the factorization A = L*D*L**T to compute the solution
// *  to a real system of linear equations A*X = B, where A is an N-by-N
// *  symmetric positive definite tridiagonal matrix and X and B are
// *  N-by-NRHS matrices.
// *
// *  Error bounds on the solution and a condition estimate are also
// *  provided.
// *
// *  Description
// *  ===========
// *
// *  The following steps are performed:
// *
// *  1. If FACT = 'N', the matrix A is factored as A = L*D*L**T, where L
// *     is a unit lower bidiagonal matrix and D is diagonal.  The
// *     factorization can also be regarded as having the form
// *     A = U**T*D*U.
// *
// *  2. The factored form of A is used to compute the condition number
// *     of the matrix A.  If the reciprocal of the condition number is
// *     less than machine precision, steps 3 and 4 are skipped.
// *
// *  3. The system of equations is solved for X using the factored form
// *     of A.
// *
// *  4. Iterative refinement is applied to improve the computed solution
// *     matrix and calculate error bounds and backward error estimates
// *     for it.
// *
// *  Arguments
// *  =========
// *
// *  FACT    (input) CHARACTER*1
// *          Specifies whether or not the factored form of A has been
// *          supplied on entry.
// *          = 'F':  On entry, DF and EF contain the factored form of A.
// *                  D, E, DF, and EF will not be modified.
// *          = 'N':  The matrix A will be copied to DF and EF and
// *                  factored.
// *
// *  N       (input) INTEGER
// *          The order of the matrix A.  N >= 0.
// *
// *  NRHS    (input) INTEGER
// *          The number of right hand sides, i.e., the number of columns
// *          of the matrices B and X.  NRHS >= 0.
// *
// *  D       (input) DOUBLE PRECISION array, dimension (N)
// *          The n diagonal elements of the tridiagonal matrix A.
// *
// *  E       (input) DOUBLE PRECISION array, dimension (N-1)
// *          The (n-1) subdiagonal elements of the tridiagonal matrix A.
// *
// *  DF      (input or output) DOUBLE PRECISION array, dimension (N)
// *          If FACT = 'F', then DF is an input argument and on entry
// *          contains the n diagonal elements of the diagonal matrix D
// *          from the L*D*L**T factorization of A.
// *          If FACT = 'N', then DF is an output argument and on exit
// *          contains the n diagonal elements of the diagonal matrix D
// *          from the L*D*L**T factorization of A.
// *
// *  EF      (input or output) DOUBLE PRECISION array, dimension (N-1)
// *          If FACT = 'F', then EF is an input argument and on entry
// *          contains the (n-1) subdiagonal elements of the unit
// *          bidiagonal factor L from the L*D*L**T factorization of A.
// *          If FACT = 'N', then EF is an output argument and on exit
// *          contains the (n-1) subdiagonal elements of the unit
// *          bidiagonal factor L from the L*D*L**T factorization of A.
// *
// *  B       (input) DOUBLE PRECISION array, dimension (LDB,NRHS)
// *          The N-by-NRHS right hand side matrix B.
// *
// *  LDB     (input) INTEGER
// *          The leading dimension of the array B.  LDB >= max(1,N).
// *
// *  X       (output) DOUBLE PRECISION array, dimension (LDX,NRHS)
// *          If INFO = 0, the N-by-NRHS solution matrix X.
// *
// *  LDX     (input) INTEGER
// *          The leading dimension of the array X.  LDX >= max(1,N).
// *
// *  RCOND   (output) DOUBLE PRECISION
// *          The reciprocal condition number of the matrix A.  If RCOND
// *          is less than the machine precision (in particular, if
// *          RCOND = 0), the matrix is singular to working precision.
// *          This condition is indicated by a return code of INFO > 0,
// *          and the solution and error bounds are not computed.
// *
// *  FERR    (output) DOUBLE PRECISION array, dimension (NRHS)
// *          The forward error bound for each solution vector
// *          X(j) (the j-th column of the solution matrix X).
// *          If XTRUE is the true solution corresponding to X(j), FERR(j)
// *          is an estimated upper bound for the magnitude of the largest
// *          element in (X(j) - XTRUE) divided by the magnitude of the
// *          largest element in X(j).
// *
// *  BERR    (output) DOUBLE PRECISION array, dimension (NRHS)
// *          The componentwise relative backward error of each solution
// *          vector X(j) (i.e., the smallest relative change in any
// *          element of A or B that makes X(j) an exact solution).
// *
// *  WORK    (workspace) DOUBLE PRECISION array, dimension (2*N)
// *
// *  INFO    (output) INTEGER
// *          = 0:  successful exit
// *          < 0:  if INFO = -i, the i-th argument had an illegal value
// *          > 0:  if INFO = i, and i is
// *                <= N  the leading minor of order i of A is not
// *                positive definite, so the factorization could not be
// *                completed unless i = N, and the solution and error
// *                bounds could not be computed.
// *                = N+1 RCOND is less than machine precision.  The
// *                factorization has been completed, but the matrix is
// *                singular to working precision, and the solution and
// *                error bounds have not been computed.
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double zero= 0.0e+0;
// *     ..
// *     .. Local Scalars ..
static boolean nofact= false;
static double anorm= 0.0;
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Test the input parameters.
// *

public static void dptsvx (String fact,
int n,
int nrhs,
double [] d, int _d_offset,
double [] e, int _e_offset,
double [] df, int _df_offset,
double [] ef, int _ef_offset,
double [] b, int _b_offset,
int ldb,
double [] x, int _x_offset,
int ldx,
doubleW rcond,
double [] ferr, int _ferr_offset,
double [] berr, int _berr_offset,
double [] work, int _work_offset,
intW info)  {

info.val = 0;
nofact = (fact.toLowerCase().charAt(0) == "N".toLowerCase().charAt(0));
if (!nofact && !(fact.toLowerCase().charAt(0) == "F".toLowerCase().charAt(0)))  {
    info.val = -1;
}              // Close if()
else if (n < 0)  {
    info.val = -2;
}              // Close else if()
else if (nrhs < 0)  {
    info.val = -3;
}              // Close else if()
else if (ldb < Math.max(1, n) )  {
    info.val = -9;
}              // Close else if()
else if (ldx < Math.max(1, n) )  {
    info.val = -11;
}              // Close else if()
if (info.val != 0)  {
    Xerbla.xerbla("DPTSVX",-info.val);
Dummy.go_to("Dptsvx",999999);
}              // Close if()
// *
if (nofact)  {
    // *
// *        Compute the L*D*L' (or U'*D*U) factorization of A.
// *
Dcopy.dcopy(n,d,_d_offset,1,df,_df_offset,1);
if (n > 1)  
    Dcopy.dcopy(n-1,e,_e_offset,1,ef,_ef_offset,1);
Dpttrf.dpttrf(n,df,_df_offset,ef,_ef_offset,info);
// *
// *        Return if INFO is non-zero.
// *
if (info.val != 0)  {
    if (info.val > 0)  
    rcond.val = zero;
Dummy.go_to("Dptsvx",999999);
}              // Close if()
}              // Close if()
// *
// *     Compute the norm of the matrix A.
// *
anorm = Dlanst.dlanst("1",n,d,_d_offset,e,_e_offset);
// *
// *     Compute the reciprocal of the condition number of A.
// *
Dptcon.dptcon(n,df,_df_offset,ef,_ef_offset,anorm,rcond,work,_work_offset,info);
// *
// *     Return if the matrix is singular to working precision.
// *
if (rcond.val < Dlamch.dlamch("Epsilon"))  {
    info.val = n+1;
Dummy.go_to("Dptsvx",999999);
}              // Close if()
// *
// *     Compute the solution vectors X.
// *
Dlacpy.dlacpy("Full",n,nrhs,b,_b_offset,ldb,x,_x_offset,ldx);
Dpttrs.dpttrs(n,nrhs,df,_df_offset,ef,_ef_offset,x,_x_offset,ldx,info);
// *
// *     Use iterative refinement to improve the computed solutions and
// *     compute error bounds and backward error estimates for them.
// *
Dptrfs.dptrfs(n,nrhs,d,_d_offset,e,_e_offset,df,_df_offset,ef,_ef_offset,b,_b_offset,ldb,x,_x_offset,ldx,ferr,_ferr_offset,berr,_berr_offset,work,_work_offset,info);
// *
Dummy.go_to("Dptsvx",999999);
// *
// *     End of DPTSVX
// *
Dummy.label("Dptsvx",999999);
return;
   }
} // End class.
