/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;



public class Dpttrf {

// *
// *  -- LAPACK routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     March 31, 1993
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DPTTRF computes the factorization of a real symmetric positive
// *  definite tridiagonal matrix A.
// *
// *  If the subdiagonal elements of A are supplied in the array E, the
// *  factorization has the form A = L*D*L**T, where D is diagonal and L
// *  is unit lower bidiagonal; if the superdiagonal elements of A are
// *  supplied, it has the form A = U**T*D*U, where U is unit upper
// *  bidiagonal.  (The two forms are equivalent if A is real.)
// *
// *  Arguments
// *  =========
// *
// *  N       (input) INTEGER
// *          The order of the matrix A.  N >= 0.
// *
// *  D       (input/output) DOUBLE PRECISION array, dimension (N)
// *          On entry, the n diagonal elements of the tridiagonal matrix
// *          A.  On exit, the n diagonal elements of the diagonal matrix
// *          D from the L*D*L**T factorization of A.
// *
// *  E       (input/output) DOUBLE PRECISION array, dimension (N-1)
// *          On entry, the (n-1) off-diagonal elements of the tridiagonal
// *          matrix A.
// *          On exit, the (n-1) off-diagonal elements of the unit
// *          bidiagonal factor L or U from the factorization of A.
// *
// *  INFO    (output) INTEGER
// *          = 0:  successful exit
// *          < 0:  if INFO = -i, the i-th argument had an illegal value
// *          > 0:  if INFO = i, the leading minor of order i is not
// *                positive definite; if i < N, the factorization could
// *                not be completed, while if i = N, the factorization was
// *                completed, but D(N) = 0.
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double zero= 0.0e+0;
// *     ..
// *     .. Local Scalars ..
static int i= 0;
static double di= 0.0;
static double ei= 0.0;
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Test the input parameters.
// *

public static void dpttrf (int n,
double [] d, int _d_offset,
double [] e, int _e_offset,
intW info)  {

info.val = 0;
if (n < 0)  {
    info.val = -1;
Xerbla.xerbla("DPTTRF",-info.val);
Dummy.go_to("Dpttrf",999999);
}              // Close if()
// *
// *     Quick return if possible
// *
if (n == 0)  
    Dummy.go_to("Dpttrf",999999);
// *
// *     Compute the L*D*L' (or U'*D*U) factorization of A.
// *
{
forloop10:
for (i = 1; i <= n-1; i++) {
// *
// *        Drop out of the loop if d(i) <= 0: the matrix is not positive
// *        definite.
// *
di = d[(i)- 1+ _d_offset];
if (di <= zero)  
    Dummy.go_to("Dpttrf",20);
// *
// *        Solve for e(i) and d(i+1).
// *
ei = e[(i)- 1+ _e_offset];
e[(i)- 1+ _e_offset] = ei/di;
d[(i+1)- 1+ _d_offset] = d[(i+1)- 1+ _d_offset]-e[(i)- 1+ _e_offset]*ei;
Dummy.label("Dpttrf",10);
}              //  Close for() loop. 
}
// *
// *     Check d(n) for positive definiteness.
// *
i = n;
if (d[(i)- 1+ _d_offset] > zero)  
    Dummy.go_to("Dpttrf",30);
// *
label20:
   Dummy.label("Dpttrf",20);
info.val = i;
// *
label30:
   Dummy.label("Dpttrf",30);
Dummy.go_to("Dpttrf",999999);
// *
// *     End of DPTTRF
// *
Dummy.label("Dpttrf",999999);
return;
   }
} // End class.
