/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;



public class Dpttrs {

// *
// *  -- LAPACK routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     March 31, 1993
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DPTTRS solves a system of linear equations A * X = B with a
// *  symmetric positive definite tridiagonal matrix A using the
// *  factorization A = L*D*L**T or A = U**T*D*U computed by DPTTRF.
// *  (The two forms are equivalent if A is real.)
// *
// *  Arguments
// *  =========
// *
// *  N       (input) INTEGER
// *          The order of the tridiagonal matrix A.  N >= 0.
// *
// *  NRHS    (input) INTEGER
// *          The number of right hand sides, i.e., the number of columns
// *          of the matrix B.  NRHS >= 0.
// *
// *  D       (input) DOUBLE PRECISION array, dimension (N)
// *          The n diagonal elements of the diagonal matrix D from the
// *          factorization computed by DPTTRF.
// *
// *  E       (input) DOUBLE PRECISION array, dimension (N-1)
// *          The (n-1) off-diagonal elements of the unit bidiagonal factor
// *          U or L from the factorization computed by DPTTRF.
// *
// *  B       (input/output) DOUBLE PRECISION array, dimension (LDB,NRHS)
// *          On entry, the right hand side matrix B.
// *          On exit, the solution matrix X.
// *
// *  LDB     (input) INTEGER
// *          The leading dimension of the array B.  LDB >= max(1,N).
// *
// *  INFO    (output) INTEGER
// *          = 0:  successful exit
// *          < 0:  if INFO = -i, the i-th argument had an illegal value
// *
// *  =====================================================================
// *
// *     .. Local Scalars ..
static int i= 0;
static int j= 0;
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Test the input arguments.
// *

public static void dpttrs (int n,
int nrhs,
double [] d, int _d_offset,
double [] e, int _e_offset,
double [] b, int _b_offset,
int ldb,
intW info)  {

info.val = 0;
if (n < 0)  {
    info.val = -1;
}              // Close if()
else if (nrhs < 0)  {
    info.val = -2;
}              // Close else if()
else if (ldb < Math.max(1, n) )  {
    info.val = -6;
}              // Close else if()
if (info.val != 0)  {
    Xerbla.xerbla("DPTTRS",-info.val);
Dummy.go_to("Dpttrs",999999);
}              // Close if()
// *
// *     Quick return if possible
// *
if (n == 0)  
    Dummy.go_to("Dpttrs",999999);
// *
// *     Solve A * X = B using the factorization A = L*D*L',
// *     overwriting each right hand side vector with its solution.
// *
{
forloop30:
for (j = 1; j <= nrhs; j++) {
// *
// *        Solve L * x = b.
// *
{
forloop10:
for (i = 2; i <= n; i++) {
b[(i)- 1+(j- 1)*ldb+ _b_offset] = b[(i)- 1+(j- 1)*ldb+ _b_offset]-b[(i-1)- 1+(j- 1)*ldb+ _b_offset]*e[(i-1)- 1+ _e_offset];
Dummy.label("Dpttrs",10);
}              //  Close for() loop. 
}
// *
// *        Solve D * L' * x = b.
// *
b[(n)- 1+(j- 1)*ldb+ _b_offset] = b[(n)- 1+(j- 1)*ldb+ _b_offset]/d[(n)- 1+ _d_offset];
{
int _i_inc = -1;
forloop20:
for (i = n-1; i >= 1; i += _i_inc) {
b[(i)- 1+(j- 1)*ldb+ _b_offset] = b[(i)- 1+(j- 1)*ldb+ _b_offset]/d[(i)- 1+ _d_offset]-b[(i+1)- 1+(j- 1)*ldb+ _b_offset]*e[(i)- 1+ _e_offset];
Dummy.label("Dpttrs",20);
}              //  Close for() loop. 
}
Dummy.label("Dpttrs",30);
}              //  Close for() loop. 
}
// *
Dummy.go_to("Dpttrs",999999);
// *
// *     End of DPTTRS
// *
Dummy.label("Dpttrs",999999);
return;
   }
} // End class.
