/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;



public class Dqrt11 {

// *
// *  -- LAPACK routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DQRT11 computes the test ratio
// *
// *        || Q'*Q - I || / (eps * m)
// *
// *  where the orthogonal matrix Q is represented as a product of
// *  elementary transformations.  Each transformation has the form
// *
// *     H(k) = I - tau(k) v(k) v(k)'
// *
// *  where tau(k) is stored in TAU(k) and v(k) is an m-vector of the form
// *  [ 0 ... 0 1 x(k) ]', where x(k) is a vector of length m-k stored
// *  in A(k+1:m,k).
// *
// *  Arguments
// *  =========
// *
// *  M       (input) INTEGER
// *          The number of rows of the matrix A.
// *
// *  K       (input) INTEGER
// *          The number of columns of A whose subdiagonal entries
// *          contain information about orthogonal transformations.
// *
// *  A       (input) DOUBLE PRECISION array, dimension (LDA,K)
// *          The (possibly partial) output of a QR reduction routine.
// *
// *  LDA     (input) INTEGER
// *          The leading dimension of the array A.
// *
// *  TAU     (input) DOUBLE PRECISION array, dimension (K)
// *          The scaling factors tau for the elementary transformations as
// *          computed by the QR factorization routine.
// *
// *  WORK    (workspace) DOUBLE PRECISION array, dimension (LWORK)
// *
// *  LWORK   (input) INTEGER
// *          The length of the array WORK.  LWORK >= M*M + M.
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double zero= 0.0e0;
static double one= 1.0e0;
// *     ..
// *     .. Local Scalars ..
static intW info= new intW(0);
static int j= 0;
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Local Arrays ..
static double [] rdummy= new double[(1)];
// *     ..
// *     .. Executable Statements ..
// *
static double dqrt11 = 0.0;


public static double dqrt11 (int m,
int k,
double [] a, int _a_offset,
int lda,
double [] tau, int _tau_offset,
double [] work, int _work_offset,
int lwork)  {

dqrt11 = zero;
// *
// *     Test for sufficient workspace
// *
if (lwork < m*m+m)  {
    Xerbla.xerbla("DQRT11",7);
Dummy.go_to("Dqrt11",999999);
}              // Close if()
// *
// *     Quick return if possible
// *
if (m <= 0)  
    Dummy.go_to("Dqrt11",999999);
// *
Dlaset.dlaset("Full",m,m,zero,one,work,_work_offset,m);
// *
// *     Form Q
// *
Dorm2r.dorm2r("Left","No transpose",m,m,k,a,_a_offset,lda,tau,_tau_offset,work,_work_offset,m,work,(m*m+1)- 1+ _work_offset,info);
// *
// *     Form Q'*Q
// *
Dorm2r.dorm2r("Left","Transpose",m,m,k,a,_a_offset,lda,tau,_tau_offset,work,_work_offset,m,work,(m*m+1)- 1+ _work_offset,info);
// *
{
forloop10:
for (j = 1; j <= m; j++) {
work[((j-1)*m+j)- 1+ _work_offset] = work[((j-1)*m+j)- 1+ _work_offset]-one;
Dummy.label("Dqrt11",10);
}              //  Close for() loop. 
}
// *
dqrt11 = Dlange.dlange("One-norm",m,m,work,_work_offset,m,rdummy,0)/((double)(m)*Dlamch.dlamch("Epsilon"));
// *
Dummy.go_to("Dqrt11",999999);
// *
// *     End of DQRT11
// *
Dummy.label("Dqrt11",999999);
return dqrt11;
   }
} // End class.
