/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;

import org.netlib.blas.*;


public class Drscl {

// *
// *  -- LAPACK auxiliary routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DRSCL multiplies an n-element real vector x by the real scalar 1/a.
// *  This is done without overflow or underflow as long as
// *  the final result x/a does not overflow or underflow.
// *
// *  Arguments
// *  =========
// *
// *  N       (input) INTEGER
// *          The number of components of the vector x.
// *
// *  SA      (input) DOUBLE PRECISION
// *          The scalar a which is used to divide each component of x.
// *          SA must be >= 0, or the subroutine will divide by zero.
// *
// *  SX      (input/output) DOUBLE PRECISION array, dimension
// *                         (1+(N-1)*abs(INCX))
// *          The n-element vector x.
// *
// *  INCX    (input) INTEGER
// *          The increment between successive values of the vector SX.
// *          > 0:  SX(1) = X(1) and SX(1+(i-1)*INCX) = x(i),     1< i<= n
// *
// * =====================================================================
// *
// *     .. Parameters ..
static double one= 1.0e+0;
static double zero= 0.0e+0;
// *     ..
// *     .. Local Scalars ..
static boolean done= false;
static doubleW bignum= new doubleW(0.0);
static double cden= 0.0;
static double cden1= 0.0;
static double cnum= 0.0;
static double cnum1= 0.0;
static double mul= 0.0;
static doubleW smlnum= new doubleW(0.0);
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Quick return if possible
// *

public static void drscl (int n,
double sa,
double [] sx, int _sx_offset,
int incx)  {

if (n <= 0)  
    Dummy.go_to("Drscl",999999);
// *
// *     Get machine parameters
// *
smlnum.val = Dlamch.dlamch("S");
bignum.val = one/smlnum.val;
Dlabad.dlabad(smlnum,bignum);
// *
// *     Initialize the denominator to SA and the numerator to 1.
// *
cden = sa;
cnum = one;
// *
label10:
   Dummy.label("Drscl",10);
cden1 = cden*smlnum.val;
cnum1 = cnum/bignum.val;
if (Math.abs(cden1) > Math.abs(cnum) && cnum != zero)  {
    // *
// *        Pre-multiply X by SMLNUM if CDEN is large compared to CNUM.
// *
mul = smlnum.val;
done = false;
cden = cden1;
}              // Close if()
else if (Math.abs(cnum1) > Math.abs(cden))  {
    // *
// *        Pre-multiply X by BIGNUM if CDEN is small compared to CNUM.
// *
mul = bignum.val;
done = false;
cnum = cnum1;
}              // Close else if()
else  {
  // *
// *        Multiply X by CNUM / CDEN and return.
// *
mul = cnum/cden;
done = true;
}              //  Close else.
// *
// *     Scale the vector X by MUL
// *
Dscal.dscal(n,mul,sx,_sx_offset,incx);
// *
if (!done)  
    Dummy.go_to("Drscl",10);
// *
Dummy.go_to("Drscl",999999);
// *
// *     End of DRSCL
// *
Dummy.label("Drscl",999999);
return;
   }
} // End class.
