/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;

import org.netlib.blas.*;


public class Dsbevd {

// *
// *  -- LAPACK driver routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DSBEVD computes all the eigenvalues and, optionally, eigenvectors of
// *  a real symmetric band matrix A. If eigenvectors are desired, it uses
// *  a divide and conquer algorithm.
// *
// *  The divide and conquer algorithm makes very mild assumptions about
// *  floating point arithmetic. It will work on machines with a guard
// *  digit in add/subtract, or on those binary machines without guard
// *  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
// *  Cray-2. It could conceivably fail on hexadecimal or decimal machines
// *  without guard digits, but we know of none.
// *
// *  Arguments
// *  =========
// *
// *  JOBZ    (input) CHARACTER*1
// *          = 'N':  Compute eigenvalues only;
// *          = 'V':  Compute eigenvalues and eigenvectors.
// *
// *  UPLO    (input) CHARACTER*1
// *          = 'U':  Upper triangle of A is stored;
// *          = 'L':  Lower triangle of A is stored.
// *
// *  N       (input) INTEGER
// *          The order of the matrix A.  N >= 0.
// *
// *  KD      (input) INTEGER
// *          The number of superdiagonals of the matrix A if UPLO = 'U',
// *          or the number of subdiagonals if UPLO = 'L'.  KD >= 0.
// *
// *  AB      (input/output) DOUBLE PRECISION array, dimension (LDAB, N)
// *          On entry, the upper or lower triangle of the symmetric band
// *          matrix A, stored in the first KD+1 rows of the array.  The
// *          j-th column of A is stored in the j-th column of the array AB
// *          as follows:
// *          if UPLO = 'U', AB(kd+1+i-j,j) = A(i,j) for max(1,j-kd)<=i<=j;
// *          if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+kd).
// *
// *          On exit, AB is overwritten by values generated during the
// *          reduction to tridiagonal form.  If UPLO = 'U', the first
// *          superdiagonal and the diagonal of the tridiagonal matrix T
// *          are returned in rows KD and KD+1 of AB, and if UPLO = 'L',
// *          the diagonal and first subdiagonal of T are returned in the
// *          first two rows of AB.
// *
// *  LDAB    (input) INTEGER
// *          The leading dimension of the array AB.  LDAB >= KD + 1.
// *
// *  W       (output) DOUBLE PRECISION array, dimension (N)
// *          If INFO = 0, the eigenvalues in ascending order.
// *
// *  Z       (output) DOUBLE PRECISION array, dimension (LDZ, N)
// *          If JOBZ = 'V', then if INFO = 0, Z contains the orthonormal
// *          eigenvectors of the matrix A, with the i-th column of Z
// *          holding the eigenvector associated with W(i).
// *          If JOBZ = 'N', then Z is not referenced.
// *
// *  LDZ     (input) INTEGER
// *          The leading dimension of the array Z.  LDZ >= 1, and if
// *          JOBZ = 'V', LDZ >= max(1,N).
// *
// *  WORK    (workspace/output) DOUBLE PRECISION array,
// *                                         dimension (LWORK)
// *          On exit, if LWORK > 0, WORK(1) returns the optimal LWORK.
// *
// *  LWORK   (input) INTEGER
// *          The dimension of the array WORK.
// *          IF N <= 1,                LWORK must be at least 1.
// *          If JOBZ  = 'N' and N > 2, LWORK must be at least 2*N.
// *          If JOBZ  = 'V' and N > 2, LWORK must be at least
// *                         ( 1 + 4*N + 2*N*lg N + 3*N**2 ),
// *                         where lg( N ) = smallest integer k such
// *                                         that 2**k >= N.
// *
// *  IWORK   (workspace/output) INTEGER array, dimension (LIWORK)
// *          On exit, if LIWORK > 0, IWORK(1) returns the optimal LIWORK.
// *
// *  LIWORK  (input) INTEGER
// *          The dimension of the array LIWORK.
// *          If JOBZ  = 'N' or N <= 1, LIWORK must be at least 1.
// *          If JOBZ  = 'V' and N > 2, LIWORK must be at least 2 + 5*N.
// *
// *  INFO    (output) INTEGER
// *          = 0:  successful exit
// *          < 0:  if INFO = -i, the i-th argument had an illegal value
// *          > 0:  if INFO = i, the algorithm failed to converge; i
// *                off-diagonal elements of an intermediate tridiagonal
// *                form did not converge to zero.
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double zero= 0.0e0;
static double one= 1.0e0;
static double two= 2.0e0;
// *     ..
// *     .. Local Scalars ..
static boolean lower= false;
static boolean wantz= false;
static intW iinfo= new intW(0);
static int inde= 0;
static int indwk2= 0;
static int indwrk= 0;
static int iscale= 0;
static int lgn= 0;
static int liwmin= 0;
static int llwrk2= 0;
static int lwmin= 0;
static double anrm= 0.0;
static double bignum= 0.0;
static double eps= 0.0;
static double rmax= 0.0;
static double rmin= 0.0;
static double safmin= 0.0;
static double sigma= 0.0;
static double smlnum= 0.0;
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Test the input parameters.
// *

public static void dsbevd (String jobz,
String uplo,
int n,
int kd,
double [] ab, int _ab_offset,
int ldab,
double [] w, int _w_offset,
double [] z, int _z_offset,
int ldz,
double [] work, int _work_offset,
int lwork,
int [] iwork, int _iwork_offset,
int liwork,
intW info)  {

wantz = (jobz.toLowerCase().charAt(0) == "V".toLowerCase().charAt(0));
lower = (uplo.toLowerCase().charAt(0) == "L".toLowerCase().charAt(0));
// *
info.val = 0;
if (n <= 1)  {
    lgn = 0;
liwmin = 1;
lwmin = 1;
}              // Close if()
else  {
  lgn = (int)(Math.log((double)(n))/Math.log(two));
if (Math.pow(2, lgn) < n)  
    lgn = lgn+1;
if (Math.pow(2, lgn) < n)  
    lgn = lgn+1;
if (wantz)  {
    liwmin = 2+5*n;
lwmin = (int)(1+4*n+2*n*lgn+3*Math.pow(n, 2));
}              // Close if()
else  {
  liwmin = 1;
lwmin = 2*n;
}              //  Close else.
}              //  Close else.
if (!(wantz || (jobz.toLowerCase().charAt(0) == "N".toLowerCase().charAt(0))))  {
    info.val = -1;
}              // Close if()
else if (!(lower || (uplo.toLowerCase().charAt(0) == "U".toLowerCase().charAt(0))))  {
    info.val = -2;
}              // Close else if()
else if (n < 0)  {
    info.val = -3;
}              // Close else if()
else if (kd < 0)  {
    info.val = -4;
}              // Close else if()
else if (ldab < kd+1)  {
    info.val = -6;
}              // Close else if()
else if (ldz < 1 || (wantz && ldz < n))  {
    info.val = -9;
}              // Close else if()
else if (lwork < lwmin)  {
    info.val = -11;
}              // Close else if()
else if (liwork < liwmin)  {
    info.val = -13;
}              // Close else if()
// *
if (info.val != 0)  {
    Xerbla.xerbla("DSBEVD ",-info.val);
Dummy.go_to("Dsbevd",10);
}              // Close if()
// *
// *     Quick return if possible
// *
if (n == 0)  
    Dummy.go_to("Dsbevd",10);
// *
if (n == 1)  {
    w[(1)- 1+ _w_offset] = ab[(1)- 1+(1- 1)*ldab+ _ab_offset];
if (wantz)  
    z[(1)- 1+(1- 1)*ldz+ _z_offset] = one;
Dummy.go_to("Dsbevd",10);
}              // Close if()
// *
// *     Get machine constants.
// *
safmin = Dlamch.dlamch("Safe minimum");
eps = Dlamch.dlamch("Precision");
smlnum = safmin/eps;
bignum = one/smlnum;
rmin = Math.sqrt(smlnum);
rmax = Math.sqrt(bignum);
// *
// *     Scale matrix to allowable range, if necessary.
// *
anrm = Dlansb.dlansb("M",uplo,n,kd,ab,_ab_offset,ldab,work,_work_offset);
iscale = 0;
if (anrm > zero && anrm < rmin)  {
    iscale = 1;
sigma = rmin/anrm;
}              // Close if()
else if (anrm > rmax)  {
    iscale = 1;
sigma = rmax/anrm;
}              // Close else if()
if (iscale == 1)  {
    if (lower)  {
    Dlascl.dlascl("B",kd,kd,one,sigma,n,n,ab,_ab_offset,ldab,info);
}              // Close if()
else  {
  Dlascl.dlascl("Q",kd,kd,one,sigma,n,n,ab,_ab_offset,ldab,info);
}              //  Close else.
}              // Close if()
// *
// *     Call DSBTRD to reduce symmetric band matrix to tridiagonal form.
// *
inde = 1;
indwrk = inde+n;
indwk2 = indwrk+n*n;
llwrk2 = lwork-indwk2+1;
Dsbtrd.dsbtrd(jobz,uplo,n,kd,ab,_ab_offset,ldab,w,_w_offset,work,(inde)- 1+ _work_offset,z,_z_offset,ldz,work,(indwrk)- 1+ _work_offset,iinfo);
// *
// *     For eigenvalues only, call DSTERF.  For eigenvectors, call SSTEDC.
// *
if (!wantz)  {
    Dsterf.dsterf(n,w,_w_offset,work,(inde)- 1+ _work_offset,info);
}              // Close if()
else  {
  Dstedc.dstedc("I",n,w,_w_offset,work,(inde)- 1+ _work_offset,work,(indwrk)- 1+ _work_offset,n,work,(indwk2)- 1+ _work_offset,llwrk2,iwork,_iwork_offset,liwork,info);
Dgemm.dgemm("N","N",n,n,n,one,z,_z_offset,ldz,work,(indwrk)- 1+ _work_offset,n,zero,work,(indwk2)- 1+ _work_offset,n);
Dlacpy.dlacpy("A",n,n,work,(indwk2)- 1+ _work_offset,n,z,_z_offset,ldz);
}              //  Close else.
// *
// *     If matrix was scaled, then rescale eigenvalues appropriately.
// *
if (iscale == 1)  
    Dscal.dscal(n,one/sigma,w,_w_offset,1);
// *
label10:
   Dummy.label("Dsbevd",10);
if (lwork > 0)  
    work[(1)- 1+ _work_offset] = (double)(lwmin);
if (liwork > 0)  
    iwork[(1)- 1+ _iwork_offset] = liwmin;
Dummy.go_to("Dsbevd",999999);
// *
// *     End of DSBEVD
// *
Dummy.label("Dsbevd",999999);
return;
   }
} // End class.
