/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;



public class Dstebz {

// *
// *  -- LAPACK routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DSTEBZ computes the eigenvalues of a symmetric tridiagonal
// *  matrix T.  The user may ask for all eigenvalues, all eigenvalues
// *  in the half-open interval (VL, VU], or the IL-th through IU-th
// *  eigenvalues.
// *
// *  To avoid overflow, the matrix must be scaled so that its
// *  largest element is no greater than overflow**(1/2) *
// *  underflow**(1/4) in absolute value, and for greatest
// *  accuracy, it should not be much smaller than that.
// *
// *  See W. Kahan "Accurate Eigenvalues of a Symmetric Tridiagonal
// *  Matrix", Report CS41, Computer Science Dept., Stanford
// *  University, July 21, 1966.
// *
// *  Arguments
// *  =========
// *
// *  RANGE   (input) CHARACTER
// *          = 'A': ("All")   all eigenvalues will be found.
// *          = 'V': ("Value") all eigenvalues in the half-open interval
// *                           (VL, VU] will be found.
// *          = 'I': ("Index") the IL-th through IU-th eigenvalues (of the
// *                           entire matrix) will be found.
// *
// *  ORDER   (input) CHARACTER
// *          = 'B': ("By Block") the eigenvalues will be grouped by
// *                              split-off block (see IBLOCK, ISPLIT) and
// *                              ordered from smallest to largest within
// *                              the block.
// *          = 'E': ("Entire matrix")
// *                              the eigenvalues for the entire matrix
// *                              will be ordered from smallest to
// *                              largest.
// *
// *  N       (input) INTEGER
// *          The order of the tridiagonal matrix T.  N >= 0.
// *
// *  VL      (input) DOUBLE PRECISION
// *  VU      (input) DOUBLE PRECISION
// *          If RANGE='V', the lower and upper bounds of the interval to
// *          be searched for eigenvalues.  Eigenvalues less than or equal
// *          to VL, or greater than VU, will not be returned.  VL < VU.
// *          Not referenced if RANGE = 'A' or 'I'.
// *
// *  IL      (input) INTEGER
// *  IU      (input) INTEGER
// *          If RANGE='I', the indices (in ascending order) of the
// *          smallest and largest eigenvalues to be returned.
// *          1 <= IL <= IU <= N, if N > 0; IL = 1 and IU = 0 if N = 0.
// *          Not referenced if RANGE = 'A' or 'V'.
// *
// *  ABSTOL  (input) DOUBLE PRECISION
// *          The absolute tolerance for the eigenvalues.  An eigenvalue
// *          (or cluster) is considered to be located if it has been
// *          determined to lie in an interval whose width is ABSTOL or
// *          less.  If ABSTOL is less than or equal to zero, then ULP*|T|
// *          will be used, where |T| means the 1-norm of T.
// *
// *          Eigenvalues will be computed most accurately when ABSTOL is
// *          set to twice the underflow threshold 2*DLAMCH('S'), not zero.
// *
// *  D       (input) DOUBLE PRECISION array, dimension (N)
// *          The n diagonal elements of the tridiagonal matrix T.
// *
// *  E       (input) DOUBLE PRECISION array, dimension (N-1)
// *          The (n-1) off-diagonal elements of the tridiagonal matrix T.
// *
// *  M       (output) INTEGER
// *          The actual number of eigenvalues found. 0 <= M <= N.
// *          (See also the description of INFO=2,3.)
// *
// *  NSPLIT  (output) INTEGER
// *          The number of diagonal blocks in the matrix T.
// *          1 <= NSPLIT <= N.
// *
// *  W       (output) DOUBLE PRECISION array, dimension (N)
// *          On exit, the first M elements of W will contain the
// *          eigenvalues.  (DSTEBZ may use the remaining N-M elements as
// *          workspace.)
// *
// *  IBLOCK  (output) INTEGER array, dimension (N)
// *          At each row/column j where E(j) is zero or small, the
// *          matrix T is considered to split into a block diagonal
// *          matrix.  On exit, if INFO = 0, IBLOCK(i) specifies to which
// *          block (from 1 to the number of blocks) the eigenvalue W(i)
// *          belongs.  (DSTEBZ may use the remaining N-M elements as
// *          workspace.)
// *
// *  ISPLIT  (output) INTEGER array, dimension (N)
// *          The splitting points, at which T breaks up into submatrices.
// *          The first submatrix consists of rows/columns 1 to ISPLIT(1),
// *          the second of rows/columns ISPLIT(1)+1 through ISPLIT(2),
// *          etc., and the NSPLIT-th consists of rows/columns
// *          ISPLIT(NSPLIT-1)+1 through ISPLIT(NSPLIT)=N.
// *          (Only the first NSPLIT elements will actually be used, but
// *          since the user cannot know a priori what value NSPLIT will
// *          have, N words must be reserved for ISPLIT.)
// *
// *  WORK    (workspace) DOUBLE PRECISION array, dimension (4*N)
// *
// *  IWORK   (workspace) INTEGER array, dimension (3*N)
// *
// *  INFO    (output) INTEGER
// *          = 0:  successful exit
// *          < 0:  if INFO = -i, the i-th argument had an illegal value
// *          > 0:  some or all of the eigenvalues failed to converge or
// *                were not computed:
// *                =1 or 3: Bisection failed to converge for some
// *                        eigenvalues; these eigenvalues are flagged by a
// *                        negative block number.  The effect is that the
// *                        eigenvalues may not be as accurate as the
// *                        absolute and relative tolerances.  This is
// *                        generally caused by unexpectedly inaccurate
// *                        arithmetic.
// *                =2 or 3: RANGE='I' only: Not all of the eigenvalues
// *                        IL:IU were found.
// *                        Effect: M < IU+1-IL
// *                        Cause:  non-monotonic arithmetic, causing the
// *                                Sturm sequence to be non-monotonic.
// *                        Cure:   recalculate, using RANGE='A', and pick
// *                                out eigenvalues IL:IU.  In some cases,
// *                                increasing the PARAMETER "FUDGE" may
// *                                make things work.
// *                = 4:    RANGE='I', and the Gershgorin interval
// *                        initially used was too small.  No eigenvalues
// *                        were computed.
// *                        Probable cause: your machine has sloppy
// *                                        floating-point arithmetic.
// *                        Cure: Increase the PARAMETER "FUDGE",
// *                              recompile, and try again.
// *
// *  Internal Parameters
// *  ===================
// *
// *  RELFAC  DOUBLE PRECISION, default = 2.0e0
// *          The relative tolerance.  An interval (a,b] lies within
// *          "relative tolerance" if  b-a < RELFAC*ulp*max(|a|,|b|),
// *          where "ulp" is the machine precision (distance from 1 to
// *          the next larger floating point number.)
// *
// *  FUDGE   DOUBLE PRECISION, default = 2
// *          A "fudge factor" to widen the Gershgorin intervals.  Ideally,
// *          a value of 1 should work, but on machines with sloppy
// *          arithmetic, this needs to be larger.  The default for
// *          publicly released versions should be large enough to handle
// *          the worst machine around.  Note that this has no effect
// *          on accuracy of the solution.
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double zero= 0.0e0;
static double one= 1.0e0;
static double two= 2.0e0;
static double half= 1.0e0/two;
static double fudge= 2.0e0;
static double relfac= 2.0e0;
// *     ..
// *     .. Local Scalars ..
static boolean ncnvrg= false;
static boolean toofew= false;
static int ib= 0;
static int ibegin= 0;
static int idiscl= 0;
static int idiscu= 0;
static int ie= 0;
static int iend= 0;
static intW iinfo= new intW(0);
static intW im= new intW(0);
static int in= 0;
static int ioff= 0;
static int iorder= 0;
static intW iout= new intW(0);
static int irange= 0;
static int itmax= 0;
static int itmp1= 0;
static int iw= 0;
static int iwoff= 0;
static int j= 0;
static int jb= 0;
static int jdisc= 0;
static int je= 0;
static int nb= 0;
static int nwl= 0;
static int nwu= 0;
static double atoli= 0.0;
static double bnorm= 0.0;
static double gl= 0.0;
static double gu= 0.0;
static double pivmin= 0.0;
static double rtoli= 0.0;
static double safemn= 0.0;
static double tmp1= 0.0;
static double tmp2= 0.0;
static double tnorm= 0.0;
static double ulp= 0.0;
static double wkill= 0.0;
static double wl= 0.0;
static double wlu= 0.0;
static double wu= 0.0;
static double wul= 0.0;
// *     ..
// *     .. Local Arrays ..
static int [] idumma= new int[(1)];
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *

public static void dstebz (String range,
String order,
int n,
double vl,
double vu,
int il,
int iu,
double abstol,
double [] d, int _d_offset,
double [] e, int _e_offset,
intW m,
intW nsplit,
double [] w, int _w_offset,
int [] iblock, int _iblock_offset,
int [] isplit, int _isplit_offset,
double [] work, int _work_offset,
int [] iwork, int _iwork_offset,
intW info)  {

info.val = 0;
// *
// *     Decode RANGE
// *
if ((range.toLowerCase().charAt(0) == "A".toLowerCase().charAt(0)))  {
    irange = 1;
}              // Close if()
else if ((range.toLowerCase().charAt(0) == "V".toLowerCase().charAt(0)))  {
    irange = 2;
}              // Close else if()
else if ((range.toLowerCase().charAt(0) == "I".toLowerCase().charAt(0)))  {
    irange = 3;
}              // Close else if()
else  {
  irange = 0;
}              //  Close else.
// *
// *     Decode ORDER
// *
if ((order.toLowerCase().charAt(0) == "B".toLowerCase().charAt(0)))  {
    iorder = 2;
}              // Close if()
else if ((order.toLowerCase().charAt(0) == "E".toLowerCase().charAt(0)))  {
    iorder = 1;
}              // Close else if()
else  {
  iorder = 0;
}              //  Close else.
// *
// *     Check for Errors
// *
if (irange <= 0)  {
    info.val = -1;
}              // Close if()
else if (iorder <= 0)  {
    info.val = -2;
}              // Close else if()
else if (n < 0)  {
    info.val = -3;
}              // Close else if()
else if (irange == 2 && vl >= vu)  {
    info.val = -5;
}              // Close else if()
else if (irange == 3 && (il < 1 || il > Math.max(1, n) ))  {
    info.val = -6;
}              // Close else if()
else if (irange == 3 && (iu < Math.min(n, il)  || iu > n))  {
    info.val = -7;
}              // Close else if()
// *
if (info.val != 0)  {
    Xerbla.xerbla("DSTEBZ",-info.val);
Dummy.go_to("Dstebz",999999);
}              // Close if()
// *
// *     Initialize error flags
// *
info.val = 0;
ncnvrg = false;
toofew = false;
// *
// *     Quick return if possible
// *
m.val = 0;
if (n == 0)  
    Dummy.go_to("Dstebz",999999);
// *
// *     Simplifications:
// *
if (irange == 3 && il == 1 && iu == n)  
    irange = 1;
// *
// *     Get machine constants
// *     NB is the minimum vector length for vector bisection, or 0
// *     if only scalar is to be done.
// *
safemn = Dlamch.dlamch("S");
ulp = Dlamch.dlamch("P");
rtoli = ulp*relfac;
nb = Ilaenv.ilaenv(1,"DSTEBZ"," ",n,-1,-1,-1);
if (nb <= 1)  
    nb = 0;
// *
// *     Special Case when N=1
// *
if (n == 1)  {
    nsplit.val = 1;
isplit[(1)- 1+ _isplit_offset] = 1;
if (irange == 2 && (vl >= d[(1)- 1+ _d_offset] || vu < d[(1)- 1+ _d_offset]))  {
    m.val = 0;
}              // Close if()
else  {
  w[(1)- 1+ _w_offset] = d[(1)- 1+ _d_offset];
iblock[(1)- 1+ _iblock_offset] = 1;
m.val = 1;
}              //  Close else.
Dummy.go_to("Dstebz",999999);
}              // Close if()
// *
// *     Compute Splitting Points
// *
nsplit.val = 1;
work[(n)- 1+ _work_offset] = zero;
pivmin = one;
// *
{
forloop10:
for (j = 2; j <= n; j++) {
tmp1 = Math.pow(e[(j-1)- 1+ _e_offset], 2);
if (Math.abs(d[(j)- 1+ _d_offset]*d[(j-1)- 1+ _d_offset])*Math.pow(ulp, 2)+safemn > tmp1)  {
    isplit[(nsplit.val)- 1+ _isplit_offset] = j-1;
nsplit.val = nsplit.val+1;
work[(j-1)- 1+ _work_offset] = zero;
}              // Close if()
else  {
  work[(j-1)- 1+ _work_offset] = tmp1;
pivmin = Math.max(pivmin, tmp1) ;
}              //  Close else.
Dummy.label("Dstebz",10);
}              //  Close for() loop. 
}
isplit[(nsplit.val)- 1+ _isplit_offset] = n;
pivmin = pivmin*safemn;
// *
// *     Compute Interval and ATOLI
// *
if (irange == 3)  {
    // *
// *        RANGE='I': Compute the interval containing eigenvalues
// *                   IL through IU.
// *
// *        Compute Gershgorin interval for entire (split) matrix
// *        and use it as the initial interval
// *
gu = d[(1)- 1+ _d_offset];
gl = d[(1)- 1+ _d_offset];
tmp1 = zero;
// *
{
forloop20:
for (j = 1; j <= n-1; j++) {
tmp2 = Math.sqrt(work[(j)- 1+ _work_offset]);
gu = Math.max(gu, d[(j)- 1+ _d_offset]+tmp1+tmp2) ;
gl = Math.min(gl, d[(j)- 1+ _d_offset]-tmp1-tmp2) ;
tmp1 = tmp2;
Dummy.label("Dstebz",20);
}              //  Close for() loop. 
}
// *
gu = Math.max(gu, d[(n)- 1+ _d_offset]+tmp1) ;
gl = Math.min(gl, d[(n)- 1+ _d_offset]-tmp1) ;
tnorm = Math.max(Math.abs(gl), Math.abs(gu)) ;
gl = gl-fudge*tnorm*ulp*n-fudge*two*pivmin;
gu = gu+fudge*tnorm*ulp*n+fudge*pivmin;
// *
// *        Compute Iteration parameters
// *
itmax = (int)((Math.log(tnorm+pivmin)-Math.log(pivmin))/Math.log(two))+2;
if (abstol <= zero)  {
    atoli = ulp*tnorm;
}              // Close if()
else  {
  atoli = abstol;
}              //  Close else.
// *
work[(n+1)- 1+ _work_offset] = gl;
work[(n+2)- 1+ _work_offset] = gl;
work[(n+3)- 1+ _work_offset] = gu;
work[(n+4)- 1+ _work_offset] = gu;
work[(n+5)- 1+ _work_offset] = gl;
work[(n+6)- 1+ _work_offset] = gu;
iwork[(1)- 1+ _iwork_offset] = -1;
iwork[(2)- 1+ _iwork_offset] = -1;
iwork[(3)- 1+ _iwork_offset] = n+1;
iwork[(4)- 1+ _iwork_offset] = n+1;
iwork[(5)- 1+ _iwork_offset] = il-1;
iwork[(6)- 1+ _iwork_offset] = iu;
// *
Dlaebz.dlaebz(3,itmax,n,2,2,nb,atoli,rtoli,pivmin,d,_d_offset,e,_e_offset,work,_work_offset,iwork,(5)- 1+ _iwork_offset,work,(n+1)- 1+ _work_offset,work,(n+5)- 1+ _work_offset,iout,iwork,_iwork_offset,w,_w_offset,iblock,_iblock_offset,iinfo);
// *
if (iwork[(6)- 1+ _iwork_offset] == iu)  {
    wl = work[(n+1)- 1+ _work_offset];
wlu = work[(n+3)- 1+ _work_offset];
nwl = iwork[(1)- 1+ _iwork_offset];
wu = work[(n+4)- 1+ _work_offset];
wul = work[(n+2)- 1+ _work_offset];
nwu = iwork[(4)- 1+ _iwork_offset];
}              // Close if()
else  {
  wl = work[(n+2)- 1+ _work_offset];
wlu = work[(n+4)- 1+ _work_offset];
nwl = iwork[(2)- 1+ _iwork_offset];
wu = work[(n+3)- 1+ _work_offset];
wul = work[(n+1)- 1+ _work_offset];
nwu = iwork[(3)- 1+ _iwork_offset];
}              //  Close else.
// *
if (nwl < 0 || nwl >= n || nwu < 1 || nwu > n)  {
    info.val = 4;
Dummy.go_to("Dstebz",999999);
}              // Close if()
}              // Close if()
else  {
  // *
// *        RANGE='A' or 'V' -- Set ATOLI
// *
tnorm = Math.max(Math.abs(d[(1)- 1+ _d_offset])+Math.abs(e[(1)- 1+ _e_offset]), Math.abs(d[(n)- 1+ _d_offset])+Math.abs(e[(n-1)- 1+ _e_offset])) ;
// *
{
forloop30:
for (j = 2; j <= n-1; j++) {
tnorm = Math.max(tnorm, Math.abs(d[(j)- 1+ _d_offset])+Math.abs(e[(j-1)- 1+ _e_offset])+Math.abs(e[(j)- 1+ _e_offset])) ;
Dummy.label("Dstebz",30);
}              //  Close for() loop. 
}
// *
if (abstol <= zero)  {
    atoli = ulp*tnorm;
}              // Close if()
else  {
  atoli = abstol;
}              //  Close else.
// *
if (irange == 2)  {
    wl = vl;
wu = vu;
}              // Close if()
}              //  Close else.
// *
// *     Find Eigenvalues -- Loop Over Blocks and recompute NWL and NWU.
// *     NWL accumulates the number of eigenvalues .le. WL,
// *     NWU accumulates the number of eigenvalues .le. WU
// *
m.val = 0;
iend = 0;
info.val = 0;
nwl = 0;
nwu = 0;
// *
{
forloop70:
for (jb = 1; jb <= nsplit.val; jb++) {
ioff = iend;
ibegin = ioff+1;
iend = isplit[(jb)- 1+ _isplit_offset];
in = iend-ioff;
// *
if (in == 1)  {
    // *
// *           Special Case -- IN=1
// *
if (irange == 1 || wl >= d[(ibegin)- 1+ _d_offset]-pivmin)  
    nwl = nwl+1;
if (irange == 1 || wu >= d[(ibegin)- 1+ _d_offset]-pivmin)  
    nwu = nwu+1;
if (irange == 1 || (wl < d[(ibegin)- 1+ _d_offset]-pivmin && wu >= d[(ibegin)- 1+ _d_offset]-pivmin))  {
    m.val = m.val+1;
w[(m.val)- 1+ _w_offset] = d[(ibegin)- 1+ _d_offset];
iblock[(m.val)- 1+ _iblock_offset] = jb;
}              // Close if()
}              // Close if()
else  {
  // *
// *           General Case -- IN > 1
// *
// *           Compute Gershgorin Interval
// *           and use it as the initial interval
// *
gu = d[(ibegin)- 1+ _d_offset];
gl = d[(ibegin)- 1+ _d_offset];
tmp1 = zero;
// *
{
forloop40:
for (j = ibegin; j <= iend-1; j++) {
tmp2 = Math.abs(e[(j)- 1+ _e_offset]);
gu = Math.max(gu, d[(j)- 1+ _d_offset]+tmp1+tmp2) ;
gl = Math.min(gl, d[(j)- 1+ _d_offset]-tmp1-tmp2) ;
tmp1 = tmp2;
Dummy.label("Dstebz",40);
}              //  Close for() loop. 
}
// *
gu = Math.max(gu, d[(iend)- 1+ _d_offset]+tmp1) ;
gl = Math.min(gl, d[(iend)- 1+ _d_offset]-tmp1) ;
bnorm = Math.max(Math.abs(gl), Math.abs(gu)) ;
gl = gl-fudge*bnorm*ulp*in-fudge*pivmin;
gu = gu+fudge*bnorm*ulp*in+fudge*pivmin;
// *
// *           Compute ATOLI for the current submatrix
// *
if (abstol <= zero)  {
    atoli = ulp*Math.max(Math.abs(gl), Math.abs(gu)) ;
}              // Close if()
else  {
  atoli = abstol;
}              //  Close else.
// *
if (irange > 1)  {
    if (gu < wl)  {
    nwl = nwl+in;
nwu = nwu+in;
continue forloop70;
}              // Close if()
gl = Math.max(gl, wl) ;
gu = Math.min(gu, wu) ;
if (gl >= gu)  
    continue forloop70;
}              // Close if()
// *
// *           Set Up Initial Interval
// *
work[(n+1)- 1+ _work_offset] = gl;
work[(n+in+1)- 1+ _work_offset] = gu;
Dlaebz.dlaebz(1,0,in,in,1,nb,atoli,rtoli,pivmin,d,(ibegin)- 1+ _d_offset,e,(ibegin)- 1+ _e_offset,work,(ibegin)- 1+ _work_offset,idumma,0,work,(n+1)- 1+ _work_offset,work,(n+2*in+1)- 1+ _work_offset,im,iwork,_iwork_offset,w,(m.val+1)- 1+ _w_offset,iblock,(m.val+1)- 1+ _iblock_offset,iinfo);
// *
nwl = nwl+iwork[(1)- 1+ _iwork_offset];
nwu = nwu+iwork[(in+1)- 1+ _iwork_offset];
iwoff = m.val-iwork[(1)- 1+ _iwork_offset];
// *
// *           Compute Eigenvalues
// *
itmax = (int)((Math.log(gu-gl+pivmin)-Math.log(pivmin))/Math.log(two))+2;
Dlaebz.dlaebz(2,itmax,in,in,1,nb,atoli,rtoli,pivmin,d,(ibegin)- 1+ _d_offset,e,(ibegin)- 1+ _e_offset,work,(ibegin)- 1+ _work_offset,idumma,0,work,(n+1)- 1+ _work_offset,work,(n+2*in+1)- 1+ _work_offset,iout,iwork,_iwork_offset,w,(m.val+1)- 1+ _w_offset,iblock,(m.val+1)- 1+ _iblock_offset,iinfo);
// *
// *           Copy Eigenvalues Into W and IBLOCK
// *           Use -JB for block number for unconverged eigenvalues.
// *
{
forloop60:
for (j = 1; j <= iout.val; j++) {
tmp1 = half*(work[(j+n)- 1+ _work_offset]+work[(j+in+n)- 1+ _work_offset]);
// *
// *              Flag non-convergence.
// *
if (j > iout.val-iinfo.val)  {
    ncnvrg = true;
ib = -jb;
}              // Close if()
else  {
  ib = jb;
}              //  Close else.
{
forloop50:
for (je = iwork[(j)- 1+ _iwork_offset]+1+iwoff; je <= iwork[(j+in)- 1+ _iwork_offset]+iwoff; je++) {
w[(je)- 1+ _w_offset] = tmp1;
iblock[(je)- 1+ _iblock_offset] = ib;
Dummy.label("Dstebz",50);
}              //  Close for() loop. 
}
Dummy.label("Dstebz",60);
}              //  Close for() loop. 
}
// *
m.val = m.val+im.val;
}              //  Close else.
Dummy.label("Dstebz",70);
}              //  Close for() loop. 
}
// *
// *     If RANGE='I', then (WL,WU) contains eigenvalues NWL+1,...,NWU
// *     If NWL+1 < IL or NWU > IU, discard extra eigenvalues.
// *
if (irange == 3)  {
    im.val = 0;
idiscl = il-1-nwl;
idiscu = nwu-iu;
// *
if (idiscl > 0 || idiscu > 0)  {
    {
forloop80:
for (je = 1; je <= m.val; je++) {
if (w[(je)- 1+ _w_offset] <= wlu && idiscl > 0)  {
    idiscl = idiscl-1;
}              // Close if()
else if (w[(je)- 1+ _w_offset] >= wul && idiscu > 0)  {
    idiscu = idiscu-1;
}              // Close else if()
else  {
  im.val = im.val+1;
w[(im.val)- 1+ _w_offset] = w[(je)- 1+ _w_offset];
iblock[(im.val)- 1+ _iblock_offset] = iblock[(je)- 1+ _iblock_offset];
}              //  Close else.
Dummy.label("Dstebz",80);
}              //  Close for() loop. 
}
m.val = im.val;
}              // Close if()
if (idiscl > 0 || idiscu > 0)  {
    // *
// *           Code to deal with effects of bad arithmetic:
// *           Some low eigenvalues to be discarded are not in (WL,WLU],
// *           or high eigenvalues to be discarded are not in (WUL,WU]
// *           so just kill off the smallest IDISCL/largest IDISCU
// *           eigenvalues, by simply finding the smallest/largest
// *           eigenvalue(s).
// *
// *           (If N(w) is monotone non-decreasing, this should never
// *               happen.)
// *
if (idiscl > 0)  {
    wkill = wu;
{
forloop100:
for (jdisc = 1; jdisc <= idiscl; jdisc++) {
iw = 0;
{
forloop90:
for (je = 1; je <= m.val; je++) {
if (iblock[(je)- 1+ _iblock_offset] != 0 && (w[(je)- 1+ _w_offset] < wkill || iw == 0))  {
    iw = je;
wkill = w[(je)- 1+ _w_offset];
}              // Close if()
Dummy.label("Dstebz",90);
}              //  Close for() loop. 
}
iblock[(iw)- 1+ _iblock_offset] = 0;
Dummy.label("Dstebz",100);
}              //  Close for() loop. 
}
}              // Close if()
if (idiscu > 0)  {
    // *
wkill = wl;
{
forloop120:
for (jdisc = 1; jdisc <= idiscu; jdisc++) {
iw = 0;
{
forloop110:
for (je = 1; je <= m.val; je++) {
if (iblock[(je)- 1+ _iblock_offset] != 0 && (w[(je)- 1+ _w_offset] > wkill || iw == 0))  {
    iw = je;
wkill = w[(je)- 1+ _w_offset];
}              // Close if()
Dummy.label("Dstebz",110);
}              //  Close for() loop. 
}
iblock[(iw)- 1+ _iblock_offset] = 0;
Dummy.label("Dstebz",120);
}              //  Close for() loop. 
}
}              // Close if()
im.val = 0;
{
forloop130:
for (je = 1; je <= m.val; je++) {
if (iblock[(je)- 1+ _iblock_offset] != 0)  {
    im.val = im.val+1;
w[(im.val)- 1+ _w_offset] = w[(je)- 1+ _w_offset];
iblock[(im.val)- 1+ _iblock_offset] = iblock[(je)- 1+ _iblock_offset];
}              // Close if()
Dummy.label("Dstebz",130);
}              //  Close for() loop. 
}
m.val = im.val;
}              // Close if()
if (idiscl < 0 || idiscu < 0)  {
    toofew = true;
}              // Close if()
}              // Close if()
// *
// *     If ORDER='B', do nothing -- the eigenvalues are already sorted
// *        by block.
// *     If ORDER='E', sort the eigenvalues from smallest to largest
// *
if (iorder == 1 && nsplit.val > 1)  {
    {
forloop150:
for (je = 1; je <= m.val-1; je++) {
ie = 0;
tmp1 = w[(je)- 1+ _w_offset];
{
forloop140:
for (j = je+1; j <= m.val; j++) {
if (w[(j)- 1+ _w_offset] < tmp1)  {
    ie = j;
tmp1 = w[(j)- 1+ _w_offset];
}              // Close if()
Dummy.label("Dstebz",140);
}              //  Close for() loop. 
}
// *
if (ie != 0)  {
    itmp1 = iblock[(ie)- 1+ _iblock_offset];
w[(ie)- 1+ _w_offset] = w[(je)- 1+ _w_offset];
iblock[(ie)- 1+ _iblock_offset] = iblock[(je)- 1+ _iblock_offset];
w[(je)- 1+ _w_offset] = tmp1;
iblock[(je)- 1+ _iblock_offset] = itmp1;
}              // Close if()
Dummy.label("Dstebz",150);
}              //  Close for() loop. 
}
}              // Close if()
// *
info.val = 0;
if (ncnvrg)  
    info.val = info.val+1;
if (toofew)  
    info.val = info.val+2;
Dummy.go_to("Dstebz",999999);
// *
// *     End of DSTEBZ
// *
Dummy.label("Dstebz",999999);
return;
   }
} // End class.
