/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;

import org.netlib.blas.*;


public class Dstedc {

// *
// *  -- LAPACK routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DSTEDC computes all eigenvalues and, optionally, eigenvectors of a
// *  symmetric tridiagonal matrix using the divide and conquer method.
// *  The eigenvectors of a full or band real symmetric matrix can also be
// *  found if DSYTRD or DSPTRD or DSBTRD has been used to reduce this
// *  matrix to tridiagonal form.
// *
// *  This code makes very mild assumptions about floating point
// *  arithmetic. It will work on machines with a guard digit in
// *  add/subtract, or on those binary machines without guard digits
// *  which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or Cray-2.
// *  It could conceivably fail on hexadecimal or decimal machines
// *  without guard digits, but we know of none.  See DLAED3 for details.
// *
// *  Arguments
// *  =========
// *
// *  COMPZ   (input) CHARACTER*1
// *          = 'N':  Compute eigenvalues only.
// *          = 'I':  Compute eigenvectors of tridiagonal matrix also.
// *          = 'V':  Compute eigenvectors of original dense symmetric
// *                  matrix also.  On entry, Z contains the orthogonal
// *                  matrix used to reduce the original matrix to
// *                  tridiagonal form.
// *
// *  N       (input) INTEGER
// *          The dimension of the symmetric tridiagonal matrix.  N >= 0.
// *
// *  D       (input/output) DOUBLE PRECISION array, dimension (N)
// *          On entry, the diagonal elements of the tridiagonal matrix.
// *          On exit, if INFO = 0, the eigenvalues in ascending order.
// *
// *  E       (input/output) DOUBLE PRECISION array, dimension (N-1)
// *          On entry, the subdiagonal elements of the tridiagonal matrix.
// *          On exit, E has been destroyed.
// *
// *  Z       (input/output) DOUBLE PRECISION array, dimension (LDZ,N)
// *          On entry, if COMPZ = 'V', then Z contains the orthogonal
// *          matrix used in the reduction to tridiagonal form.
// *          On exit, if INFO = 0, then if COMPZ = 'V', Z contains the
// *          orthonormal eigenvectors of the original symmetric matrix,
// *          and if COMPZ = 'I', Z contains the orthonormal eigenvectors
// *          of the symmetric tridiagonal matrix.
// *          If  COMPZ = 'N', then Z is not referenced.
// *
// *  LDZ     (input) INTEGER
// *          The leading dimension of the array Z.  LDZ >= 1.
// *          If eigenvectors are desired, then LDZ >= max(1,N).
// *
// *  WORK    (workspace/output) DOUBLE PRECISION array,
// *                                         dimension (LWORK)
// *          On exit, if LWORK > 0, WORK(1) returns the optimal LWORK.
// *
// *  LWORK   (input) INTEGER
// *          The dimension of the array WORK.
// *          If COMPZ = 'N' or N <= 1 then LWORK must be at least 1.
// *          If COMPZ = 'V' and N > 1 then LWORK must be at least
// *                         ( 1 + 3*N + 2*N*lg N + 3*N**2 ),
// *                         where lg( N ) = smallest integer k such
// *                         that 2**k >= N.
// *          If COMPZ = 'I' and N > 1 then LWORK must be at least
// *                         ( 1 + 3*N + 2*N*lg N + 2*N**2 ).
// *
// *  IWORK   (workspace/output) INTEGER array, dimension (LIWORK)
// *          On exit, if LIWORK > 0, IWORK(1) returns the optimal LIWORK.
// *
// *  LIWORK  (input) INTEGER
// *          The dimension of the array IWORK.
// *          If COMPZ = 'N' or N <= 1 then LIWORK must be at least 1.
// *          If COMPZ = 'V' and N > 1 then LIWORK must be at least
// *                         ( 6 + 6*N + 5*N*lg N ).
// *          If COMPZ = 'I' and N > 1 then LIWORK must be at least
// *                         ( 2 + 5*N ).
// *
// *  INFO    (output) INTEGER
// *          = 0:  successful exit.
// *          < 0:  if INFO = -i, the i-th argument had an illegal value.
// *          > 0:  The algorithm failed to compute an eigenvalue while
// *                working on the submatrix lying in rows and columns
// *                INFO/(N+1) through mod(INFO,N+1).
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static int smlsiz= 25;
static double zero= 0.0e0;
static double one= 1.0e0;
static double two= 2.0e0;
// *     ..
// *     .. Local Scalars ..
static int dtrtrw= 0;
static int end= 0;
static int i= 0;
static int icompz= 0;
static int ii= 0;
static int j= 0;
static int k= 0;
static int lgn= 0;
static int liwmin= 0;
static int lwmin= 0;
static int m= 0;
static int start= 0;
static int storez= 0;
static double eps= 0.0;
static double orgnrm= 0.0;
static double p= 0.0;
static double tiny= 0.0;
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Test the input parameters.
// *

public static void dstedc (String compz,
int n,
double [] d, int _d_offset,
double [] e, int _e_offset,
double [] z, int _z_offset,
int ldz,
double [] work, int _work_offset,
int lwork,
int [] iwork, int _iwork_offset,
int liwork,
intW info)  {

info.val = 0;
// *
if ((compz.toLowerCase().charAt(0) == "N".toLowerCase().charAt(0)))  {
    icompz = 0;
}              // Close if()
else if ((compz.toLowerCase().charAt(0) == "V".toLowerCase().charAt(0)))  {
    icompz = 1;
}              // Close else if()
else if ((compz.toLowerCase().charAt(0) == "I".toLowerCase().charAt(0)))  {
    icompz = 2;
}              // Close else if()
else  {
  icompz = -1;
}              //  Close else.
if (n <= 1 || icompz <= 0)  {
    liwmin = 1;
lwmin = 1;
}              // Close if()
else  {
  lgn = (int)(Math.log((double)(n))/Math.log(two));
if (Math.pow(2, lgn) < n)  
    lgn = lgn+1;
if (Math.pow(2, lgn) < n)  
    lgn = lgn+1;
if (icompz == 1)  {
    lwmin = (int)(1+3*n+2*n*lgn+3*Math.pow(n, 2));
liwmin = 6+6*n+5*n*lgn;
}              // Close if()
else if (icompz == 2)  {
    lwmin = (int)(1+3*n+2*n*lgn+2*Math.pow(n, 2));
liwmin = 2+5*n;
}              // Close else if()
}              //  Close else.
if (icompz < 0)  {
    info.val = -1;
}              // Close if()
else if (n < 0)  {
    info.val = -2;
}              // Close else if()
else if ((ldz < 1) || (icompz > 0 && ldz < Math.max(1, n) ))  {
    info.val = -6;
}              // Close else if()
else if (lwork < lwmin)  {
    info.val = -8;
}              // Close else if()
else if (liwork < liwmin)  {
    info.val = -10;
}              // Close else if()
if (info.val != 0)  {
    Xerbla.xerbla("DSTEDC",-info.val);
Dummy.go_to("Dstedc",50);
}              // Close if()
// *
// *     Quick return if possible
// *
if (n == 0)  
    Dummy.go_to("Dstedc",50);
if (n == 1)  {
    if (icompz != 0)  
    z[(1)- 1+(1- 1)*ldz+ _z_offset] = one;
Dummy.go_to("Dstedc",50);
}              // Close if()
// *
// *     If the following conditional clause is removed, then the routine
// *     will use the Divide and Conquer routine to compute only the
// *     eigenvalues, which requires (3N + 3N**2) real workspace and
// *     (2 + 5N + 2N lg(N)) integer workspace.
// *     Since on many architectures DSTERF is much faster than any other
// *     algorithm for finding eigenvalues only, it is used here
// *     as the default.
// *
// *     If COMPZ = 'N', use DSTERF to compute the eigenvalues.
// *
if (icompz == 0)  {
    Dsterf.dsterf(n,d,_d_offset,e,_e_offset,info);
Dummy.go_to("Dstedc",50);
}              // Close if()
// *
// *     If N is smaller than the minimum divide size (SMLSIZ+1), then
// *     solve the problem with another solver.
// *
if (n <= smlsiz)  {
    if (icompz == 0)  {
    Dsterf.dsterf(n,d,_d_offset,e,_e_offset,info);
Dummy.go_to("Dstedc",50);
}              // Close if()
else if (icompz == 2)  {
    Dsteqr.dsteqr("I",n,d,_d_offset,e,_e_offset,z,_z_offset,ldz,work,_work_offset,info);
Dummy.go_to("Dstedc",50);
}              // Close else if()
else  {
  Dsteqr.dsteqr("V",n,d,_d_offset,e,_e_offset,z,_z_offset,ldz,work,_work_offset,info);
Dummy.go_to("Dstedc",50);
}              //  Close else.
}              // Close if()
// *
// *     If COMPZ = 'V', the Z matrix must be stored elsewhere for later
// *     use.
// *
if (icompz == 1)  {
    storez = 1+n*n;
}              // Close if()
else  {
  storez = 1;
}              //  Close else.
// *
if (icompz == 2)  {
    Dlaset.dlaset("Full",n,n,zero,one,z,_z_offset,ldz);
}              // Close if()
// *
// *     Scale.
// *
orgnrm = Dlanst.dlanst("M",n,d,_d_offset,e,_e_offset);
if (orgnrm == zero)  
    Dummy.go_to("Dstedc",50);
// *
eps = Dlamch.dlamch("Epsilon");
// *
start = 1;
// *
// *     while ( START <= N )
// *
label10:
   Dummy.label("Dstedc",10);
while (start <= n)  {
    // *
// *     Let END be the position of the next subdiagonal entry such that
// *     E( END ) <= TINY or END = N if no such subdiagonal exists.  The
// *     matrix identified by the elements between START and END
// *     constitutes an independent sub-problem.
// *
end = start;
label20:
   Dummy.label("Dstedc",20);
if (end < n)  {
    tiny = eps*Math.sqrt(Math.abs(d[(end)- 1+ _d_offset]))*Math.sqrt(Math.abs(d[(end+1)- 1+ _d_offset]));
if (Math.abs(e[(end)- 1+ _e_offset]) > tiny)  {
    end = end+1;
Dummy.go_to("Dstedc",20);
}              // Close if()
}              // Close if()
// *
// *        (Sub) Problem determined.  Compute its size and solve it.
// *
m = end-start+1;
if (m == 1)  {
    start = end+1;
// goto 10 (end while)
}              // Close if()
if (m > smlsiz)  {
    info.val = smlsiz;
// *
// *           Scale.
// *
orgnrm = Dlanst.dlanst("M",m,d,(start)- 1+ _d_offset,e,(start)- 1+ _e_offset);
Dlascl.dlascl("G",0,0,orgnrm,one,m,1,d,(start)- 1+ _d_offset,m,info);
Dlascl.dlascl("G",0,0,orgnrm,one,m-1,1,e,(start)- 1+ _e_offset,m-1,info);
// *
if (icompz == 1)  {
    dtrtrw = 1;
}              // Close if()
else  {
  dtrtrw = start;
}              //  Close else.
Dlaed0.dlaed0(icompz,n,m,d,(start)- 1+ _d_offset,e,(start)- 1+ _e_offset,z,(dtrtrw)- 1+(start- 1)*ldz+ _z_offset,ldz,work,(1)- 1+ _work_offset,n,work,(storez)- 1+ _work_offset,iwork,_iwork_offset,info);
if (info.val != 0)  {
    info.val = (info.val/(m+1)+start-1)*(n+1)+(info.val)%((m+1)) +start-1;
Dummy.go_to("Dstedc",50);
}              // Close if()
// *
// *           Scale back.
// *
Dlascl.dlascl("G",0,0,one,orgnrm,m,1,d,(start)- 1+ _d_offset,m,info);
// *
}              // Close if()
else  {
  if (icompz == 1)  {
    // *
// *     Since QR won't update a Z matrix which is larger than the
// *     length of D, we must solve the sub-problem in a workspace and
// *     then multiply back into Z.
// *
Dsteqr.dsteqr("I",m,d,(start)- 1+ _d_offset,e,(start)- 1+ _e_offset,work,_work_offset,m,work,(m*m+1)- 1+ _work_offset,info);
Dlacpy.dlacpy("A",n,m,z,(1)- 1+(start- 1)*ldz+ _z_offset,ldz,work,(storez)- 1+ _work_offset,n);
Dgemm.dgemm("N","N",n,m,m,one,work,(storez)- 1+ _work_offset,ldz,work,_work_offset,m,zero,z,(1)- 1+(start- 1)*ldz+ _z_offset,ldz);
}              // Close if()
else if (icompz == 2)  {
    Dsteqr.dsteqr("I",m,d,(start)- 1+ _d_offset,e,(start)- 1+ _e_offset,z,(start)- 1+(start- 1)*ldz+ _z_offset,ldz,work,_work_offset,info);
}              // Close else if()
else  {
  Dsterf.dsterf(m,d,(start)- 1+ _d_offset,e,(start)- 1+ _e_offset,info);
}              //  Close else.
if (info.val != 0)  {
    info.val = start*(n+1)+end;
Dummy.go_to("Dstedc",50);
}              // Close if()
}              //  Close else.
// *
start = end+1;
// goto 10 (end while)
}              // Close if()
// *
// *     endwhile
// *
// *     If the problem split any number of times, then the eigenvalues
// *     will not be properly ordered.  Here we permute the eigenvalues
// *     (and the associated eigenvectors) into ascending order.
// *
if (m != n)  {
    if (icompz == 0)  {
    // *
// *        Use Quick Sort
// *
Dlasrt.dlasrt("I",n,d,_d_offset,info);
// *
}              // Close if()
else  {
  // *
// *        Use Selection Sort to minimize swaps of eigenvectors
// *
{
forloop40:
for (ii = 2; ii <= n; ii++) {
i = ii-1;
k = i;
p = d[(i)- 1+ _d_offset];
{
forloop30:
for (j = ii; j <= n; j++) {
if (d[(j)- 1+ _d_offset] < p)  {
    k = j;
p = d[(j)- 1+ _d_offset];
}              // Close if()
Dummy.label("Dstedc",30);
}              //  Close for() loop. 
}
if (k != i)  {
    d[(k)- 1+ _d_offset] = d[(i)- 1+ _d_offset];
d[(i)- 1+ _d_offset] = p;
Dswap.dswap(n,z,(1)- 1+(i- 1)*ldz+ _z_offset,1,z,(1)- 1+(k- 1)*ldz+ _z_offset,1);
}              // Close if()
Dummy.label("Dstedc",40);
}              //  Close for() loop. 
}
}              //  Close else.
}              // Close if()
// *
label50:
   Dummy.label("Dstedc",50);
if (lwork > 0)  
    work[(1)- 1+ _work_offset] = (double)(lwmin);
if (liwork > 0)  
    iwork[(1)- 1+ _iwork_offset] = liwmin;
Dummy.go_to("Dstedc",999999);
// *
// *     End of DSTEDC
// *
Dummy.label("Dstedc",999999);
return;
   }
} // End class.
