/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;

import org.netlib.blas.*;


public class Dstein {

// *
// *  -- LAPACK routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DSTEIN computes the eigenvectors of a real symmetric tridiagonal
// *  matrix T corresponding to specified eigenvalues, using inverse
// *  iteration.
// *
// *  The maximum number of iterations allowed for each eigenvector is
// *  specified by an internal parameter MAXITS (currently set to 5).
// *
// *  Arguments
// *  =========
// *
// *  N       (input) INTEGER
// *          The order of the matrix.  N >= 0.
// *
// *  D       (input) DOUBLE PRECISION array, dimension (N)
// *          The n diagonal elements of the tridiagonal matrix T.
// *
// *  E       (input) DOUBLE PRECISION array, dimension (N)
// *          The (n-1) subdiagonal elements of the tridiagonal matrix
// *          T, in elements 1 to N-1.  E(N) need not be set.
// *
// *  M       (input) INTEGER
// *          The number of eigenvectors to be found.  0 <= M <= N.
// *
// *  W       (input) DOUBLE PRECISION array, dimension (N)
// *          The first M elements of W contain the eigenvalues for
// *          which eigenvectors are to be computed.  The eigenvalues
// *          should be grouped by split-off block and ordered from
// *          smallest to largest within the block.  ( The output array
// *          W from DSTEBZ with ORDER = 'B' is expected here. )
// *
// *  IBLOCK  (input) INTEGER array, dimension (N)
// *          The submatrix indices associated with the corresponding
// *          eigenvalues in W; IBLOCK(i)=1 if eigenvalue W(i) belongs to
// *          the first submatrix from the top, =2 if W(i) belongs to
// *          the second submatrix, etc.  ( The output array IBLOCK
// *          from DSTEBZ is expected here. )
// *
// *  ISPLIT  (input) INTEGER array, dimension (N)
// *          The splitting points, at which T breaks up into submatrices.
// *          The first submatrix consists of rows/columns 1 to
// *          ISPLIT( 1 ), the second of rows/columns ISPLIT( 1 )+1
// *          through ISPLIT( 2 ), etc.
// *          ( The output array ISPLIT from DSTEBZ is expected here. )
// *
// *  Z       (output) DOUBLE PRECISION array, dimension (LDZ, M)
// *          The computed eigenvectors.  The eigenvector associated
// *          with the eigenvalue W(i) is stored in the i-th column of
// *          Z.  Any vector which fails to converge is set to its current
// *          iterate after MAXITS iterations.
// *
// *  LDZ     (input) INTEGER
// *          The leading dimension of the array Z.  LDZ >= max(1,N).
// *
// *  WORK    (workspace) DOUBLE PRECISION array, dimension (5*N)
// *
// *  IWORK   (workspace) INTEGER array, dimension (N)
// *
// *  IFAIL   (output) INTEGER array, dimension (M)
// *          On normal exit, all elements of IFAIL are zero.
// *          If one or more eigenvectors fail to converge after
// *          MAXITS iterations, then their indices are stored in
// *          array IFAIL.
// *
// *  INFO    (output) INTEGER
// *          = 0: successful exit.
// *          < 0: if INFO = -i, the i-th argument had an illegal value
// *          > 0: if INFO = i, then i eigenvectors failed to converge
// *               in MAXITS iterations.  Their indices are stored in
// *               array IFAIL.
// *
// *  Internal Parameters
// *  ===================
// *
// *  MAXITS  INTEGER, default = 5
// *          The maximum number of iterations performed.
// *
// *  EXTRA   INTEGER, default = 2
// *          The number of iterations performed after norm growth
// *          criterion is satisfied, should be at least 1.
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double zero= 0.0e+0;
static double one= 1.0e+0;
static double ten= 1.0e+1;
static double odm3= 1.0e-3;
static double odm1= 1.0e-1;
static int maxits= 5;
static int extra= 2;
// *     ..
// *     .. Local Scalars ..
static int b1= 0;
static int blksiz= 0;
static int bn= 0;
static int gpind= 0;
static int i= 0;
static intW iinfo= new intW(0);
static int indrv1= 0;
static int indrv2= 0;
static int indrv3= 0;
static int indrv4= 0;
static int indrv5= 0;
static int its= 0;
static int j= 0;
static int j1= 0;
static int jblk= 0;
static int jmax= 0;
static int nblk= 0;
static int nrmchk= 0;
static double dtpcrt= 0.0;
static double eps= 0.0;
static double eps1= 0.0;
static double nrm= 0.0;
static double onenrm= 0.0;
static double ortol= 0.0;
static double pertol= 0.0;
static double scl= 0.0;
static double sep= 0.0;
static doubleW tol= new doubleW(0.0);
static double xj= 0.0;
static double xjm= 0.0;
static double ztr= 0.0;
// *     ..
// *     .. Local Arrays ..
static int [] iseed= new int[(4)];
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Test the input parameters.
// *

public static void dstein (int n,
double [] d, int _d_offset,
double [] e, int _e_offset,
int m,
double [] w, int _w_offset,
int [] iblock, int _iblock_offset,
int [] isplit, int _isplit_offset,
double [] z, int _z_offset,
int ldz,
double [] work, int _work_offset,
int [] iwork, int _iwork_offset,
int [] ifail, int _ifail_offset,
intW info)  {

info.val = 0;
{
forloop10:
for (i = 1; i <= m; i++) {
ifail[(i)- 1+ _ifail_offset] = 0;
Dummy.label("Dstein",10);
}              //  Close for() loop. 
}
// *
if (n < 0)  {
    info.val = -1;
}              // Close if()
else if (m < 0 || m > n)  {
    info.val = -4;
}              // Close else if()
else if (ldz < Math.max(1, n) )  {
    info.val = -9;
}              // Close else if()
else  {
  {
forloop20:
for (j = 2; j <= m; j++) {
if (iblock[(j)- 1+ _iblock_offset] < iblock[(j-1)- 1+ _iblock_offset])  {
    info.val = -6;
Dummy.go_to("Dstein",30);
}              // Close if()
if (iblock[(j)- 1+ _iblock_offset] == iblock[(j-1)- 1+ _iblock_offset] && w[(j)- 1+ _w_offset] < w[(j-1)- 1+ _w_offset])  {
    info.val = -5;
Dummy.go_to("Dstein",30);
}              // Close if()
Dummy.label("Dstein",20);
}              //  Close for() loop. 
}
label30:
   Dummy.label("Dstein",30);
}              //  Close else.
// *
if (info.val != 0)  {
    Xerbla.xerbla("DSTEIN",-info.val);
Dummy.go_to("Dstein",999999);
}              // Close if()
// *
// *     Quick return if possible
// *
if (n == 0 || m == 0)  {
    Dummy.go_to("Dstein",999999);
}              // Close if()
else if (n == 1)  {
    z[(1)- 1+(1- 1)*ldz+ _z_offset] = one;
Dummy.go_to("Dstein",999999);
}              // Close else if()
// *
// *     Get machine constants.
// *
eps = Dlamch.dlamch("Precision");
// *
// *     Initialize seed for random number generator DLARNV.
// *
{
forloop40:
for (i = 1; i <= 4; i++) {
iseed[(i)- 1] = 1;
Dummy.label("Dstein",40);
}              //  Close for() loop. 
}
// *
// *     Initialize pointers.
// *
indrv1 = 0;
indrv2 = indrv1+n;
indrv3 = indrv2+n;
indrv4 = indrv3+n;
indrv5 = indrv4+n;
// *
// *     Compute eigenvectors of matrix blocks.
// *
j1 = 1;
{
forloop160:
for (nblk = 1; nblk <= iblock[(m)- 1+ _iblock_offset]; nblk++) {
// *
// *        Find starting and ending indices of block nblk.
// *
if (nblk == 1)  {
    b1 = 1;
}              // Close if()
else  {
  b1 = isplit[(nblk-1)- 1+ _isplit_offset]+1;
}              //  Close else.
bn = isplit[(nblk)- 1+ _isplit_offset];
blksiz = bn-b1+1;
if (blksiz == 1)  
    Dummy.go_to("Dstein",60);
gpind = b1;
// *
// *        Compute reorthogonalization criterion and stopping criterion.
// *
onenrm = Math.abs(d[(b1)- 1+ _d_offset])+Math.abs(e[(b1)- 1+ _e_offset]);
onenrm = Math.max(onenrm, Math.abs(d[(bn)- 1+ _d_offset])+Math.abs(e[(bn-1)- 1+ _e_offset])) ;
{
forloop50:
for (i = b1+1; i <= bn-1; i++) {
onenrm = Math.max(onenrm, Math.abs(d[(i)- 1+ _d_offset])+Math.abs(e[(i-1)- 1+ _e_offset])+Math.abs(e[(i)- 1+ _e_offset])) ;
Dummy.label("Dstein",50);
}              //  Close for() loop. 
}
ortol = odm3*onenrm;
// *
dtpcrt = Math.sqrt(odm1/blksiz);
// *
// *        Loop through eigenvalues of block nblk.
// *
label60:
   Dummy.label("Dstein",60);
jblk = 0;
{
forloop150:
for (j = j1; j <= m; j++) {
if (iblock[(j)- 1+ _iblock_offset] != nblk)  {
    j1 = j;
continue forloop160;
}              // Close if()
jblk = jblk+1;
xj = w[(j)- 1+ _w_offset];
// *
// *           Skip all the work if the block size is one.
// *
if (blksiz == 1)  {
    work[(indrv1+1)- 1+ _work_offset] = one;
Dummy.go_to("Dstein",120);
}              // Close if()
// *
// *           If eigenvalues j and j-1 are too close, add a relatively
// *           small perturbation.
// *
if (jblk > 1)  {
    eps1 = Math.abs(eps*xj);
pertol = ten*eps1;
sep = xj-xjm;
if (sep < pertol)  
    xj = xjm+pertol;
}              // Close if()
// *
its = 0;
nrmchk = 0;
// *
// *           Get random starting vector.
// *
Dlarnv.dlarnv(2,iseed,0,blksiz,work,(indrv1+1)- 1+ _work_offset);
// *
// *           Copy the matrix T so it won't be destroyed in factorization.
// *
Dcopy.dcopy(blksiz,d,(b1)- 1+ _d_offset,1,work,(indrv4+1)- 1+ _work_offset,1);
Dcopy.dcopy(blksiz-1,e,(b1)- 1+ _e_offset,1,work,(indrv2+2)- 1+ _work_offset,1);
Dcopy.dcopy(blksiz-1,e,(b1)- 1+ _e_offset,1,work,(indrv3+1)- 1+ _work_offset,1);
// *
// *           Compute LU factors with partial pivoting  ( PT = LU )
// *
tol.val = zero;
Dlagtf.dlagtf(blksiz,work,(indrv4+1)- 1+ _work_offset,xj,work,(indrv2+2)- 1+ _work_offset,work,(indrv3+1)- 1+ _work_offset,tol.val,work,(indrv5+1)- 1+ _work_offset,iwork,_iwork_offset,iinfo);
// *
// *           Update iteration count.
// *
label70:
   Dummy.label("Dstein",70);
its = its+1;
if (its > maxits)  
    Dummy.go_to("Dstein",100);
// *
// *           Normalize and scale the righthand side vector Pb.
// *
scl = blksiz*onenrm*Math.max(eps, Math.abs(work[(indrv4+blksiz)- 1+ _work_offset])) /Dasum.dasum(blksiz,work,(indrv1+1)- 1+ _work_offset,1);
Dscal.dscal(blksiz,scl,work,(indrv1+1)- 1+ _work_offset,1);
// *
// *           Solve the system LU = Pb.
// *
Dlagts.dlagts(-1,blksiz,work,(indrv4+1)- 1+ _work_offset,work,(indrv2+2)- 1+ _work_offset,work,(indrv3+1)- 1+ _work_offset,work,(indrv5+1)- 1+ _work_offset,iwork,_iwork_offset,work,(indrv1+1)- 1+ _work_offset,tol,iinfo);
// *
// *           Reorthogonalize by modified Gram-Schmidt if eigenvalues are
// *           close enough.
// *
if (jblk == 1)  
    Dummy.go_to("Dstein",90);
if (Math.abs(xj-xjm) > ortol)  
    gpind = j;
if (gpind != j)  {
    {
forloop80:
for (i = gpind; i <= j-1; i++) {
ztr = -Ddot.ddot(blksiz,work,(indrv1+1)- 1+ _work_offset,1,z,(b1)- 1+(i- 1)*ldz+ _z_offset,1);
Daxpy.daxpy(blksiz,ztr,z,(b1)- 1+(i- 1)*ldz+ _z_offset,1,work,(indrv1+1)- 1+ _work_offset,1);
Dummy.label("Dstein",80);
}              //  Close for() loop. 
}
}              // Close if()
// *
// *           Check the infinity norm of the iterate.
// *
label90:
   Dummy.label("Dstein",90);
jmax = Idamax.idamax(blksiz,work,(indrv1+1)- 1+ _work_offset,1);
nrm = Math.abs(work[(indrv1+jmax)- 1+ _work_offset]);
// *
// *           Continue for additional iterations after norm reaches
// *           stopping criterion.
// *
if (nrm < dtpcrt)  
    Dummy.go_to("Dstein",70);
nrmchk = nrmchk+1;
if (nrmchk < extra+1)  
    Dummy.go_to("Dstein",70);
// *
Dummy.go_to("Dstein",110);
// *
// *           If stopping criterion was not satisfied, update info and
// *           store eigenvector number in array ifail.
// *
label100:
   Dummy.label("Dstein",100);
info.val = info.val+1;
ifail[(info.val)- 1+ _ifail_offset] = j;
// *
// *           Accept iterate as jth eigenvector.
// *
label110:
   Dummy.label("Dstein",110);
scl = one/Dnrm2.dnrm2(blksiz,work,(indrv1+1)- 1+ _work_offset,1);
jmax = Idamax.idamax(blksiz,work,(indrv1+1)- 1+ _work_offset,1);
if (work[(indrv1+jmax)- 1+ _work_offset] < zero)  
    scl = -scl;
Dscal.dscal(blksiz,scl,work,(indrv1+1)- 1+ _work_offset,1);
label120:
   Dummy.label("Dstein",120);
{
forloop130:
for (i = 1; i <= n; i++) {
z[(i)- 1+(j- 1)*ldz+ _z_offset] = zero;
Dummy.label("Dstein",130);
}              //  Close for() loop. 
}
{
forloop140:
for (i = 1; i <= blksiz; i++) {
z[(b1+i-1)- 1+(j- 1)*ldz+ _z_offset] = work[(indrv1+i)- 1+ _work_offset];
Dummy.label("Dstein",140);
}              //  Close for() loop. 
}
// *
// *           Save the shift to check eigenvalue spacing at next
// *           iteration.
// *
xjm = xj;
// *
Dummy.label("Dstein",150);
}              //  Close for() loop. 
}
Dummy.label("Dstein",160);
}              //  Close for() loop. 
}
// *
Dummy.go_to("Dstein",999999);
// *
// *     End of DSTEIN
// *
Dummy.label("Dstein",999999);
return;
   }
} // End class.
