/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;

import org.netlib.blas.*;


public class Dsteqr {

// *
// *  -- LAPACK routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DSTEQR computes all eigenvalues and, optionally, eigenvectors of a
// *  symmetric tridiagonal matrix using the implicit QL or QR method.
// *  The eigenvectors of a full or band symmetric matrix can also be found
// *  if DSYTRD or DSPTRD or DSBTRD has been used to reduce this matrix to
// *  tridiagonal form.
// *
// *  Arguments
// *  =========
// *
// *  COMPZ   (input) CHARACTER*1
// *          = 'N':  Compute eigenvalues only.
// *          = 'V':  Compute eigenvalues and eigenvectors of the original
// *                  symmetric matrix.  On entry, Z must contain the
// *                  orthogonal matrix used to reduce the original matrix
// *                  to tridiagonal form.
// *          = 'I':  Compute eigenvalues and eigenvectors of the
// *                  tridiagonal matrix.  Z is initialized to the identity
// *                  matrix.
// *
// *  N       (input) INTEGER
// *          The order of the matrix.  N >= 0.
// *
// *  D       (input/output) DOUBLE PRECISION array, dimension (N)
// *          On entry, the diagonal elements of the tridiagonal matrix.
// *          On exit, if INFO = 0, the eigenvalues in ascending order.
// *
// *  E       (input/output) DOUBLE PRECISION array, dimension (N-1)
// *          On entry, the (n-1) subdiagonal elements of the tridiagonal
// *          matrix.
// *          On exit, E has been destroyed.
// *
// *  Z       (input/output) DOUBLE PRECISION array, dimension (LDZ, N)
// *          On entry, if  COMPZ = 'V', then Z contains the orthogonal
// *          matrix used in the reduction to tridiagonal form.
// *          On exit, if INFO = 0, then if  COMPZ = 'V', Z contains the
// *          orthonormal eigenvectors of the original symmetric matrix,
// *          and if COMPZ = 'I', Z contains the orthonormal eigenvectors
// *          of the symmetric tridiagonal matrix.
// *          If COMPZ = 'N', then Z is not referenced.
// *
// *  LDZ     (input) INTEGER
// *          The leading dimension of the array Z.  LDZ >= 1, and if
// *          eigenvectors are desired, then  LDZ >= max(1,N).
// *
// *  WORK    (workspace) DOUBLE PRECISION array, dimension (max(1,2*N-2))
// *          If COMPZ = 'N', then WORK is not referenced.
// *
// *  INFO    (output) INTEGER
// *          = 0:  successful exit
// *          < 0:  if INFO = -i, the i-th argument had an illegal value
// *          > 0:  the algorithm has failed to find all the eigenvalues in
// *                a total of 30*N iterations; if INFO = i, then i
// *                elements of E have not converged to zero; on exit, D
// *                and E contain the elements of a symmetric tridiagonal
// *                matrix which is orthogonally similar to the original
// *                matrix.
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double zero= 0.0e0;
static double one= 1.0e0;
static double two= 2.0e0;
static double three= 3.0e0;
static int maxit= 30;
// *     ..
// *     .. Local Scalars ..
static int i= 0;
static int icompz= 0;
static int ii= 0;
static int iscale= 0;
static int j= 0;
static int jtot= 0;
static int k= 0;
static int l= 0;
static int l1= 0;
static int lend= 0;
static int lendm1= 0;
static int lendp1= 0;
static int lendsv= 0;
static int lm1= 0;
static int lsv= 0;
static int m= 0;
static int mm= 0;
static int mm1= 0;
static int nm1= 0;
static int nmaxit= 0;
static double anorm= 0.0;
static double b= 0.0;
static doubleW c= new doubleW(0.0);
static double eps= 0.0;
static double eps2= 0.0;
static double f= 0.0;
static double g= 0.0;
static double p= 0.0;
static doubleW r= new doubleW(0.0);
static doubleW rt1= new doubleW(0.0);
static doubleW rt2= new doubleW(0.0);
static doubleW s= new doubleW(0.0);
static double safmax= 0.0;
static double safmin= 0.0;
static double ssfmax= 0.0;
static double ssfmin= 0.0;
static double tst= 0.0;
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Test the input parameters.
// *

public static void dsteqr (String compz,
int n,
double [] d, int _d_offset,
double [] e, int _e_offset,
double [] z, int _z_offset,
int ldz,
double [] work, int _work_offset,
intW info)  {

info.val = 0;
// *
if ((compz.toLowerCase().charAt(0) == "N".toLowerCase().charAt(0)))  {
    icompz = 0;
}              // Close if()
else if ((compz.toLowerCase().charAt(0) == "V".toLowerCase().charAt(0)))  {
    icompz = 1;
}              // Close else if()
else if ((compz.toLowerCase().charAt(0) == "I".toLowerCase().charAt(0)))  {
    icompz = 2;
}              // Close else if()
else  {
  icompz = -1;
}              //  Close else.
if (icompz < 0)  {
    info.val = -1;
}              // Close if()
else if (n < 0)  {
    info.val = -2;
}              // Close else if()
else if ((ldz < 1) || (icompz > 0 && ldz < Math.max(1, n) ))  {
    info.val = -6;
}              // Close else if()
if (info.val != 0)  {
    Xerbla.xerbla("DSTEQR",-info.val);
Dummy.go_to("Dsteqr",999999);
}              // Close if()
// *
// *     Quick return if possible
// *
if (n == 0)  
    Dummy.go_to("Dsteqr",999999);
// *
if (n == 1)  {
    if (icompz == 2)  
    z[(1)- 1+(1- 1)*ldz+ _z_offset] = one;
Dummy.go_to("Dsteqr",999999);
}              // Close if()
// *
// *     Determine the unit roundoff and over/underflow thresholds.
// *
eps = Dlamch.dlamch("E");
eps2 = Math.pow(eps, 2);
safmin = Dlamch.dlamch("S");
safmax = one/safmin;
ssfmax = Math.sqrt(safmax)/three;
ssfmin = Math.sqrt(safmin)/eps2;
// *
// *     Compute the eigenvalues and eigenvectors of the tridiagonal
// *     matrix.
// *
if (icompz == 2)  
    Dlaset.dlaset("Full",n,n,zero,one,z,_z_offset,ldz);
// *
nmaxit = n*maxit;
jtot = 0;
// *
// *     Determine where the matrix splits and choose QL or QR iteration
// *     for each block, according to whether top or bottom diagonal
// *     element is smaller.
// *
l1 = 1;
nm1 = n-1;
// *
label10:
   Dummy.label("Dsteqr",10);
if (l1 > n)  
    Dummy.go_to("Dsteqr",160);
if (l1 > 1)  
    e[(l1-1)- 1+ _e_offset] = zero;
if (l1 <= nm1)  {
    {
forloop20:
for (m = l1; m <= nm1; m++) {
tst = Math.abs(e[(m)- 1+ _e_offset]);
if (tst == zero)  
    Dummy.go_to("Dsteqr",30);
if (tst <= (Math.sqrt(Math.abs(d[(m)- 1+ _d_offset]))*Math.sqrt(Math.abs(d[(m+1)- 1+ _d_offset])))*eps)  {
    e[(m)- 1+ _e_offset] = zero;
Dummy.go_to("Dsteqr",30);
}              // Close if()
Dummy.label("Dsteqr",20);
}              //  Close for() loop. 
}
}              // Close if()
m = n;
// *
label30:
   Dummy.label("Dsteqr",30);
l = l1;
lsv = l;
lend = m;
lendsv = lend;
l1 = m+1;
if (lend == l)  
    Dummy.go_to("Dsteqr",10);
// *
// *     Scale submatrix in rows and columns L to LEND
// *
anorm = Dlanst.dlanst("I",lend-l+1,d,(l)- 1+ _d_offset,e,(l)- 1+ _e_offset);
iscale = 0;
if (anorm == zero)  
    Dummy.go_to("Dsteqr",10);
if (anorm > ssfmax)  {
    iscale = 1;
Dlascl.dlascl("G",0,0,anorm,ssfmax,lend-l+1,1,d,(l)- 1+ _d_offset,n,info);
Dlascl.dlascl("G",0,0,anorm,ssfmax,lend-l,1,e,(l)- 1+ _e_offset,n,info);
}              // Close if()
else if (anorm < ssfmin)  {
    iscale = 2;
Dlascl.dlascl("G",0,0,anorm,ssfmin,lend-l+1,1,d,(l)- 1+ _d_offset,n,info);
Dlascl.dlascl("G",0,0,anorm,ssfmin,lend-l,1,e,(l)- 1+ _e_offset,n,info);
}              // Close else if()
// *
// *     Choose between QL and QR iteration
// *
if (Math.abs(d[(lend)- 1+ _d_offset]) < Math.abs(d[(l)- 1+ _d_offset]))  {
    lend = lsv;
l = lendsv;
}              // Close if()
// *
if (lend > l)  {
    // *
// *        QL Iteration
// *
// *        Look for small subdiagonal element.
// *
label40:
   Dummy.label("Dsteqr",40);
if (l != lend)  {
    lendm1 = lend-1;
{
forloop50:
for (m = l; m <= lendm1; m++) {
tst = Math.pow(Math.abs(e[(m)- 1+ _e_offset]), 2);
if (tst <= (eps2*Math.abs(d[(m)- 1+ _d_offset]))*Math.abs(d[(m+1)- 1+ _d_offset])+safmin)  
    Dummy.go_to("Dsteqr",60);
Dummy.label("Dsteqr",50);
}              //  Close for() loop. 
}
}              // Close if()
// *
m = lend;
// *
label60:
   Dummy.label("Dsteqr",60);
if (m < lend)  
    e[(m)- 1+ _e_offset] = zero;
p = d[(l)- 1+ _d_offset];
if (m == l)  
    Dummy.go_to("Dsteqr",80);
// *
// *        If remaining matrix is 2-by-2, use DLAE2 or SLAEV2
// *        to compute its eigensystem.
// *
if (m == l+1)  {
    if (icompz > 0)  {
    Dlaev2.dlaev2(d[(l)- 1+ _d_offset],e[(l)- 1+ _e_offset],d[(l+1)- 1+ _d_offset],rt1,rt2,c,s);
work[(l)- 1+ _work_offset] = c.val;
work[(n-1+l)- 1+ _work_offset] = s.val;
Dlasr.dlasr("R","V","B",n,2,work,(l)- 1+ _work_offset,work,(n-1+l)- 1+ _work_offset,z,(1)- 1+(l- 1)*ldz+ _z_offset,ldz);
}              // Close if()
else  {
  Dlae2.dlae2(d[(l)- 1+ _d_offset],e[(l)- 1+ _e_offset],d[(l+1)- 1+ _d_offset],rt1,rt2);
}              //  Close else.
d[(l)- 1+ _d_offset] = rt1.val;
d[(l+1)- 1+ _d_offset] = rt2.val;
e[(l)- 1+ _e_offset] = zero;
l = l+2;
if (l <= lend)  
    Dummy.go_to("Dsteqr",40);
Dummy.go_to("Dsteqr",140);
}              // Close if()
// *
if (jtot == nmaxit)  
    Dummy.go_to("Dsteqr",140);
jtot = jtot+1;
// *
// *        Form shift.
// *
g = (d[(l+1)- 1+ _d_offset]-p)/(two*e[(l)- 1+ _e_offset]);
r.val = Dlapy2.dlapy2(g,one);
g = d[(m)- 1+ _d_offset]-p+(e[(l)- 1+ _e_offset]/(g+((g) >= 0 ? Math.abs(r.val) : -Math.abs(r.val))));
// *
s.val = one;
c.val = one;
p = zero;
// *
// *        Inner loop
// *
mm1 = m-1;
{
int _i_inc = -1;
forloop70:
for (i = mm1; i >= l; i += _i_inc) {
f = s.val*e[(i)- 1+ _e_offset];
b = c.val*e[(i)- 1+ _e_offset];
Dlartg.dlartg(g,f,c,s,r);
if (i != m-1)  
    e[(i+1)- 1+ _e_offset] = r.val;
g = d[(i+1)- 1+ _d_offset]-p;
r.val = (d[(i)- 1+ _d_offset]-g)*s.val+two*c.val*b;
p = s.val*r.val;
d[(i+1)- 1+ _d_offset] = g+p;
g = c.val*r.val-b;
// *
// *           If eigenvectors are desired, then save rotations.
// *
if (icompz > 0)  {
    work[(i)- 1+ _work_offset] = c.val;
work[(n-1+i)- 1+ _work_offset] = -s.val;
}              // Close if()
// *
Dummy.label("Dsteqr",70);
}              //  Close for() loop. 
}
// *
// *        If eigenvectors are desired, then apply saved rotations.
// *
if (icompz > 0)  {
    mm = m-l+1;
Dlasr.dlasr("R","V","B",n,mm,work,(l)- 1+ _work_offset,work,(n-1+l)- 1+ _work_offset,z,(1)- 1+(l- 1)*ldz+ _z_offset,ldz);
}              // Close if()
// *
d[(l)- 1+ _d_offset] = d[(l)- 1+ _d_offset]-p;
e[(l)- 1+ _e_offset] = g;
Dummy.go_to("Dsteqr",40);
// *
// *        Eigenvalue found.
// *
label80:
   Dummy.label("Dsteqr",80);
d[(l)- 1+ _d_offset] = p;
// *
l = l+1;
if (l <= lend)  
    Dummy.go_to("Dsteqr",40);
Dummy.go_to("Dsteqr",140);
// *
}              // Close if()
else  {
  // *
// *        QR Iteration
// *
// *        Look for small superdiagonal element.
// *
label90:
   Dummy.label("Dsteqr",90);
if (l != lend)  {
    lendp1 = lend+1;
{
int _m_inc = -1;
forloop100:
for (m = l; m >= lendp1; m += _m_inc) {
tst = Math.pow(Math.abs(e[(m-1)- 1+ _e_offset]), 2);
if (tst <= (eps2*Math.abs(d[(m)- 1+ _d_offset]))*Math.abs(d[(m-1)- 1+ _d_offset])+safmin)  
    Dummy.go_to("Dsteqr",110);
Dummy.label("Dsteqr",100);
}              //  Close for() loop. 
}
}              // Close if()
// *
m = lend;
// *
label110:
   Dummy.label("Dsteqr",110);
if (m > lend)  
    e[(m-1)- 1+ _e_offset] = zero;
p = d[(l)- 1+ _d_offset];
if (m == l)  
    Dummy.go_to("Dsteqr",130);
// *
// *        If remaining matrix is 2-by-2, use DLAE2 or SLAEV2
// *        to compute its eigensystem.
// *
if (m == l-1)  {
    if (icompz > 0)  {
    Dlaev2.dlaev2(d[(l-1)- 1+ _d_offset],e[(l-1)- 1+ _e_offset],d[(l)- 1+ _d_offset],rt1,rt2,c,s);
work[(m)- 1+ _work_offset] = c.val;
work[(n-1+m)- 1+ _work_offset] = s.val;
Dlasr.dlasr("R","V","F",n,2,work,(m)- 1+ _work_offset,work,(n-1+m)- 1+ _work_offset,z,(1)- 1+(l-1- 1)*ldz+ _z_offset,ldz);
}              // Close if()
else  {
  Dlae2.dlae2(d[(l-1)- 1+ _d_offset],e[(l-1)- 1+ _e_offset],d[(l)- 1+ _d_offset],rt1,rt2);
}              //  Close else.
d[(l-1)- 1+ _d_offset] = rt1.val;
d[(l)- 1+ _d_offset] = rt2.val;
e[(l-1)- 1+ _e_offset] = zero;
l = l-2;
if (l >= lend)  
    Dummy.go_to("Dsteqr",90);
Dummy.go_to("Dsteqr",140);
}              // Close if()
// *
if (jtot == nmaxit)  
    Dummy.go_to("Dsteqr",140);
jtot = jtot+1;
// *
// *        Form shift.
// *
g = (d[(l-1)- 1+ _d_offset]-p)/(two*e[(l-1)- 1+ _e_offset]);
r.val = Dlapy2.dlapy2(g,one);
g = d[(m)- 1+ _d_offset]-p+(e[(l-1)- 1+ _e_offset]/(g+((g) >= 0 ? Math.abs(r.val) : -Math.abs(r.val))));
// *
s.val = one;
c.val = one;
p = zero;
// *
// *        Inner loop
// *
lm1 = l-1;
{
forloop120:
for (i = m; i <= lm1; i++) {
f = s.val*e[(i)- 1+ _e_offset];
b = c.val*e[(i)- 1+ _e_offset];
Dlartg.dlartg(g,f,c,s,r);
if (i != m)  
    e[(i-1)- 1+ _e_offset] = r.val;
g = d[(i)- 1+ _d_offset]-p;
r.val = (d[(i+1)- 1+ _d_offset]-g)*s.val+two*c.val*b;
p = s.val*r.val;
d[(i)- 1+ _d_offset] = g+p;
g = c.val*r.val-b;
// *
// *           If eigenvectors are desired, then save rotations.
// *
if (icompz > 0)  {
    work[(i)- 1+ _work_offset] = c.val;
work[(n-1+i)- 1+ _work_offset] = s.val;
}              // Close if()
// *
Dummy.label("Dsteqr",120);
}              //  Close for() loop. 
}
// *
// *        If eigenvectors are desired, then apply saved rotations.
// *
if (icompz > 0)  {
    mm = l-m+1;
Dlasr.dlasr("R","V","F",n,mm,work,(m)- 1+ _work_offset,work,(n-1+m)- 1+ _work_offset,z,(1)- 1+(m- 1)*ldz+ _z_offset,ldz);
}              // Close if()
// *
d[(l)- 1+ _d_offset] = d[(l)- 1+ _d_offset]-p;
e[(lm1)- 1+ _e_offset] = g;
Dummy.go_to("Dsteqr",90);
// *
// *        Eigenvalue found.
// *
label130:
   Dummy.label("Dsteqr",130);
d[(l)- 1+ _d_offset] = p;
// *
l = l-1;
if (l >= lend)  
    Dummy.go_to("Dsteqr",90);
Dummy.go_to("Dsteqr",140);
// *
}              //  Close else.
// *
// *     Undo scaling if necessary
// *
label140:
   Dummy.label("Dsteqr",140);
if (iscale == 1)  {
    Dlascl.dlascl("G",0,0,ssfmax,anorm,lendsv-lsv+1,1,d,(lsv)- 1+ _d_offset,n,info);
Dlascl.dlascl("G",0,0,ssfmax,anorm,lendsv-lsv,1,e,(lsv)- 1+ _e_offset,n,info);
}              // Close if()
else if (iscale == 2)  {
    Dlascl.dlascl("G",0,0,ssfmin,anorm,lendsv-lsv+1,1,d,(lsv)- 1+ _d_offset,n,info);
Dlascl.dlascl("G",0,0,ssfmin,anorm,lendsv-lsv,1,e,(lsv)- 1+ _e_offset,n,info);
}              // Close else if()
// *
// *     Check for no convergence to an eigenvalue after a total
// *     of N*MAXIT iterations.
// *
if (jtot < nmaxit)  
    Dummy.go_to("Dsteqr",10);
{
forloop150:
for (i = 1; i <= n-1; i++) {
if (e[(i)- 1+ _e_offset] != zero)  
    info.val = info.val+1;
Dummy.label("Dsteqr",150);
}              //  Close for() loop. 
}
Dummy.go_to("Dsteqr",190);
// *
// *     Order eigenvalues and eigenvectors.
// *
label160:
   Dummy.label("Dsteqr",160);
if (icompz == 0)  {
    // *
// *        Use Quick Sort
// *
Dlasrt.dlasrt("I",n,d,_d_offset,info);
// *
}              // Close if()
else  {
  // *
// *        Use Selection Sort to minimize swaps of eigenvectors
// *
{
forloop180:
for (ii = 2; ii <= n; ii++) {
i = ii-1;
k = i;
p = d[(i)- 1+ _d_offset];
{
forloop170:
for (j = ii; j <= n; j++) {
if (d[(j)- 1+ _d_offset] < p)  {
    k = j;
p = d[(j)- 1+ _d_offset];
}              // Close if()
Dummy.label("Dsteqr",170);
}              //  Close for() loop. 
}
if (k != i)  {
    d[(k)- 1+ _d_offset] = d[(i)- 1+ _d_offset];
d[(i)- 1+ _d_offset] = p;
Dswap.dswap(n,z,(1)- 1+(i- 1)*ldz+ _z_offset,1,z,(1)- 1+(k- 1)*ldz+ _z_offset,1);
}              // Close if()
Dummy.label("Dsteqr",180);
}              //  Close for() loop. 
}
}              //  Close else.
// *
label190:
   Dummy.label("Dsteqr",190);
Dummy.go_to("Dsteqr",999999);
// *
// *     End of DSTEQR
// *
Dummy.label("Dsteqr",999999);
return;
   }
} // End class.
