/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;

import org.netlib.blas.*;


public class Dstevx {

// *
// *  -- LAPACK driver routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DSTEVX computes selected eigenvalues and, optionally, eigenvectors
// *  of a real symmetric tridiagonal matrix A.  Eigenvalues and
// *  eigenvectors can be selected by specifying either a range of values
// *  or a range of indices for the desired eigenvalues.
// *
// *  Arguments
// *  =========
// *
// *  JOBZ    (input) CHARACTER*1
// *          = 'N':  Compute eigenvalues only;
// *          = 'V':  Compute eigenvalues and eigenvectors.
// *
// *  RANGE   (input) CHARACTER*1
// *          = 'A': all eigenvalues will be found.
// *          = 'V': all eigenvalues in the half-open interval (VL,VU]
// *                 will be found.
// *          = 'I': the IL-th through IU-th eigenvalues will be found.
// *
// *  N       (input) INTEGER
// *          The order of the matrix.  N >= 0.
// *
// *  D       (input/output) DOUBLE PRECISION array, dimension (N)
// *          On entry, the n diagonal elements of the tridiagonal matrix
// *          A.
// *          On exit, D may be multiplied by a constant factor chosen
// *          to avoid over/underflow in computing the eigenvalues.
// *
// *  E       (input/output) DOUBLE PRECISION array, dimension (N)
// *          On entry, the (n-1) subdiagonal elements of the tridiagonal
// *          matrix A in elements 1 to N-1 of E; E(N) need not be set.
// *          On exit, E may be multiplied by a constant factor chosen
// *          to avoid over/underflow in computing the eigenvalues.
// *
// *  VL      (input) DOUBLE PRECISION
// *  VU      (input) DOUBLE PRECISION
// *          If RANGE='V', the lower and upper bounds of the interval to
// *          be searched for eigenvalues. VL < VU.
// *          Not referenced if RANGE = 'A' or 'I'.
// *
// *  IL      (input) INTEGER
// *  IU      (input) INTEGER
// *          If RANGE='I', the indices (in ascending order) of the
// *          smallest and largest eigenvalues to be returned.
// *          1 <= IL <= IU <= N, if N > 0; IL = 1 and IU = 0 if N = 0.
// *          Not referenced if RANGE = 'A' or 'V'.
// *
// *  ABSTOL  (input) DOUBLE PRECISION
// *          The absolute error tolerance for the eigenvalues.
// *          An approximate eigenvalue is accepted as converged
// *          when it is determined to lie in an interval [a,b]
// *          of width less than or equal to
// *
// *                  ABSTOL + EPS *   max( |a|,|b| ) ,
// *
// *          where EPS is the machine precision.  If ABSTOL is less
// *          than or equal to zero, then  EPS*|T|  will be used in
// *          its place, where |T| is the 1-norm of the tridiagonal
// *          matrix.
// *
// *          Eigenvalues will be computed most accurately when ABSTOL is
// *          set to twice the underflow threshold 2*DLAMCH('S'), not zero.
// *          If this routine returns with INFO>0, indicating that some
// *          eigenvectors did not converge, try setting ABSTOL to
// *          2*DLAMCH('S').
// *
// *          See "Computing Small Singular Values of Bidiagonal Matrices
// *          with Guaranteed High Relative Accuracy," by Demmel and
// *          Kahan, LAPACK Working Note #3.
// *
// *  M       (output) INTEGER
// *          The total number of eigenvalues found.  0 <= M <= N.
// *          If RANGE = 'A', M = N, and if RANGE = 'I', M = IU-IL+1.
// *
// *  W       (output) DOUBLE PRECISION array, dimension (N)
// *          The first M elements contain the selected eigenvalues in
// *          ascending order.
// *
// *  Z       (output) DOUBLE PRECISION array, dimension (LDZ, max(1,M) )
// *          If JOBZ = 'V', then if INFO = 0, the first M columns of Z
// *          contain the orthonormal eigenvectors of the matrix A
// *          corresponding to the selected eigenvalues, with the i-th
// *          column of Z holding the eigenvector associated with W(i).
// *          If an eigenvector fails to converge (INFO > 0), then that
// *          column of Z contains the latest approximation to the
// *          eigenvector, and the index of the eigenvector is returned
// *          in IFAIL.  If JOBZ = 'N', then Z is not referenced.
// *          Note: the user must ensure that at least max(1,M) columns are
// *          supplied in the array Z; if RANGE = 'V', the exact value of M
// *          is not known in advance and an upper bound must be used.
// *
// *  LDZ     (input) INTEGER
// *          The leading dimension of the array Z.  LDZ >= 1, and if
// *          JOBZ = 'V', LDZ >= max(1,N).
// *
// *  WORK    (workspace) DOUBLE PRECISION array, dimension (5*N)
// *
// *  IWORK   (workspace) INTEGER array, dimension (5*N)
// *
// *  IFAIL   (output) INTEGER array, dimension (N)
// *          If JOBZ = 'V', then if INFO = 0, the first M elements of
// *          IFAIL are zero.  If INFO > 0, then IFAIL contains the
// *          indices of the eigenvectors that failed to converge.
// *          If JOBZ = 'N', then IFAIL is not referenced.
// *
// *  INFO    (output) INTEGER
// *          = 0:  successful exit
// *          < 0:  if INFO = -i, the i-th argument had an illegal value
// *          > 0:  if INFO = i, then i eigenvectors failed to converge.
// *                Their indices are stored in array IFAIL.
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double zero= 0.0e0;
static double one= 1.0e0;
// *     ..
// *     .. Local Scalars ..
static boolean alleig= false;
static boolean indeig= false;
static boolean valeig= false;
static boolean wantz= false;
static String order= new String(" ");
static int i= 0;
static int imax= 0;
static int indibl= 0;
static int indisp= 0;
static int indiwo= 0;
static int indwrk= 0;
static int iscale= 0;
static int itmp1= 0;
static int j= 0;
static int jj= 0;
static intW nsplit= new intW(0);
static double bignum= 0.0;
static double eps= 0.0;
static double rmax= 0.0;
static double rmin= 0.0;
static double safmin= 0.0;
static double sigma= 0.0;
static double smlnum= 0.0;
static double tmp1= 0.0;
static double tnrm= 0.0;
static double vll= 0.0;
static double vuu= 0.0;
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Test the input parameters.
// *

public static void dstevx (String jobz,
String range,
int n,
double [] d, int _d_offset,
double [] e, int _e_offset,
double vl,
double vu,
int il,
int iu,
double abstol,
intW m,
double [] w, int _w_offset,
double [] z, int _z_offset,
int ldz,
double [] work, int _work_offset,
int [] iwork, int _iwork_offset,
int [] ifail, int _ifail_offset,
intW info)  {

wantz = (jobz.toLowerCase().charAt(0) == "V".toLowerCase().charAt(0));
alleig = (range.toLowerCase().charAt(0) == "A".toLowerCase().charAt(0));
valeig = (range.toLowerCase().charAt(0) == "V".toLowerCase().charAt(0));
indeig = (range.toLowerCase().charAt(0) == "I".toLowerCase().charAt(0));
// *
info.val = 0;
if (!(wantz || (jobz.toLowerCase().charAt(0) == "N".toLowerCase().charAt(0))))  {
    info.val = -1;
}              // Close if()
else if (!(alleig || valeig || indeig))  {
    info.val = -2;
}              // Close else if()
else if (n < 0)  {
    info.val = -3;
}              // Close else if()
else if (valeig && n > 0 && vu <= vl)  {
    info.val = -7;
}              // Close else if()
else if (indeig && il < 1)  {
    info.val = -8;
}              // Close else if()
else if (indeig && (iu < Math.min(n, il)  || iu > n))  {
    info.val = -9;
}              // Close else if()
else if (ldz < 1 || (wantz && ldz < n))  {
    info.val = -14;
}              // Close else if()
// *
if (info.val != 0)  {
    Xerbla.xerbla("DSTEVX",-info.val);
Dummy.go_to("Dstevx",999999);
}              // Close if()
// *
// *     Quick return if possible
// *
m.val = 0;
if (n == 0)  
    Dummy.go_to("Dstevx",999999);
// *
if (n == 1)  {
    if (alleig || indeig)  {
    m.val = 1;
w[(1)- 1+ _w_offset] = d[(1)- 1+ _d_offset];
}              // Close if()
else  {
  if (vl < d[(1)- 1+ _d_offset] && vu >= d[(1)- 1+ _d_offset])  {
    m.val = 1;
w[(1)- 1+ _w_offset] = d[(1)- 1+ _d_offset];
}              // Close if()
}              //  Close else.
if (wantz)  
    z[(1)- 1+(1- 1)*ldz+ _z_offset] = one;
Dummy.go_to("Dstevx",999999);
}              // Close if()
// *
// *     Get machine constants.
// *
safmin = Dlamch.dlamch("Safe minimum");
eps = Dlamch.dlamch("Precision");
smlnum = safmin/eps;
bignum = one/smlnum;
rmin = Math.sqrt(smlnum);
rmax = Math.min(Math.sqrt(bignum), one/Math.sqrt(Math.sqrt(safmin))) ;
// *
// *     Scale matrix to allowable range, if necessary.
// *
iscale = 0;
if (valeig)  {
    vll = vl;
vuu = vu;
}              // Close if()
tnrm = Dlanst.dlanst("M",n,d,_d_offset,e,_e_offset);
if (tnrm > zero && tnrm < rmin)  {
    iscale = 1;
sigma = rmin/tnrm;
}              // Close if()
else if (tnrm > rmax)  {
    iscale = 1;
sigma = rmax/tnrm;
}              // Close else if()
if (iscale == 1)  {
    Dscal.dscal(n,sigma,d,_d_offset,1);
Dscal.dscal(n-1,sigma,e,(1)- 1+ _e_offset,1);
if (valeig)  {
    vll = vl*sigma;
vuu = vu*sigma;
}              // Close if()
}              // Close if()
// *
// *     If all eigenvalues are desired and ABSTOL is less than zero, then
// *     call DSTERF or SSTEQR.  If this fails for some eigenvalue, then
// *     try DSTEBZ.
// *
if ((alleig || (indeig && il == 1 && iu == n)) && (abstol <= zero))  {
    Dcopy.dcopy(n,d,_d_offset,1,w,_w_offset,1);
Dcopy.dcopy(n-1,e,(1)- 1+ _e_offset,1,work,(1)- 1+ _work_offset,1);
indwrk = n+1;
if (!wantz)  {
    Dsterf.dsterf(n,w,_w_offset,work,_work_offset,info);
}              // Close if()
else  {
  Dsteqr.dsteqr("I",n,w,_w_offset,work,_work_offset,z,_z_offset,ldz,work,(indwrk)- 1+ _work_offset,info);
if (info.val == 0)  {
    {
forloop10:
for (i = 1; i <= n; i++) {
ifail[(i)- 1+ _ifail_offset] = 0;
Dummy.label("Dstevx",10);
}              //  Close for() loop. 
}
}              // Close if()
}              //  Close else.
if (info.val == 0)  {
    m.val = n;
Dummy.go_to("Dstevx",20);
}              // Close if()
info.val = 0;
}              // Close if()
// *
// *     Otherwise, call DSTEBZ and, if eigenvectors are desired, SSTEIN.
// *
if (wantz)  {
    order = "B";
}              // Close if()
else  {
  order = "E";
}              //  Close else.
indwrk = 1;
indibl = 1;
indisp = indibl+n;
indiwo = indisp+n;
Dstebz.dstebz(range,order,n,vll,vuu,il,iu,abstol,d,_d_offset,e,_e_offset,m,nsplit,w,_w_offset,iwork,(indibl)- 1+ _iwork_offset,iwork,(indisp)- 1+ _iwork_offset,work,(indwrk)- 1+ _work_offset,iwork,(indiwo)- 1+ _iwork_offset,info);
// *
if (wantz)  {
    Dstein.dstein(n,d,_d_offset,e,_e_offset,m.val,w,_w_offset,iwork,(indibl)- 1+ _iwork_offset,iwork,(indisp)- 1+ _iwork_offset,z,_z_offset,ldz,work,(indwrk)- 1+ _work_offset,iwork,(indiwo)- 1+ _iwork_offset,ifail,_ifail_offset,info);
}              // Close if()
// *
// *     If matrix was scaled, then rescale eigenvalues appropriately.
// *
label20:
   Dummy.label("Dstevx",20);
if (iscale == 1)  {
    if (info.val == 0)  {
    imax = m.val;
}              // Close if()
else  {
  imax = info.val-1;
}              //  Close else.
Dscal.dscal(imax,one/sigma,w,_w_offset,1);
}              // Close if()
// *
// *     If eigenvalues are not in order, then sort them, along with
// *     eigenvectors.
// *
if (wantz)  {
    {
forloop40:
for (j = 1; j <= m.val-1; j++) {
i = 0;
tmp1 = w[(j)- 1+ _w_offset];
{
forloop30:
for (jj = j+1; jj <= m.val; jj++) {
if (w[(jj)- 1+ _w_offset] < tmp1)  {
    i = jj;
tmp1 = w[(jj)- 1+ _w_offset];
}              // Close if()
Dummy.label("Dstevx",30);
}              //  Close for() loop. 
}
// *
if (i != 0)  {
    itmp1 = iwork[(indibl+i-1)- 1+ _iwork_offset];
w[(i)- 1+ _w_offset] = w[(j)- 1+ _w_offset];
iwork[(indibl+i-1)- 1+ _iwork_offset] = iwork[(indibl+j-1)- 1+ _iwork_offset];
w[(j)- 1+ _w_offset] = tmp1;
iwork[(indibl+j-1)- 1+ _iwork_offset] = itmp1;
Dswap.dswap(n,z,(1)- 1+(i- 1)*ldz+ _z_offset,1,z,(1)- 1+(j- 1)*ldz+ _z_offset,1);
if (info.val != 0)  {
    itmp1 = ifail[(i)- 1+ _ifail_offset];
ifail[(i)- 1+ _ifail_offset] = ifail[(j)- 1+ _ifail_offset];
ifail[(j)- 1+ _ifail_offset] = itmp1;
}              // Close if()
}              // Close if()
Dummy.label("Dstevx",40);
}              //  Close for() loop. 
}
}              // Close if()
// *
Dummy.go_to("Dstevx",999999);
// *
// *     End of DSTEVX
// *
Dummy.label("Dstevx",999999);
return;
   }
} // End class.
