/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;

import org.netlib.blas.*;


public class Dsytd2 {

// *
// *  -- LAPACK routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     October 31, 1992
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DSYTD2 reduces a real symmetric matrix A to symmetric tridiagonal
// *  form T by an orthogonal similarity transformation: Q' * A * Q = T.
// *
// *  Arguments
// *  =========
// *
// *  UPLO    (input) CHARACTER*1
// *          Specifies whether the upper or lower triangular part of the
// *          symmetric matrix A is stored:
// *          = 'U':  Upper triangular
// *          = 'L':  Lower triangular
// *
// *  N       (input) INTEGER
// *          The order of the matrix A.  N >= 0.
// *
// *  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
// *          On entry, the symmetric matrix A.  If UPLO = 'U', the leading
// *          n-by-n upper triangular part of A contains the upper
// *          triangular part of the matrix A, and the strictly lower
// *          triangular part of A is not referenced.  If UPLO = 'L', the
// *          leading n-by-n lower triangular part of A contains the lower
// *          triangular part of the matrix A, and the strictly upper
// *          triangular part of A is not referenced.
// *          On exit, if UPLO = 'U', the diagonal and first superdiagonal
// *          of A are overwritten by the corresponding elements of the
// *          tridiagonal matrix T, and the elements above the first
// *          superdiagonal, with the array TAU, represent the orthogonal
// *          matrix Q as a product of elementary reflectors; if UPLO
// *          = 'L', the diagonal and first subdiagonal of A are over-
// *          written by the corresponding elements of the tridiagonal
// *          matrix T, and the elements below the first subdiagonal, with
// *          the array TAU, represent the orthogonal matrix Q as a product
// *          of elementary reflectors. See Further Details.
// *
// *  LDA     (input) INTEGER
// *          The leading dimension of the array A.  LDA >= max(1,N).
// *
// *  D       (output) DOUBLE PRECISION array, dimension (N)
// *          The diagonal elements of the tridiagonal matrix T:
// *          D(i) = A(i,i).
// *
// *  E       (output) DOUBLE PRECISION array, dimension (N-1)
// *          The off-diagonal elements of the tridiagonal matrix T:
// *          E(i) = A(i,i+1) if UPLO = 'U', E(i) = A(i+1,i) if UPLO = 'L'.
// *
// *  TAU     (output) DOUBLE PRECISION array, dimension (N-1)
// *          The scalar factors of the elementary reflectors (see Further
// *          Details).
// *
// *  INFO    (output) INTEGER
// *          = 0:  successful exit
// *          < 0:  if INFO = -i, the i-th argument had an illegal value.
// *
// *  Further Details
// *  ===============
// *
// *  If UPLO = 'U', the matrix Q is represented as a product of elementary
// *  reflectors
// *
// *     Q = H(n-1) . . . H(2) H(1).
// *
// *  Each H(i) has the form
// *
// *     H(i) = I - tau * v * v'
// *
// *  where tau is a real scalar, and v is a real vector with
// *  v(i+1:n) = 0 and v(i) = 1; v(1:i-1) is stored on exit in
// *  A(1:i-1,i+1), and tau in TAU(i).
// *
// *  If UPLO = 'L', the matrix Q is represented as a product of elementary
// *  reflectors
// *
// *     Q = H(1) H(2) . . . H(n-1).
// *
// *  Each H(i) has the form
// *
// *     H(i) = I - tau * v * v'
// *
// *  where tau is a real scalar, and v is a real vector with
// *  v(1:i) = 0 and v(i+1) = 1; v(i+2:n) is stored on exit in A(i+2:n,i),
// *  and tau in TAU(i).
// *
// *  The contents of A on exit are illustrated by the following examples
// *  with n = 5:
// *
// *  if UPLO = 'U':                       if UPLO = 'L':
// *
// *    (  d   e   v2  v3  v4 )              (  d                  )
// *    (      d   e   v3  v4 )              (  e   d              )
// *    (          d   e   v4 )              (  v1  e   d          )
// *    (              d   e  )              (  v1  v2  e   d      )
// *    (                  d  )              (  v1  v2  v3  e   d  )
// *
// *  where d and e denote diagonal and off-diagonal elements of T, and vi
// *  denotes an element of the vector defining H(i).
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double one= 1.0e0;
static double zero= 0.0e0;
static double half= 1.0e0/2.0e0;
// *     ..
// *     .. Local Scalars ..
static boolean upper= false;
static int i= 0;
static double alpha= 0.0;
static doubleW taui= new doubleW(0.0);
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Test the input parameters
// *

public static void dsytd2 (String uplo,
int n,
double [] a, int _a_offset,
int lda,
double [] d, int _d_offset,
double [] e, int _e_offset,
double [] tau, int _tau_offset,
intW info)  {

info.val = 0;
upper = (uplo.toLowerCase().charAt(0) == "U".toLowerCase().charAt(0));
if (!upper && !(uplo.toLowerCase().charAt(0) == "L".toLowerCase().charAt(0)))  {
    info.val = -1;
}              // Close if()
else if (n < 0)  {
    info.val = -2;
}              // Close else if()
else if (lda < Math.max(1, n) )  {
    info.val = -4;
}              // Close else if()
if (info.val != 0)  {
    Xerbla.xerbla("DSYTD2",-info.val);
Dummy.go_to("Dsytd2",999999);
}              // Close if()
// *
// *     Quick return if possible
// *
if (n <= 0)  
    Dummy.go_to("Dsytd2",999999);
// *
if (upper)  {
    // *
// *        Reduce the upper triangle of A
// *
{
int _i_inc = -1;
forloop10:
for (i = n-1; i >= 1; i += _i_inc) {
// *
// *           Generate elementary reflector H(i) = I - tau * v * v'
// *           to annihilate A(1:i-1,i+1)
// *
dlarfg_adapter(i,a,(i)- 1+(i+1- 1)*lda+ _a_offset,a,(1)- 1+(i+1- 1)*lda+ _a_offset,1,taui);
e[(i)- 1+ _e_offset] = a[(i)- 1+(i+1- 1)*lda+ _a_offset];
// *
if (taui.val != zero)  {
    // *
// *              Apply H(i) from both sides to A(1:i,1:i)
// *
a[(i)- 1+(i+1- 1)*lda+ _a_offset] = one;
// *
// *              Compute  x := tau * A * v  storing x in TAU(1:i)
// *
Dsymv.dsymv(uplo,i,taui.val,a,_a_offset,lda,a,(1)- 1+(i+1- 1)*lda+ _a_offset,1,zero,tau,_tau_offset,1);
// *
// *              Compute  w := x - 1/2 * tau * (x'*v) * v
// *
alpha = -half*taui.val*Ddot.ddot(i,tau,_tau_offset,1,a,(1)- 1+(i+1- 1)*lda+ _a_offset,1);
Daxpy.daxpy(i,alpha,a,(1)- 1+(i+1- 1)*lda+ _a_offset,1,tau,_tau_offset,1);
// *
// *              Apply the transformation as a rank-2 update:
// *                 A := A - v * w' - w * v'
// *
Dsyr2.dsyr2(uplo,i,-one,a,(1)- 1+(i+1- 1)*lda+ _a_offset,1,tau,_tau_offset,1,a,_a_offset,lda);
// *
a[(i)- 1+(i+1- 1)*lda+ _a_offset] = e[(i)- 1+ _e_offset];
}              // Close if()
d[(i+1)- 1+ _d_offset] = a[(i+1)- 1+(i+1- 1)*lda+ _a_offset];
tau[(i)- 1+ _tau_offset] = taui.val;
Dummy.label("Dsytd2",10);
}              //  Close for() loop. 
}
d[(1)- 1+ _d_offset] = a[(1)- 1+(1- 1)*lda+ _a_offset];
}              // Close if()
else  {
  // *
// *        Reduce the lower triangle of A
// *
{
forloop20:
for (i = 1; i <= n-1; i++) {
// *
// *           Generate elementary reflector H(i) = I - tau * v * v'
// *           to annihilate A(i+2:n,i)
// *
dlarfg_adapter(n-i,a,(i+1)- 1+(i- 1)*lda+ _a_offset,a,(int)((Math.min(i+2, n) )- 1+(i- 1)*lda+ _a_offset),1,taui);
e[(i)- 1+ _e_offset] = a[(i+1)- 1+(i- 1)*lda+ _a_offset];
// *
if (taui.val != zero)  {
    // *
// *              Apply H(i) from both sides to A(i+1:n,i+1:n)
// *
a[(i+1)- 1+(i- 1)*lda+ _a_offset] = one;
// *
// *              Compute  x := tau * A * v  storing y in TAU(i:n-1)
// *
Dsymv.dsymv(uplo,n-i,taui.val,a,(i+1)- 1+(i+1- 1)*lda+ _a_offset,lda,a,(i+1)- 1+(i- 1)*lda+ _a_offset,1,zero,tau,(i)- 1+ _tau_offset,1);
// *
// *              Compute  w := x - 1/2 * tau * (x'*v) * v
// *
alpha = -half*taui.val*Ddot.ddot(n-i,tau,(i)- 1+ _tau_offset,1,a,(i+1)- 1+(i- 1)*lda+ _a_offset,1);
Daxpy.daxpy(n-i,alpha,a,(i+1)- 1+(i- 1)*lda+ _a_offset,1,tau,(i)- 1+ _tau_offset,1);
// *
// *              Apply the transformation as a rank-2 update:
// *                 A := A - v * w' - w * v'
// *
Dsyr2.dsyr2(uplo,n-i,-one,a,(i+1)- 1+(i- 1)*lda+ _a_offset,1,tau,(i)- 1+ _tau_offset,1,a,(i+1)- 1+(i+1- 1)*lda+ _a_offset,lda);
// *
a[(i+1)- 1+(i- 1)*lda+ _a_offset] = e[(i)- 1+ _e_offset];
}              // Close if()
d[(i)- 1+ _d_offset] = a[(i)- 1+(i- 1)*lda+ _a_offset];
tau[(i)- 1+ _tau_offset] = taui.val;
Dummy.label("Dsytd2",20);
}              //  Close for() loop. 
}
d[(n)- 1+ _d_offset] = a[(n)- 1+(n- 1)*lda+ _a_offset];
}              //  Close else.
// *
Dummy.go_to("Dsytd2",999999);
// *
// *     End of DSYTD2
// *
Dummy.label("Dsytd2",999999);
return;
   }
// adapter for dlarfg
private static void dlarfg_adapter(int arg0 ,double [] arg1 , int arg1_offset ,double [] arg2 , int arg2_offset ,int arg3 ,doubleW arg4 )
{
doubleW _f2j_tmp1 = new doubleW(arg1[arg1_offset]);

Dlarfg.dlarfg(arg0,_f2j_tmp1,arg2, arg2_offset,arg3,arg4);

arg1[arg1_offset] = _f2j_tmp1.val;
}

} // End class.
