/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;

import org.netlib.blas.*;


public class Dsytf2 {

// *
// *  -- LAPACK routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     October 31, 1992
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DSYTF2 computes the factorization of a real symmetric matrix A using
// *  the Bunch-Kaufman diagonal pivoting method:
// *
// *     A = U*D*U'  or  A = L*D*L'
// *
// *  where U (or L) is a product of permutation and unit upper (lower)
// *  triangular matrices, U' is the transpose of U, and D is symmetric and
// *  block diagonal with 1-by-1 and 2-by-2 diagonal blocks.
// *
// *  This is the unblocked version of the algorithm, calling Level 2 BLAS.
// *
// *  Arguments
// *  =========
// *
// *  UPLO    (input) CHARACTER*1
// *          Specifies whether the upper or lower triangular part of the
// *          symmetric matrix A is stored:
// *          = 'U':  Upper triangular
// *          = 'L':  Lower triangular
// *
// *  N       (input) INTEGER
// *          The order of the matrix A.  N >= 0.
// *
// *  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
// *          On entry, the symmetric matrix A.  If UPLO = 'U', the leading
// *          n-by-n upper triangular part of A contains the upper
// *          triangular part of the matrix A, and the strictly lower
// *          triangular part of A is not referenced.  If UPLO = 'L', the
// *          leading n-by-n lower triangular part of A contains the lower
// *          triangular part of the matrix A, and the strictly upper
// *          triangular part of A is not referenced.
// *
// *          On exit, the block diagonal matrix D and the multipliers used
// *          to obtain the factor U or L (see below for further details).
// *
// *  LDA     (input) INTEGER
// *          The leading dimension of the array A.  LDA >= max(1,N).
// *
// *  IPIV    (output) INTEGER array, dimension (N)
// *          Details of the interchanges and the block structure of D.
// *          If IPIV(k) > 0, then rows and columns k and IPIV(k) were
// *          interchanged and D(k,k) is a 1-by-1 diagonal block.
// *          If UPLO = 'U' and IPIV(k) = IPIV(k-1) < 0, then rows and
// *          columns k-1 and -IPIV(k) were interchanged and D(k-1:k,k-1:k)
// *          is a 2-by-2 diagonal block.  If UPLO = 'L' and IPIV(k) =
// *          IPIV(k+1) < 0, then rows and columns k+1 and -IPIV(k) were
// *          interchanged and D(k:k+1,k:k+1) is a 2-by-2 diagonal block.
// *
// *  INFO    (output) INTEGER
// *          = 0: successful exit
// *          < 0: if INFO = -k, the k-th argument had an illegal value
// *          > 0: if INFO = k, D(k,k) is exactly zero.  The factorization
// *               has been completed, but the block diagonal matrix D is
// *               exactly singular, and division by zero will occur if it
// *               is used to solve a system of equations.
// *
// *  Further Details
// *  ===============
// *
// *  If UPLO = 'U', then A = U*D*U', where
// *     U = P(n)*U(n)* ... *P(k)U(k)* ...,
// *  i.e., U is a product of terms P(k)*U(k), where k decreases from n to
// *  1 in steps of 1 or 2, and D is a block diagonal matrix with 1-by-1
// *  and 2-by-2 diagonal blocks D(k).  P(k) is a permutation matrix as
// *  defined by IPIV(k), and U(k) is a unit upper triangular matrix, such
// *  that if the diagonal block D(k) is of order s (s = 1 or 2), then
// *
// *             (   I    v    0   )   k-s
// *     U(k) =  (   0    I    0   )   s
// *             (   0    0    I   )   n-k
// *                k-s   s   n-k
// *
// *  If s = 1, D(k) overwrites A(k,k), and v overwrites A(1:k-1,k).
// *  If s = 2, the upper triangle of D(k) overwrites A(k-1,k-1), A(k-1,k),
// *  and A(k,k), and v overwrites A(1:k-2,k-1:k).
// *
// *  If UPLO = 'L', then A = L*D*L', where
// *     L = P(1)*L(1)* ... *P(k)*L(k)* ...,
// *  i.e., L is a product of terms P(k)*L(k), where k increases from 1 to
// *  n in steps of 1 or 2, and D is a block diagonal matrix with 1-by-1
// *  and 2-by-2 diagonal blocks D(k).  P(k) is a permutation matrix as
// *  defined by IPIV(k), and L(k) is a unit lower triangular matrix, such
// *  that if the diagonal block D(k) is of order s (s = 1 or 2), then
// *
// *             (   I    0     0   )  k-1
// *     L(k) =  (   0    I     0   )  s
// *             (   0    v     I   )  n-k-s+1
// *                k-1   s  n-k-s+1
// *
// *  If s = 1, D(k) overwrites A(k,k), and v overwrites A(k+1:n,k).
// *  If s = 2, the lower triangle of D(k) overwrites A(k,k), A(k+1,k),
// *  and A(k+1,k+1), and v overwrites A(k+2:n,k:k+1).
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double zero= 0.0e+0;
static double one= 1.0e+0;
static double eight= 8.0e+0;
static double sevten= 17.0e+0;
// *     ..
// *     .. Local Scalars ..
static boolean upper= false;
static int imax= 0;
static int jmax= 0;
static int k= 0;
static int kk= 0;
static int kp= 0;
static int kstep= 0;
static double absakk= 0.0;
static double alpha= 0.0;
static doubleW c= new doubleW(0.0);
static double colmax= 0.0;
static doubleW r1= new doubleW(0.0);
static doubleW r2= new doubleW(0.0);
static double rowmax= 0.0;
static doubleW s= new doubleW(0.0);
static double t= 0.0;
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Test the input parameters.
// *

public static void dsytf2 (String uplo,
int n,
double [] a, int _a_offset,
int lda,
int [] ipiv, int _ipiv_offset,
intW info)  {

info.val = 0;
upper = (uplo.toLowerCase().charAt(0) == "U".toLowerCase().charAt(0));
if (!upper && !(uplo.toLowerCase().charAt(0) == "L".toLowerCase().charAt(0)))  {
    info.val = -1;
}              // Close if()
else if (n < 0)  {
    info.val = -2;
}              // Close else if()
else if (lda < Math.max(1, n) )  {
    info.val = -4;
}              // Close else if()
if (info.val != 0)  {
    Xerbla.xerbla("DSYTF2",-info.val);
Dummy.go_to("Dsytf2",999999);
}              // Close if()
// *
// *     Initialize ALPHA for use in choosing pivot block size.
// *
alpha = (one+Math.sqrt(sevten))/eight;
// *
if (upper)  {
    // *
// *        Factorize A as U*D*U' using the upper triangle of A
// *
// *        K is the main loop index, decreasing from N to 1 in steps of
// *        1 or 2
// *
k = n;
label10:
   Dummy.label("Dsytf2",10);
// *
// *        If K < 1, exit from loop
// *
if (k < 1)  
    Dummy.go_to("Dsytf2",30);
kstep = 1;
// *
// *        Determine rows and columns to be interchanged and whether
// *        a 1-by-1 or 2-by-2 pivot block will be used
// *
absakk = Math.abs(a[(k)- 1+(k- 1)*lda+ _a_offset]);
// *
// *        IMAX is the row-index of the largest off-diagonal element in
// *        column K, and COLMAX is its absolute value
// *
if (k > 1)  {
    imax = Idamax.idamax(k-1,a,(1)- 1+(k- 1)*lda+ _a_offset,1);
colmax = Math.abs(a[(imax)- 1+(k- 1)*lda+ _a_offset]);
}              // Close if()
else  {
  colmax = zero;
}              //  Close else.
// *
if (Math.max(absakk, colmax)  == zero)  {
    // *
// *           Column K is zero: set INFO and continue
// *
if (info.val == 0)  
    info.val = k;
kp = k;
}              // Close if()
else  {
  if (absakk >= alpha*colmax)  {
    // *
// *              no interchange, use 1-by-1 pivot block
// *
kp = k;
}              // Close if()
else  {
  // *
// *              JMAX is the column-index of the largest off-diagonal
// *              element in row IMAX, and ROWMAX is its absolute value
// *
jmax = imax+Idamax.idamax(k-imax,a,(imax)- 1+(imax+1- 1)*lda+ _a_offset,lda);
rowmax = Math.abs(a[(imax)- 1+(jmax- 1)*lda+ _a_offset]);
if (imax > 1)  {
    jmax = Idamax.idamax(imax-1,a,(1)- 1+(imax- 1)*lda+ _a_offset,1);
rowmax = Math.max(rowmax, Math.abs(a[(jmax)- 1+(imax- 1)*lda+ _a_offset])) ;
}              // Close if()
// *
if (absakk >= alpha*colmax*(colmax/rowmax))  {
    // *
// *                 no interchange, use 1-by-1 pivot block
// *
kp = k;
}              // Close if()
else if (Math.abs(a[(imax)- 1+(imax- 1)*lda+ _a_offset]) >= alpha*rowmax)  {
    // *
// *                 interchange rows and columns K and IMAX, use 1-by-1
// *                 pivot block
// *
kp = imax;
}              // Close else if()
else  {
  // *
// *                 interchange rows and columns K-1 and IMAX, use 2-by-2
// *                 pivot block
// *
kp = imax;
kstep = 2;
}              //  Close else.
}              //  Close else.
// *
kk = k-kstep+1;
if (kp != kk)  {
    // *
// *              Interchange rows and columns KK and KP in the leading
// *              submatrix A(1:k,1:k)
// *
Dswap.dswap(kp-1,a,(1)- 1+(kk- 1)*lda+ _a_offset,1,a,(1)- 1+(kp- 1)*lda+ _a_offset,1);
Dswap.dswap(kk-kp-1,a,(kp+1)- 1+(kk- 1)*lda+ _a_offset,1,a,(kp)- 1+(kp+1- 1)*lda+ _a_offset,lda);
t = a[(kk)- 1+(kk- 1)*lda+ _a_offset];
a[(kk)- 1+(kk- 1)*lda+ _a_offset] = a[(kp)- 1+(kp- 1)*lda+ _a_offset];
a[(kp)- 1+(kp- 1)*lda+ _a_offset] = t;
if (kstep == 2)  {
    t = a[(k-1)- 1+(k- 1)*lda+ _a_offset];
a[(k-1)- 1+(k- 1)*lda+ _a_offset] = a[(kp)- 1+(k- 1)*lda+ _a_offset];
a[(kp)- 1+(k- 1)*lda+ _a_offset] = t;
}              // Close if()
}              // Close if()
// *
// *           Update the leading submatrix
// *
if (kstep == 1)  {
    // *
// *              1-by-1 pivot block D(k): column k now holds
// *
// *              W(k) = U(k)*D(k)
// *
// *              where U(k) is the k-th column of U
// *
// *              Perform a rank-1 update of A(1:k-1,1:k-1) as
// *
// *              A := A - U(k)*D(k)*U(k)' = A - W(k)*1/D(k)*W(k)'
// *
r1.val = one/a[(k)- 1+(k- 1)*lda+ _a_offset];
Dsyr.dsyr(uplo,k-1,-r1.val,a,(1)- 1+(k- 1)*lda+ _a_offset,1,a,_a_offset,lda);
// *
// *              Store U(k) in column k
// *
Dscal.dscal(k-1,r1.val,a,(1)- 1+(k- 1)*lda+ _a_offset,1);
}              // Close if()
else  {
  // *
// *              2-by-2 pivot block D(k): columns k and k-1 now hold
// *
// *              ( W(k-1) W(k) ) = ( U(k-1) U(k) )*D(k)
// *
// *              where U(k) and U(k-1) are the k-th and (k-1)-th columns
// *              of U
// *
// *              Perform a rank-2 update of A(1:k-2,1:k-2) as
// *
// *              A := A - ( U(k-1) U(k) )*D(k)*( U(k-1) U(k) )'
// *                 = A - ( W(k-1) W(k) )*inv(D(k))*( W(k-1) W(k) )'
// *
// *              Convert this to two rank-1 updates by using the eigen-
// *              decomposition of D(k)
// *
Dlaev2.dlaev2(a[(k-1)- 1+(k-1- 1)*lda+ _a_offset],a[(k-1)- 1+(k- 1)*lda+ _a_offset],a[(k)- 1+(k- 1)*lda+ _a_offset],r1,r2,c,s);
r1.val = one/r1.val;
r2.val = one/r2.val;
Drot.drot(k-2,a,(1)- 1+(k-1- 1)*lda+ _a_offset,1,a,(1)- 1+(k- 1)*lda+ _a_offset,1,c.val,s.val);
Dsyr.dsyr(uplo,k-2,-r1.val,a,(1)- 1+(k-1- 1)*lda+ _a_offset,1,a,_a_offset,lda);
Dsyr.dsyr(uplo,k-2,-r2.val,a,(1)- 1+(k- 1)*lda+ _a_offset,1,a,_a_offset,lda);
// *
// *              Store U(k) and U(k-1) in columns k and k-1
// *
Dscal.dscal(k-2,r1.val,a,(1)- 1+(k-1- 1)*lda+ _a_offset,1);
Dscal.dscal(k-2,r2.val,a,(1)- 1+(k- 1)*lda+ _a_offset,1);
Drot.drot(k-2,a,(1)- 1+(k-1- 1)*lda+ _a_offset,1,a,(1)- 1+(k- 1)*lda+ _a_offset,1,c.val,-s.val);
}              //  Close else.
}              //  Close else.
// *
// *        Store details of the interchanges in IPIV
// *
if (kstep == 1)  {
    ipiv[(k)- 1+ _ipiv_offset] = kp;
}              // Close if()
else  {
  ipiv[(k)- 1+ _ipiv_offset] = -kp;
ipiv[(k-1)- 1+ _ipiv_offset] = -kp;
}              //  Close else.
// *
// *        Decrease K and return to the start of the main loop
// *
k = k-kstep;
Dummy.go_to("Dsytf2",10);
// *
}              // Close if()
else  {
  // *
// *        Factorize A as L*D*L' using the lower triangle of A
// *
// *        K is the main loop index, increasing from 1 to N in steps of
// *        1 or 2
// *
k = 1;
label20:
   Dummy.label("Dsytf2",20);
// *
// *        If K > N, exit from loop
// *
if (k > n)  
    Dummy.go_to("Dsytf2",30);
kstep = 1;
// *
// *        Determine rows and columns to be interchanged and whether
// *        a 1-by-1 or 2-by-2 pivot block will be used
// *
absakk = Math.abs(a[(k)- 1+(k- 1)*lda+ _a_offset]);
// *
// *        IMAX is the row-index of the largest off-diagonal element in
// *        column K, and COLMAX is its absolute value
// *
if (k < n)  {
    imax = k+Idamax.idamax(n-k,a,(k+1)- 1+(k- 1)*lda+ _a_offset,1);
colmax = Math.abs(a[(imax)- 1+(k- 1)*lda+ _a_offset]);
}              // Close if()
else  {
  colmax = zero;
}              //  Close else.
// *
if (Math.max(absakk, colmax)  == zero)  {
    // *
// *           Column K is zero: set INFO and continue
// *
if (info.val == 0)  
    info.val = k;
kp = k;
}              // Close if()
else  {
  if (absakk >= alpha*colmax)  {
    // *
// *              no interchange, use 1-by-1 pivot block
// *
kp = k;
}              // Close if()
else  {
  // *
// *              JMAX is the column-index of the largest off-diagonal
// *              element in row IMAX, and ROWMAX is its absolute value
// *
jmax = k-1+Idamax.idamax(imax-k,a,(imax)- 1+(k- 1)*lda+ _a_offset,lda);
rowmax = Math.abs(a[(imax)- 1+(jmax- 1)*lda+ _a_offset]);
if (imax < n)  {
    jmax = imax+Idamax.idamax(n-imax,a,(imax+1)- 1+(imax- 1)*lda+ _a_offset,1);
rowmax = Math.max(rowmax, Math.abs(a[(jmax)- 1+(imax- 1)*lda+ _a_offset])) ;
}              // Close if()
// *
if (absakk >= alpha*colmax*(colmax/rowmax))  {
    // *
// *                 no interchange, use 1-by-1 pivot block
// *
kp = k;
}              // Close if()
else if (Math.abs(a[(imax)- 1+(imax- 1)*lda+ _a_offset]) >= alpha*rowmax)  {
    // *
// *                 interchange rows and columns K and IMAX, use 1-by-1
// *                 pivot block
// *
kp = imax;
}              // Close else if()
else  {
  // *
// *                 interchange rows and columns K+1 and IMAX, use 2-by-2
// *                 pivot block
// *
kp = imax;
kstep = 2;
}              //  Close else.
}              //  Close else.
// *
kk = k+kstep-1;
if (kp != kk)  {
    // *
// *              Interchange rows and columns KK and KP in the trailing
// *              submatrix A(k:n,k:n)
// *
if (kp < n)  
    Dswap.dswap(n-kp,a,(kp+1)- 1+(kk- 1)*lda+ _a_offset,1,a,(kp+1)- 1+(kp- 1)*lda+ _a_offset,1);
Dswap.dswap(kp-kk-1,a,(kk+1)- 1+(kk- 1)*lda+ _a_offset,1,a,(kp)- 1+(kk+1- 1)*lda+ _a_offset,lda);
t = a[(kk)- 1+(kk- 1)*lda+ _a_offset];
a[(kk)- 1+(kk- 1)*lda+ _a_offset] = a[(kp)- 1+(kp- 1)*lda+ _a_offset];
a[(kp)- 1+(kp- 1)*lda+ _a_offset] = t;
if (kstep == 2)  {
    t = a[(k+1)- 1+(k- 1)*lda+ _a_offset];
a[(k+1)- 1+(k- 1)*lda+ _a_offset] = a[(kp)- 1+(k- 1)*lda+ _a_offset];
a[(kp)- 1+(k- 1)*lda+ _a_offset] = t;
}              // Close if()
}              // Close if()
// *
// *           Update the trailing submatrix
// *
if (kstep == 1)  {
    // *
// *              1-by-1 pivot block D(k): column k now holds
// *
// *              W(k) = L(k)*D(k)
// *
// *              where L(k) is the k-th column of L
// *
if (k < n)  {
    // *
// *                 Perform a rank-1 update of A(k+1:n,k+1:n) as
// *
// *                 A := A - L(k)*D(k)*L(k)' = A - W(k)*(1/D(k))*W(k)'
// *
r1.val = one/a[(k)- 1+(k- 1)*lda+ _a_offset];
Dsyr.dsyr(uplo,n-k,-r1.val,a,(k+1)- 1+(k- 1)*lda+ _a_offset,1,a,(k+1)- 1+(k+1- 1)*lda+ _a_offset,lda);
// *
// *                 Store L(k) in column K
// *
Dscal.dscal(n-k,r1.val,a,(k+1)- 1+(k- 1)*lda+ _a_offset,1);
}              // Close if()
}              // Close if()
else  {
  // *
// *              2-by-2 pivot block D(k): columns K and K+1 now hold
// *
// *              ( W(k) W(k+1) ) = ( L(k) L(k+1) )*D(k)
// *
// *              where L(k) and L(k+1) are the k-th and (k+1)-th columns
// *              of L
// *
if (k < n-1)  {
    // *
// *                 Perform a rank-2 update of A(k+2:n,k+2:n) as
// *
// *                 A := A - ( L(k) L(k+1) )*D(k)*( L(k) L(k+1) )'
// *                    = A - ( W(k) W(k+1) )*inv(D(k))*( W(k) W(k+1) )'
// *
// *                 Convert this to two rank-1 updates by using the eigen-
// *                 decomposition of D(k)
// *
Dlaev2.dlaev2(a[(k)- 1+(k- 1)*lda+ _a_offset],a[(k+1)- 1+(k- 1)*lda+ _a_offset],a[(k+1)- 1+(k+1- 1)*lda+ _a_offset],r1,r2,c,s);
r1.val = one/r1.val;
r2.val = one/r2.val;
Drot.drot(n-k-1,a,(k+2)- 1+(k- 1)*lda+ _a_offset,1,a,(k+2)- 1+(k+1- 1)*lda+ _a_offset,1,c.val,s.val);
Dsyr.dsyr(uplo,n-k-1,-r1.val,a,(k+2)- 1+(k- 1)*lda+ _a_offset,1,a,(k+2)- 1+(k+2- 1)*lda+ _a_offset,lda);
Dsyr.dsyr(uplo,n-k-1,-r2.val,a,(k+2)- 1+(k+1- 1)*lda+ _a_offset,1,a,(k+2)- 1+(k+2- 1)*lda+ _a_offset,lda);
// *
// *                 Store L(k) and L(k+1) in columns k and k+1
// *
Dscal.dscal(n-k-1,r1.val,a,(k+2)- 1+(k- 1)*lda+ _a_offset,1);
Dscal.dscal(n-k-1,r2.val,a,(k+2)- 1+(k+1- 1)*lda+ _a_offset,1);
Drot.drot(n-k-1,a,(k+2)- 1+(k- 1)*lda+ _a_offset,1,a,(k+2)- 1+(k+1- 1)*lda+ _a_offset,1,c.val,-s.val);
}              // Close if()
}              //  Close else.
}              //  Close else.
// *
// *        Store details of the interchanges in IPIV
// *
if (kstep == 1)  {
    ipiv[(k)- 1+ _ipiv_offset] = kp;
}              // Close if()
else  {
  ipiv[(k)- 1+ _ipiv_offset] = -kp;
ipiv[(k+1)- 1+ _ipiv_offset] = -kp;
}              //  Close else.
// *
// *        Increase K and return to the start of the main loop
// *
k = k+kstep;
Dummy.go_to("Dsytf2",20);
// *
}              //  Close else.
// *
label30:
   Dummy.label("Dsytf2",30);
Dummy.go_to("Dsytf2",999999);
// *
// *     End of DSYTF2
// *
Dummy.label("Dsytf2",999999);
return;
   }
} // End class.
