/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;

import org.netlib.blas.*;


public class Dsytrd {

// *
// *  -- LAPACK routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DSYTRD reduces a real symmetric matrix A to real symmetric
// *  tridiagonal form T by an orthogonal similarity transformation:
// *  Q**T * A * Q = T.
// *
// *  Arguments
// *  =========
// *
// *  UPLO    (input) CHARACTER*1
// *          = 'U':  Upper triangle of A is stored;
// *          = 'L':  Lower triangle of A is stored.
// *
// *  N       (input) INTEGER
// *          The order of the matrix A.  N >= 0.
// *
// *  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
// *          On entry, the symmetric matrix A.  If UPLO = 'U', the leading
// *          N-by-N upper triangular part of A contains the upper
// *          triangular part of the matrix A, and the strictly lower
// *          triangular part of A is not referenced.  If UPLO = 'L', the
// *          leading N-by-N lower triangular part of A contains the lower
// *          triangular part of the matrix A, and the strictly upper
// *          triangular part of A is not referenced.
// *          On exit, if UPLO = 'U', the diagonal and first superdiagonal
// *          of A are overwritten by the corresponding elements of the
// *          tridiagonal matrix T, and the elements above the first
// *          superdiagonal, with the array TAU, represent the orthogonal
// *          matrix Q as a product of elementary reflectors; if UPLO
// *          = 'L', the diagonal and first subdiagonal of A are over-
// *          written by the corresponding elements of the tridiagonal
// *          matrix T, and the elements below the first subdiagonal, with
// *          the array TAU, represent the orthogonal matrix Q as a product
// *          of elementary reflectors. See Further Details.
// *
// *  LDA     (input) INTEGER
// *          The leading dimension of the array A.  LDA >= max(1,N).
// *
// *  D       (output) DOUBLE PRECISION array, dimension (N)
// *          The diagonal elements of the tridiagonal matrix T:
// *          D(i) = A(i,i).
// *
// *  E       (output) DOUBLE PRECISION array, dimension (N-1)
// *          The off-diagonal elements of the tridiagonal matrix T:
// *          E(i) = A(i,i+1) if UPLO = 'U', E(i) = A(i+1,i) if UPLO = 'L'.
// *
// *  TAU     (output) DOUBLE PRECISION array, dimension (N-1)
// *          The scalar factors of the elementary reflectors (see Further
// *          Details).
// *
// *  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
// *          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
// *
// *  LWORK   (input) INTEGER
// *          The dimension of the array WORK.  LWORK >= 1.
// *          For optimum performance LWORK >= N*NB, where NB is the
// *          optimal blocksize.
// *
// *  INFO    (output) INTEGER
// *          = 0:  successful exit
// *          < 0:  if INFO = -i, the i-th argument had an illegal value
// *
// *  Further Details
// *  ===============
// *
// *  If UPLO = 'U', the matrix Q is represented as a product of elementary
// *  reflectors
// *
// *     Q = H(n-1) . . . H(2) H(1).
// *
// *  Each H(i) has the form
// *
// *     H(i) = I - tau * v * v'
// *
// *  where tau is a real scalar, and v is a real vector with
// *  v(i+1:n) = 0 and v(i) = 1; v(1:i-1) is stored on exit in
// *  A(1:i-1,i+1), and tau in TAU(i).
// *
// *  If UPLO = 'L', the matrix Q is represented as a product of elementary
// *  reflectors
// *
// *     Q = H(1) H(2) . . . H(n-1).
// *
// *  Each H(i) has the form
// *
// *     H(i) = I - tau * v * v'
// *
// *  where tau is a real scalar, and v is a real vector with
// *  v(1:i) = 0 and v(i+1) = 1; v(i+2:n) is stored on exit in A(i+2:n,i),
// *  and tau in TAU(i).
// *
// *  The contents of A on exit are illustrated by the following examples
// *  with n = 5:
// *
// *  if UPLO = 'U':                       if UPLO = 'L':
// *
// *    (  d   e   v2  v3  v4 )              (  d                  )
// *    (      d   e   v3  v4 )              (  e   d              )
// *    (          d   e   v4 )              (  v1  e   d          )
// *    (              d   e  )              (  v1  v2  e   d      )
// *    (                  d  )              (  v1  v2  v3  e   d  )
// *
// *  where d and e denote diagonal and off-diagonal elements of T, and vi
// *  denotes an element of the vector defining H(i).
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double one= 1.0e0;
// *     ..
// *     .. Local Scalars ..
static boolean upper= false;
static int i= 0;
static intW iinfo= new intW(0);
static int iws= 0;
static int j= 0;
static int kk= 0;
static int ldwork= 0;
static int nb= 0;
static int nbmin= 0;
static int nx= 0;
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Test the input parameters
// *

public static void dsytrd (String uplo,
int n,
double [] a, int _a_offset,
int lda,
double [] d, int _d_offset,
double [] e, int _e_offset,
double [] tau, int _tau_offset,
double [] work, int _work_offset,
int lwork,
intW info)  {

info.val = 0;
upper = (uplo.toLowerCase().charAt(0) == "U".toLowerCase().charAt(0));
if (!upper && !(uplo.toLowerCase().charAt(0) == "L".toLowerCase().charAt(0)))  {
    info.val = -1;
}              // Close if()
else if (n < 0)  {
    info.val = -2;
}              // Close else if()
else if (lda < Math.max(1, n) )  {
    info.val = -4;
}              // Close else if()
else if (lwork < 1)  {
    info.val = -9;
}              // Close else if()
if (info.val != 0)  {
    Xerbla.xerbla("DSYTRD",-info.val);
Dummy.go_to("Dsytrd",999999);
}              // Close if()
// *
// *     Quick return if possible
// *
if (n == 0)  {
    work[(1)- 1+ _work_offset] = (double)(1);
Dummy.go_to("Dsytrd",999999);
}              // Close if()
// *
// *     Determine the block size.
// *
nb = Ilaenv.ilaenv(1,"DSYTRD",uplo,n,-1,-1,-1);
nx = n;
iws = 1;
if (nb > 1 && nb < n)  {
    // *
// *        Determine when to cross over from blocked to unblocked code
// *        (last block is always handled by unblocked code).
// *
nx = (int)(Math.max(nb, Ilaenv.ilaenv(3,"DSYTRD",uplo,n,-1,-1,-1)) );
if (nx < n)  {
    // *
// *           Determine if workspace is large enough for blocked code.
// *
ldwork = n;
iws = ldwork*nb;
if (lwork < iws)  {
    // *
// *              Not enough workspace to use optimal NB:  determine the
// *              minimum value of NB, and reduce NB or force use of
// *              unblocked code by setting NX = N.
// *
nb = (int)(Math.max(lwork/ldwork, 1) );
nbmin = Ilaenv.ilaenv(2,"DSYTRD",uplo,n,-1,-1,-1);
if (nb < nbmin)  
    nx = n;
}              // Close if()
}              // Close if()
else  {
  nx = n;
}              //  Close else.
}              // Close if()
else  {
  nb = 1;
}              //  Close else.
// *
if (upper)  {
    // *
// *        Reduce the upper triangle of A.
// *        Columns 1:kk are handled by the unblocked method.
// *
kk = n-((n-nx+nb-1)/nb)*nb;
{
int _i_inc = -nb;
forloop20:
for (i = n-nb+1; (_i_inc < 0) ? i >= kk+1 : i <= kk+1; i += _i_inc) {
// *
// *           Reduce columns i:i+nb-1 to tridiagonal form and form the
// *           matrix W which is needed to update the unreduced part of
// *           the matrix
// *
Dlatrd.dlatrd(uplo,i+nb-1,nb,a,_a_offset,lda,e,_e_offset,tau,_tau_offset,work,_work_offset,ldwork);
// *
// *           Update the unreduced submatrix A(1:i-1,1:i-1), using an
// *           update of the form:  A := A - V*W' - W*V'
// *
Dsyr2k.dsyr2k(uplo,"No transpose",i-1,nb,-one,a,(1)- 1+(i- 1)*lda+ _a_offset,lda,work,_work_offset,ldwork,one,a,_a_offset,lda);
// *
// *           Copy superdiagonal elements back into A, and diagonal
// *           elements into D
// *
{
forloop10:
for (j = i; j <= i+nb-1; j++) {
a[(j-1)- 1+(j- 1)*lda+ _a_offset] = e[(j-1)- 1+ _e_offset];
d[(j)- 1+ _d_offset] = a[(j)- 1+(j- 1)*lda+ _a_offset];
Dummy.label("Dsytrd",10);
}              //  Close for() loop. 
}
Dummy.label("Dsytrd",20);
}              //  Close for() loop. 
}
// *
// *        Use unblocked code to reduce the last or only block
// *
Dsytd2.dsytd2(uplo,kk,a,_a_offset,lda,d,_d_offset,e,_e_offset,tau,_tau_offset,iinfo);
}              // Close if()
else  {
  // *
// *        Reduce the lower triangle of A
// *
{
int _i_inc = nb;
forloop40:
for (i = 1; (_i_inc < 0) ? i >= n-nx : i <= n-nx; i += _i_inc) {
// *
// *           Reduce columns i:i+nb-1 to tridiagonal form and form the
// *           matrix W which is needed to update the unreduced part of
// *           the matrix
// *
Dlatrd.dlatrd(uplo,n-i+1,nb,a,(i)- 1+(i- 1)*lda+ _a_offset,lda,e,(i)- 1+ _e_offset,tau,(i)- 1+ _tau_offset,work,_work_offset,ldwork);
// *
// *           Update the unreduced submatrix A(i+ib:n,i+ib:n), using
// *           an update of the form:  A := A - V*W' - W*V'
// *
Dsyr2k.dsyr2k(uplo,"No transpose",n-i-nb+1,nb,-one,a,(i+nb)- 1+(i- 1)*lda+ _a_offset,lda,work,(nb+1)- 1+ _work_offset,ldwork,one,a,(i+nb)- 1+(i+nb- 1)*lda+ _a_offset,lda);
// *
// *           Copy subdiagonal elements back into A, and diagonal
// *           elements into D
// *
{
forloop30:
for (j = i; j <= i+nb-1; j++) {
a[(j+1)- 1+(j- 1)*lda+ _a_offset] = e[(j)- 1+ _e_offset];
d[(j)- 1+ _d_offset] = a[(j)- 1+(j- 1)*lda+ _a_offset];
Dummy.label("Dsytrd",30);
}              //  Close for() loop. 
}
Dummy.label("Dsytrd",40);
}              //  Close for() loop. 
}
// *
// *        Use unblocked code to reduce the last or only block
// *
Dsytd2.dsytd2(uplo,n-i+1,a,(i)- 1+(i- 1)*lda+ _a_offset,lda,d,(i)- 1+ _d_offset,e,(i)- 1+ _e_offset,tau,(i)- 1+ _tau_offset,iinfo);
}              //  Close else.
// *
work[(1)- 1+ _work_offset] = (double)(iws);
Dummy.go_to("Dsytrd",999999);
// *
// *     End of DSYTRD
// *
Dummy.label("Dsytrd",999999);
return;
   }
} // End class.
