/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;



public class Dsytrf {

// *
// *  -- LAPACK routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DSYTRF computes the factorization of a real symmetric matrix A using
// *  the Bunch-Kaufman diagonal pivoting method.  The form of the
// *  factorization is
// *
// *     A = U*D*U**T  or  A = L*D*L**T
// *
// *  where U (or L) is a product of permutation and unit upper (lower)
// *  triangular matrices, and D is symmetric and block diagonal with
// *  1-by-1 and 2-by-2 diagonal blocks.
// *
// *  This is the blocked version of the algorithm, calling Level 3 BLAS.
// *
// *  Arguments
// *  =========
// *
// *  UPLO    (input) CHARACTER*1
// *          = 'U':  Upper triangle of A is stored;
// *          = 'L':  Lower triangle of A is stored.
// *
// *  N       (input) INTEGER
// *          The order of the matrix A.  N >= 0.
// *
// *  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
// *          On entry, the symmetric matrix A.  If UPLO = 'U', the leading
// *          N-by-N upper triangular part of A contains the upper
// *          triangular part of the matrix A, and the strictly lower
// *          triangular part of A is not referenced.  If UPLO = 'L', the
// *          leading N-by-N lower triangular part of A contains the lower
// *          triangular part of the matrix A, and the strictly upper
// *          triangular part of A is not referenced.
// *
// *          On exit, the block diagonal matrix D and the multipliers used
// *          to obtain the factor U or L (see below for further details).
// *
// *  LDA     (input) INTEGER
// *          The leading dimension of the array A.  LDA >= max(1,N).
// *
// *  IPIV    (output) INTEGER array, dimension (N)
// *          Details of the interchanges and the block structure of D.
// *          If IPIV(k) > 0, then rows and columns k and IPIV(k) were
// *          interchanged and D(k,k) is a 1-by-1 diagonal block.
// *          If UPLO = 'U' and IPIV(k) = IPIV(k-1) < 0, then rows and
// *          columns k-1 and -IPIV(k) were interchanged and D(k-1:k,k-1:k)
// *          is a 2-by-2 diagonal block.  If UPLO = 'L' and IPIV(k) =
// *          IPIV(k+1) < 0, then rows and columns k+1 and -IPIV(k) were
// *          interchanged and D(k:k+1,k:k+1) is a 2-by-2 diagonal block.
// *
// *  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
// *          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
// *
// *  LWORK   (input) INTEGER
// *          The length of WORK.  LWORK >=1.  For best performance
// *          LWORK >= N*NB, where NB is the block size returned by ILAENV.
// *
// *  INFO    (output) INTEGER
// *          = 0:  successful exit
// *          < 0:  if INFO = -i, the i-th argument had an illegal value
// *          > 0:  if INFO = i, D(i,i) is exactly zero.  The factorization
// *                has been completed, but the block diagonal matrix D is
// *                exactly singular, and division by zero will occur if it
// *                is used to solve a system of equations.
// *
// *  Further Details
// *  ===============
// *
// *  If UPLO = 'U', then A = U*D*U', where
// *     U = P(n)*U(n)* ... *P(k)U(k)* ...,
// *  i.e., U is a product of terms P(k)*U(k), where k decreases from n to
// *  1 in steps of 1 or 2, and D is a block diagonal matrix with 1-by-1
// *  and 2-by-2 diagonal blocks D(k).  P(k) is a permutation matrix as
// *  defined by IPIV(k), and U(k) is a unit upper triangular matrix, such
// *  that if the diagonal block D(k) is of order s (s = 1 or 2), then
// *
// *             (   I    v    0   )   k-s
// *     U(k) =  (   0    I    0   )   s
// *             (   0    0    I   )   n-k
// *                k-s   s   n-k
// *
// *  If s = 1, D(k) overwrites A(k,k), and v overwrites A(1:k-1,k).
// *  If s = 2, the upper triangle of D(k) overwrites A(k-1,k-1), A(k-1,k),
// *  and A(k,k), and v overwrites A(1:k-2,k-1:k).
// *
// *  If UPLO = 'L', then A = L*D*L', where
// *     L = P(1)*L(1)* ... *P(k)*L(k)* ...,
// *  i.e., L is a product of terms P(k)*L(k), where k increases from 1 to
// *  n in steps of 1 or 2, and D is a block diagonal matrix with 1-by-1
// *  and 2-by-2 diagonal blocks D(k).  P(k) is a permutation matrix as
// *  defined by IPIV(k), and L(k) is a unit lower triangular matrix, such
// *  that if the diagonal block D(k) is of order s (s = 1 or 2), then
// *
// *             (   I    0     0   )  k-1
// *     L(k) =  (   0    I     0   )  s
// *             (   0    v     I   )  n-k-s+1
// *                k-1   s  n-k-s+1
// *
// *  If s = 1, D(k) overwrites A(k,k), and v overwrites A(k+1:n,k).
// *  If s = 2, the lower triangle of D(k) overwrites A(k,k), A(k+1,k),
// *  and A(k+1,k+1), and v overwrites A(k+2:n,k:k+1).
// *
// *  =====================================================================
// *
// *     .. Local Scalars ..
static boolean upper= false;
static intW iinfo= new intW(0);
static int iws= 0;
static int j= 0;
static int k= 0;
static intW kb= new intW(0);
static int ldwork= 0;
static int nb= 0;
static int nbmin= 0;
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Test the input parameters.
// *

public static void dsytrf (String uplo,
int n,
double [] a, int _a_offset,
int lda,
int [] ipiv, int _ipiv_offset,
double [] work, int _work_offset,
int lwork,
intW info)  {

info.val = 0;
upper = (uplo.toLowerCase().charAt(0) == "U".toLowerCase().charAt(0));
if (!upper && !(uplo.toLowerCase().charAt(0) == "L".toLowerCase().charAt(0)))  {
    info.val = -1;
}              // Close if()
else if (n < 0)  {
    info.val = -2;
}              // Close else if()
else if (lda < Math.max(1, n) )  {
    info.val = -4;
}              // Close else if()
else if (lwork < 1)  {
    info.val = -7;
}              // Close else if()
if (info.val != 0)  {
    Xerbla.xerbla("DSYTRF",-info.val);
Dummy.go_to("Dsytrf",999999);
}              // Close if()
// *
// *     Determine the block size
// *
nb = Ilaenv.ilaenv(1,"DSYTRF",uplo,n,-1,-1,-1);
nbmin = 2;
ldwork = n;
if (nb > 1 && nb < n)  {
    iws = ldwork*nb;
if (lwork < iws)  {
    nb = (int)(Math.max(lwork/ldwork, 1) );
nbmin = (int)(Math.max(2, Ilaenv.ilaenv(2,"DSYTRF",uplo,n,-1,-1,-1)) );
}              // Close if()
}              // Close if()
else  {
  iws = 1;
}              //  Close else.
if (nb < nbmin)  
    nb = n;
// *
if (upper)  {
    // *
// *        Factorize A as U*D*U' using the upper triangle of A
// *
// *        K is the main loop index, decreasing from N to 1 in steps of
// *        KB, where KB is the number of columns factorized by DLASYF;
// *        KB is either NB or NB-1, or K for the last block
// *
k = n;
label10:
   Dummy.label("Dsytrf",10);
// *
// *        If K < 1, exit from loop
// *
if (k < 1)  
    Dummy.go_to("Dsytrf",40);
// *
if (k > nb)  {
    // *
// *           Factorize columns k-kb+1:k of A and use blocked code to
// *           update columns 1:k-kb
// *
Dlasyf.dlasyf(uplo,k,nb,kb,a,_a_offset,lda,ipiv,_ipiv_offset,work,_work_offset,ldwork,iinfo);
}              // Close if()
else  {
  // *
// *           Use unblocked code to factorize columns 1:k of A
// *
Dsytf2.dsytf2(uplo,k,a,_a_offset,lda,ipiv,_ipiv_offset,iinfo);
kb.val = k;
}              //  Close else.
// *
// *        Set INFO on the first occurrence of a zero pivot
// *
if (info.val == 0 && iinfo.val > 0)  
    info.val = iinfo.val;
// *
// *        Decrease K and return to the start of the main loop
// *
k = k-kb.val;
Dummy.go_to("Dsytrf",10);
// *
}              // Close if()
else  {
  // *
// *        Factorize A as L*D*L' using the lower triangle of A
// *
// *        K is the main loop index, increasing from 1 to N in steps of
// *        KB, where KB is the number of columns factorized by DLASYF;
// *        KB is either NB or NB-1, or N-K+1 for the last block
// *
k = 1;
label20:
   Dummy.label("Dsytrf",20);
// *
// *        If K > N, exit from loop
// *
if (k > n)  
    Dummy.go_to("Dsytrf",40);
// *
if (k <= n-nb)  {
    // *
// *           Factorize columns k:k+kb-1 of A and use blocked code to
// *           update columns k+kb:n
// *
Dlasyf.dlasyf(uplo,n-k+1,nb,kb,a,(k)- 1+(k- 1)*lda+ _a_offset,lda,ipiv,(k)- 1+ _ipiv_offset,work,_work_offset,ldwork,iinfo);
}              // Close if()
else  {
  // *
// *           Use unblocked code to factorize columns k:n of A
// *
Dsytf2.dsytf2(uplo,n-k+1,a,(k)- 1+(k- 1)*lda+ _a_offset,lda,ipiv,(k)- 1+ _ipiv_offset,iinfo);
kb.val = n-k+1;
}              //  Close else.
// *
// *        Set INFO on the first occurrence of a zero pivot
// *
if (info.val == 0 && iinfo.val > 0)  
    info.val = iinfo.val+k-1;
// *
// *        Adjust IPIV
// *
{
forloop30:
for (j = k; j <= k+kb.val-1; j++) {
if (ipiv[(j)- 1+ _ipiv_offset] > 0)  {
    ipiv[(j)- 1+ _ipiv_offset] = ipiv[(j)- 1+ _ipiv_offset]+k-1;
}              // Close if()
else  {
  ipiv[(j)- 1+ _ipiv_offset] = ipiv[(j)- 1+ _ipiv_offset]-k+1;
}              //  Close else.
Dummy.label("Dsytrf",30);
}              //  Close for() loop. 
}
// *
// *        Increase K and return to the start of the main loop
// *
k = k+kb.val;
Dummy.go_to("Dsytrf",20);
// *
}              //  Close else.
// *
label40:
   Dummy.label("Dsytrf",40);
work[(1)- 1+ _work_offset] = (double)(iws);
Dummy.go_to("Dsytrf",999999);
// *
// *     End of DSYTRF
// *
Dummy.label("Dsytrf",999999);
return;
   }
} // End class.
