/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;

import org.netlib.blas.*;


public class Dtgevc {

// *
// *  -- LAPACK routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *
// *  Purpose
// *  =======
// *
// *  DTGEVC computes some or all of the right and/or left generalized
// *  eigenvectors of a pair of real upper triangular matrices (A,B).
// *
// *  The right generalized eigenvector x and the left generalized
// *  eigenvector y of (A,B) corresponding to a generalized eigenvalue
// *  w are defined by:
// *
// *          (A - wB) * x = 0  and  y**H * (A - wB) = 0
// *
// *  where y**H denotes the conjugate tranpose of y.
// *
// *  If an eigenvalue w is determined by zero diagonal elements of both A
// *  and B, a unit vector is returned as the corresponding eigenvector.
// *
// *  If all eigenvectors are requested, the routine may either return
// *  the matrices X and/or Y of right or left eigenvectors of (A,B), or
// *  the products Z*X and/or Q*Y, where Z and Q are input orthogonal
// *  matrices.  If (A,B) was obtained from the generalized real-Schur
// *  factorization of an original pair of matrices
// *     (A0,B0) = (Q*A*Z**H,Q*B*Z**H),
// *  then Z*X and Q*Y are the matrices of right or left eigenvectors of
// *  A.
// *
// *  A must be block upper triangular, with 1-by-1 and 2-by-2 diagonal
// *  blocks.  Corresponding to each 2-by-2 diagonal block is a complex
// *  conjugate pair of eigenvalues and eigenvectors; only one
// *  eigenvector of the pair is computed, namely the one corresponding
// *  to the eigenvalue with positive imaginary part.
// *
// *  Arguments
// *  =========
// *
// *  SIDE    (input) CHARACTER*1
// *          = 'R': compute right eigenvectors only;
// *          = 'L': compute left eigenvectors only;
// *          = 'B': compute both right and left eigenvectors.
// *
// *  HOWMNY  (input) CHARACTER*1
// *          = 'A': compute all right and/or left eigenvectors;
// *          = 'B': compute all right and/or left eigenvectors, and
// *                 backtransform them using the input matrices supplied
// *                 in VR and/or VL;
// *          = 'S': compute selected right and/or left eigenvectors,
// *                 specified by the logical array SELECT.
// *
// *  SELECT  (input) LOGICAL array, dimension (N)
// *          If HOWMNY='S', SELECT specifies the eigenvectors to be
// *          computed.
// *          If HOWMNY='A' or 'B', SELECT is not referenced.
// *          To select the real eigenvector corresponding to the real
// *          eigenvalue w(j), SELECT(j) must be set to .TRUE.  To select
// *          the complex eigenvector corresponding to a complex conjugate
// *          pair w(j) and w(j+1), either SELECT(j) or SELECT(j+1) must
// *          be set to .TRUE..
// *
// *  N       (input) INTEGER
// *          The order of the matrices A and B.  N >= 0.
// *
// *  A       (input) DOUBLE PRECISION array, dimension (LDA,N)
// *          The upper quasi-triangular matrix A.
// *
// *  LDA     (input) INTEGER
// *          The leading dimension of array A.  LDA >= max(1, N).
// *
// *  B       (input) DOUBLE PRECISION array, dimension (LDB,N)
// *          The upper triangular matrix B.  If A has a 2-by-2 diagonal
// *          block, then the corresponding 2-by-2 block of B must be
// *          diagonal with positive elements.
// *
// *  LDB     (input) INTEGER
// *          The leading dimension of array B.  LDB >= max(1,N).
// *
// *  VL      (input/output) DOUBLE PRECISION array, dimension (LDVL,MM)
// *          On entry, if SIDE = 'L' or 'B' and HOWMNY = 'B', VL must
// *          contain an N-by-N matrix Q (usually the orthogonal matrix Q
// *          of left Schur vectors returned by DHGEQZ).
// *          On exit, if SIDE = 'L' or 'B', VL contains:
// *          if HOWMNY = 'A', the matrix Y of left eigenvectors of (A,B);
// *          if HOWMNY = 'B', the matrix Q*Y;
// *          if HOWMNY = 'S', the left eigenvectors of (A,B) specified by
// *                      SELECT, stored consecutively in the columns of
// *                      VL, in the same order as their eigenvalues.
// *          If SIDE = 'R', VL is not referenced.
// *
// *          A complex eigenvector corresponding to a complex eigenvalue
// *          is stored in two consecutive columns, the first holding the
// *          real part, and the second the imaginary part.
// *
// *  LDVL    (input) INTEGER
// *          The leading dimension of array VL.
// *          LDVL >= max(1,N) if SIDE = 'L' or 'B'; LDVL >= 1 otherwise.
// *
// *  VR      (input/output) COMPLEX*16 array, dimension (LDVR,MM)
// *          On entry, if SIDE = 'R' or 'B' and HOWMNY = 'B', VR must
// *          contain an N-by-N matrix Q (usually the orthogonal matrix Z
// *          of right Schur vectors returned by DHGEQZ).
// *          On exit, if SIDE = 'R' or 'B', VR contains:
// *          if HOWMNY = 'A', the matrix X of right eigenvectors of (A,B);
// *          if HOWMNY = 'B', the matrix Z*X;
// *          if HOWMNY = 'S', the right eigenvectors of (A,B) specified by
// *                      SELECT, stored consecutively in the columns of
// *                      VR, in the same order as their eigenvalues.
// *          If SIDE = 'L', VR is not referenced.
// *
// *          A complex eigenvector corresponding to a complex eigenvalue
// *          is stored in two consecutive columns, the first holding the
// *          real part and the second the imaginary part.
// *
// *  LDVR    (input) INTEGER
// *          The leading dimension of the array VR.
// *          LDVR >= max(1,N) if SIDE = 'R' or 'B'; LDVR >= 1 otherwise.
// *
// *  MM      (input) INTEGER
// *          The number of columns in the arrays VL and/or VR. MM >= M.
// *
// *  M       (output) INTEGER
// *          The number of columns in the arrays VL and/or VR actually
// *          used to store the eigenvectors.  If HOWMNY = 'A' or 'B', M
// *          is set to N.  Each selected real eigenvector occupies one
// *          column and each selected complex eigenvector occupies two
// *          columns.
// *
// *  WORK    (workspace) DOUBLE PRECISION array, dimension (6*N)
// *
// *  INFO    (output) INTEGER
// *          = 0:  successful exit.
// *          < 0:  if INFO = -i, the i-th argument had an illegal value.
// *          > 0:  the 2-by-2 block (INFO:INFO+1) does not have a complex
// *                eigenvalue.
// *
// *  Further Details
// *  ===============
// *
// *  Allocation of workspace:
// *  ---------- -- ---------
// *
// *     WORK( j ) = 1-norm of j-th column of A, above the diagonal
// *     WORK( N+j ) = 1-norm of j-th column of B, above the diagonal
// *     WORK( 2*N+1:3*N ) = real part of eigenvector
// *     WORK( 3*N+1:4*N ) = imaginary part of eigenvector
// *     WORK( 4*N+1:5*N ) = real part of back-transformed eigenvector
// *     WORK( 5*N+1:6*N ) = imaginary part of back-transformed eigenvector
// *
// *  Rowwise vs. columnwise solution methods:
// *  ------- --  ---------- -------- -------
// *
// *  Finding a generalized eigenvector consists basically of solving the
// *  singular triangular system
// *
// *   (A - w B) x = 0     (for right) or:   (A - w B)**H y = 0  (for left)
// *
// *  Consider finding the i-th right eigenvector (assume all eigenvalues
// *  are real). The equation to be solved is:
// *       n                   i
// *  0 = sum  C(j,k) v(k)  = sum  C(j,k) v(k)     for j = i,. . .,1
// *      k=j                 k=j
// *
// *  where  C = (A - w B)  (The components v(i+1:n) are 0.)
// *
// *  The "rowwise" method is:
// *
// *  (1)  v(i) := 1
// *  for j = i-1,. . .,1:
// *                          i
// *      (2) compute  s = - sum C(j,k) v(k)   and
// *                        k=j+1
// *
// *      (3) v(j) := s / C(j,j)
// *
// *  Step 2 is sometimes called the "dot product" step, since it is an
// *  inner product between the j-th row and the portion of the eigenvector
// *  that has been computed so far.
// *
// *  The "columnwise" method consists basically in doing the sums
// *  for all the rows in parallel.  As each v(j) is computed, the
// *  contribution of v(j) times the j-th column of C is added to the
// *  partial sums.  Since FORTRAN arrays are stored columnwise, this has
// *  the advantage that at each step, the elements of C that are accessed
// *  are adjacent to one another, whereas with the rowwise method, the
// *  elements accessed at a step are spaced LDA (and LDB) words apart.
// *
// *  When finding left eigenvectors, the matrix in question is the
// *  transpose of the one in storage, so the rowwise method then
// *  actually accesses columns of A and B at each step, and so is the
// *  preferred method.
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double zero= 0.0e+0;
static double one= 1.0e+0;
static double safety= 1.0e+2;
// *     ..
// *     .. Local Scalars ..
static boolean compl= false;
static boolean compr= false;
static boolean il2by2= false;
static boolean ilabad= false;
static boolean ilall= false;
static boolean ilback= false;
static boolean ilbbad= false;
static boolean ilcomp= false;
static boolean ilcplx= false;
static boolean lsa= false;
static boolean lsb= false;
static int i= 0;
static int ibeg= 0;
static int ieig= 0;
static int iend= 0;
static int ihwmny= 0;
static intW iinfo= new intW(0);
static int im= 0;
static int iside= 0;
static int j= 0;
static int ja= 0;
static int jc= 0;
static int je= 0;
static int jr= 0;
static int jw= 0;
static int na= 0;
static int nw= 0;
static doubleW acoef= new doubleW(0.0);
static double acoefa= 0.0;
static double anorm= 0.0;
static double ascale= 0.0;
static double bcoefa= 0.0;
static doubleW bcoefi= new doubleW(0.0);
static doubleW bcoefr= new doubleW(0.0);
static doubleW big= new doubleW(0.0);
static double bignum= 0.0;
static double bnorm= 0.0;
static double bscale= 0.0;
static double cim2a= 0.0;
static double cim2b= 0.0;
static double cimaga= 0.0;
static double cimagb= 0.0;
static double cre2a= 0.0;
static double cre2b= 0.0;
static double creala= 0.0;
static double crealb= 0.0;
static double dmin= 0.0;
static doubleW safmin= new doubleW(0.0);
static double salfar= 0.0;
static double sbeta= 0.0;
static doubleW scale= new doubleW(0.0);
static double small= 0.0;
static doubleW temp= new doubleW(0.0);
static doubleW temp2= new doubleW(0.0);
static double temp2i= 0.0;
static double temp2r= 0.0;
static double ulp= 0.0;
static double xmax= 0.0;
static double xscale= 0.0;
// *     ..
// *     .. Local Arrays ..
static double [] bdiag= new double[(2)];
static double [] sum= new double[(2) * (2)];
static double [] suma= new double[(2) * (2)];
static double [] sumb= new double[(2) * (2)];
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Decode and Test the input parameters
// *

public static void dtgevc (String side,
String howmny,
boolean [] select, int _select_offset,
int n,
double [] a, int _a_offset,
int lda,
double [] b, int _b_offset,
int ldb,
double [] vl, int _vl_offset,
int ldvl,
double [] vr, int _vr_offset,
int ldvr,
int mm,
intW m,
double [] work, int _work_offset,
intW info)  {

if ((howmny.toLowerCase().charAt(0) == "A".toLowerCase().charAt(0)))  {
    ihwmny = 1;
ilall = true;
ilback = false;
}              // Close if()
else if ((howmny.toLowerCase().charAt(0) == "S".toLowerCase().charAt(0)))  {
    ihwmny = 2;
ilall = false;
ilback = false;
}              // Close else if()
else if ((howmny.toLowerCase().charAt(0) == "B".toLowerCase().charAt(0)) || (howmny.toLowerCase().charAt(0) == "T".toLowerCase().charAt(0)))  {
    ihwmny = 3;
ilall = true;
ilback = true;
}              // Close else if()
else  {
  ihwmny = -1;
ilall = true;
}              //  Close else.
// *
if ((side.toLowerCase().charAt(0) == "R".toLowerCase().charAt(0)))  {
    iside = 1;
compl = false;
compr = true;
}              // Close if()
else if ((side.toLowerCase().charAt(0) == "L".toLowerCase().charAt(0)))  {
    iside = 2;
compl = true;
compr = false;
}              // Close else if()
else if ((side.toLowerCase().charAt(0) == "B".toLowerCase().charAt(0)))  {
    iside = 3;
compl = true;
compr = true;
}              // Close else if()
else  {
  iside = -1;
}              //  Close else.
// *
// *     Count the number of eigenvectors to be computed
// *
if (!ilall)  {
    im = 0;
ilcplx = false;
{
forloop10:
for (j = 1; j <= n; j++) {
if (ilcplx)  {
    ilcplx = false;
continue forloop10;
}              // Close if()
if (j < n)  {
    if (a[(j+1)- 1+(j- 1)*lda+ _a_offset] != zero)  
    ilcplx = true;
}              // Close if()
if (ilcplx)  {
    if (select[(j)- 1+ _select_offset] || select[(j+1)- 1+ _select_offset])  
    im = im+2;
}              // Close if()
else  {
  if (select[(j)- 1+ _select_offset])  
    im = im+1;
}              //  Close else.
Dummy.label("Dtgevc",10);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  im = n;
}              //  Close else.
// *
// *     Check 2-by-2 diagonal blocks of A, B
// *
ilabad = false;
ilbbad = false;
{
forloop20:
for (j = 1; j <= n-1; j++) {
if (a[(j+1)- 1+(j- 1)*lda+ _a_offset] != zero)  {
    if (b[(j)- 1+(j- 1)*ldb+ _b_offset] == zero || b[(j+1)- 1+(j+1- 1)*ldb+ _b_offset] == zero || b[(j)- 1+(j+1- 1)*ldb+ _b_offset] != zero)  
    ilbbad = true;
if (j < n-1)  {
    if (a[(j+2)- 1+(j+1- 1)*lda+ _a_offset] != zero)  
    ilabad = true;
}              // Close if()
}              // Close if()
Dummy.label("Dtgevc",20);
}              //  Close for() loop. 
}
// *
info.val = 0;
if (iside < 0)  {
    info.val = -1;
}              // Close if()
else if (ihwmny < 0)  {
    info.val = -2;
}              // Close else if()
else if (n < 0)  {
    info.val = -4;
}              // Close else if()
else if (ilabad)  {
    info.val = -5;
}              // Close else if()
else if (lda < Math.max(1, n) )  {
    info.val = -6;
}              // Close else if()
else if (ilbbad)  {
    info.val = -7;
}              // Close else if()
else if (ldb < Math.max(1, n) )  {
    info.val = -8;
}              // Close else if()
else if (compl && ldvl < n || ldvl < 1)  {
    info.val = -10;
}              // Close else if()
else if (compr && ldvr < n || ldvr < 1)  {
    info.val = -12;
}              // Close else if()
else if (mm < im)  {
    info.val = -13;
}              // Close else if()
if (info.val != 0)  {
    Xerbla.xerbla("DTGEVC",-info.val);
Dummy.go_to("Dtgevc",999999);
}              // Close if()
// *
// *     Quick return if possible
// *
m.val = im;
if (n == 0)  
    Dummy.go_to("Dtgevc",999999);
// *
// *     Machine Constants
// *
safmin.val = Dlamch.dlamch("Safe minimum");
big.val = one/safmin.val;
Dlabad.dlabad(safmin,big);
ulp = Dlamch.dlamch("Epsilon")*Dlamch.dlamch("Base");
small = safmin.val*n/ulp;
big.val = one/small;
bignum = one/(safmin.val*n);
// *
// *     Compute the 1-norm of each column of the strictly upper triangular
// *     part (i.e., excluding all elements belonging to the diagonal
// *     blocks) of A and B to check for possible overflow in the
// *     triangular solver.
// *
anorm = Math.abs(a[(1)- 1+(1- 1)*lda+ _a_offset]);
if (n > 1)  
    anorm = anorm+Math.abs(a[(2)- 1+(1- 1)*lda+ _a_offset]);
bnorm = Math.abs(b[(1)- 1+(1- 1)*ldb+ _b_offset]);
work[(1)- 1+ _work_offset] = zero;
work[(n+1)- 1+ _work_offset] = zero;
// *
{
forloop50:
for (j = 2; j <= n; j++) {
temp.val = zero;
temp2.val = zero;
if (a[(j)- 1+(j-1- 1)*lda+ _a_offset] == zero)  {
    iend = j-1;
}              // Close if()
else  {
  iend = j-2;
}              //  Close else.
{
forloop30:
for (i = 1; i <= iend; i++) {
temp.val = temp.val+Math.abs(a[(i)- 1+(j- 1)*lda+ _a_offset]);
temp2.val = temp2.val+Math.abs(b[(i)- 1+(j- 1)*ldb+ _b_offset]);
Dummy.label("Dtgevc",30);
}              //  Close for() loop. 
}
work[(j)- 1+ _work_offset] = temp.val;
work[(n+j)- 1+ _work_offset] = temp2.val;
{
forloop40:
for (i = iend+1; i <= Math.min(j+1, n) ; i++) {
temp.val = temp.val+Math.abs(a[(i)- 1+(j- 1)*lda+ _a_offset]);
temp2.val = temp2.val+Math.abs(b[(i)- 1+(j- 1)*ldb+ _b_offset]);
Dummy.label("Dtgevc",40);
}              //  Close for() loop. 
}
anorm = Math.max(anorm, temp.val) ;
bnorm = Math.max(bnorm, temp2.val) ;
Dummy.label("Dtgevc",50);
}              //  Close for() loop. 
}
// *
ascale = one/Math.max(anorm, safmin.val) ;
bscale = one/Math.max(bnorm, safmin.val) ;
// *
// *     Left eigenvectors
// *
if (compl)  {
    ieig = 0;
// *
// *        Main loop over eigenvalues
// *
ilcplx = false;
{
forloop220:
for (je = 1; je <= n; je++) {
// *
// *           Skip this iteration if (a) HOWMNY='S' and SELECT=.FALSE., or
// *           (b) this would be the second of a complex pair.
// *           Check for complex eigenvalue, so as to be sure of which
// *           entry(-ies) of SELECT to look at.
// *
if (ilcplx)  {
    ilcplx = false;
continue forloop220;
}              // Close if()
nw = 1;
if (je < n)  {
    if (a[(je+1)- 1+(je- 1)*lda+ _a_offset] != zero)  {
    ilcplx = true;
nw = 2;
}              // Close if()
}              // Close if()
if (ilall)  {
    ilcomp = true;
}              // Close if()
else if (ilcplx)  {
    ilcomp = select[(je)- 1+ _select_offset] || select[(je+1)- 1+ _select_offset];
}              // Close else if()
else  {
  ilcomp = select[(je)- 1+ _select_offset];
}              //  Close else.
if (!ilcomp)  
    continue forloop220;
// *
// *           Decide if (a) singular pencil, (b) real eigenvalue, or
// *           (c) complex eigenvalue.
// *
if (!ilcplx)  {
    if (Math.abs(a[(je)- 1+(je- 1)*lda+ _a_offset]) <= safmin.val && Math.abs(b[(je)- 1+(je- 1)*ldb+ _b_offset]) <= safmin.val)  {
    // *
// *                 Singular matrix pencil -- return unit eigenvector
// *
ieig = ieig+1;
{
forloop60:
for (jr = 1; jr <= n; jr++) {
vl[(jr)- 1+(ieig- 1)*ldvl+ _vl_offset] = zero;
Dummy.label("Dtgevc",60);
}              //  Close for() loop. 
}
vl[(ieig)- 1+(ieig- 1)*ldvl+ _vl_offset] = one;
continue forloop220;
}              // Close if()
}              // Close if()
// *
// *           Clear vector
// *
{
forloop70:
for (jr = 1; jr <= nw*n; jr++) {
work[(2*n+jr)- 1+ _work_offset] = zero;
Dummy.label("Dtgevc",70);
}              //  Close for() loop. 
}
// *                                                 T
// *           Compute coefficients in  ( a A - b B )  y = 0
// *              a  is  ACOEF
// *              b  is  BCOEFR + i*BCOEFI
// *
if (!ilcplx)  {
    // *
// *              Real eigenvalue
// *
temp.val = one/Math.max((Math.abs(a[(je)- 1+(je- 1)*lda+ _a_offset])*ascale) > (Math.abs(b[(je)- 1+(je- 1)*ldb+ _b_offset])*bscale) ? (Math.abs(a[(je)- 1+(je- 1)*lda+ _a_offset])*ascale) : (Math.abs(b[(je)- 1+(je- 1)*ldb+ _b_offset])*bscale), safmin.val);
salfar = (temp.val*a[(je)- 1+(je- 1)*lda+ _a_offset])*ascale;
sbeta = (temp.val*b[(je)- 1+(je- 1)*ldb+ _b_offset])*bscale;
acoef.val = sbeta*ascale;
bcoefr.val = salfar*bscale;
bcoefi.val = zero;
// *
// *              Scale to avoid underflow
// *
scale.val = one;
lsa = Math.abs(sbeta) >= safmin.val && Math.abs(acoef.val) < small;
lsb = Math.abs(salfar) >= safmin.val && Math.abs(bcoefr.val) < small;
if (lsa)  
    scale.val = (small/Math.abs(sbeta))*Math.min(anorm, big.val) ;
if (lsb)  
    scale.val = Math.max(scale.val, (small/Math.abs(salfar))*Math.min(bnorm, big.val) ) ;
if (lsa || lsb)  {
    scale.val = Math.min(scale.val, one/(safmin.val*Math.max((one) > (Math.abs(acoef.val)) ? (one) : (Math.abs(acoef.val)), Math.abs(bcoefr.val)))) ;
if (lsa)  {
    acoef.val = ascale*(scale.val*sbeta);
}              // Close if()
else  {
  acoef.val = scale.val*acoef.val;
}              //  Close else.
if (lsb)  {
    bcoefr.val = bscale*(scale.val*salfar);
}              // Close if()
else  {
  bcoefr.val = scale.val*bcoefr.val;
}              //  Close else.
}              // Close if()
acoefa = Math.abs(acoef.val);
bcoefa = Math.abs(bcoefr.val);
// *
// *              First component is 1
// *
work[(2*n+je)- 1+ _work_offset] = one;
xmax = one;
}              // Close if()
else  {
  // *
// *              Complex eigenvalue
// *
Dlag2.dlag2(a,(je)- 1+(je- 1)*lda+ _a_offset,lda,b,(je)- 1+(je- 1)*ldb+ _b_offset,ldb,safmin.val*safety,acoef,temp,bcoefr,temp2,bcoefi);
bcoefi.val = -bcoefi.val;
if (bcoefi.val == zero)  {
    info.val = je;
Dummy.go_to("Dtgevc",999999);
}              // Close if()
// *
// *              Scale to avoid over/underflow
// *
acoefa = Math.abs(acoef.val);
bcoefa = Math.abs(bcoefr.val)+Math.abs(bcoefi.val);
scale.val = one;
if (acoefa*ulp < safmin.val && acoefa >= safmin.val)  
    scale.val = (safmin.val/ulp)/acoefa;
if (bcoefa*ulp < safmin.val && bcoefa >= safmin.val)  
    scale.val = Math.max(scale.val, (safmin.val/ulp)/bcoefa) ;
if (safmin.val*acoefa > ascale)  
    scale.val = ascale/(safmin.val*acoefa);
if (safmin.val*bcoefa > bscale)  
    scale.val = Math.min(scale.val, bscale/(safmin.val*bcoefa)) ;
if (scale.val != one)  {
    acoef.val = scale.val*acoef.val;
acoefa = Math.abs(acoef.val);
bcoefr.val = scale.val*bcoefr.val;
bcoefi.val = scale.val*bcoefi.val;
bcoefa = Math.abs(bcoefr.val)+Math.abs(bcoefi.val);
}              // Close if()
// *
// *              Compute first two components of eigenvector
// *
temp.val = acoef.val*a[(je+1)- 1+(je- 1)*lda+ _a_offset];
temp2r = acoef.val*a[(je)- 1+(je- 1)*lda+ _a_offset]-bcoefr.val*b[(je)- 1+(je- 1)*ldb+ _b_offset];
temp2i = -bcoefi.val*b[(je)- 1+(je- 1)*ldb+ _b_offset];
if (Math.abs(temp.val) > Math.abs(temp2r)+Math.abs(temp2i))  {
    work[(2*n+je)- 1+ _work_offset] = one;
work[(3*n+je)- 1+ _work_offset] = zero;
work[(2*n+je+1)- 1+ _work_offset] = -temp2r/temp.val;
work[(3*n+je+1)- 1+ _work_offset] = -temp2i/temp.val;
}              // Close if()
else  {
  work[(2*n+je+1)- 1+ _work_offset] = one;
work[(3*n+je+1)- 1+ _work_offset] = zero;
temp.val = acoef.val*a[(je)- 1+(je+1- 1)*lda+ _a_offset];
work[(2*n+je)- 1+ _work_offset] = (bcoefr.val*b[(je+1)- 1+(je+1- 1)*ldb+ _b_offset]-acoef.val*a[(je+1)- 1+(je+1- 1)*lda+ _a_offset])/temp.val;
work[(3*n+je)- 1+ _work_offset] = bcoefi.val*b[(je+1)- 1+(je+1- 1)*ldb+ _b_offset]/temp.val;
}              //  Close else.
xmax = Math.max(Math.abs(work[(2*n+je)- 1+ _work_offset])+Math.abs(work[(3*n+je)- 1+ _work_offset]), Math.abs(work[(2*n+je+1)- 1+ _work_offset])+Math.abs(work[(3*n+je+1)- 1+ _work_offset])) ;
}              //  Close else.
// *
dmin = Math.max((ulp*acoefa*anorm) > (ulp*bcoefa*bnorm) ? (ulp*acoefa*anorm) : (ulp*bcoefa*bnorm), safmin.val);
// *
// *                                           T
// *           Triangular solve of  (a A - b B)  y = 0
// *
// *                                   T
// *           (rowwise in  (a A - b B) , or columnwise in (a A - b B) )
// *
il2by2 = false;
// *
{
forloop160:
for (j = je+nw; j <= n; j++) {
if (il2by2)  {
    il2by2 = false;
continue forloop160;
}              // Close if()
// *
na = 1;
bdiag[(1)- 1] = b[(j)- 1+(j- 1)*ldb+ _b_offset];
if (j < n)  {
    if (a[(j+1)- 1+(j- 1)*lda+ _a_offset] != zero)  {
    il2by2 = true;
bdiag[(2)- 1] = b[(j+1)- 1+(j+1- 1)*ldb+ _b_offset];
na = 2;
}              // Close if()
}              // Close if()
// *
// *              Check whether scaling is necessary for dot products
// *
xscale = one/Math.max(one, xmax) ;
temp.val = Math.max((work[(j)- 1+ _work_offset]) > (work[(n+j)- 1+ _work_offset]) ? (work[(j)- 1+ _work_offset]) : (work[(n+j)- 1+ _work_offset]), acoefa*work[(j)- 1+ _work_offset]+bcoefa*work[(n+j)- 1+ _work_offset]);
if (il2by2)  
    temp.val = Math.max(Math.max(Math.max(temp.val, work[(j+1)- 1+ _work_offset]), work[(n+j+1)- 1+ _work_offset]), acoefa*work[(j+1)- 1+ _work_offset]+bcoefa*work[(n+j+1)- 1+ _work_offset]) ;
if (temp.val > bignum*xscale)  {
    {
forloop90:
for (jw = 0; jw <= nw-1; jw++) {
{
forloop80:
for (jr = je; jr <= j-1; jr++) {
work[((jw+2)*n+jr)- 1+ _work_offset] = xscale*work[((jw+2)*n+jr)- 1+ _work_offset];
Dummy.label("Dtgevc",80);
}              //  Close for() loop. 
}
Dummy.label("Dtgevc",90);
}              //  Close for() loop. 
}
xmax = xmax*xscale;
}              // Close if()
// *
// *              Compute dot products
// *
// *                    j-1
// *              SUM = sum  conjg( a*A(k,j) - b*B(k,j) )*x(k)
// *                    k=je
// *
// *              To reduce the op count, this is done as
// *
// *              _        j-1                  _        j-1
// *              a*conjg( sum  A(k,j)*x(k) ) - b*conjg( sum  B(k,j)*x(k) )
// *                       k=je                          k=je
// *
// *              which may cause underflow problems if A or B are close
// *              to underflow.  (E.g., less than SMALL.)
// *
// *
// *              A series of compiler directives to defeat vectorization
// *              for the next loop
// *
// *$PL$ CMCHAR=' '
// CDIR$          NEXTSCALAR
// C$DIR          SCALAR
// CDIR$          NEXT SCALAR
// CVD$L          NOVECTOR
// CDEC$          NOVECTOR
// CVD$           NOVECTOR
// *VDIR          NOVECTOR
// *VOCL          LOOP,SCALAR
// CIBM           PREFER SCALAR
// *$PL$ CMCHAR='*'
// *
{
forloop120:
for (jw = 1; jw <= nw; jw++) {
// *
// *$PL$ CMCHAR=' '
// CDIR$             NEXTSCALAR
// C$DIR             SCALAR
// CDIR$             NEXT SCALAR
// CVD$L             NOVECTOR
// CDEC$             NOVECTOR
// CVD$              NOVECTOR
// *VDIR             NOVECTOR
// *VOCL             LOOP,SCALAR
// CIBM              PREFER SCALAR
// *$PL$ CMCHAR='*'
// *
{
forloop110:
for (ja = 1; ja <= na; ja++) {
suma[(ja)- 1+(jw- 1)*2] = zero;
sumb[(ja)- 1+(jw- 1)*2] = zero;
// *
{
forloop100:
for (jr = je; jr <= j-1; jr++) {
suma[(ja)- 1+(jw- 1)*2] = suma[(ja)- 1+(jw- 1)*2]+a[(jr)- 1+(j+ja-1- 1)*lda+ _a_offset]*work[((jw+1)*n+jr)- 1+ _work_offset];
sumb[(ja)- 1+(jw- 1)*2] = sumb[(ja)- 1+(jw- 1)*2]+b[(jr)- 1+(j+ja-1- 1)*ldb+ _b_offset]*work[((jw+1)*n+jr)- 1+ _work_offset];
Dummy.label("Dtgevc",100);
}              //  Close for() loop. 
}
Dummy.label("Dtgevc",110);
}              //  Close for() loop. 
}
Dummy.label("Dtgevc",120);
}              //  Close for() loop. 
}
// *
// *$PL$ CMCHAR=' '
// CDIR$          NEXTSCALAR
// C$DIR          SCALAR
// CDIR$          NEXT SCALAR
// CVD$L          NOVECTOR
// CDEC$          NOVECTOR
// CVD$           NOVECTOR
// *VDIR          NOVECTOR
// *VOCL          LOOP,SCALAR
// CIBM           PREFER SCALAR
// *$PL$ CMCHAR='*'
// *
{
forloop130:
for (ja = 1; ja <= na; ja++) {
if (ilcplx)  {
    sum[(ja)- 1+(1- 1)*2] = -acoef.val*suma[(ja)- 1+(1- 1)*2]+bcoefr.val*sumb[(ja)- 1+(1- 1)*2]-bcoefi.val*sumb[(ja)- 1+(2- 1)*2];
sum[(ja)- 1+(2- 1)*2] = -acoef.val*suma[(ja)- 1+(2- 1)*2]+bcoefr.val*sumb[(ja)- 1+(2- 1)*2]+bcoefi.val*sumb[(ja)- 1+(1- 1)*2];
}              // Close if()
else  {
  sum[(ja)- 1+(1- 1)*2] = -acoef.val*suma[(ja)- 1+(1- 1)*2]+bcoefr.val*sumb[(ja)- 1+(1- 1)*2];
}              //  Close else.
Dummy.label("Dtgevc",130);
}              //  Close for() loop. 
}
// *
// *                                  T
// *              Solve  ( a A - b B )  y = SUM(,)
// *              with scaling and perturbation of the denominator
// *
Dlaln2.dlaln2(true,na,nw,dmin,acoef.val,a,(j)- 1+(j- 1)*lda+ _a_offset,lda,bdiag[(1)- 1],bdiag[(2)- 1],sum,0,2,bcoefr.val,bcoefi.val,work,(2*n+j)- 1+ _work_offset,n,scale,temp,iinfo);
if (scale.val < one)  {
    {
forloop150:
for (jw = 0; jw <= nw-1; jw++) {
{
forloop140:
for (jr = je; jr <= j-1; jr++) {
work[((jw+2)*n+jr)- 1+ _work_offset] = scale.val*work[((jw+2)*n+jr)- 1+ _work_offset];
Dummy.label("Dtgevc",140);
}              //  Close for() loop. 
}
Dummy.label("Dtgevc",150);
}              //  Close for() loop. 
}
xmax = scale.val*xmax;
}              // Close if()
xmax = Math.max(xmax, temp.val) ;
Dummy.label("Dtgevc",160);
}              //  Close for() loop. 
}
// *
// *           Copy eigenvector to VL, back transforming if
// *           HOWMNY='B'.
// *
ieig = ieig+1;
if (ilback)  {
    {
forloop170:
for (jw = 0; jw <= nw-1; jw++) {
Dgemv.dgemv("N",n,n+1-je,one,vl,(1)- 1+(je- 1)*ldvl+ _vl_offset,ldvl,work,((jw+2)*n+je)- 1+ _work_offset,1,zero,work,((jw+4)*n+1)- 1+ _work_offset,1);
Dummy.label("Dtgevc",170);
}              //  Close for() loop. 
}
Dlacpy.dlacpy(" ",n,nw,work,(4*n+1)- 1+ _work_offset,n,vl,(1)- 1+(je- 1)*ldvl+ _vl_offset,ldvl);
ibeg = 1;
}              // Close if()
else  {
  Dlacpy.dlacpy(" ",n,nw,work,(2*n+1)- 1+ _work_offset,n,vl,(1)- 1+(ieig- 1)*ldvl+ _vl_offset,ldvl);
ibeg = je;
}              //  Close else.
// *
// *           Scale eigenvector
// *
xmax = zero;
if (ilcplx)  {
    {
forloop180:
for (j = ibeg; j <= n; j++) {
xmax = Math.max(xmax, Math.abs(vl[(j)- 1+(ieig- 1)*ldvl+ _vl_offset])+Math.abs(vl[(j)- 1+(ieig+1- 1)*ldvl+ _vl_offset])) ;
Dummy.label("Dtgevc",180);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  {
forloop190:
for (j = ibeg; j <= n; j++) {
xmax = Math.max(xmax, Math.abs(vl[(j)- 1+(ieig- 1)*ldvl+ _vl_offset])) ;
Dummy.label("Dtgevc",190);
}              //  Close for() loop. 
}
}              //  Close else.
// *
if (xmax > safmin.val)  {
    xscale = one/xmax;
// *
{
forloop210:
for (jw = 0; jw <= nw-1; jw++) {
{
forloop200:
for (jr = ibeg; jr <= n; jr++) {
vl[(jr)- 1+(ieig+jw- 1)*ldvl+ _vl_offset] = xscale*vl[(jr)- 1+(ieig+jw- 1)*ldvl+ _vl_offset];
Dummy.label("Dtgevc",200);
}              //  Close for() loop. 
}
Dummy.label("Dtgevc",210);
}              //  Close for() loop. 
}
}              // Close if()
ieig = ieig+nw-1;
// *
Dummy.label("Dtgevc",220);
}              //  Close for() loop. 
}
}              // Close if()
// *
// *     Right eigenvectors
// *
if (compr)  {
    ieig = im+1;
// *
// *        Main loop over eigenvalues
// *
ilcplx = false;
{
int _je_inc = -1;
forloop500:
for (je = n; je >= 1; je += _je_inc) {
// *
// *           Skip this iteration if (a) HOWMNY='S' and SELECT=.FALSE., or
// *           (b) this would be the second of a complex pair.
// *           Check for complex eigenvalue, so as to be sure of which
// *           entry(-ies) of SELECT to look at -- if complex, SELECT(JE)
// *           or SELECT(JE-1).
// *           If this is a complex pair, the 2-by-2 diagonal block
// *           corresponding to the eigenvalue is in rows/columns JE-1:JE
// *
if (ilcplx)  {
    ilcplx = false;
continue forloop500;
}              // Close if()
nw = 1;
if (je > 1)  {
    if (a[(je)- 1+(je-1- 1)*lda+ _a_offset] != zero)  {
    ilcplx = true;
nw = 2;
}              // Close if()
}              // Close if()
if (ilall)  {
    ilcomp = true;
}              // Close if()
else if (ilcplx)  {
    ilcomp = select[(je)- 1+ _select_offset] || select[(je-1)- 1+ _select_offset];
}              // Close else if()
else  {
  ilcomp = select[(je)- 1+ _select_offset];
}              //  Close else.
if (!ilcomp)  
    continue forloop500;
// *
// *           Decide if (a) singular pencil, (b) real eigenvalue, or
// *           (c) complex eigenvalue.
// *
if (!ilcplx)  {
    if (Math.abs(a[(je)- 1+(je- 1)*lda+ _a_offset]) <= safmin.val && Math.abs(b[(je)- 1+(je- 1)*ldb+ _b_offset]) <= safmin.val)  {
    // *
// *                 Singular matrix pencil -- unit eigenvector
// *
ieig = ieig-1;
{
forloop230:
for (jr = 1; jr <= n; jr++) {
vr[(jr)- 1+(ieig- 1)*ldvr+ _vr_offset] = zero;
Dummy.label("Dtgevc",230);
}              //  Close for() loop. 
}
vr[(ieig)- 1+(ieig- 1)*ldvr+ _vr_offset] = one;
continue forloop500;
}              // Close if()
}              // Close if()
// *
// *           Clear vector
// *
{
forloop250:
for (jw = 0; jw <= nw-1; jw++) {
{
forloop240:
for (jr = 1; jr <= n; jr++) {
work[((jw+2)*n+jr)- 1+ _work_offset] = zero;
Dummy.label("Dtgevc",240);
}              //  Close for() loop. 
}
Dummy.label("Dtgevc",250);
}              //  Close for() loop. 
}
// *
// *           Compute coefficients in  ( a A - b B ) x = 0
// *              a  is  ACOEF
// *              b  is  BCOEFR + i*BCOEFI
// *
if (!ilcplx)  {
    // *
// *              Real eigenvalue
// *
temp.val = one/Math.max((Math.abs(a[(je)- 1+(je- 1)*lda+ _a_offset])*ascale) > (Math.abs(b[(je)- 1+(je- 1)*ldb+ _b_offset])*bscale) ? (Math.abs(a[(je)- 1+(je- 1)*lda+ _a_offset])*ascale) : (Math.abs(b[(je)- 1+(je- 1)*ldb+ _b_offset])*bscale), safmin.val);
salfar = (temp.val*a[(je)- 1+(je- 1)*lda+ _a_offset])*ascale;
sbeta = (temp.val*b[(je)- 1+(je- 1)*ldb+ _b_offset])*bscale;
acoef.val = sbeta*ascale;
bcoefr.val = salfar*bscale;
bcoefi.val = zero;
// *
// *              Scale to avoid underflow
// *
scale.val = one;
lsa = Math.abs(sbeta) >= safmin.val && Math.abs(acoef.val) < small;
lsb = Math.abs(salfar) >= safmin.val && Math.abs(bcoefr.val) < small;
if (lsa)  
    scale.val = (small/Math.abs(sbeta))*Math.min(anorm, big.val) ;
if (lsb)  
    scale.val = Math.max(scale.val, (small/Math.abs(salfar))*Math.min(bnorm, big.val) ) ;
if (lsa || lsb)  {
    scale.val = Math.min(scale.val, one/(safmin.val*Math.max((one) > (Math.abs(acoef.val)) ? (one) : (Math.abs(acoef.val)), Math.abs(bcoefr.val)))) ;
if (lsa)  {
    acoef.val = ascale*(scale.val*sbeta);
}              // Close if()
else  {
  acoef.val = scale.val*acoef.val;
}              //  Close else.
if (lsb)  {
    bcoefr.val = bscale*(scale.val*salfar);
}              // Close if()
else  {
  bcoefr.val = scale.val*bcoefr.val;
}              //  Close else.
}              // Close if()
acoefa = Math.abs(acoef.val);
bcoefa = Math.abs(bcoefr.val);
// *
// *              First component is 1
// *
work[(2*n+je)- 1+ _work_offset] = one;
xmax = one;
// *
// *              Compute contribution from column JE of A and B to sum
// *              (See "Further Details", above.)
// *
{
forloop260:
for (jr = 1; jr <= je-1; jr++) {
work[(2*n+jr)- 1+ _work_offset] = bcoefr.val*b[(jr)- 1+(je- 1)*ldb+ _b_offset]-acoef.val*a[(jr)- 1+(je- 1)*lda+ _a_offset];
Dummy.label("Dtgevc",260);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  // *
// *              Complex eigenvalue
// *
Dlag2.dlag2(a,(je-1)- 1+(je-1- 1)*lda+ _a_offset,lda,b,(je-1)- 1+(je-1- 1)*ldb+ _b_offset,ldb,safmin.val*safety,acoef,temp,bcoefr,temp2,bcoefi);
if (bcoefi.val == zero)  {
    info.val = je-1;
Dummy.go_to("Dtgevc",999999);
}              // Close if()
// *
// *              Scale to avoid over/underflow
// *
acoefa = Math.abs(acoef.val);
bcoefa = Math.abs(bcoefr.val)+Math.abs(bcoefi.val);
scale.val = one;
if (acoefa*ulp < safmin.val && acoefa >= safmin.val)  
    scale.val = (safmin.val/ulp)/acoefa;
if (bcoefa*ulp < safmin.val && bcoefa >= safmin.val)  
    scale.val = Math.max(scale.val, (safmin.val/ulp)/bcoefa) ;
if (safmin.val*acoefa > ascale)  
    scale.val = ascale/(safmin.val*acoefa);
if (safmin.val*bcoefa > bscale)  
    scale.val = Math.min(scale.val, bscale/(safmin.val*bcoefa)) ;
if (scale.val != one)  {
    acoef.val = scale.val*acoef.val;
acoefa = Math.abs(acoef.val);
bcoefr.val = scale.val*bcoefr.val;
bcoefi.val = scale.val*bcoefi.val;
bcoefa = Math.abs(bcoefr.val)+Math.abs(bcoefi.val);
}              // Close if()
// *
// *              Compute first two components of eigenvector
// *              and contribution to sums
// *
temp.val = acoef.val*a[(je)- 1+(je-1- 1)*lda+ _a_offset];
temp2r = acoef.val*a[(je)- 1+(je- 1)*lda+ _a_offset]-bcoefr.val*b[(je)- 1+(je- 1)*ldb+ _b_offset];
temp2i = -bcoefi.val*b[(je)- 1+(je- 1)*ldb+ _b_offset];
if (Math.abs(temp.val) >= Math.abs(temp2r)+Math.abs(temp2i))  {
    work[(2*n+je)- 1+ _work_offset] = one;
work[(3*n+je)- 1+ _work_offset] = zero;
work[(2*n+je-1)- 1+ _work_offset] = -temp2r/temp.val;
work[(3*n+je-1)- 1+ _work_offset] = -temp2i/temp.val;
}              // Close if()
else  {
  work[(2*n+je-1)- 1+ _work_offset] = one;
work[(3*n+je-1)- 1+ _work_offset] = zero;
temp.val = acoef.val*a[(je-1)- 1+(je- 1)*lda+ _a_offset];
work[(2*n+je)- 1+ _work_offset] = (bcoefr.val*b[(je-1)- 1+(je-1- 1)*ldb+ _b_offset]-acoef.val*a[(je-1)- 1+(je-1- 1)*lda+ _a_offset])/temp.val;
work[(3*n+je)- 1+ _work_offset] = bcoefi.val*b[(je-1)- 1+(je-1- 1)*ldb+ _b_offset]/temp.val;
}              //  Close else.
// *
xmax = Math.max(Math.abs(work[(2*n+je)- 1+ _work_offset])+Math.abs(work[(3*n+je)- 1+ _work_offset]), Math.abs(work[(2*n+je-1)- 1+ _work_offset])+Math.abs(work[(3*n+je-1)- 1+ _work_offset])) ;
// *
// *              Compute contribution from columns JE and JE-1
// *              of A and B to the sums.
// *
creala = acoef.val*work[(2*n+je-1)- 1+ _work_offset];
cimaga = acoef.val*work[(3*n+je-1)- 1+ _work_offset];
crealb = bcoefr.val*work[(2*n+je-1)- 1+ _work_offset]-bcoefi.val*work[(3*n+je-1)- 1+ _work_offset];
cimagb = bcoefi.val*work[(2*n+je-1)- 1+ _work_offset]+bcoefr.val*work[(3*n+je-1)- 1+ _work_offset];
cre2a = acoef.val*work[(2*n+je)- 1+ _work_offset];
cim2a = acoef.val*work[(3*n+je)- 1+ _work_offset];
cre2b = bcoefr.val*work[(2*n+je)- 1+ _work_offset]-bcoefi.val*work[(3*n+je)- 1+ _work_offset];
cim2b = bcoefi.val*work[(2*n+je)- 1+ _work_offset]+bcoefr.val*work[(3*n+je)- 1+ _work_offset];
{
forloop270:
for (jr = 1; jr <= je-2; jr++) {
work[(2*n+jr)- 1+ _work_offset] = -creala*a[(jr)- 1+(je-1- 1)*lda+ _a_offset]+crealb*b[(jr)- 1+(je-1- 1)*ldb+ _b_offset]-cre2a*a[(jr)- 1+(je- 1)*lda+ _a_offset]+cre2b*b[(jr)- 1+(je- 1)*ldb+ _b_offset];
work[(3*n+jr)- 1+ _work_offset] = -cimaga*a[(jr)- 1+(je-1- 1)*lda+ _a_offset]+cimagb*b[(jr)- 1+(je-1- 1)*ldb+ _b_offset]-cim2a*a[(jr)- 1+(je- 1)*lda+ _a_offset]+cim2b*b[(jr)- 1+(je- 1)*ldb+ _b_offset];
Dummy.label("Dtgevc",270);
}              //  Close for() loop. 
}
}              //  Close else.
// *
dmin = Math.max((ulp*acoefa*anorm) > (ulp*bcoefa*bnorm) ? (ulp*acoefa*anorm) : (ulp*bcoefa*bnorm), safmin.val);
// *
// *           Columnwise triangular solve of  (a A - b B)  x = 0
// *
il2by2 = false;
{
int _j_inc = -1;
forloop370:
for (j = je-nw; j >= 1; j += _j_inc) {
// *
// *              If a 2-by-2 block, is in position j-1:j, wait until
// *              next iteration to process it (when it will be j:j+1)
// *
if (!il2by2 && j > 1)  {
    if (a[(j)- 1+(j-1- 1)*lda+ _a_offset] != zero)  {
    il2by2 = true;
continue forloop370;
}              // Close if()
}              // Close if()
bdiag[(1)- 1] = b[(j)- 1+(j- 1)*ldb+ _b_offset];
if (il2by2)  {
    na = 2;
bdiag[(2)- 1] = b[(j+1)- 1+(j+1- 1)*ldb+ _b_offset];
}              // Close if()
else  {
  na = 1;
}              //  Close else.
// *
// *              Compute x(j) (and x(j+1), if 2-by-2 block)
// *
Dlaln2.dlaln2(false,na,nw,dmin,acoef.val,a,(j)- 1+(j- 1)*lda+ _a_offset,lda,bdiag[(1)- 1],bdiag[(2)- 1],work,(2*n+j)- 1+ _work_offset,n,bcoefr.val,bcoefi.val,sum,0,2,scale,temp,iinfo);
if (scale.val < one)  {
    // *
{
forloop290:
for (jw = 0; jw <= nw-1; jw++) {
{
forloop280:
for (jr = 1; jr <= je; jr++) {
work[((jw+2)*n+jr)- 1+ _work_offset] = scale.val*work[((jw+2)*n+jr)- 1+ _work_offset];
Dummy.label("Dtgevc",280);
}              //  Close for() loop. 
}
Dummy.label("Dtgevc",290);
}              //  Close for() loop. 
}
}              // Close if()
xmax = Math.max(scale.val*xmax, temp.val) ;
// *
{
forloop310:
for (jw = 1; jw <= nw; jw++) {
{
forloop300:
for (ja = 1; ja <= na; ja++) {
work[((jw+1)*n+j+ja-1)- 1+ _work_offset] = sum[(ja)- 1+(jw- 1)*2];
Dummy.label("Dtgevc",300);
}              //  Close for() loop. 
}
Dummy.label("Dtgevc",310);
}              //  Close for() loop. 
}
// *
// *              w = w + x(j)*(a A(*,j) - b B(*,j) ) with scaling
// *
if (j > 1)  {
    // *
// *                 Check whether scaling is necessary for sum.
// *
xscale = one/Math.max(one, xmax) ;
temp.val = acoefa*work[(j)- 1+ _work_offset]+bcoefa*work[(n+j)- 1+ _work_offset];
if (il2by2)  
    temp.val = Math.max(temp.val, acoefa*work[(j+1)- 1+ _work_offset]+bcoefa*work[(n+j+1)- 1+ _work_offset]) ;
temp.val = Math.max((temp.val) > (acoefa) ? (temp.val) : (acoefa), bcoefa);
if (temp.val > bignum*xscale)  {
    // *
{
forloop330:
for (jw = 0; jw <= nw-1; jw++) {
{
forloop320:
for (jr = 1; jr <= je; jr++) {
work[((jw+2)*n+jr)- 1+ _work_offset] = xscale*work[((jw+2)*n+jr)- 1+ _work_offset];
Dummy.label("Dtgevc",320);
}              //  Close for() loop. 
}
Dummy.label("Dtgevc",330);
}              //  Close for() loop. 
}
xmax = xmax*xscale;
}              // Close if()
// *
// *                 Compute the contributions of the off-diagonals of
// *                 column j (and j+1, if 2-by-2 block) of A and B to the
// *                 sums.
// *
// *
{
forloop360:
for (ja = 1; ja <= na; ja++) {
if (ilcplx)  {
    creala = acoef.val*work[(2*n+j+ja-1)- 1+ _work_offset];
cimaga = acoef.val*work[(3*n+j+ja-1)- 1+ _work_offset];
crealb = bcoefr.val*work[(2*n+j+ja-1)- 1+ _work_offset]-bcoefi.val*work[(3*n+j+ja-1)- 1+ _work_offset];
cimagb = bcoefi.val*work[(2*n+j+ja-1)- 1+ _work_offset]+bcoefr.val*work[(3*n+j+ja-1)- 1+ _work_offset];
{
forloop340:
for (jr = 1; jr <= j-1; jr++) {
work[(2*n+jr)- 1+ _work_offset] = work[(2*n+jr)- 1+ _work_offset]-creala*a[(jr)- 1+(j+ja-1- 1)*lda+ _a_offset]+crealb*b[(jr)- 1+(j+ja-1- 1)*ldb+ _b_offset];
work[(3*n+jr)- 1+ _work_offset] = work[(3*n+jr)- 1+ _work_offset]-cimaga*a[(jr)- 1+(j+ja-1- 1)*lda+ _a_offset]+cimagb*b[(jr)- 1+(j+ja-1- 1)*ldb+ _b_offset];
Dummy.label("Dtgevc",340);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  creala = acoef.val*work[(2*n+j+ja-1)- 1+ _work_offset];
crealb = bcoefr.val*work[(2*n+j+ja-1)- 1+ _work_offset];
{
forloop350:
for (jr = 1; jr <= j-1; jr++) {
work[(2*n+jr)- 1+ _work_offset] = work[(2*n+jr)- 1+ _work_offset]-creala*a[(jr)- 1+(j+ja-1- 1)*lda+ _a_offset]+crealb*b[(jr)- 1+(j+ja-1- 1)*ldb+ _b_offset];
Dummy.label("Dtgevc",350);
}              //  Close for() loop. 
}
}              //  Close else.
Dummy.label("Dtgevc",360);
}              //  Close for() loop. 
}
}              // Close if()
// *
il2by2 = false;
Dummy.label("Dtgevc",370);
}              //  Close for() loop. 
}
// *
// *           Copy eigenvector to VR, back transforming if
// *           HOWMNY='B'.
// *
ieig = ieig-nw;
if (ilback)  {
    // *
{
forloop410:
for (jw = 0; jw <= nw-1; jw++) {
{
forloop380:
for (jr = 1; jr <= n; jr++) {
work[((jw+4)*n+jr)- 1+ _work_offset] = work[((jw+2)*n+1)- 1+ _work_offset]*vr[(jr)- 1+(1- 1)*ldvr+ _vr_offset];
Dummy.label("Dtgevc",380);
}              //  Close for() loop. 
}
// *
// *                 A series of compiler directives to defeat
// *                 vectorization for the next loop
// *
// *
{
forloop400:
for (jc = 2; jc <= je; jc++) {
{
forloop390:
for (jr = 1; jr <= n; jr++) {
work[((jw+4)*n+jr)- 1+ _work_offset] = work[((jw+4)*n+jr)- 1+ _work_offset]+work[((jw+2)*n+jc)- 1+ _work_offset]*vr[(jr)- 1+(jc- 1)*ldvr+ _vr_offset];
Dummy.label("Dtgevc",390);
}              //  Close for() loop. 
}
Dummy.label("Dtgevc",400);
}              //  Close for() loop. 
}
Dummy.label("Dtgevc",410);
}              //  Close for() loop. 
}
// *
{
forloop430:
for (jw = 0; jw <= nw-1; jw++) {
{
forloop420:
for (jr = 1; jr <= n; jr++) {
vr[(jr)- 1+(ieig+jw- 1)*ldvr+ _vr_offset] = work[((jw+4)*n+jr)- 1+ _work_offset];
Dummy.label("Dtgevc",420);
}              //  Close for() loop. 
}
Dummy.label("Dtgevc",430);
}              //  Close for() loop. 
}
// *
iend = n;
}              // Close if()
else  {
  {
forloop450:
for (jw = 0; jw <= nw-1; jw++) {
{
forloop440:
for (jr = 1; jr <= n; jr++) {
vr[(jr)- 1+(ieig+jw- 1)*ldvr+ _vr_offset] = work[((jw+2)*n+jr)- 1+ _work_offset];
Dummy.label("Dtgevc",440);
}              //  Close for() loop. 
}
Dummy.label("Dtgevc",450);
}              //  Close for() loop. 
}
// *
iend = je;
}              //  Close else.
// *
// *           Scale eigenvector
// *
xmax = zero;
if (ilcplx)  {
    {
forloop460:
for (j = 1; j <= iend; j++) {
xmax = Math.max(xmax, Math.abs(vr[(j)- 1+(ieig- 1)*ldvr+ _vr_offset])+Math.abs(vr[(j)- 1+(ieig+1- 1)*ldvr+ _vr_offset])) ;
Dummy.label("Dtgevc",460);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  {
forloop470:
for (j = 1; j <= iend; j++) {
xmax = Math.max(xmax, Math.abs(vr[(j)- 1+(ieig- 1)*ldvr+ _vr_offset])) ;
Dummy.label("Dtgevc",470);
}              //  Close for() loop. 
}
}              //  Close else.
// *
if (xmax > safmin.val)  {
    xscale = one/xmax;
{
forloop490:
for (jw = 0; jw <= nw-1; jw++) {
{
forloop480:
for (jr = 1; jr <= iend; jr++) {
vr[(jr)- 1+(ieig+jw- 1)*ldvr+ _vr_offset] = xscale*vr[(jr)- 1+(ieig+jw- 1)*ldvr+ _vr_offset];
Dummy.label("Dtgevc",480);
}              //  Close for() loop. 
}
Dummy.label("Dtgevc",490);
}              //  Close for() loop. 
}
}              // Close if()
Dummy.label("Dtgevc",500);
}              //  Close for() loop. 
}
}              // Close if()
// *
Dummy.go_to("Dtgevc",999999);
// *
// *     End of DTGEVC
// *
Dummy.label("Dtgevc",999999);
return;
   }
} // End class.
