/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;

import org.netlib.blas.*;


public class Dtgsja {

// *
// *  -- LAPACK routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DTGSJA computes the generalized singular value decomposition (GSVD)
// *  of two real upper triangular (or trapezoidal) matrices A and B.
// *
// *  On entry, it is assumed that matrices A and B have the following
// *  forms, which may be obtained by the preprocessing subroutine DGGSVP
// *  from a general M-by-N matrix A and P-by-N matrix B:
// *
// *               N-K-L  K    L
// *     A =    K ( 0    A12  A13 ) if M-K-L >= 0;
// *            L ( 0     0   A23 )
// *        M-K-L ( 0     0    0  )
// *
// *             N-K-L  K    L
// *     A =  K ( 0    A12  A13 ) if M-K-L < 0;
// *        M-K ( 0     0   A23 )
// *
// *             N-K-L  K    L
// *     B =  L ( 0     0   B13 )
// *        P-L ( 0     0    0  )
// *
// *  where the K-by-K matrix A12 and L-by-L matrix B13 are nonsingular
// *  upper triangular; A23 is L-by-L upper triangular if M-K-L >= 0,
// *  otherwise A23 is (M-K)-by-L upper trapezoidal.
// *
// *  On exit,
// *
// *              U'*A*Q = D1*( 0 R ),    V'*B*Q = D2*( 0 R ),
// *
// *  where U, V and Q are orthogonal matrices, Z' denotes the transpose
// *  of Z, R is a nonsingular upper triangular matrix, and D1 and D2 are
// *  ``diagonal'' matrices, which are of the following structures:
// *
// *  If M-K-L >= 0,
// *
// *                      K  L
// *         D1 =     K ( I  0 )
// *                  L ( 0  C )
// *              M-K-L ( 0  0 )
// *
// *                    K  L
// *         D2 = L   ( 0  S )
// *              P-L ( 0  0 )
// *
// *                 N-K-L  K    L
// *    ( 0 R ) = K (  0   R11  R12 ) K
// *              L (  0    0   R22 ) L
// *
// *  where
// *
// *    C = diag( ALPHA(K+1), ... , ALPHA(K+L) ),
// *    S = diag( BETA(K+1),  ... , BETA(K+L) ),
// *    C**2 + S**2 = I.
// *
// *    R is stored in A(1:K+L,N-K-L+1:N) on exit.
// *
// *  If M-K-L < 0,
// *
// *                 K M-K K+L-M
// *      D1 =   K ( I  0    0   )
// *           M-K ( 0  C    0   )
// *
// *                   K M-K K+L-M
// *      D2 =   M-K ( 0  S    0   )
// *           K+L-M ( 0  0    I   )
// *             P-L ( 0  0    0   )
// *
// *                 N-K-L  K   M-K  K+L-M
// * ( 0 R ) =    K ( 0    R11  R12  R13  )
// *            M-K ( 0     0   R22  R23  )
// *          K+L-M ( 0     0    0   R33  )
// *
// *  where
// *  C = diag( ALPHA(K+1), ... , ALPHA(M) ),
// *  S = diag( BETA(K+1),  ... , BETA(M) ),
// *  C**2 + S**2 = I.
// *
// *  R = ( R11 R12 R13 ) is stored in A(1:M, N-K-L+1:N) and R33 is stored
// *      (  0  R22 R23 )
// *  in B(M-K+1:L,N+M-K-L+1:N) on exit.
// *
// *  The computation of the orthogonal transformation matrices U, V or Q
// *  is optional.  These matrices may either be formed explicitly, or they
// *  may be postmultiplied into input matrices U1, V1, or Q1.
// *
// *  Arguments
// *  =========
// *
// *  JOBU    (input) CHARACTER*1
// *          = 'U':  U must contain an orthogonal matrix U1 on entry, and
// *                  the product U1*U is returned;
// *          = 'I':  U is initialized to the unit matrix, and the
// *                  orthogonal matrix U is returned;
// *          = 'N':  U is not computed.
// *
// *  JOBV    (input) CHARACTER*1
// *          = 'V':  V must contain an orthogonal matrix V1 on entry, and
// *                  the product V1*V is returned;
// *          = 'I':  V is initialized to the unit matrix, and the
// *                  orthogonal matrix V is returned;
// *          = 'N':  V is not computed.
// *
// *  JOBQ    (input) CHARACTER*1
// *          = 'Q':  Q must contain an orthogonal matrix Q1 on entry, and
// *                  the product Q1*Q is returned;
// *          = 'I':  Q is initialized to the unit matrix, and the
// *                  orthogonal matrix Q is returned;
// *          = 'N':  Q is not computed.
// *
// *  M       (input) INTEGER
// *          The number of rows of the matrix A.  M >= 0.
// *
// *  P       (input) INTEGER
// *          The number of rows of the matrix B.  P >= 0.
// *
// *  N       (input) INTEGER
// *          The number of columns of the matrices A and B.  N >= 0.
// *
// *  K       (input) INTEGER
// *  L       (input) INTEGER
// *          K and L specify the subblocks in the input matrices A and B:
// *          A23 = A(K+1:MIN(K+L,M),N-L+1:N) and B13 = B(1:L,N-L+1:N)
// *          of A and B, whose GSVD is going to be computed by DTGSJA.
// *          See Further details.
// *
// *  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
// *          On entry, the M-by-N matrix A.
// *          On exit, A(N-K+1:N,1:MIN(K+L,M) ) contains the triangular
// *          matrix R or part of R.  See Purpose for details.
// *
// *  LDA     (input) INTEGER
// *          The leading dimension of the array A. LDA >= max(1,M).
// *
// *  B       (input/output) DOUBLE PRECISION array, dimension (LDB,N)
// *          On entry, the P-by-N matrix B.
// *          On exit, if necessary, B(M-K+1:L,N+M-K-L+1:N) contains
// *          a part of R.  See Purpose for details.
// *
// *  LDB     (input) INTEGER
// *          The leading dimension of the array B. LDB >= max(1,P).
// *
// *  TOLA    (input) DOUBLE PRECISION
// *  TOLB    (input) DOUBLE PRECISION
// *          TOLA and TOLB are the convergence criteria for the Jacobi-
// *          Kogbetliantz iteration procedure. Generally, they are the
// *          same as used in the preprocessing step, say
// *              TOLA = max(M,N)*norm(A)*MAZHEPS,
// *              TOLB = max(P,N)*norm(B)*MAZHEPS.
// *
// *  ALPHA   (output) DOUBLE PRECISION array, dimension (N)
// *  BETA    (output) DOUBLE PRECISION array, dimension (N)
// *          On exit, ALPHA and BETA contain the generalized singular
// *          value pairs of A and B;
// *            ALPHA(1:K) = 1,
// *            BETA(1:K)  = 0,
// *          and if M-K-L >= 0,
// *            ALPHA(K+1:K+L) = diag(C),
// *            BETA(K+1:K+L)  = diag(S),
// *          or if M-K-L < 0,
// *            ALPHA(K+1:M)= C, ALPHA(M+1:K+L)= 0
// *            BETA(K+1:M) = S, BETA(M+1:K+L) = 1.
// *          Furthermore, if K+L < N,
// *            ALPHA(K+L+1:N) = 0 and
// *            BETA(K+L+1:N)  = 0.
// *
// *  U       (input/output) DOUBLE PRECISION array, dimension (LDU,M)
// *          On entry, if JOBU = 'U', U must contain a matrix U1 (usually
// *          the orthogonal matrix returned by DGGSVP).
// *          On exit,
// *          if JOBU = 'I', U contains the orthogonal matrix U;
// *          if JOBU = 'U', U contains the product U1*U.
// *          If JOBU = 'N', U is not referenced.
// *
// *  LDU     (input) INTEGER
// *          The leading dimension of the array U. LDU >= max(1,M) if
// *          JOBU = 'U'; LDU >= 1 otherwise.
// *
// *  V       (input/output) DOUBLE PRECISION array, dimension (LDV,P)
// *          On entry, if JOBV = 'V', V must contain a matrix V1 (usually
// *          the orthogonal matrix returned by DGGSVP).
// *          On exit,
// *          if JOBV = 'I', V contains the orthogonal matrix V;
// *          if JOBV = 'V', V contains the product V1*V.
// *          If JOBV = 'N', V is not referenced.
// *
// *  LDV     (input) INTEGER
// *          The leading dimension of the array V. LDV >= max(1,P) if
// *          JOBV = 'V'; LDV >= 1 otherwise.
// *
// *  Q       (input/output) DOUBLE PRECISION array, dimension (LDQ,N)
// *          On entry, if JOBQ = 'Q', Q must contain a matrix Q1 (usually
// *          the orthogonal matrix returned by DGGSVP).
// *          On exit,
// *          if JOBQ = 'I', Q contains the orthogonal matrix Q;
// *          if JOBQ = 'Q', Q contains the product Q1*Q.
// *          If JOBQ = 'N', Q is not referenced.
// *
// *  LDQ     (input) INTEGER
// *          The leading dimension of the array Q. LDQ >= max(1,N) if
// *          JOBQ = 'Q'; LDQ >= 1 otherwise.
// *
// *  WORK    (workspace) DOUBLE PRECISION array, dimension (2*N)
// *
// *  NCYCLE  (output) INTEGER
// *          The number of cycles required for convergence.
// *
// *  INFO    (output) INTEGER
// *          = 0:  successful exit
// *          < 0:  if INFO = -i, the i-th argument had an illegal value.
// *          = 1:  the procedure does not converge after MAXIT cycles.
// *
// *  Internal Parameters
// *  ===================
// *
// *  MAXIT   INTEGER
// *          MAXIT specifies the total loops that the iterative procedure
// *          may take. If after MAXIT cycles, the routine fails to
// *          converge, we return INFO = 1.
// *
// *  Further Details
// *  ===============
// *
// *  DTGSJA essentially uses a variant of Kogbetliantz algorithm to reduce
// *  min(L,M-K)-by-L triangular (or trapezoidal) matrix A23 and L-by-L
// *  matrix B13 to the form:
// *
// *           U1'*A13*Q1 = C1*R1; V1'*B13*Q1 = S1*R1,
// *
// *  where U1, V1 and Q1 are orthogonal matrix, and Z' is the transpose
// *  of Z.  C1 and S1 are diagonal matrices satisfying
// *
// *                C1**2 + S1**2 = I,
// *
// *  and R1 is an L-by-L nonsingular upper triangular matrix.
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static int maxit= 40;
static double zero= 0.0e+0;
static double one= 1.0e+0;
// *     ..
// *     .. Local Scalars ..
// *
static boolean initq= false;
static boolean initu= false;
static boolean initv= false;
static boolean upper= false;
static boolean wantq= false;
static boolean wantu= false;
static boolean wantv= false;
static int i= 0;
static int j= 0;
static int kcycle= 0;
static double a1= 0.0;
static double a2= 0.0;
static double a3= 0.0;
static double b1= 0.0;
static double b2= 0.0;
static double b3= 0.0;
static doubleW csq= new doubleW(0.0);
static doubleW csu= new doubleW(0.0);
static doubleW csv= new doubleW(0.0);
static double error= 0.0;
static double gamma= 0.0;
static doubleW rwk= new doubleW(0.0);
static doubleW snq= new doubleW(0.0);
static doubleW snu= new doubleW(0.0);
static doubleW snv= new doubleW(0.0);
static doubleW ssmin= new doubleW(0.0);
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Decode and test the input parameters
// *

public static void dtgsja (String jobu,
String jobv,
String jobq,
int m,
int p,
int n,
int k,
int l,
double [] a, int _a_offset,
int lda,
double [] b, int _b_offset,
int ldb,
double tola,
double tolb,
double [] alpha, int _alpha_offset,
double [] beta, int _beta_offset,
double [] u, int _u_offset,
int ldu,
double [] v, int _v_offset,
int ldv,
double [] q, int _q_offset,
int ldq,
double [] work, int _work_offset,
intW ncycle,
intW info)  {

initu = (jobu.toLowerCase().charAt(0) == "I".toLowerCase().charAt(0));
wantu = initu || (jobu.toLowerCase().charAt(0) == "U".toLowerCase().charAt(0));
// *
initv = (jobv.toLowerCase().charAt(0) == "I".toLowerCase().charAt(0));
wantv = initv || (jobv.toLowerCase().charAt(0) == "V".toLowerCase().charAt(0));
// *
initq = (jobq.toLowerCase().charAt(0) == "I".toLowerCase().charAt(0));
wantq = initq || (jobq.toLowerCase().charAt(0) == "Q".toLowerCase().charAt(0));
// *
info.val = 0;
if (!(initu || wantu || (jobu.toLowerCase().charAt(0) == "N".toLowerCase().charAt(0))))  {
    info.val = -1;
}              // Close if()
else if (!(initv || wantv || (jobv.toLowerCase().charAt(0) == "N".toLowerCase().charAt(0))))  {
    info.val = -2;
}              // Close else if()
else if (!(initq || wantq || (jobq.toLowerCase().charAt(0) == "N".toLowerCase().charAt(0))))  {
    info.val = -3;
}              // Close else if()
else if (m < 0)  {
    info.val = -4;
}              // Close else if()
else if (p < 0)  {
    info.val = -5;
}              // Close else if()
else if (n < 0)  {
    info.val = -6;
}              // Close else if()
else if (lda < Math.max(1, m) )  {
    info.val = -10;
}              // Close else if()
else if (ldb < Math.max(1, p) )  {
    info.val = -12;
}              // Close else if()
else if (ldu < 1 || (wantu && ldu < m))  {
    info.val = -18;
}              // Close else if()
else if (ldv < 1 || (wantv && ldv < p))  {
    info.val = -20;
}              // Close else if()
else if (ldq < 1 || (wantq && ldq < n))  {
    info.val = -22;
}              // Close else if()
if (info.val != 0)  {
    Xerbla.xerbla("DTGSJA",-info.val);
Dummy.go_to("Dtgsja",999999);
}              // Close if()
// *
// *     Initialize U, V and Q, if necessary
// *
if (initu)  
    Dlaset.dlaset("Full",m,m,zero,one,u,_u_offset,ldu);
if (initv)  
    Dlaset.dlaset("Full",p,p,zero,one,v,_v_offset,ldv);
if (initq)  
    Dlaset.dlaset("Full",n,n,zero,one,q,_q_offset,ldq);
// *
// *     Loop until convergence
// *
upper = false;
{
forloop40:
for (kcycle = 1; kcycle <= maxit; kcycle++) {
// *
upper = !upper;
// *
{
forloop20:
for (i = 1; i <= l-1; i++) {
{
forloop10:
for (j = i+1; j <= l; j++) {
// *
a1 = zero;
a2 = zero;
a3 = zero;
if (k+i <= m)  
    a1 = a[(k+i)- 1+(n-l+i- 1)*lda+ _a_offset];
if (k+j <= m)  
    a3 = a[(k+j)- 1+(n-l+j- 1)*lda+ _a_offset];
// *
b1 = b[(i)- 1+(n-l+i- 1)*ldb+ _b_offset];
b3 = b[(j)- 1+(n-l+j- 1)*ldb+ _b_offset];
// *
if (upper)  {
    if (k+i <= m)  
    a2 = a[(k+i)- 1+(n-l+j- 1)*lda+ _a_offset];
b2 = b[(i)- 1+(n-l+j- 1)*ldb+ _b_offset];
}              // Close if()
else  {
  if (k+j <= m)  
    a2 = a[(k+j)- 1+(n-l+i- 1)*lda+ _a_offset];
b2 = b[(j)- 1+(n-l+i- 1)*ldb+ _b_offset];
}              //  Close else.
// *
Dlags2.dlags2(upper,a1,a2,a3,b1,b2,b3,csu,snu,csv,snv,csq,snq);
// *
// *              Update (K+I)-th and (K+J)-th rows of matrix A: U'*A
// *
if (k+j <= m)  
    Drot.drot(l,a,(k+j)- 1+(n-l+1- 1)*lda+ _a_offset,lda,a,(k+i)- 1+(n-l+1- 1)*lda+ _a_offset,lda,csu.val,snu.val);
// *
// *              Update I-th and J-th rows of matrix B: V'*B
// *
Drot.drot(l,b,(j)- 1+(n-l+1- 1)*ldb+ _b_offset,ldb,b,(i)- 1+(n-l+1- 1)*ldb+ _b_offset,ldb,csv.val,snv.val);
// *
// *              Update (N-L+I)-th and (N-L+J)-th columns of matrices
// *              A and B: A*Q and B*Q
// *
Drot.drot((int) ( Math.min(k+l, m) ),a,(1)- 1+(n-l+j- 1)*lda+ _a_offset,1,a,(1)- 1+(n-l+i- 1)*lda+ _a_offset,1,csq.val,snq.val);
// *
Drot.drot(l,b,(1)- 1+(n-l+j- 1)*ldb+ _b_offset,1,b,(1)- 1+(n-l+i- 1)*ldb+ _b_offset,1,csq.val,snq.val);
// *
if (upper)  {
    if (k+i <= m)  
    a[(k+i)- 1+(n-l+j- 1)*lda+ _a_offset] = zero;
b[(i)- 1+(n-l+j- 1)*ldb+ _b_offset] = zero;
}              // Close if()
else  {
  if (k+j <= m)  
    a[(k+j)- 1+(n-l+i- 1)*lda+ _a_offset] = zero;
b[(j)- 1+(n-l+i- 1)*ldb+ _b_offset] = zero;
}              //  Close else.
// *
// *              Update orthogonal matrices U, V, Q, if desired.
// *
if (wantu && k+j <= m)  
    Drot.drot(m,u,(1)- 1+(k+j- 1)*ldu+ _u_offset,1,u,(1)- 1+(k+i- 1)*ldu+ _u_offset,1,csu.val,snu.val);
// *
if (wantv)  
    Drot.drot(p,v,(1)- 1+(j- 1)*ldv+ _v_offset,1,v,(1)- 1+(i- 1)*ldv+ _v_offset,1,csv.val,snv.val);
// *
if (wantq)  
    Drot.drot(n,q,(1)- 1+(n-l+j- 1)*ldq+ _q_offset,1,q,(1)- 1+(n-l+i- 1)*ldq+ _q_offset,1,csq.val,snq.val);
// *
Dummy.label("Dtgsja",10);
}              //  Close for() loop. 
}
Dummy.label("Dtgsja",20);
}              //  Close for() loop. 
}
// *
if (!upper)  {
    // *
// *           The matrices A13 and B13 were lower triangular at the start
// *           of the cycle, and are now upper triangular.
// *
// *           Convergence test: test the parallelism of the corresponding
// *           rows of A and B.
// *
error = zero;
{
forloop30:
for (i = 1; i <= Math.min(l, m-k) ; i++) {
Dcopy.dcopy(l-i+1,a,(k+i)- 1+(n-l+i- 1)*lda+ _a_offset,lda,work,_work_offset,1);
Dcopy.dcopy(l-i+1,b,(i)- 1+(n-l+i- 1)*ldb+ _b_offset,ldb,work,(l+1)- 1+ _work_offset,1);
Dlapll.dlapll(l-i+1,work,_work_offset,1,work,(l+1)- 1+ _work_offset,1,ssmin);
error = Math.max(error, ssmin.val) ;
Dummy.label("Dtgsja",30);
}              //  Close for() loop. 
}
// *
if (Math.abs(error) <= (double)(n)*Math.min(tola, tolb) )  
    Dummy.go_to("Dtgsja",50);
}              // Close if()
// *
// *        End of cycle loop
// *
Dummy.label("Dtgsja",40);
}              //  Close for() loop. 
}
// *
// *     The algorithm has not converged after MAXIT cycles.
// *
info.val = 1;
Dummy.go_to("Dtgsja",100);
// *
label50:
   Dummy.label("Dtgsja",50);
// *
// *     If ERROR <= N*MIN(TOLA,TOLB), then the algorithm has converged.
// *     Compute the generalized singular value pairs (ALPHA, BETA), and
// *     set the triangular matrix R to array A.
// *
{
forloop60:
for (i = 1; i <= k; i++) {
alpha[(i)- 1+ _alpha_offset] = one;
beta[(i)- 1+ _beta_offset] = zero;
Dummy.label("Dtgsja",60);
}              //  Close for() loop. 
}
// *
{
forloop70:
for (i = 1; i <= Math.min(l, m-k) ; i++) {
// *
a1 = a[(k+i)- 1+(n-l+i- 1)*lda+ _a_offset];
b1 = b[(i)- 1+(n-l+i- 1)*ldb+ _b_offset];
// *
if (a1 != zero)  {
    gamma = b1/a1;
// *
// *           change sign if necessary
// *
if (gamma < zero)  {
    Dscal.dscal(l-i+1,-one,b,(i)- 1+(n-l+i- 1)*ldb+ _b_offset,ldb);
if (wantv)  
    Dscal.dscal(p,-one,v,(1)- 1+(i- 1)*ldv+ _v_offset,1);
}              // Close if()
// *
dlartg_adapter(Math.abs(gamma),one,beta,(k+i)- 1+ _beta_offset,alpha,(k+i)- 1+ _alpha_offset,rwk);
// *
if (alpha[(k+i)- 1+ _alpha_offset] >= beta[(k+i)- 1+ _beta_offset])  {
    Dscal.dscal(l-i+1,one/alpha[(k+i)- 1+ _alpha_offset],a,(k+i)- 1+(n-l+i- 1)*lda+ _a_offset,lda);
}              // Close if()
else  {
  Dscal.dscal(l-i+1,one/beta[(k+i)- 1+ _beta_offset],b,(i)- 1+(n-l+i- 1)*ldb+ _b_offset,ldb);
Dcopy.dcopy(l-i+1,b,(i)- 1+(n-l+i- 1)*ldb+ _b_offset,ldb,a,(k+i)- 1+(n-l+i- 1)*lda+ _a_offset,lda);
}              //  Close else.
// *
}              // Close if()
else  {
  // *
alpha[(k+i)- 1+ _alpha_offset] = zero;
beta[(k+i)- 1+ _beta_offset] = one;
Dcopy.dcopy(l-i+1,b,(i)- 1+(n-l+i- 1)*ldb+ _b_offset,ldb,a,(k+i)- 1+(n-l+i- 1)*lda+ _a_offset,lda);
// *
}              //  Close else.
// *
Dummy.label("Dtgsja",70);
}              //  Close for() loop. 
}
// *
// *     Post-assignment
// *
{
forloop80:
for (i = m+1; i <= k+l; i++) {
alpha[(i)- 1+ _alpha_offset] = zero;
beta[(i)- 1+ _beta_offset] = one;
Dummy.label("Dtgsja",80);
}              //  Close for() loop. 
}
// *
if (k+l < n)  {
    {
forloop90:
for (i = k+l+1; i <= n; i++) {
alpha[(i)- 1+ _alpha_offset] = zero;
beta[(i)- 1+ _beta_offset] = zero;
Dummy.label("Dtgsja",90);
}              //  Close for() loop. 
}
}              // Close if()
// *
label100:
   Dummy.label("Dtgsja",100);
ncycle.val = kcycle;
Dummy.go_to("Dtgsja",999999);
// *
// *     End of DTGSJA
// *
Dummy.label("Dtgsja",999999);
return;
   }
// adapter for dlartg
private static void dlartg_adapter(double arg0 ,double arg1 ,double [] arg2 , int arg2_offset ,double [] arg3 , int arg3_offset ,doubleW arg4 )
{
doubleW _f2j_tmp2 = new doubleW(arg2[arg2_offset]);
doubleW _f2j_tmp3 = new doubleW(arg3[arg3_offset]);

Dlartg.dlartg(arg0,arg1,_f2j_tmp2,_f2j_tmp3,arg4);

arg2[arg2_offset] = _f2j_tmp2.val;
arg3[arg3_offset] = _f2j_tmp3.val;
}

} // End class.
