/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;

import org.netlib.blas.*;


public class Dtrevc {

// *
// *  -- LAPACK routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DTREVC computes some or all of the right and/or left eigenvectors of
// *  a real upper quasi-triangular matrix T.
// *
// *  The right eigenvector x and the left eigenvector y of T corresponding
// *  to an eigenvalue w are defined by:
// *
// *               T*x = w*x,     y'*T = w*y'
// *
// *  where y' denotes the conjugate transpose of the vector y.
// *
// *  If all eigenvectors are requested, the routine may either return the
// *  matrices X and/or Y of right or left eigenvectors of T, or the
// *  products Q*X and/or Q*Y, where Q is an input orthogonal
// *  matrix. If T was obtained from the real-Schur factorization of an
// *  original matrix A = Q*T*Q', then Q*X and Q*Y are the matrices of
// *  right or left eigenvectors of A.
// *
// *  T must be in Schur canonical form (as returned by DHSEQR), that is,
// *  block upper triangular with 1-by-1 and 2-by-2 diagonal blocks; each
// *  2-by-2 diagonal block has its diagonal elements equal and its
// *  off-diagonal elements of opposite sign.  Corresponding to each 2-by-2
// *  diagonal block is a complex conjugate pair of eigenvalues and
// *  eigenvectors; only one eigenvector of the pair is computed, namely
// *  the one corresponding to the eigenvalue with positive imaginary part.
// *
// *
// *  Arguments
// *  =========
// *
// *  SIDE    (input) CHARACTER*1
// *          = 'R':  compute right eigenvectors only;
// *          = 'L':  compute left eigenvectors only;
// *          = 'B':  compute both right and left eigenvectors.
// *
// *  HOWMNY  (input) CHARACTER*1
// *          = 'A':  compute all right and/or left eigenvectors;
// *          = 'B':  compute all right and/or left eigenvectors,
// *                  and backtransform them using the input matrices
// *                  supplied in VR and/or VL;
// *          = 'S':  compute selected right and/or left eigenvectors,
// *                  specified by the logical array SELECT.
// *
// *  SELECT  (input/output) LOGICAL array, dimension (N)
// *          If HOWMNY = 'S', SELECT specifies the eigenvectors to be
// *          computed.
// *          If HOWMNY = 'A' or 'B', SELECT is not referenced.
// *          To select the real eigenvector corresponding to a real
// *          eigenvalue w(j), SELECT(j) must be set to .TRUE..  To select
// *          the complex eigenvector corresponding to a complex conjugate
// *          pair w(j) and w(j+1), either SELECT(j) or SELECT(j+1) must be
// *          set to .TRUE.; then on exit SELECT(j) is .TRUE. and
// *          SELECT(j+1) is .FALSE..
// *
// *  N       (input) INTEGER
// *          The order of the matrix T. N >= 0.
// *
// *  T       (input) DOUBLE PRECISION array, dimension (LDT,N)
// *          The upper quasi-triangular matrix T in Schur canonical form.
// *
// *  LDT     (input) INTEGER
// *          The leading dimension of the array T. LDT >= max(1,N).
// *
// *  VL      (input/output) DOUBLE PRECISION array, dimension (LDVL,MM)
// *          On entry, if SIDE = 'L' or 'B' and HOWMNY = 'B', VL must
// *          contain an N-by-N matrix Q (usually the orthogonal matrix Q
// *          of Schur vectors returned by DHSEQR).
// *          On exit, if SIDE = 'L' or 'B', VL contains:
// *          if HOWMNY = 'A', the matrix Y of left eigenvectors of T;
// *          if HOWMNY = 'B', the matrix Q*Y;
// *          if HOWMNY = 'S', the left eigenvectors of T specified by
// *                           SELECT, stored consecutively in the columns
// *                           of VL, in the same order as their
// *                           eigenvalues.
// *          A complex eigenvector corresponding to a complex eigenvalue
// *          is stored in two consecutive columns, the first holding the
// *          real part, and the second the imaginary part.
// *          If SIDE = 'R', VL is not referenced.
// *
// *  LDVL    (input) INTEGER
// *          The leading dimension of the array VL.  LDVL >= max(1,N) if
// *          SIDE = 'L' or 'B'; LDVL >= 1 otherwise.
// *
// *  VR      (input/output) DOUBLE PRECISION array, dimension (LDVR,MM)
// *          On entry, if SIDE = 'R' or 'B' and HOWMNY = 'B', VR must
// *          contain an N-by-N matrix Q (usually the orthogonal matrix Q
// *          of Schur vectors returned by DHSEQR).
// *          On exit, if SIDE = 'R' or 'B', VR contains:
// *          if HOWMNY = 'A', the matrix X of right eigenvectors of T;
// *          if HOWMNY = 'B', the matrix Q*X;
// *          if HOWMNY = 'S', the right eigenvectors of T specified by
// *                           SELECT, stored consecutively in the columns
// *                           of VR, in the same order as their
// *                           eigenvalues.
// *          A complex eigenvector corresponding to a complex eigenvalue
// *          is stored in two consecutive columns, the first holding the
// *          real part and the second the imaginary part.
// *          If SIDE = 'L', VR is not referenced.
// *
// *  LDVR    (input) INTEGER
// *          The leading dimension of the array VR.  LDVR >= max(1,N) if
// *          SIDE = 'R' or 'B'; LDVR >= 1 otherwise.
// *
// *  MM      (input) INTEGER
// *          The number of columns in the arrays VL and/or VR. MM >= M.
// *
// *  M       (output) INTEGER
// *          The number of columns in the arrays VL and/or VR actually
// *          used to store the eigenvectors.
// *          If HOWMNY = 'A' or 'B', M is set to N.
// *          Each selected real eigenvector occupies one column and each
// *          selected complex eigenvector occupies two columns.
// *
// *  WORK    (workspace) DOUBLE PRECISION array, dimension (3*N)
// *
// *  INFO    (output) INTEGER
// *          = 0:  successful exit
// *          < 0:  if INFO = -i, the i-th argument had an illegal value
// *
// *  Further Details
// *  ===============
// *
// *  The algorithm used in this program is basically backward (forward)
// *  substitution, with scaling to make the the code robust against
// *  possible overflow.
// *
// *  Each eigenvector is normalized so that the element of largest
// *  magnitude has magnitude 1; here the magnitude of a complex number
// *  (x,y) is taken to be |x| + |y|.
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double zero= 0.0e+0;
static double one= 1.0e+0;
// *     ..
// *     .. Local Scalars ..
static boolean allv= false;
static boolean bothv= false;
static boolean leftv= false;
static boolean over= false;
static boolean pair= false;
static boolean rightv= false;
static boolean somev= false;
static int i= 0;
static intW ierr= new intW(0);
static int ii= 0;
static int ip= 0;
static int is= 0;
static int j= 0;
static int j1= 0;
static int j2= 0;
static int jnxt= 0;
static int k= 0;
static int ki= 0;
static int n2= 0;
static double beta= 0.0;
static double bignum= 0.0;
static double emax= 0.0;
static doubleW ovfl= new doubleW(0.0);
static double rec= 0.0;
static double remax= 0.0;
static doubleW scale= new doubleW(0.0);
static double smin= 0.0;
static double smlnum= 0.0;
static double ulp= 0.0;
static doubleW unfl= new doubleW(0.0);
static double vcrit= 0.0;
static double vmax= 0.0;
static double wi= 0.0;
static double wr= 0.0;
static doubleW xnorm= new doubleW(0.0);
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Local Arrays ..
static double [] x= new double[(2) * (2)];
// *     ..
// *     .. Executable Statements ..
// *
// *     Decode and test the input parameters
// *

public static void dtrevc (String side,
String howmny,
boolean [] select, int _select_offset,
int n,
double [] t, int _t_offset,
int ldt,
double [] vl, int _vl_offset,
int ldvl,
double [] vr, int _vr_offset,
int ldvr,
int mm,
intW m,
double [] work, int _work_offset,
intW info)  {

bothv = (side.toLowerCase().charAt(0) == "B".toLowerCase().charAt(0));
rightv = (side.toLowerCase().charAt(0) == "R".toLowerCase().charAt(0)) || bothv;
leftv = (side.toLowerCase().charAt(0) == "L".toLowerCase().charAt(0)) || bothv;
// *
allv = (howmny.toLowerCase().charAt(0) == "A".toLowerCase().charAt(0));
over = (howmny.toLowerCase().charAt(0) == "B".toLowerCase().charAt(0)) || (howmny.toLowerCase().charAt(0) == "O".toLowerCase().charAt(0));
somev = (howmny.toLowerCase().charAt(0) == "S".toLowerCase().charAt(0));
// *
info.val = 0;
if (!rightv && !leftv)  {
    info.val = -1;
}              // Close if()
else if (!allv && !over && !somev)  {
    info.val = -2;
}              // Close else if()
else if (n < 0)  {
    info.val = -4;
}              // Close else if()
else if (ldt < Math.max(1, n) )  {
    info.val = -6;
}              // Close else if()
else if (ldvl < 1 || (leftv && ldvl < n))  {
    info.val = -8;
}              // Close else if()
else if (ldvr < 1 || (rightv && ldvr < n))  {
    info.val = -10;
}              // Close else if()
else  {
  // *
// *        Set M to the number of columns required to store the selected
// *        eigenvectors, standardize the array SELECT if necessary, and
// *        test MM.
// *
if (somev)  {
    m.val = 0;
pair = false;
{
forloop10:
for (j = 1; j <= n; j++) {
if (pair)  {
    pair = false;
select[(j)- 1+ _select_offset] = false;
}              // Close if()
else  {
  if (j < n)  {
    if (t[(j+1)- 1+(j- 1)*ldt+ _t_offset] == zero)  {
    if (select[(j)- 1+ _select_offset])  
    m.val = m.val+1;
}              // Close if()
else  {
  pair = true;
if (select[(j)- 1+ _select_offset] || select[(j+1)- 1+ _select_offset])  {
    select[(j)- 1+ _select_offset] = true;
m.val = m.val+2;
}              // Close if()
}              //  Close else.
}              // Close if()
else  {
  if (select[(n)- 1+ _select_offset])  
    m.val = m.val+1;
}              //  Close else.
}              //  Close else.
Dummy.label("Dtrevc",10);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  m.val = n;
}              //  Close else.
// *
if (mm < m.val)  {
    info.val = -11;
}              // Close if()
}              //  Close else.
if (info.val != 0)  {
    Xerbla.xerbla("DTREVC",-info.val);
Dummy.go_to("Dtrevc",999999);
}              // Close if()
// *
// *     Quick return if possible.
// *
if (n == 0)  
    Dummy.go_to("Dtrevc",999999);
// *
// *     Set the constants to control overflow.
// *
unfl.val = Dlamch.dlamch("Safe minimum");
ovfl.val = one/unfl.val;
Dlabad.dlabad(unfl,ovfl);
ulp = Dlamch.dlamch("Precision");
smlnum = unfl.val*(n/ulp);
bignum = (one-ulp)/smlnum;
// *
// *     Compute 1-norm of each column of strictly upper triangular
// *     part of T to control overflow in triangular solver.
// *
work[(1)- 1+ _work_offset] = zero;
{
forloop30:
for (j = 2; j <= n; j++) {
work[(j)- 1+ _work_offset] = zero;
{
forloop20:
for (i = 1; i <= j-1; i++) {
work[(j)- 1+ _work_offset] = work[(j)- 1+ _work_offset]+Math.abs(t[(i)- 1+(j- 1)*ldt+ _t_offset]);
Dummy.label("Dtrevc",20);
}              //  Close for() loop. 
}
Dummy.label("Dtrevc",30);
}              //  Close for() loop. 
}
// *
// *     Index IP is used to specify the real or complex eigenvalue:
// *       IP = 0, real eigenvalue,
// *            1, first of conjugate complex pair: (wr,wi)
// *           -1, second of conjugate complex pair: (wr,wi)
// *
n2 = 2*n;
// *
if (rightv)  {
    // *
// *        Compute right eigenvectors.
// *
ip = 0;
is = m.val;
{
int _ki_inc = -1;
forloop140:
for (ki = n; ki >= 1; ki += _ki_inc) {
// *
if (ip == 1)  
    Dummy.go_to("Dtrevc",130);
if (ki == 1)  
    Dummy.go_to("Dtrevc",40);
if (t[(ki)- 1+(ki-1- 1)*ldt+ _t_offset] == zero)  
    Dummy.go_to("Dtrevc",40);
ip = -1;
// *
label40:
   Dummy.label("Dtrevc",40);
if (somev)  {
    if (ip == 0)  {
    if (!select[(ki)- 1+ _select_offset])  
    Dummy.go_to("Dtrevc",130);
}              // Close if()
else  {
  if (!select[(ki-1)- 1+ _select_offset])  
    Dummy.go_to("Dtrevc",130);
}              //  Close else.
}              // Close if()
// *
// *           Compute the KI-th eigenvalue (WR,WI).
// *
wr = t[(ki)- 1+(ki- 1)*ldt+ _t_offset];
wi = zero;
if (ip != 0)  
    wi = Math.sqrt(Math.abs(t[(ki)- 1+(ki-1- 1)*ldt+ _t_offset]))*Math.sqrt(Math.abs(t[(ki-1)- 1+(ki- 1)*ldt+ _t_offset]));
smin = Math.max(ulp*(Math.abs(wr)+Math.abs(wi)), smlnum) ;
// *
if (ip == 0)  {
    // *
// *              Real right eigenvector
// *
work[(ki+n)- 1+ _work_offset] = one;
// *
// *              Form right-hand side
// *
{
forloop50:
for (k = 1; k <= ki-1; k++) {
work[(k+n)- 1+ _work_offset] = -t[(k)- 1+(ki- 1)*ldt+ _t_offset];
Dummy.label("Dtrevc",50);
}              //  Close for() loop. 
}
// *
// *              Solve the upper quasi-triangular system:
// *                 (T(1:KI-1,1:KI-1) - WR)*X = SCALE*WORK.
// *
jnxt = ki-1;
{
int _j_inc = -1;
forloop60:
for (j = ki-1; j >= 1; j += _j_inc) {
if (j > jnxt)  
    continue forloop60;
j1 = j;
j2 = j;
jnxt = j-1;
if (j > 1)  {
    if (t[(j)- 1+(j-1- 1)*ldt+ _t_offset] != zero)  {
    j1 = j-1;
jnxt = j-2;
}              // Close if()
}              // Close if()
// *
if (j1 == j2)  {
    // *
// *                    1-by-1 diagonal block
// *
Dlaln2.dlaln2(false,1,1,smin,one,t,(j)- 1+(j- 1)*ldt+ _t_offset,ldt,one,one,work,(j+n)- 1+ _work_offset,n,wr,zero,x,0,2,scale,xnorm,ierr);
// *
// *                    Scale X(1,1) to avoid overflow when updating
// *                    the right-hand side.
// *
if (xnorm.val > one)  {
    if (work[(j)- 1+ _work_offset] > bignum/xnorm.val)  {
    x[(1)- 1+(1- 1)*2] = x[(1)- 1+(1- 1)*2]/xnorm.val;
scale.val = scale.val/xnorm.val;
}              // Close if()
}              // Close if()
// *
// *                    Scale if necessary
// *
if (scale.val != one)  
    Dscal.dscal(ki,scale.val,work,(1+n)- 1+ _work_offset,1);
work[(j+n)- 1+ _work_offset] = x[(1)- 1+(1- 1)*2];
// *
// *                    Update right-hand side
// *
Daxpy.daxpy(j-1,-x[(1)- 1+(1- 1)*2],t,(1)- 1+(j- 1)*ldt+ _t_offset,1,work,(1+n)- 1+ _work_offset,1);
// *
}              // Close if()
else  {
  // *
// *                    2-by-2 diagonal block
// *
Dlaln2.dlaln2(false,2,1,smin,one,t,(j-1)- 1+(j-1- 1)*ldt+ _t_offset,ldt,one,one,work,(j-1+n)- 1+ _work_offset,n,wr,zero,x,0,2,scale,xnorm,ierr);
// *
// *                    Scale X(1,1) and X(2,1) to avoid overflow when
// *                    updating the right-hand side.
// *
if (xnorm.val > one)  {
    beta = Math.max(work[(j-1)- 1+ _work_offset], work[(j)- 1+ _work_offset]) ;
if (beta > bignum/xnorm.val)  {
    x[(1)- 1+(1- 1)*2] = x[(1)- 1+(1- 1)*2]/xnorm.val;
x[(2)- 1+(1- 1)*2] = x[(2)- 1+(1- 1)*2]/xnorm.val;
scale.val = scale.val/xnorm.val;
}              // Close if()
}              // Close if()
// *
// *                    Scale if necessary
// *
if (scale.val != one)  
    Dscal.dscal(ki,scale.val,work,(1+n)- 1+ _work_offset,1);
work[(j-1+n)- 1+ _work_offset] = x[(1)- 1+(1- 1)*2];
work[(j+n)- 1+ _work_offset] = x[(2)- 1+(1- 1)*2];
// *
// *                    Update right-hand side
// *
Daxpy.daxpy(j-2,-x[(1)- 1+(1- 1)*2],t,(1)- 1+(j-1- 1)*ldt+ _t_offset,1,work,(1+n)- 1+ _work_offset,1);
Daxpy.daxpy(j-2,-x[(2)- 1+(1- 1)*2],t,(1)- 1+(j- 1)*ldt+ _t_offset,1,work,(1+n)- 1+ _work_offset,1);
}              //  Close else.
Dummy.label("Dtrevc",60);
}              //  Close for() loop. 
}
// *
// *              Copy the vector x or Q*x to VR and normalize.
// *
if (!over)  {
    Dcopy.dcopy(ki,work,(1+n)- 1+ _work_offset,1,vr,(1)- 1+(is- 1)*ldvr+ _vr_offset,1);
// *
ii = Idamax.idamax(ki,vr,(1)- 1+(is- 1)*ldvr+ _vr_offset,1);
remax = one/Math.abs(vr[(ii)- 1+(is- 1)*ldvr+ _vr_offset]);
Dscal.dscal(ki,remax,vr,(1)- 1+(is- 1)*ldvr+ _vr_offset,1);
// *
{
forloop70:
for (k = ki+1; k <= n; k++) {
vr[(k)- 1+(is- 1)*ldvr+ _vr_offset] = zero;
Dummy.label("Dtrevc",70);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  if (ki > 1)  
    Dgemv.dgemv("N",n,ki-1,one,vr,_vr_offset,ldvr,work,(1+n)- 1+ _work_offset,1,work[(ki+n)- 1+ _work_offset],vr,(1)- 1+(ki- 1)*ldvr+ _vr_offset,1);
// *
ii = Idamax.idamax(n,vr,(1)- 1+(ki- 1)*ldvr+ _vr_offset,1);
remax = one/Math.abs(vr[(ii)- 1+(ki- 1)*ldvr+ _vr_offset]);
Dscal.dscal(n,remax,vr,(1)- 1+(ki- 1)*ldvr+ _vr_offset,1);
}              //  Close else.
// *
}              // Close if()
else  {
  // *
// *              Complex right eigenvector.
// *
// *              Initial solve
// *                [ (T(KI-1,KI-1) T(KI-1,KI) ) - (WR + I* WI)]*X = 0.
// *                [ (T(KI,KI-1)   T(KI,KI)   )               ]
// *
if (Math.abs(t[(ki-1)- 1+(ki- 1)*ldt+ _t_offset]) >= Math.abs(t[(ki)- 1+(ki-1- 1)*ldt+ _t_offset]))  {
    work[(ki-1+n)- 1+ _work_offset] = one;
work[(ki+n2)- 1+ _work_offset] = wi/t[(ki-1)- 1+(ki- 1)*ldt+ _t_offset];
}              // Close if()
else  {
  work[(ki-1+n)- 1+ _work_offset] = -wi/t[(ki)- 1+(ki-1- 1)*ldt+ _t_offset];
work[(ki+n2)- 1+ _work_offset] = one;
}              //  Close else.
work[(ki+n)- 1+ _work_offset] = zero;
work[(ki-1+n2)- 1+ _work_offset] = zero;
// *
// *              Form right-hand side
// *
{
forloop80:
for (k = 1; k <= ki-2; k++) {
work[(k+n)- 1+ _work_offset] = -work[(ki-1+n)- 1+ _work_offset]*t[(k)- 1+(ki-1- 1)*ldt+ _t_offset];
work[(k+n2)- 1+ _work_offset] = -work[(ki+n2)- 1+ _work_offset]*t[(k)- 1+(ki- 1)*ldt+ _t_offset];
Dummy.label("Dtrevc",80);
}              //  Close for() loop. 
}
// *
// *              Solve upper quasi-triangular system:
// *              (T(1:KI-2,1:KI-2) - (WR+i*WI))*X = SCALE*(WORK+i*WORK2)
// *
jnxt = ki-2;
{
int _j_inc = -1;
forloop90:
for (j = ki-2; j >= 1; j += _j_inc) {
if (j > jnxt)  
    continue forloop90;
j1 = j;
j2 = j;
jnxt = j-1;
if (j > 1)  {
    if (t[(j)- 1+(j-1- 1)*ldt+ _t_offset] != zero)  {
    j1 = j-1;
jnxt = j-2;
}              // Close if()
}              // Close if()
// *
if (j1 == j2)  {
    // *
// *                    1-by-1 diagonal block
// *
Dlaln2.dlaln2(false,1,2,smin,one,t,(j)- 1+(j- 1)*ldt+ _t_offset,ldt,one,one,work,(j+n)- 1+ _work_offset,n,wr,wi,x,0,2,scale,xnorm,ierr);
// *
// *                    Scale X(1,1) and X(1,2) to avoid overflow when
// *                    updating the right-hand side.
// *
if (xnorm.val > one)  {
    if (work[(j)- 1+ _work_offset] > bignum/xnorm.val)  {
    x[(1)- 1+(1- 1)*2] = x[(1)- 1+(1- 1)*2]/xnorm.val;
x[(1)- 1+(2- 1)*2] = x[(1)- 1+(2- 1)*2]/xnorm.val;
scale.val = scale.val/xnorm.val;
}              // Close if()
}              // Close if()
// *
// *                    Scale if necessary
// *
if (scale.val != one)  {
    Dscal.dscal(ki,scale.val,work,(1+n)- 1+ _work_offset,1);
Dscal.dscal(ki,scale.val,work,(1+n2)- 1+ _work_offset,1);
}              // Close if()
work[(j+n)- 1+ _work_offset] = x[(1)- 1+(1- 1)*2];
work[(j+n2)- 1+ _work_offset] = x[(1)- 1+(2- 1)*2];
// *
// *                    Update the right-hand side
// *
Daxpy.daxpy(j-1,-x[(1)- 1+(1- 1)*2],t,(1)- 1+(j- 1)*ldt+ _t_offset,1,work,(1+n)- 1+ _work_offset,1);
Daxpy.daxpy(j-1,-x[(1)- 1+(2- 1)*2],t,(1)- 1+(j- 1)*ldt+ _t_offset,1,work,(1+n2)- 1+ _work_offset,1);
// *
}              // Close if()
else  {
  // *
// *                    2-by-2 diagonal block
// *
Dlaln2.dlaln2(false,2,2,smin,one,t,(j-1)- 1+(j-1- 1)*ldt+ _t_offset,ldt,one,one,work,(j-1+n)- 1+ _work_offset,n,wr,wi,x,0,2,scale,xnorm,ierr);
// *
// *                    Scale X to avoid overflow when updating
// *                    the right-hand side.
// *
if (xnorm.val > one)  {
    beta = Math.max(work[(j-1)- 1+ _work_offset], work[(j)- 1+ _work_offset]) ;
if (beta > bignum/xnorm.val)  {
    rec = one/xnorm.val;
x[(1)- 1+(1- 1)*2] = x[(1)- 1+(1- 1)*2]*rec;
x[(1)- 1+(2- 1)*2] = x[(1)- 1+(2- 1)*2]*rec;
x[(2)- 1+(1- 1)*2] = x[(2)- 1+(1- 1)*2]*rec;
x[(2)- 1+(2- 1)*2] = x[(2)- 1+(2- 1)*2]*rec;
scale.val = scale.val*rec;
}              // Close if()
}              // Close if()
// *
// *                    Scale if necessary
// *
if (scale.val != one)  {
    Dscal.dscal(ki,scale.val,work,(1+n)- 1+ _work_offset,1);
Dscal.dscal(ki,scale.val,work,(1+n2)- 1+ _work_offset,1);
}              // Close if()
work[(j-1+n)- 1+ _work_offset] = x[(1)- 1+(1- 1)*2];
work[(j+n)- 1+ _work_offset] = x[(2)- 1+(1- 1)*2];
work[(j-1+n2)- 1+ _work_offset] = x[(1)- 1+(2- 1)*2];
work[(j+n2)- 1+ _work_offset] = x[(2)- 1+(2- 1)*2];
// *
// *                    Update the right-hand side
// *
Daxpy.daxpy(j-2,-x[(1)- 1+(1- 1)*2],t,(1)- 1+(j-1- 1)*ldt+ _t_offset,1,work,(1+n)- 1+ _work_offset,1);
Daxpy.daxpy(j-2,-x[(2)- 1+(1- 1)*2],t,(1)- 1+(j- 1)*ldt+ _t_offset,1,work,(1+n)- 1+ _work_offset,1);
Daxpy.daxpy(j-2,-x[(1)- 1+(2- 1)*2],t,(1)- 1+(j-1- 1)*ldt+ _t_offset,1,work,(1+n2)- 1+ _work_offset,1);
Daxpy.daxpy(j-2,-x[(2)- 1+(2- 1)*2],t,(1)- 1+(j- 1)*ldt+ _t_offset,1,work,(1+n2)- 1+ _work_offset,1);
}              //  Close else.
Dummy.label("Dtrevc",90);
}              //  Close for() loop. 
}
// *
// *              Copy the vector x or Q*x to VR and normalize.
// *
if (!over)  {
    Dcopy.dcopy(ki,work,(1+n)- 1+ _work_offset,1,vr,(1)- 1+(is-1- 1)*ldvr+ _vr_offset,1);
Dcopy.dcopy(ki,work,(1+n2)- 1+ _work_offset,1,vr,(1)- 1+(is- 1)*ldvr+ _vr_offset,1);
// *
emax = zero;
{
forloop100:
for (k = 1; k <= ki; k++) {
emax = Math.max(emax, Math.abs(vr[(k)- 1+(is-1- 1)*ldvr+ _vr_offset])+Math.abs(vr[(k)- 1+(is- 1)*ldvr+ _vr_offset])) ;
Dummy.label("Dtrevc",100);
}              //  Close for() loop. 
}
// *
remax = one/emax;
Dscal.dscal(ki,remax,vr,(1)- 1+(is-1- 1)*ldvr+ _vr_offset,1);
Dscal.dscal(ki,remax,vr,(1)- 1+(is- 1)*ldvr+ _vr_offset,1);
// *
{
forloop110:
for (k = ki+1; k <= n; k++) {
vr[(k)- 1+(is-1- 1)*ldvr+ _vr_offset] = zero;
vr[(k)- 1+(is- 1)*ldvr+ _vr_offset] = zero;
Dummy.label("Dtrevc",110);
}              //  Close for() loop. 
}
// *
}              // Close if()
else  {
  // *
if (ki > 2)  {
    Dgemv.dgemv("N",n,ki-2,one,vr,_vr_offset,ldvr,work,(1+n)- 1+ _work_offset,1,work[(ki-1+n)- 1+ _work_offset],vr,(1)- 1+(ki-1- 1)*ldvr+ _vr_offset,1);
Dgemv.dgemv("N",n,ki-2,one,vr,_vr_offset,ldvr,work,(1+n2)- 1+ _work_offset,1,work[(ki+n2)- 1+ _work_offset],vr,(1)- 1+(ki- 1)*ldvr+ _vr_offset,1);
}              // Close if()
else  {
  Dscal.dscal(n,work[(ki-1+n)- 1+ _work_offset],vr,(1)- 1+(ki-1- 1)*ldvr+ _vr_offset,1);
Dscal.dscal(n,work[(ki+n2)- 1+ _work_offset],vr,(1)- 1+(ki- 1)*ldvr+ _vr_offset,1);
}              //  Close else.
// *
emax = zero;
{
forloop120:
for (k = 1; k <= n; k++) {
emax = Math.max(emax, Math.abs(vr[(k)- 1+(ki-1- 1)*ldvr+ _vr_offset])+Math.abs(vr[(k)- 1+(ki- 1)*ldvr+ _vr_offset])) ;
Dummy.label("Dtrevc",120);
}              //  Close for() loop. 
}
remax = one/emax;
Dscal.dscal(n,remax,vr,(1)- 1+(ki-1- 1)*ldvr+ _vr_offset,1);
Dscal.dscal(n,remax,vr,(1)- 1+(ki- 1)*ldvr+ _vr_offset,1);
}              //  Close else.
}              //  Close else.
// *
is = is-1;
if (ip != 0)  
    is = is-1;
label130:
   Dummy.label("Dtrevc",130);
if (ip == 1)  
    ip = 0;
if (ip == -1)  
    ip = 1;
Dummy.label("Dtrevc",140);
}              //  Close for() loop. 
}
}              // Close if()
// *
if (leftv)  {
    // *
// *        Compute left eigenvectors.
// *
ip = 0;
is = 1;
{
forloop260:
for (ki = 1; ki <= n; ki++) {
// *
if (ip == -1)  
    Dummy.go_to("Dtrevc",250);
if (ki == n)  
    Dummy.go_to("Dtrevc",150);
if (t[(ki+1)- 1+(ki- 1)*ldt+ _t_offset] == zero)  
    Dummy.go_to("Dtrevc",150);
ip = 1;
// *
label150:
   Dummy.label("Dtrevc",150);
if (somev)  {
    if (!select[(ki)- 1+ _select_offset])  
    Dummy.go_to("Dtrevc",250);
}              // Close if()
// *
// *           Compute the KI-th eigenvalue (WR,WI).
// *
wr = t[(ki)- 1+(ki- 1)*ldt+ _t_offset];
wi = zero;
if (ip != 0)  
    wi = Math.sqrt(Math.abs(t[(ki)- 1+(ki+1- 1)*ldt+ _t_offset]))*Math.sqrt(Math.abs(t[(ki+1)- 1+(ki- 1)*ldt+ _t_offset]));
smin = Math.max(ulp*(Math.abs(wr)+Math.abs(wi)), smlnum) ;
// *
if (ip == 0)  {
    // *
// *              Real left eigenvector.
// *
work[(ki+n)- 1+ _work_offset] = one;
// *
// *              Form right-hand side
// *
{
forloop160:
for (k = ki+1; k <= n; k++) {
work[(k+n)- 1+ _work_offset] = -t[(ki)- 1+(k- 1)*ldt+ _t_offset];
Dummy.label("Dtrevc",160);
}              //  Close for() loop. 
}
// *
// *              Solve the quasi-triangular system:
// *                 (T(KI+1:N,KI+1:N) - WR)'*X = SCALE*WORK
// *
vmax = one;
vcrit = bignum;
// *
jnxt = ki+1;
{
forloop170:
for (j = ki+1; j <= n; j++) {
if (j < jnxt)  
    continue forloop170;
j1 = j;
j2 = j;
jnxt = j+1;
if (j < n)  {
    if (t[(j+1)- 1+(j- 1)*ldt+ _t_offset] != zero)  {
    j2 = j+1;
jnxt = j+2;
}              // Close if()
}              // Close if()
// *
if (j1 == j2)  {
    // *
// *                    1-by-1 diagonal block
// *
// *                    Scale if necessary to avoid overflow when forming
// *                    the right-hand side.
// *
if (work[(j)- 1+ _work_offset] > vcrit)  {
    rec = one/vmax;
Dscal.dscal(n-ki+1,rec,work,(ki+n)- 1+ _work_offset,1);
vmax = one;
vcrit = bignum;
}              // Close if()
// *
work[(j+n)- 1+ _work_offset] = work[(j+n)- 1+ _work_offset]-Ddot.ddot(j-ki-1,t,(ki+1)- 1+(j- 1)*ldt+ _t_offset,1,work,(ki+1+n)- 1+ _work_offset,1);
// *
// *                    Solve (T(J,J)-WR)'*X = WORK
// *
Dlaln2.dlaln2(false,1,1,smin,one,t,(j)- 1+(j- 1)*ldt+ _t_offset,ldt,one,one,work,(j+n)- 1+ _work_offset,n,wr,zero,x,0,2,scale,xnorm,ierr);
// *
// *                    Scale if necessary
// *
if (scale.val != one)  
    Dscal.dscal(n-ki+1,scale.val,work,(ki+n)- 1+ _work_offset,1);
work[(j+n)- 1+ _work_offset] = x[(1)- 1+(1- 1)*2];
vmax = Math.max(Math.abs(work[(j+n)- 1+ _work_offset]), vmax) ;
vcrit = bignum/vmax;
// *
}              // Close if()
else  {
  // *
// *                    2-by-2 diagonal block
// *
// *                    Scale if necessary to avoid overflow when forming
// *                    the right-hand side.
// *
beta = Math.max(work[(j)- 1+ _work_offset], work[(j+1)- 1+ _work_offset]) ;
if (beta > vcrit)  {
    rec = one/vmax;
Dscal.dscal(n-ki+1,rec,work,(ki+n)- 1+ _work_offset,1);
vmax = one;
vcrit = bignum;
}              // Close if()
// *
work[(j+n)- 1+ _work_offset] = work[(j+n)- 1+ _work_offset]-Ddot.ddot(j-ki-1,t,(ki+1)- 1+(j- 1)*ldt+ _t_offset,1,work,(ki+1+n)- 1+ _work_offset,1);
// *
work[(j+1+n)- 1+ _work_offset] = work[(j+1+n)- 1+ _work_offset]-Ddot.ddot(j-ki-1,t,(ki+1)- 1+(j+1- 1)*ldt+ _t_offset,1,work,(ki+1+n)- 1+ _work_offset,1);
// *
// *                    Solve
// *                      [T(J,J)-WR   T(J,J+1)     ]'* X = SCALE*( WORK1 )
// *                      [T(J+1,J)    T(J+1,J+1)-WR]             ( WORK2 )
// *
Dlaln2.dlaln2(true,2,1,smin,one,t,(j)- 1+(j- 1)*ldt+ _t_offset,ldt,one,one,work,(j+n)- 1+ _work_offset,n,wr,zero,x,0,2,scale,xnorm,ierr);
// *
// *                    Scale if necessary
// *
if (scale.val != one)  
    Dscal.dscal(n-ki+1,scale.val,work,(ki+n)- 1+ _work_offset,1);
work[(j+n)- 1+ _work_offset] = x[(1)- 1+(1- 1)*2];
work[(j+1+n)- 1+ _work_offset] = x[(2)- 1+(1- 1)*2];
// *
vmax = Math.max((Math.abs(work[(j+n)- 1+ _work_offset])) > (Math.abs(work[(j+1+n)- 1+ _work_offset])) ? (Math.abs(work[(j+n)- 1+ _work_offset])) : (Math.abs(work[(j+1+n)- 1+ _work_offset])), vmax);
vcrit = bignum/vmax;
// *
}              //  Close else.
Dummy.label("Dtrevc",170);
}              //  Close for() loop. 
}
// *
// *              Copy the vector x or Q*x to VL and normalize.
// *
if (!over)  {
    Dcopy.dcopy(n-ki+1,work,(ki+n)- 1+ _work_offset,1,vl,(ki)- 1+(is- 1)*ldvl+ _vl_offset,1);
// *
ii = Idamax.idamax(n-ki+1,vl,(ki)- 1+(is- 1)*ldvl+ _vl_offset,1)+ki-1;
remax = one/Math.abs(vl[(ii)- 1+(is- 1)*ldvl+ _vl_offset]);
Dscal.dscal(n-ki+1,remax,vl,(ki)- 1+(is- 1)*ldvl+ _vl_offset,1);
// *
{
forloop180:
for (k = 1; k <= ki-1; k++) {
vl[(k)- 1+(is- 1)*ldvl+ _vl_offset] = zero;
Dummy.label("Dtrevc",180);
}              //  Close for() loop. 
}
// *
}              // Close if()
else  {
  // *
if (ki < n)  
    Dgemv.dgemv("N",n,n-ki,one,vl,(1)- 1+(ki+1- 1)*ldvl+ _vl_offset,ldvl,work,(ki+1+n)- 1+ _work_offset,1,work[(ki+n)- 1+ _work_offset],vl,(1)- 1+(ki- 1)*ldvl+ _vl_offset,1);
// *
ii = Idamax.idamax(n,vl,(1)- 1+(ki- 1)*ldvl+ _vl_offset,1);
remax = one/Math.abs(vl[(ii)- 1+(ki- 1)*ldvl+ _vl_offset]);
Dscal.dscal(n,remax,vl,(1)- 1+(ki- 1)*ldvl+ _vl_offset,1);
// *
}              //  Close else.
// *
}              // Close if()
else  {
  // *
// *              Complex left eigenvector.
// *
// *               Initial solve:
// *                 ((T(KI,KI)    T(KI,KI+1) )' - (WR - I* WI))*X = 0.
// *                 ((T(KI+1,KI) T(KI+1,KI+1))                )
// *
if (Math.abs(t[(ki)- 1+(ki+1- 1)*ldt+ _t_offset]) >= Math.abs(t[(ki+1)- 1+(ki- 1)*ldt+ _t_offset]))  {
    work[(ki+n)- 1+ _work_offset] = wi/t[(ki)- 1+(ki+1- 1)*ldt+ _t_offset];
work[(ki+1+n2)- 1+ _work_offset] = one;
}              // Close if()
else  {
  work[(ki+n)- 1+ _work_offset] = one;
work[(ki+1+n2)- 1+ _work_offset] = -wi/t[(ki+1)- 1+(ki- 1)*ldt+ _t_offset];
}              //  Close else.
work[(ki+1+n)- 1+ _work_offset] = zero;
work[(ki+n2)- 1+ _work_offset] = zero;
// *
// *              Form right-hand side
// *
{
forloop190:
for (k = ki+2; k <= n; k++) {
work[(k+n)- 1+ _work_offset] = -work[(ki+n)- 1+ _work_offset]*t[(ki)- 1+(k- 1)*ldt+ _t_offset];
work[(k+n2)- 1+ _work_offset] = -work[(ki+1+n2)- 1+ _work_offset]*t[(ki+1)- 1+(k- 1)*ldt+ _t_offset];
Dummy.label("Dtrevc",190);
}              //  Close for() loop. 
}
// *
// *              Solve complex quasi-triangular system:
// *              ( T(KI+2,N:KI+2,N) - (WR-i*WI) )*X = WORK1+i*WORK2
// *
vmax = one;
vcrit = bignum;
// *
jnxt = ki+2;
{
forloop200:
for (j = ki+2; j <= n; j++) {
if (j < jnxt)  
    continue forloop200;
j1 = j;
j2 = j;
jnxt = j+1;
if (j < n)  {
    if (t[(j+1)- 1+(j- 1)*ldt+ _t_offset] != zero)  {
    j2 = j+1;
jnxt = j+2;
}              // Close if()
}              // Close if()
// *
if (j1 == j2)  {
    // *
// *                    1-by-1 diagonal block
// *
// *                    Scale if necessary to avoid overflow when
// *                    forming the right-hand side elements.
// *
if (work[(j)- 1+ _work_offset] > vcrit)  {
    rec = one/vmax;
Dscal.dscal(n-ki+1,rec,work,(ki+n)- 1+ _work_offset,1);
Dscal.dscal(n-ki+1,rec,work,(ki+n2)- 1+ _work_offset,1);
vmax = one;
vcrit = bignum;
}              // Close if()
// *
work[(j+n)- 1+ _work_offset] = work[(j+n)- 1+ _work_offset]-Ddot.ddot(j-ki-2,t,(ki+2)- 1+(j- 1)*ldt+ _t_offset,1,work,(ki+2+n)- 1+ _work_offset,1);
work[(j+n2)- 1+ _work_offset] = work[(j+n2)- 1+ _work_offset]-Ddot.ddot(j-ki-2,t,(ki+2)- 1+(j- 1)*ldt+ _t_offset,1,work,(ki+2+n2)- 1+ _work_offset,1);
// *
// *                    Solve (T(J,J)-(WR-i*WI))*(X11+i*X12)= WK+I*WK2
// *
Dlaln2.dlaln2(false,1,2,smin,one,t,(j)- 1+(j- 1)*ldt+ _t_offset,ldt,one,one,work,(j+n)- 1+ _work_offset,n,wr,-wi,x,0,2,scale,xnorm,ierr);
// *
// *                    Scale if necessary
// *
if (scale.val != one)  {
    Dscal.dscal(n-ki+1,scale.val,work,(ki+n)- 1+ _work_offset,1);
Dscal.dscal(n-ki+1,scale.val,work,(ki+n2)- 1+ _work_offset,1);
}              // Close if()
work[(j+n)- 1+ _work_offset] = x[(1)- 1+(1- 1)*2];
work[(j+n2)- 1+ _work_offset] = x[(1)- 1+(2- 1)*2];
vmax = Math.max((Math.abs(work[(j+n)- 1+ _work_offset])) > (Math.abs(work[(j+n2)- 1+ _work_offset])) ? (Math.abs(work[(j+n)- 1+ _work_offset])) : (Math.abs(work[(j+n2)- 1+ _work_offset])), vmax);
vcrit = bignum/vmax;
// *
}              // Close if()
else  {
  // *
// *                    2-by-2 diagonal block
// *
// *                    Scale if necessary to avoid overflow when forming
// *                    the right-hand side elements.
// *
beta = Math.max(work[(j)- 1+ _work_offset], work[(j+1)- 1+ _work_offset]) ;
if (beta > vcrit)  {
    rec = one/vmax;
Dscal.dscal(n-ki+1,rec,work,(ki+n)- 1+ _work_offset,1);
Dscal.dscal(n-ki+1,rec,work,(ki+n2)- 1+ _work_offset,1);
vmax = one;
vcrit = bignum;
}              // Close if()
// *
work[(j+n)- 1+ _work_offset] = work[(j+n)- 1+ _work_offset]-Ddot.ddot(j-ki-2,t,(ki+2)- 1+(j- 1)*ldt+ _t_offset,1,work,(ki+2+n)- 1+ _work_offset,1);
// *
work[(j+n2)- 1+ _work_offset] = work[(j+n2)- 1+ _work_offset]-Ddot.ddot(j-ki-2,t,(ki+2)- 1+(j- 1)*ldt+ _t_offset,1,work,(ki+2+n2)- 1+ _work_offset,1);
// *
work[(j+1+n)- 1+ _work_offset] = work[(j+1+n)- 1+ _work_offset]-Ddot.ddot(j-ki-2,t,(ki+2)- 1+(j+1- 1)*ldt+ _t_offset,1,work,(ki+2+n)- 1+ _work_offset,1);
// *
work[(j+1+n2)- 1+ _work_offset] = work[(j+1+n2)- 1+ _work_offset]-Ddot.ddot(j-ki-2,t,(ki+2)- 1+(j+1- 1)*ldt+ _t_offset,1,work,(ki+2+n2)- 1+ _work_offset,1);
// *
// *                    Solve 2-by-2 complex linear equation
// *                      ([T(j,j)   T(j,j+1)  ]'-(wr-i*wi)*I)*X = SCALE*B
// *                      ([T(j+1,j) T(j+1,j+1)]             )
// *
Dlaln2.dlaln2(true,2,2,smin,one,t,(j)- 1+(j- 1)*ldt+ _t_offset,ldt,one,one,work,(j+n)- 1+ _work_offset,n,wr,-wi,x,0,2,scale,xnorm,ierr);
// *
// *                    Scale if necessary
// *
if (scale.val != one)  {
    Dscal.dscal(n-ki+1,scale.val,work,(ki+n)- 1+ _work_offset,1);
Dscal.dscal(n-ki+1,scale.val,work,(ki+n2)- 1+ _work_offset,1);
}              // Close if()
work[(j+n)- 1+ _work_offset] = x[(1)- 1+(1- 1)*2];
work[(j+n2)- 1+ _work_offset] = x[(1)- 1+(2- 1)*2];
work[(j+1+n)- 1+ _work_offset] = x[(2)- 1+(1- 1)*2];
work[(j+1+n2)- 1+ _work_offset] = x[(2)- 1+(2- 1)*2];
vmax = Math.max(Math.max(Math.max(Math.max(Math.abs(x[(1)- 1+(1- 1)*2]), Math.abs(x[(1)- 1+(2- 1)*2])), Math.abs(x[(2)- 1+(1- 1)*2])), Math.abs(x[(2)- 1+(2- 1)*2])), vmax) ;
vcrit = bignum/vmax;
// *
}              //  Close else.
Dummy.label("Dtrevc",200);
}              //  Close for() loop. 
}
// *
// *              Copy the vector x or Q*x to VL and normalize.
// *
label210:
   Dummy.label("Dtrevc",210);
if (!over)  {
    Dcopy.dcopy(n-ki+1,work,(ki+n)- 1+ _work_offset,1,vl,(ki)- 1+(is- 1)*ldvl+ _vl_offset,1);
Dcopy.dcopy(n-ki+1,work,(ki+n2)- 1+ _work_offset,1,vl,(ki)- 1+(is+1- 1)*ldvl+ _vl_offset,1);
// *
emax = zero;
{
forloop220:
for (k = ki; k <= n; k++) {
emax = Math.max(emax, Math.abs(vl[(k)- 1+(is- 1)*ldvl+ _vl_offset])+Math.abs(vl[(k)- 1+(is+1- 1)*ldvl+ _vl_offset])) ;
Dummy.label("Dtrevc",220);
}              //  Close for() loop. 
}
remax = one/emax;
Dscal.dscal(n-ki+1,remax,vl,(ki)- 1+(is- 1)*ldvl+ _vl_offset,1);
Dscal.dscal(n-ki+1,remax,vl,(ki)- 1+(is+1- 1)*ldvl+ _vl_offset,1);
// *
{
forloop230:
for (k = 1; k <= ki-1; k++) {
vl[(k)- 1+(is- 1)*ldvl+ _vl_offset] = zero;
vl[(k)- 1+(is+1- 1)*ldvl+ _vl_offset] = zero;
Dummy.label("Dtrevc",230);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  if (ki < n-1)  {
    Dgemv.dgemv("N",n,n-ki-1,one,vl,(1)- 1+(ki+2- 1)*ldvl+ _vl_offset,ldvl,work,(ki+2+n)- 1+ _work_offset,1,work[(ki+n)- 1+ _work_offset],vl,(1)- 1+(ki- 1)*ldvl+ _vl_offset,1);
Dgemv.dgemv("N",n,n-ki-1,one,vl,(1)- 1+(ki+2- 1)*ldvl+ _vl_offset,ldvl,work,(ki+2+n2)- 1+ _work_offset,1,work[(ki+1+n2)- 1+ _work_offset],vl,(1)- 1+(ki+1- 1)*ldvl+ _vl_offset,1);
}              // Close if()
else  {
  Dscal.dscal(n,work[(ki+n)- 1+ _work_offset],vl,(1)- 1+(ki- 1)*ldvl+ _vl_offset,1);
Dscal.dscal(n,work[(ki+1+n2)- 1+ _work_offset],vl,(1)- 1+(ki+1- 1)*ldvl+ _vl_offset,1);
}              //  Close else.
// *
emax = zero;
{
forloop240:
for (k = 1; k <= n; k++) {
emax = Math.max(emax, Math.abs(vl[(k)- 1+(ki- 1)*ldvl+ _vl_offset])+Math.abs(vl[(k)- 1+(ki+1- 1)*ldvl+ _vl_offset])) ;
Dummy.label("Dtrevc",240);
}              //  Close for() loop. 
}
remax = one/emax;
Dscal.dscal(n,remax,vl,(1)- 1+(ki- 1)*ldvl+ _vl_offset,1);
Dscal.dscal(n,remax,vl,(1)- 1+(ki+1- 1)*ldvl+ _vl_offset,1);
// *
}              //  Close else.
// *
}              //  Close else.
// *
is = is+1;
if (ip != 0)  
    is = is+1;
label250:
   Dummy.label("Dtrevc",250);
if (ip == -1)  
    ip = 0;
if (ip == 1)  
    ip = -1;
// *
Dummy.label("Dtrevc",260);
}              //  Close for() loop. 
}
// *
}              // Close if()
// *
Dummy.go_to("Dtrevc",999999);
// *
// *     End of DTREVC
// *
Dummy.label("Dtrevc",999999);
return;
   }
} // End class.
