/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;



public class Dtrsen {

// *
// *  -- LAPACK routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DTRSEN reorders the real Schur factorization of a real matrix
// *  A = Q*T*Q**T, so that a selected cluster of eigenvalues appears in
// *  the leading diagonal blocks of the upper quasi-triangular matrix T,
// *  and the leading columns of Q form an orthonormal basis of the
// *  corresponding right invariant subspace.
// *
// *  Optionally the routine computes the reciprocal condition numbers of
// *  the cluster of eigenvalues and/or the invariant subspace.
// *
// *  T must be in Schur canonical form (as returned by DHSEQR), that is,
// *  block upper triangular with 1-by-1 and 2-by-2 diagonal blocks; each
// *  2-by-2 diagonal block has its diagonal elemnts equal and its
// *  off-diagonal elements of opposite sign.
// *
// *  Arguments
// *  =========
// *
// *  JOB     (input) CHARACTER*1
// *          Specifies whether condition numbers are required for the
// *          cluster of eigenvalues (S) or the invariant subspace (SEP):
// *          = 'N': none;
// *          = 'E': for eigenvalues only (S);
// *          = 'V': for invariant subspace only (SEP);
// *          = 'B': for both eigenvalues and invariant subspace (S and
// *                 SEP).
// *
// *  COMPQ   (input) CHARACTER*1
// *          = 'V': update the matrix Q of Schur vectors;
// *          = 'N': do not update Q.
// *
// *  SELECT  (input) LOGICAL array, dimension (N)
// *          SELECT specifies the eigenvalues in the selected cluster. To
// *          select a real eigenvalue w(j), SELECT(j) must be set to
// *          .TRUE.. To select a complex conjugate pair of eigenvalues
// *          w(j) and w(j+1), corresponding to a 2-by-2 diagonal block,
// *          either SELECT(j) or SELECT(j+1) or both must be set to
// *          .TRUE.; a complex conjugate pair of eigenvalues must be
// *          either both included in the cluster or both excluded.
// *
// *  N       (input) INTEGER
// *          The order of the matrix T. N >= 0.
// *
// *  T       (input/output) DOUBLE PRECISION array, dimension (LDT,N)
// *          On entry, the upper quasi-triangular matrix T, in Schur
// *          canonical form.
// *          On exit, T is overwritten by the reordered matrix T, again in
// *          Schur canonical form, with the selected eigenvalues in the
// *          leading diagonal blocks.
// *
// *  LDT     (input) INTEGER
// *          The leading dimension of the array T. LDT >= max(1,N).
// *
// *  Q       (input/output) DOUBLE PRECISION array, dimension (LDQ,N)
// *          On entry, if COMPQ = 'V', the matrix Q of Schur vectors.
// *          On exit, if COMPQ = 'V', Q has been postmultiplied by the
// *          orthogonal transformation matrix which reorders T; the
// *          leading M columns of Q form an orthonormal basis for the
// *          specified invariant subspace.
// *          If COMPQ = 'N', Q is not referenced.
// *
// *  LDQ     (input) INTEGER
// *          The leading dimension of the array Q.
// *          LDQ >= 1; and if COMPQ = 'V', LDQ >= N.
// *
// *  WR      (output) DOUBLE PRECISION array, dimension (N)
// *  WI      (output) DOUBLE PRECISION array, dimension (N)
// *          The real and imaginary parts, respectively, of the reordered
// *          eigenvalues of T. The eigenvalues are stored in the same
// *          order as on the diagonal of T, with WR(i) = T(i,i) and, if
// *          T(i:i+1,i:i+1) is a 2-by-2 diagonal block, WI(i) > 0 and
// *          WI(i+1) = -WI(i). Note that if a complex eigenvalue is
// *          sufficiently ill-conditioned, then its value may differ
// *          significantly from its value before reordering.
// *
// *  M       (output) INTEGER
// *          The dimension of the specified invariant subspace.
// *          0 < = M <= N.
// *
// *  S       (output) DOUBLE PRECISION
// *          If JOB = 'E' or 'B', S is a lower bound on the reciprocal
// *          condition number for the selected cluster of eigenvalues.
// *          S cannot underestimate the true reciprocal condition number
// *          by more than a factor of sqrt(N). If M = 0 or N, S = 1.
// *          If JOB = 'N' or 'V', S is not referenced.
// *
// *  SEP     (output) DOUBLE PRECISION
// *          If JOB = 'V' or 'B', SEP is the estimated reciprocal
// *          condition number of the specified invariant subspace. If
// *          M = 0 or N, SEP = norm(T).
// *          If JOB = 'N' or 'E', SEP is not referenced.
// *
// *  WORK    (workspace) DOUBLE PRECISION array, dimension (LWORK)
// *
// *  LWORK   (input) INTEGER
// *          The dimension of the array WORK.
// *          If JOB = 'N', LWORK >= max(1,N);
// *          if JOB = 'E', LWORK >= M*(N-M);
// *          if JOB = 'V' or 'B', LWORK >= 2*M*(N-M).
// *
// *  IWORK   (workspace) INTEGER array, dimension (LIWORK)
// *          IF JOB = 'N' or 'E', IWORK is not referenced.
// *
// *  LIWORK  (input) INTEGER
// *          The dimension of the array IWORK.
// *          If JOB = 'N' or 'E', LIWORK >= 1;
// *          if JOB = 'V' or 'B', LIWORK >= M*(N-M).
// *
// *  INFO    (output) INTEGER
// *          = 0: successful exit
// *          < 0: if INFO = -i, the i-th argument had an illegal value
// *          = 1: reordering of T failed because some eigenvalues are too
// *               close to separate (the problem is very ill-conditioned);
// *               T may have been partially reordered, and WR and WI
// *               contain the eigenvalues in the same order as in T; S and
// *               SEP (if requested) are set to zero.
// *
// *  Further Details
// *  ===============
// *
// *  DTRSEN first collects the selected eigenvalues by computing an
// *  orthogonal transformation Z to move them to the top left corner of T.
// *  In other words, the selected eigenvalues are the eigenvalues of T11
// *  in:
// *
// *                Z'*T*Z = ( T11 T12 ) n1
// *                         (  0  T22 ) n2
// *                            n1  n2
// *
// *  where N = n1+n2 and Z' means the transpose of Z. The first n1 columns
// *  of Z span the specified invariant subspace of T.
// *
// *  If T has been obtained from the real Schur factorization of a matrix
// *  A = Q*T*Q', then the reordered real Schur factorization of A is given
// *  by A = (Q*Z)*(Z'*T*Z)*(Q*Z)', and the first n1 columns of Q*Z span
// *  the corresponding invariant subspace of A.
// *
// *  The reciprocal condition number of the average of the eigenvalues of
// *  T11 may be returned in S. S lies between 0 (very badly conditioned)
// *  and 1 (very well conditioned). It is computed as follows. First we
// *  compute R so that
// *
// *                         P = ( I  R ) n1
// *                             ( 0  0 ) n2
// *                               n1 n2
// *
// *  is the projector on the invariant subspace associated with T11.
// *  R is the solution of the Sylvester equation:
// *
// *                        T11*R - R*T22 = T12.
// *
// *  Let F-norm(M) denote the Frobenius-norm of M and 2-norm(M) denote
// *  the two-norm of M. Then S is computed as the lower bound
// *
// *                      (1 + F-norm(R)**2)**(-1/2)
// *
// *  on the reciprocal of 2-norm(P), the true reciprocal condition number.
// *  S cannot underestimate 1 / 2-norm(P) by more than a factor of
// *  sqrt(N).
// *
// *  An approximate error bound for the computed average of the
// *  eigenvalues of T11 is
// *
// *                         EPS * norm(T) / S
// *
// *  where EPS is the machine precision.
// *
// *  The reciprocal condition number of the right invariant subspace
// *  spanned by the first n1 columns of Z (or of Q*Z) is returned in SEP.
// *  SEP is defined as the separation of T11 and T22:
// *
// *                     sep( T11, T22 ) = sigma-min( C )
// *
// *  where sigma-min(C) is the smallest singular value of the
// *  n1*n2-by-n1*n2 matrix
// *
// *     C  = kprod( I(n2), T11 ) - kprod( transpose(T22), I(n1) )
// *
// *  I(m) is an m by m identity matrix, and kprod denotes the Kronecker
// *  product. We estimate sigma-min(C) by the reciprocal of an estimate of
// *  the 1-norm of inverse(C). The true reciprocal 1-norm of inverse(C)
// *  cannot differ from sigma-min(C) by more than a factor of sqrt(n1*n2).
// *
// *  When SEP is small, small changes in T can cause large changes in
// *  the invariant subspace. An approximate bound on the maximum angular
// *  error in the computed right invariant subspace is
// *
// *                      EPS * norm(T) / SEP
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double zero= 0.0e+0;
static double one= 1.0e+0;
// *     ..
// *     .. Local Scalars ..
static boolean pair= false;
static boolean swap= false;
static boolean wantbh= false;
static boolean wantq= false;
static boolean wants= false;
static boolean wantsp= false;
static intW ierr= new intW(0);
static int k= 0;
static intW kase= new intW(0);
static intW kk= new intW(0);
static intW ks= new intW(0);
static int n1= 0;
static int n2= 0;
static int nn= 0;
static doubleW est= new doubleW(0.0);
static double rnorm= 0.0;
static doubleW scale= new doubleW(0.0);
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Decode and test the input parameters
// *

public static void dtrsen (String job,
String compq,
boolean [] select, int _select_offset,
int n,
double [] t, int _t_offset,
int ldt,
double [] q, int _q_offset,
int ldq,
double [] wr, int _wr_offset,
double [] wi, int _wi_offset,
intW m,
doubleW s,
doubleW sep,
double [] work, int _work_offset,
int lwork,
int [] iwork, int _iwork_offset,
int liwork,
intW info)  {

wantbh = (job.toLowerCase().charAt(0) == "B".toLowerCase().charAt(0));
wants = (job.toLowerCase().charAt(0) == "E".toLowerCase().charAt(0)) || wantbh;
wantsp = (job.toLowerCase().charAt(0) == "V".toLowerCase().charAt(0)) || wantbh;
wantq = (compq.toLowerCase().charAt(0) == "V".toLowerCase().charAt(0));
// *
info.val = 0;
if (!(job.toLowerCase().charAt(0) == "N".toLowerCase().charAt(0)) && !wants && !wantsp)  {
    info.val = -1;
}              // Close if()
else if (!(compq.toLowerCase().charAt(0) == "N".toLowerCase().charAt(0)) && !wantq)  {
    info.val = -2;
}              // Close else if()
else if (n < 0)  {
    info.val = -4;
}              // Close else if()
else if (ldt < Math.max(1, n) )  {
    info.val = -6;
}              // Close else if()
else if (ldq < 1 || (wantq && ldq < n))  {
    info.val = -8;
}              // Close else if()
else  {
  // *
// *        Set M to the dimension of the specified invariant subspace,
// *        and test LWORK and LIWORK.
// *
m.val = 0;
pair = false;
{
forloop10:
for (k = 1; k <= n; k++) {
if (pair)  {
    pair = false;
}              // Close if()
else  {
  if (k < n)  {
    if (t[(k+1)- 1+(k- 1)*ldt+ _t_offset] == zero)  {
    if (select[(k)- 1+ _select_offset])  
    m.val = m.val+1;
}              // Close if()
else  {
  pair = true;
if (select[(k)- 1+ _select_offset] || select[(k+1)- 1+ _select_offset])  
    m.val = m.val+2;
}              //  Close else.
}              // Close if()
else  {
  if (select[(n)- 1+ _select_offset])  
    m.val = m.val+1;
}              //  Close else.
}              //  Close else.
Dummy.label("Dtrsen",10);
}              //  Close for() loop. 
}
// *
n1 = m.val;
n2 = n-m.val;
nn = n1*n2;
// *
if (lwork < 1 || ((wants && !wantsp) && lwork < nn) || (wantsp && lwork < 2*nn))  {
    info.val = -15;
}              // Close if()
else if (liwork < 1 || (wantsp && liwork < nn))  {
    info.val = -17;
}              // Close else if()
}              //  Close else.
if (info.val != 0)  {
    Xerbla.xerbla("DTRSEN",-info.val);
Dummy.go_to("Dtrsen",999999);
}              // Close if()
// *
// *     Quick return if possible.
// *
if (m.val == n || m.val == 0)  {
    if (wants)  
    s.val = one;
if (wantsp)  
    sep.val = Dlange.dlange("1",n,n,t,_t_offset,ldt,work,_work_offset);
Dummy.go_to("Dtrsen",40);
}              // Close if()
// *
// *     Collect the selected blocks at the top-left corner of T.
// *
ks.val = 0;
pair = false;
{
forloop20:
for (k = 1; k <= n; k++) {
if (pair)  {
    pair = false;
}              // Close if()
else  {
  swap = select[(k)- 1+ _select_offset];
if (k < n)  {
    if (t[(k+1)- 1+(k- 1)*ldt+ _t_offset] != zero)  {
    pair = true;
swap = swap || select[(k+1)- 1+ _select_offset];
}              // Close if()
}              // Close if()
if (swap)  {
    ks.val = ks.val+1;
// *
// *              Swap the K-th block to position KS.
// *
ierr.val = 0;
kk.val = k;
if (k != ks.val)  
    Dtrexc.dtrexc(compq,n,t,_t_offset,ldt,q,_q_offset,ldq,kk,ks,work,_work_offset,ierr);
if (ierr.val == 1 || ierr.val == 2)  {
    // *
// *                 Blocks too close to swap: exit.
// *
info.val = 1;
if (wants)  
    s.val = zero;
if (wantsp)  
    sep.val = zero;
Dummy.go_to("Dtrsen",40);
}              // Close if()
if (pair)  
    ks.val = ks.val+1;
}              // Close if()
}              //  Close else.
Dummy.label("Dtrsen",20);
}              //  Close for() loop. 
}
// *
if (wants)  {
    // *
// *        Solve Sylvester equation for R:
// *
// *           T11*R - R*T22 = scale*T12
// *
Dlacpy.dlacpy("F",n1,n2,t,(1)- 1+(n1+1- 1)*ldt+ _t_offset,ldt,work,_work_offset,n1);
Dtrsyl.dtrsyl("N","N",-1,n1,n2,t,_t_offset,ldt,t,(n1+1)- 1+(n1+1- 1)*ldt+ _t_offset,ldt,work,_work_offset,n1,scale,ierr);
// *
// *        Estimate the reciprocal of the condition number of the cluster
// *        of eigenvalues.
// *
rnorm = Dlange.dlange("F",n1,n2,work,_work_offset,n1,work,_work_offset);
if (rnorm == zero)  {
    s.val = one;
}              // Close if()
else  {
  s.val = scale.val/(Math.sqrt(scale.val*scale.val/rnorm+rnorm)*Math.sqrt(rnorm));
}              //  Close else.
}              // Close if()
// *
if (wantsp)  {
    // *
// *        Estimate sep(T11,T22).
// *
est.val = zero;
kase.val = 0;
label30:
   Dummy.label("Dtrsen",30);
Dlacon.dlacon(nn,work,(nn+1)- 1+ _work_offset,work,_work_offset,iwork,_iwork_offset,est,kase);
if (kase.val != 0)  {
    if (kase.val == 1)  {
    // *
// *              Solve  T11*R - R*T22 = scale*X.
// *
Dtrsyl.dtrsyl("N","N",-1,n1,n2,t,_t_offset,ldt,t,(n1+1)- 1+(n1+1- 1)*ldt+ _t_offset,ldt,work,_work_offset,n1,scale,ierr);
}              // Close if()
else  {
  // *
// *              Solve  T11'*R - R*T22' = scale*X.
// *
Dtrsyl.dtrsyl("T","T",-1,n1,n2,t,_t_offset,ldt,t,(n1+1)- 1+(n1+1- 1)*ldt+ _t_offset,ldt,work,_work_offset,n1,scale,ierr);
}              //  Close else.
Dummy.go_to("Dtrsen",30);
}              // Close if()
// *
sep.val = scale.val/est.val;
}              // Close if()
// *
label40:
   Dummy.label("Dtrsen",40);
// *
// *     Store the output eigenvalues in WR and WI.
// *
{
forloop50:
for (k = 1; k <= n; k++) {
wr[(k)- 1+ _wr_offset] = t[(k)- 1+(k- 1)*ldt+ _t_offset];
wi[(k)- 1+ _wi_offset] = zero;
Dummy.label("Dtrsen",50);
}              //  Close for() loop. 
}
{
forloop60:
for (k = 1; k <= n-1; k++) {
if (t[(k+1)- 1+(k- 1)*ldt+ _t_offset] != zero)  {
    wi[(k)- 1+ _wi_offset] = Math.sqrt(Math.abs(t[(k)- 1+(k+1- 1)*ldt+ _t_offset]))*Math.sqrt(Math.abs(t[(k+1)- 1+(k- 1)*ldt+ _t_offset]));
wi[(k+1)- 1+ _wi_offset] = -wi[(k)- 1+ _wi_offset];
}              // Close if()
Dummy.label("Dtrsen",60);
}              //  Close for() loop. 
}
Dummy.go_to("Dtrsen",999999);
// *
// *     End of DTRSEN
// *
Dummy.label("Dtrsen",999999);
return;
   }
} // End class.
