/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;

import org.netlib.blas.*;


public class Dtrsna {

// *
// *  -- LAPACK routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DTRSNA estimates reciprocal condition numbers for specified
// *  eigenvalues and/or right eigenvectors of a real upper
// *  quasi-triangular matrix T (or of any matrix Q*T*Q**T with Q
// *  orthogonal).
// *
// *  T must be in Schur canonical form (as returned by DHSEQR), that is,
// *  block upper triangular with 1-by-1 and 2-by-2 diagonal blocks; each
// *  2-by-2 diagonal block has its diagonal elements equal and its
// *  off-diagonal elements of opposite sign.
// *
// *  Arguments
// *  =========
// *
// *  JOB     (input) CHARACTER*1
// *          Specifies whether condition numbers are required for
// *          eigenvalues (S) or eigenvectors (SEP):
// *          = 'E': for eigenvalues only (S);
// *          = 'V': for eigenvectors only (SEP);
// *          = 'B': for both eigenvalues and eigenvectors (S and SEP).
// *
// *  HOWMNY  (input) CHARACTER*1
// *          = 'A': compute condition numbers for all eigenpairs;
// *          = 'S': compute condition numbers for selected eigenpairs
// *                 specified by the array SELECT.
// *
// *  SELECT  (input) LOGICAL array, dimension (N)
// *          If HOWMNY = 'S', SELECT specifies the eigenpairs for which
// *          condition numbers are required. To select condition numbers
// *          for the eigenpair corresponding to a real eigenvalue w(j),
// *          SELECT(j) must be set to .TRUE.. To select condition numbers
// *          corresponding to a complex conjugate pair of eigenvalues w(j)
// *          and w(j+1), either SELECT(j) or SELECT(j+1) or both, must be
// *          set to .TRUE..
// *          If HOWMNY = 'A', SELECT is not referenced.
// *
// *  N       (input) INTEGER
// *          The order of the matrix T. N >= 0.
// *
// *  T       (input) DOUBLE PRECISION array, dimension (LDT,N)
// *          The upper quasi-triangular matrix T, in Schur canonical form.
// *
// *  LDT     (input) INTEGER
// *          The leading dimension of the array T. LDT >= max(1,N).
// *
// *  VL      (input) DOUBLE PRECISION array, dimension (LDVL,M)
// *          If JOB = 'E' or 'B', VL must contain left eigenvectors of T
// *          (or of any Q*T*Q**T with Q orthogonal), corresponding to the
// *          eigenpairs specified by HOWMNY and SELECT. The eigenvectors
// *          must be stored in consecutive columns of VL, as returned by
// *          DHSEIN or DTREVC.
// *          If JOB = 'V', VL is not referenced.
// *
// *  LDVL    (input) INTEGER
// *          The leading dimension of the array VL.
// *          LDVL >= 1; and if JOB = 'E' or 'B', LDVL >= N.
// *
// *  VR      (input) DOUBLE PRECISION array, dimension (LDVR,M)
// *          If JOB = 'E' or 'B', VR must contain right eigenvectors of T
// *          (or of any Q*T*Q**T with Q orthogonal), corresponding to the
// *          eigenpairs specified by HOWMNY and SELECT. The eigenvectors
// *          must be stored in consecutive columns of VR, as returned by
// *          DHSEIN or DTREVC.
// *          If JOB = 'V', VR is not referenced.
// *
// *  LDVR    (input) INTEGER
// *          The leading dimension of the array VR.
// *          LDVR >= 1; and if JOB = 'E' or 'B', LDVR >= N.
// *
// *  S       (output) DOUBLE PRECISION array, dimension (MM)
// *          If JOB = 'E' or 'B', the reciprocal condition numbers of the
// *          selected eigenvalues, stored in consecutive elements of the
// *          array. For a complex conjugate pair of eigenvalues two
// *          consecutive elements of S are set to the same value. Thus
// *          S(j), SEP(j), and the j-th columns of VL and VR all
// *          correspond to the same eigenpair (but not in general the
// *          j-th eigenpair, unless all eigenpairs are selected).
// *          If JOB = 'V', S is not referenced.
// *
// *  SEP     (output) DOUBLE PRECISION array, dimension (MM)
// *          If JOB = 'V' or 'B', the estimated reciprocal condition
// *          numbers of the selected eigenvectors, stored in consecutive
// *          elements of the array. For a complex eigenvector two
// *          consecutive elements of SEP are set to the same value. If
// *          the eigenvalues cannot be reordered to compute SEP(j), SEP(j)
// *          is set to 0; this can only occur when the true value would be
// *          very small anyway.
// *          If JOB = 'E', SEP is not referenced.
// *
// *  MM      (input) INTEGER
// *          The number of elements in the arrays S (if JOB = 'E' or 'B')
// *           and/or SEP (if JOB = 'V' or 'B'). MM >= M.
// *
// *  M       (output) INTEGER
// *          The number of elements of the arrays S and/or SEP actually
// *          used to store the estimated condition numbers.
// *          If HOWMNY = 'A', M is set to N.
// *
// *  WORK    (workspace) DOUBLE PRECISION array, dimension (LDWORK,N+1)
// *          If JOB = 'E', WORK is not referenced.
// *
// *  LDWORK  (input) INTEGER
// *          The leading dimension of the array WORK.
// *          LDWORK >= 1; and if JOB = 'V' or 'B', LDWORK >= N.
// *
// *  IWORK   (workspace) INTEGER array, dimension (N)
// *          If JOB = 'E', IWORK is not referenced.
// *
// *  INFO    (output) INTEGER
// *          = 0: successful exit
// *          < 0: if INFO = -i, the i-th argument had an illegal value
// *
// *  Further Details
// *  ===============
// *
// *  The reciprocal of the condition number of an eigenvalue lambda is
// *  defined as
// *
// *          S(lambda) = |v'*u| / (norm(u)*norm(v))
// *
// *  where u and v are the right and left eigenvectors of T corresponding
// *  to lambda; v' denotes the conjugate-transpose of v, and norm(u)
// *  denotes the Euclidean norm. These reciprocal condition numbers always
// *  lie between zero (very badly conditioned) and one (very well
// *  conditioned). If n = 1, S(lambda) is defined to be 1.
// *
// *  An approximate error bound for a computed eigenvalue W(i) is given by
// *
// *                      EPS * norm(T) / S(i)
// *
// *  where EPS is the machine precision.
// *
// *  The reciprocal of the condition number of the right eigenvector u
// *  corresponding to lambda is defined as follows. Suppose
// *
// *              T = ( lambda  c  )
// *                  (   0    T22 )
// *
// *  Then the reciprocal condition number is
// *
// *          SEP( lambda, T22 ) = sigma-min( T22 - lambda*I )
// *
// *  where sigma-min denotes the smallest singular value. We approximate
// *  the smallest singular value by the reciprocal of an estimate of the
// *  one-norm of the inverse of T22 - lambda*I. If n = 1, SEP(1) is
// *  defined to be abs(T(1,1)).
// *
// *  An approximate error bound for a computed right eigenvector VR(i)
// *  is given by
// *
// *                      EPS * norm(T) / SEP(i)
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double zero= 0.0e+0;
static double one= 1.0e+0;
static double two= 2.0e+0;
// *     ..
// *     .. Local Scalars ..
static boolean pair= false;
static boolean somcon= false;
static boolean wantbh= false;
static boolean wants= false;
static boolean wantsp= false;
static int i= 0;
static intW ierr= new intW(0);
static intW ifst= new intW(0);
static intW ilst= new intW(0);
static int j= 0;
static int k= 0;
static intW kase= new intW(0);
static int ks= 0;
static int n2= 0;
static int nn= 0;
static doubleW bignum= new doubleW(0.0);
static double cond= 0.0;
static double cs= 0.0;
static double delta= 0.0;
static double dumm= 0.0;
static double eps= 0.0;
static doubleW est= new doubleW(0.0);
static double lnrm= 0.0;
static double mu= 0.0;
static double prod= 0.0;
static double prod1= 0.0;
static double prod2= 0.0;
static double rnrm= 0.0;
static doubleW scale= new doubleW(0.0);
static doubleW smlnum= new doubleW(0.0);
static double sn= 0.0;
// *     ..
// *     .. Local Arrays ..
static double [] dummy= new double[(1)];
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Decode and test the input parameters
// *

public static void dtrsna (String job,
String howmny,
boolean [] select, int _select_offset,
int n,
double [] t, int _t_offset,
int ldt,
double [] vl, int _vl_offset,
int ldvl,
double [] vr, int _vr_offset,
int ldvr,
double [] s, int _s_offset,
double [] sep, int _sep_offset,
int mm,
intW m,
double [] work, int _work_offset,
int ldwork,
int [] iwork, int _iwork_offset,
intW info)  {

wantbh = (job.toLowerCase().charAt(0) == "B".toLowerCase().charAt(0));
wants = (job.toLowerCase().charAt(0) == "E".toLowerCase().charAt(0)) || wantbh;
wantsp = (job.toLowerCase().charAt(0) == "V".toLowerCase().charAt(0)) || wantbh;
// *
somcon = (howmny.toLowerCase().charAt(0) == "S".toLowerCase().charAt(0));
// *
info.val = 0;
if (!wants && !wantsp)  {
    info.val = -1;
}              // Close if()
else if (!(howmny.toLowerCase().charAt(0) == "A".toLowerCase().charAt(0)) && !somcon)  {
    info.val = -2;
}              // Close else if()
else if (n < 0)  {
    info.val = -4;
}              // Close else if()
else if (ldt < Math.max(1, n) )  {
    info.val = -6;
}              // Close else if()
else if (ldvl < 1 || (wants && ldvl < n))  {
    info.val = -8;
}              // Close else if()
else if (ldvr < 1 || (wants && ldvr < n))  {
    info.val = -10;
}              // Close else if()
else  {
  // *
// *        Set M to the number of eigenpairs for which condition numbers
// *        are required, and test MM.
// *
if (somcon)  {
    m.val = 0;
pair = false;
{
forloop10:
for (k = 1; k <= n; k++) {
if (pair)  {
    pair = false;
}              // Close if()
else  {
  if (k < n)  {
    if (t[(k+1)- 1+(k- 1)*ldt+ _t_offset] == zero)  {
    if (select[(k)- 1+ _select_offset])  
    m.val = m.val+1;
}              // Close if()
else  {
  pair = true;
if (select[(k)- 1+ _select_offset] || select[(k+1)- 1+ _select_offset])  
    m.val = m.val+2;
}              //  Close else.
}              // Close if()
else  {
  if (select[(n)- 1+ _select_offset])  
    m.val = m.val+1;
}              //  Close else.
}              //  Close else.
Dummy.label("Dtrsna",10);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  m.val = n;
}              //  Close else.
// *
if (mm < m.val)  {
    info.val = -13;
}              // Close if()
else if (ldwork < 1 || (wantsp && ldwork < n))  {
    info.val = -16;
}              // Close else if()
}              //  Close else.
if (info.val != 0)  {
    Xerbla.xerbla("DTRSNA",-info.val);
Dummy.go_to("Dtrsna",999999);
}              // Close if()
// *
// *     Quick return if possible
// *
if (n == 0)  
    Dummy.go_to("Dtrsna",999999);
// *
if (n == 1)  {
    if (somcon)  {
    if (!select[(1)- 1+ _select_offset])  
    Dummy.go_to("Dtrsna",999999);
}              // Close if()
if (wants)  
    s[(1)- 1+ _s_offset] = one;
if (wantsp)  
    sep[(1)- 1+ _sep_offset] = Math.abs(t[(1)- 1+(1- 1)*ldt+ _t_offset]);
Dummy.go_to("Dtrsna",999999);
}              // Close if()
// *
// *     Get machine constants
// *
eps = Dlamch.dlamch("P");
smlnum.val = Dlamch.dlamch("S")/eps;
bignum.val = one/smlnum.val;
Dlabad.dlabad(smlnum,bignum);
// *
ks = 0;
pair = false;
{
forloop60:
for (k = 1; k <= n; k++) {
// *
// *        Determine whether T(k,k) begins a 1-by-1 or 2-by-2 block.
// *
if (pair)  {
    pair = false;
continue forloop60;
}              // Close if()
else  {
  if (k < n)  
    pair = t[(k+1)- 1+(k- 1)*ldt+ _t_offset] != zero;
}              //  Close else.
// *
// *        Determine whether condition numbers are required for the k-th
// *        eigenpair.
// *
if (somcon)  {
    if (pair)  {
    if (!select[(k)- 1+ _select_offset] && !select[(k+1)- 1+ _select_offset])  
    continue forloop60;
}              // Close if()
else  {
  if (!select[(k)- 1+ _select_offset])  
    continue forloop60;
}              //  Close else.
}              // Close if()
// *
ks = ks+1;
// *
if (wants)  {
    // *
// *           Compute the reciprocal condition number of the k-th
// *           eigenvalue.
// *
if (!pair)  {
    // *
// *              Real eigenvalue.
// *
prod = Ddot.ddot(n,vr,(1)- 1+(ks- 1)*ldvr+ _vr_offset,1,vl,(1)- 1+(ks- 1)*ldvl+ _vl_offset,1);
rnrm = Dnrm2.dnrm2(n,vr,(1)- 1+(ks- 1)*ldvr+ _vr_offset,1);
lnrm = Dnrm2.dnrm2(n,vl,(1)- 1+(ks- 1)*ldvl+ _vl_offset,1);
s[(ks)- 1+ _s_offset] = Math.abs(prod)/(rnrm*lnrm);
}              // Close if()
else  {
  // *
// *              Complex eigenvalue.
// *
prod1 = Ddot.ddot(n,vr,(1)- 1+(ks- 1)*ldvr+ _vr_offset,1,vl,(1)- 1+(ks- 1)*ldvl+ _vl_offset,1);
prod1 = prod1+Ddot.ddot(n,vr,(1)- 1+(ks+1- 1)*ldvr+ _vr_offset,1,vl,(1)- 1+(ks+1- 1)*ldvl+ _vl_offset,1);
prod2 = Ddot.ddot(n,vl,(1)- 1+(ks- 1)*ldvl+ _vl_offset,1,vr,(1)- 1+(ks+1- 1)*ldvr+ _vr_offset,1);
prod2 = prod2-Ddot.ddot(n,vl,(1)- 1+(ks+1- 1)*ldvl+ _vl_offset,1,vr,(1)- 1+(ks- 1)*ldvr+ _vr_offset,1);
rnrm = Dlapy2.dlapy2(Dnrm2.dnrm2(n,vr,(1)- 1+(ks- 1)*ldvr+ _vr_offset,1),Dnrm2.dnrm2(n,vr,(1)- 1+(ks+1- 1)*ldvr+ _vr_offset,1));
lnrm = Dlapy2.dlapy2(Dnrm2.dnrm2(n,vl,(1)- 1+(ks- 1)*ldvl+ _vl_offset,1),Dnrm2.dnrm2(n,vl,(1)- 1+(ks+1- 1)*ldvl+ _vl_offset,1));
cond = Dlapy2.dlapy2(prod1,prod2)/(rnrm*lnrm);
s[(ks)- 1+ _s_offset] = cond;
s[(ks+1)- 1+ _s_offset] = cond;
}              //  Close else.
}              // Close if()
// *
if (wantsp)  {
    // *
// *           Estimate the reciprocal condition number of the k-th
// *           eigenvector.
// *
// *           Copy the matrix T to the array WORK and swap the diagonal
// *           block beginning at T(k,k) to the (1,1) position.
// *
Dlacpy.dlacpy("Full",n,n,t,_t_offset,ldt,work,_work_offset,ldwork);
ifst.val = k;
ilst.val = 1;
Dtrexc.dtrexc("No Q",n,work,_work_offset,ldwork,dummy,0,1,ifst,ilst,work,(1)- 1+(n+1- 1)*ldwork+ _work_offset,ierr);
// *
if (ierr.val == 1 || ierr.val == 2)  {
    // *
// *              Could not swap because blocks not well separated
// *
scale.val = one;
est.val = bignum.val;
}              // Close if()
else  {
  // *
// *              Reordering successful
// *
if (work[(2)- 1+(1- 1)*ldwork+ _work_offset] == zero)  {
    // *
// *                 Form C = T22 - lambda*I in WORK(2:N,2:N).
// *
{
forloop20:
for (i = 2; i <= n; i++) {
work[(i)- 1+(i- 1)*ldwork+ _work_offset] = work[(i)- 1+(i- 1)*ldwork+ _work_offset]-work[(1)- 1+(1- 1)*ldwork+ _work_offset];
Dummy.label("Dtrsna",20);
}              //  Close for() loop. 
}
n2 = 1;
nn = n-1;
}              // Close if()
else  {
  // *
// *                 Triangularize the 2 by 2 block by unitary
// *                 transformation U = [  cs   i*ss ]
// *                                    [ i*ss   cs  ].
// *                 such that the (1,1) position of WORK is complex
// *                 eigenvalue lambda with positive imaginary part. (2,2)
// *                 position of WORK is the complex eigenvalue lambda
// *                 with negative imaginary  part.
// *
mu = Math.sqrt(Math.abs(work[(1)- 1+(2- 1)*ldwork+ _work_offset]))*Math.sqrt(Math.abs(work[(2)- 1+(1- 1)*ldwork+ _work_offset]));
delta = Dlapy2.dlapy2(mu,work[(2)- 1+(1- 1)*ldwork+ _work_offset]);
cs = mu/delta;
sn = -work[(2)- 1+(1- 1)*ldwork+ _work_offset]/delta;
// *
// *                 Form
// *
// *                 C' = WORK(2:N,2:N) + i*[rwork(1) ..... rwork(n-1) ]
// *                                        [   mu                     ]
// *                                        [         ..               ]
// *                                        [             ..           ]
// *                                        [                  mu      ]
// *                 where C' is conjugate transpose of complex matrix C,
// *                 and RWORK is stored starting in the N+1-st column of
// *                 WORK.
// *
{
forloop30:
for (j = 3; j <= n; j++) {
work[(2)- 1+(j- 1)*ldwork+ _work_offset] = cs*work[(2)- 1+(j- 1)*ldwork+ _work_offset];
work[(j)- 1+(j- 1)*ldwork+ _work_offset] = work[(j)- 1+(j- 1)*ldwork+ _work_offset]-work[(1)- 1+(1- 1)*ldwork+ _work_offset];
Dummy.label("Dtrsna",30);
}              //  Close for() loop. 
}
work[(2)- 1+(2- 1)*ldwork+ _work_offset] = zero;
// *
work[(1)- 1+(n+1- 1)*ldwork+ _work_offset] = two*mu;
{
forloop40:
for (i = 2; i <= n-1; i++) {
work[(i)- 1+(n+1- 1)*ldwork+ _work_offset] = sn*work[(1)- 1+(i+1- 1)*ldwork+ _work_offset];
Dummy.label("Dtrsna",40);
}              //  Close for() loop. 
}
n2 = 2;
nn = 2*(n-1);
}              //  Close else.
// *
// *              Estimate norm(inv(C'))
// *
est.val = zero;
kase.val = 0;
label50:
   Dummy.label("Dtrsna",50);
Dlacon.dlacon(nn,work,(1)- 1+(n+2- 1)*ldwork+ _work_offset,work,(1)- 1+(n+4- 1)*ldwork+ _work_offset,iwork,_iwork_offset,est,kase);
if (kase.val != 0)  {
    if (kase.val == 1)  {
    if (n2 == 1)  {
    // *
// *                       Real eigenvalue: solve C'*x = scale*c.
// *
Dlaqtr.dlaqtr(true,true,n-1,work,(2)- 1+(2- 1)*ldwork+ _work_offset,ldwork,dummy,0,dumm,scale,work,(1)- 1+(n+4- 1)*ldwork+ _work_offset,work,(1)- 1+(n+6- 1)*ldwork+ _work_offset,ierr);
}              // Close if()
else  {
  // *
// *                       Complex eigenvalue: solve
// *                       C'*(p+iq) = scale*(c+id) in real arithmetic.
// *
Dlaqtr.dlaqtr(true,false,n-1,work,(2)- 1+(2- 1)*ldwork+ _work_offset,ldwork,work,(1)- 1+(n+1- 1)*ldwork+ _work_offset,mu,scale,work,(1)- 1+(n+4- 1)*ldwork+ _work_offset,work,(1)- 1+(n+6- 1)*ldwork+ _work_offset,ierr);
}              //  Close else.
}              // Close if()
else  {
  if (n2 == 1)  {
    // *
// *                       Real eigenvalue: solve C*x = scale*c.
// *
Dlaqtr.dlaqtr(false,true,n-1,work,(2)- 1+(2- 1)*ldwork+ _work_offset,ldwork,dummy,0,dumm,scale,work,(1)- 1+(n+4- 1)*ldwork+ _work_offset,work,(1)- 1+(n+6- 1)*ldwork+ _work_offset,ierr);
}              // Close if()
else  {
  // *
// *                       Complex eigenvalue: solve
// *                       C*(p+iq) = scale*(c+id) in real arithmetic.
// *
Dlaqtr.dlaqtr(false,false,n-1,work,(2)- 1+(2- 1)*ldwork+ _work_offset,ldwork,work,(1)- 1+(n+1- 1)*ldwork+ _work_offset,mu,scale,work,(1)- 1+(n+4- 1)*ldwork+ _work_offset,work,(1)- 1+(n+6- 1)*ldwork+ _work_offset,ierr);
// *
}              //  Close else.
}              //  Close else.
// *
Dummy.go_to("Dtrsna",50);
}              // Close if()
}              //  Close else.
// *
sep[(ks)- 1+ _sep_offset] = scale.val/Math.max(est.val, smlnum.val) ;
if (pair)  
    sep[(ks+1)- 1+ _sep_offset] = sep[(ks)- 1+ _sep_offset];
}              // Close if()
// *
if (pair)  
    ks = ks+1;
// *
Dummy.label("Dtrsna",60);
}              //  Close for() loop. 
}
Dummy.go_to("Dtrsna",999999);
// *
// *     End of DTRSNA
// *
Dummy.label("Dtrsna",999999);
return;
   }
} // End class.
