/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;

import org.netlib.blas.*;


public class Dtrsyl {

// *
// *  -- LAPACK routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     March 31, 1993
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DTRSYL solves the real Sylvester matrix equation:
// *
// *     op(A)*X + X*op(B) = scale*C or
// *     op(A)*X - X*op(B) = scale*C,
// *
// *  where op(A) = A or A**T, and  A and B are both upper quasi-
// *  triangular. A is M-by-M and B is N-by-N; the right hand side C and
// *  the solution X are M-by-N; and scale is an output scale factor, set
// *  <= 1 to avoid overflow in X.
// *
// *  A and B must be in Schur canonical form (as returned by DHSEQR), that
// *  is, block upper triangular with 1-by-1 and 2-by-2 diagonal blocks;
// *  each 2-by-2 diagonal block has its diagonal elements equal and its
// *  off-diagonal elements of opposite sign.
// *
// *  Arguments
// *  =========
// *
// *  TRANA   (input) CHARACTER*1
// *          Specifies the option op(A):
// *          = 'N': op(A) = A    (No transpose)
// *          = 'T': op(A) = A**T (Transpose)
// *          = 'C': op(A) = A**H (Conjugate transpose = Transpose)
// *
// *  TRANB   (input) CHARACTER*1
// *          Specifies the option op(B):
// *          = 'N': op(B) = B    (No transpose)
// *          = 'T': op(B) = B**T (Transpose)
// *          = 'C': op(B) = B**H (Conjugate transpose = Transpose)
// *
// *  ISGN    (input) INTEGER
// *          Specifies the sign in the equation:
// *          = +1: solve op(A)*X + X*op(B) = scale*C
// *          = -1: solve op(A)*X - X*op(B) = scale*C
// *
// *  M       (input) INTEGER
// *          The order of the matrix A, and the number of rows in the
// *          matrices X and C. M >= 0.
// *
// *  N       (input) INTEGER
// *          The order of the matrix B, and the number of columns in the
// *          matrices X and C. N >= 0.
// *
// *  A       (input) DOUBLE PRECISION array, dimension (LDA,M)
// *          The upper quasi-triangular matrix A, in Schur canonical form.
// *
// *  LDA     (input) INTEGER
// *          The leading dimension of the array A. LDA >= max(1,M).
// *
// *  B       (input) DOUBLE PRECISION array, dimension (LDB,N)
// *          The upper quasi-triangular matrix B, in Schur canonical form.
// *
// *  LDB     (input) INTEGER
// *          The leading dimension of the array B. LDB >= max(1,N).
// *
// *  C       (input/output) DOUBLE PRECISION array, dimension (LDC,N)
// *          On entry, the M-by-N right hand side matrix C.
// *          On exit, C is overwritten by the solution matrix X.
// *
// *  LDC     (input) INTEGER
// *          The leading dimension of the array C. LDC >= max(1,M)
// *
// *  SCALE   (output) DOUBLE PRECISION
// *          The scale factor, scale, set <= 1 to avoid overflow in X.
// *
// *  INFO    (output) INTEGER
// *          = 0: successful exit
// *          < 0: if INFO = -i, the i-th argument had an illegal value
// *          = 1: A and B have common or very close eigenvalues; perturbed
// *               values were used to solve the equation (but the matrices
// *               A and B are unchanged).
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double zero= 0.0e+0;
static double one= 1.0e+0;
// *     ..
// *     .. Local Scalars ..
static boolean notrna= false;
static boolean notrnb= false;
static intW ierr= new intW(0);
static int j= 0;
static int k= 0;
static int k1= 0;
static int k2= 0;
static int knext= 0;
static int l= 0;
static int l1= 0;
static int l2= 0;
static int lnext= 0;
static double a11= 0.0;
static doubleW bignum= new doubleW(0.0);
static double da11= 0.0;
static double db= 0.0;
static double eps= 0.0;
static doubleW scaloc= new doubleW(0.0);
static double sgn= 0.0;
static double smin= 0.0;
static doubleW smlnum= new doubleW(0.0);
static double suml= 0.0;
static double sumr= 0.0;
static doubleW xnorm= new doubleW(0.0);
// *     ..
// *     .. Local Arrays ..
static double [] dum= new double[(1)];
static double [] vec= new double[(2) * (2)];
static double [] x= new double[(2) * (2)];
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Decode and Test input parameters
// *

public static void dtrsyl (String trana,
String tranb,
int isgn,
int m,
int n,
double [] a, int _a_offset,
int lda,
double [] b, int _b_offset,
int ldb,
double [] c, int _c_offset,
int Ldc,
doubleW scale,
intW info)  {

notrna = (trana.toLowerCase().charAt(0) == "N".toLowerCase().charAt(0));
notrnb = (tranb.toLowerCase().charAt(0) == "N".toLowerCase().charAt(0));
// *
info.val = 0;
if (!notrna && !(trana.toLowerCase().charAt(0) == "T".toLowerCase().charAt(0)) && !(trana.toLowerCase().charAt(0) == "C".toLowerCase().charAt(0)))  {
    info.val = -1;
}              // Close if()
else if (!notrnb && !(tranb.toLowerCase().charAt(0) == "T".toLowerCase().charAt(0)) && !(tranb.toLowerCase().charAt(0) == "C".toLowerCase().charAt(0)))  {
    info.val = -2;
}              // Close else if()
else if (isgn != 1 && isgn != -1)  {
    info.val = -3;
}              // Close else if()
else if (m < 0)  {
    info.val = -4;
}              // Close else if()
else if (n < 0)  {
    info.val = -5;
}              // Close else if()
else if (lda < Math.max(1, m) )  {
    info.val = -7;
}              // Close else if()
else if (ldb < Math.max(1, n) )  {
    info.val = -9;
}              // Close else if()
else if (Ldc < Math.max(1, m) )  {
    info.val = -11;
}              // Close else if()
if (info.val != 0)  {
    Xerbla.xerbla("DTRSYL",-info.val);
Dummy.go_to("Dtrsyl",999999);
}              // Close if()
// *
// *     Quick return if possible
// *
if (m == 0 || n == 0)  
    Dummy.go_to("Dtrsyl",999999);
// *
// *     Set constants to control overflow
// *
eps = Dlamch.dlamch("P");
smlnum.val = Dlamch.dlamch("S");
bignum.val = one/smlnum.val;
Dlabad.dlabad(smlnum,bignum);
smlnum.val = smlnum.val*(double)(m*n)/eps;
bignum.val = one/smlnum.val;
// *
smin = Math.max((smlnum.val) > (eps*Dlange.dlange("M",m,m,a,_a_offset,lda,dum,0)) ? (smlnum.val) : (eps*Dlange.dlange("M",m,m,a,_a_offset,lda,dum,0)), eps*Dlange.dlange("M",n,n,b,_b_offset,ldb,dum,0));
// *
scale.val = one;
sgn = (double)(isgn);
// *
if (notrna && notrnb)  {
    // *
// *        Solve    A*X + ISGN*X*B = scale*C.
// *
// *        The (K,L)th block of X is determined starting from
// *        bottom-left corner column by column by
// *
// *         A(K,K)*X(K,L) + ISGN*X(K,L)*B(L,L) = C(K,L) - R(K,L)
// *
// *        Where
// *                  M                         L-1
// *        R(K,L) = SUM [A(K,I)*X(I,L)] + ISGN*SUM [X(K,J)*B(J,L)].
// *                I=K+1                       J=1
// *
// *        Start column loop (index = L)
// *        L1 (L2) : column index of the first (first) row of X(K,L).
// *
lnext = 1;
{
forloop60:
for (l = 1; l <= n; l++) {
if (l < lnext)  
    continue forloop60;
if (l == n)  {
    l1 = l;
l2 = l;
}              // Close if()
else  {
  if (b[(l+1)- 1+(l- 1)*ldb+ _b_offset] != zero)  {
    l1 = l;
l2 = l+1;
lnext = l+2;
}              // Close if()
else  {
  l1 = l;
l2 = l;
lnext = l+1;
}              //  Close else.
}              //  Close else.
// *
// *           Start row loop (index = K)
// *           K1 (K2): row index of the first (last) row of X(K,L).
// *
knext = m;
{
int _k_inc = -1;
forloop50:
for (k = m; k >= 1; k += _k_inc) {
if (k > knext)  
    continue forloop50;
if (k == 1)  {
    k1 = k;
k2 = k;
}              // Close if()
else  {
  if (a[(k)- 1+(k-1- 1)*lda+ _a_offset] != zero)  {
    k1 = k-1;
k2 = k;
knext = k-2;
}              // Close if()
else  {
  k1 = k;
k2 = k;
knext = k-1;
}              //  Close else.
}              //  Close else.
// *
if (l1 == l2 && k1 == k2)  {
    suml = Ddot.ddot(m-k1,a,(k1)- 1+(Math.min(k1+1, m) - 1)*lda+ _a_offset,lda,c,(int)((Math.min(k1+1, m) )- 1+(l1- 1)*Ldc+ _c_offset),1);
sumr = Ddot.ddot(l1-1,c,(k1)- 1+(1- 1)*Ldc+ _c_offset,Ldc,b,(1)- 1+(l1- 1)*ldb+ _b_offset,1);
vec[(1)- 1+(1- 1)*2] = c[(k1)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
scaloc.val = one;
// *
a11 = a[(k1)- 1+(k1- 1)*lda+ _a_offset]+sgn*b[(l1)- 1+(l1- 1)*ldb+ _b_offset];
da11 = Math.abs(a11);
if (da11 <= smin)  {
    a11 = smin;
da11 = smin;
info.val = 1;
}              // Close if()
db = Math.abs(vec[(1)- 1+(1- 1)*2]);
if (da11 < one && db > one)  {
    if (db > bignum.val*da11)  
    scaloc.val = one/db;
}              // Close if()
x[(1)- 1+(1- 1)*2] = (vec[(1)- 1+(1- 1)*2]*scaloc.val)/a11;
// *
if (scaloc.val != one)  {
    {
forloop10:
for (j = 1; j <= n; j++) {
Dscal.dscal(m,scaloc.val,c,(1)- 1+(j- 1)*Ldc+ _c_offset,1);
Dummy.label("Dtrsyl",10);
}              //  Close for() loop. 
}
scale.val = scale.val*scaloc.val;
}              // Close if()
c[(k1)- 1+(l1- 1)*Ldc+ _c_offset] = x[(1)- 1+(1- 1)*2];
// *
}              // Close if()
else if (l1 == l2 && k1 != k2)  {
    // *
suml = Ddot.ddot(m-k2,a,(k1)- 1+(Math.min(k2+1, m) - 1)*lda+ _a_offset,lda,c,(int)((Math.min(k2+1, m) )- 1+(l1- 1)*Ldc+ _c_offset),1);
sumr = Ddot.ddot(l1-1,c,(k1)- 1+(1- 1)*Ldc+ _c_offset,Ldc,b,(1)- 1+(l1- 1)*ldb+ _b_offset,1);
vec[(1)- 1+(1- 1)*2] = c[(k1)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
suml = Ddot.ddot(m-k2,a,(k2)- 1+(Math.min(k2+1, m) - 1)*lda+ _a_offset,lda,c,(int)((Math.min(k2+1, m) )- 1+(l1- 1)*Ldc+ _c_offset),1);
sumr = Ddot.ddot(l1-1,c,(k2)- 1+(1- 1)*Ldc+ _c_offset,Ldc,b,(1)- 1+(l1- 1)*ldb+ _b_offset,1);
vec[(2)- 1+(1- 1)*2] = c[(k2)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
Dlaln2.dlaln2(false,2,1,smin,one,a,(k1)- 1+(k1- 1)*lda+ _a_offset,lda,one,one,vec,0,2,-sgn*b[(l1)- 1+(l1- 1)*ldb+ _b_offset],zero,x,0,2,scaloc,xnorm,ierr);
if (ierr.val != 0)  
    info.val = 1;
// *
if (scaloc.val != one)  {
    {
forloop20:
for (j = 1; j <= n; j++) {
Dscal.dscal(m,scaloc.val,c,(1)- 1+(j- 1)*Ldc+ _c_offset,1);
Dummy.label("Dtrsyl",20);
}              //  Close for() loop. 
}
scale.val = scale.val*scaloc.val;
}              // Close if()
c[(k1)- 1+(l1- 1)*Ldc+ _c_offset] = x[(1)- 1+(1- 1)*2];
c[(k2)- 1+(l1- 1)*Ldc+ _c_offset] = x[(2)- 1+(1- 1)*2];
// *
}              // Close else if()
else if (l1 != l2 && k1 == k2)  {
    // *
suml = Ddot.ddot(m-k1,a,(k1)- 1+(Math.min(k1+1, m) - 1)*lda+ _a_offset,lda,c,(int)((Math.min(k1+1, m) )- 1+(l1- 1)*Ldc+ _c_offset),1);
sumr = Ddot.ddot(l1-1,c,(k1)- 1+(1- 1)*Ldc+ _c_offset,Ldc,b,(1)- 1+(l1- 1)*ldb+ _b_offset,1);
vec[(1)- 1+(1- 1)*2] = sgn*(c[(k1)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr));
// *
suml = Ddot.ddot(m-k1,a,(k1)- 1+(Math.min(k1+1, m) - 1)*lda+ _a_offset,lda,c,(int)((Math.min(k1+1, m) )- 1+(l2- 1)*Ldc+ _c_offset),1);
sumr = Ddot.ddot(l1-1,c,(k1)- 1+(1- 1)*Ldc+ _c_offset,Ldc,b,(1)- 1+(l2- 1)*ldb+ _b_offset,1);
vec[(2)- 1+(1- 1)*2] = sgn*(c[(k1)- 1+(l2- 1)*Ldc+ _c_offset]-(suml+sgn*sumr));
// *
Dlaln2.dlaln2(true,2,1,smin,one,b,(l1)- 1+(l1- 1)*ldb+ _b_offset,ldb,one,one,vec,0,2,-sgn*a[(k1)- 1+(k1- 1)*lda+ _a_offset],zero,x,0,2,scaloc,xnorm,ierr);
if (ierr.val != 0)  
    info.val = 1;
// *
if (scaloc.val != one)  {
    {
forloop30:
for (j = 1; j <= n; j++) {
Dscal.dscal(m,scaloc.val,c,(1)- 1+(j- 1)*Ldc+ _c_offset,1);
Dummy.label("Dtrsyl",30);
}              //  Close for() loop. 
}
scale.val = scale.val*scaloc.val;
}              // Close if()
c[(k1)- 1+(l1- 1)*Ldc+ _c_offset] = x[(1)- 1+(1- 1)*2];
c[(k1)- 1+(l2- 1)*Ldc+ _c_offset] = x[(2)- 1+(1- 1)*2];
// *
}              // Close else if()
else if (l1 != l2 && k1 != k2)  {
    // *
suml = Ddot.ddot(m-k2,a,(k1)- 1+(Math.min(k2+1, m) - 1)*lda+ _a_offset,lda,c,(int)((Math.min(k2+1, m) )- 1+(l1- 1)*Ldc+ _c_offset),1);
sumr = Ddot.ddot(l1-1,c,(k1)- 1+(1- 1)*Ldc+ _c_offset,Ldc,b,(1)- 1+(l1- 1)*ldb+ _b_offset,1);
vec[(1)- 1+(1- 1)*2] = c[(k1)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
suml = Ddot.ddot(m-k2,a,(k1)- 1+(Math.min(k2+1, m) - 1)*lda+ _a_offset,lda,c,(int)((Math.min(k2+1, m) )- 1+(l2- 1)*Ldc+ _c_offset),1);
sumr = Ddot.ddot(l1-1,c,(k1)- 1+(1- 1)*Ldc+ _c_offset,Ldc,b,(1)- 1+(l2- 1)*ldb+ _b_offset,1);
vec[(1)- 1+(2- 1)*2] = c[(k1)- 1+(l2- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
suml = Ddot.ddot(m-k2,a,(k2)- 1+(Math.min(k2+1, m) - 1)*lda+ _a_offset,lda,c,(int)((Math.min(k2+1, m) )- 1+(l1- 1)*Ldc+ _c_offset),1);
sumr = Ddot.ddot(l1-1,c,(k2)- 1+(1- 1)*Ldc+ _c_offset,Ldc,b,(1)- 1+(l1- 1)*ldb+ _b_offset,1);
vec[(2)- 1+(1- 1)*2] = c[(k2)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
suml = Ddot.ddot(m-k2,a,(k2)- 1+(Math.min(k2+1, m) - 1)*lda+ _a_offset,lda,c,(int)((Math.min(k2+1, m) )- 1+(l2- 1)*Ldc+ _c_offset),1);
sumr = Ddot.ddot(l1-1,c,(k2)- 1+(1- 1)*Ldc+ _c_offset,Ldc,b,(1)- 1+(l2- 1)*ldb+ _b_offset,1);
vec[(2)- 1+(2- 1)*2] = c[(k2)- 1+(l2- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
Dlasy2.dlasy2(false,false,isgn,2,2,a,(k1)- 1+(k1- 1)*lda+ _a_offset,lda,b,(l1)- 1+(l1- 1)*ldb+ _b_offset,ldb,vec,0,2,scaloc,x,0,2,xnorm,ierr);
if (ierr.val != 0)  
    info.val = 1;
// *
if (scaloc.val != one)  {
    {
forloop40:
for (j = 1; j <= n; j++) {
Dscal.dscal(m,scaloc.val,c,(1)- 1+(j- 1)*Ldc+ _c_offset,1);
Dummy.label("Dtrsyl",40);
}              //  Close for() loop. 
}
scale.val = scale.val*scaloc.val;
}              // Close if()
c[(k1)- 1+(l1- 1)*Ldc+ _c_offset] = x[(1)- 1+(1- 1)*2];
c[(k1)- 1+(l2- 1)*Ldc+ _c_offset] = x[(1)- 1+(2- 1)*2];
c[(k2)- 1+(l1- 1)*Ldc+ _c_offset] = x[(2)- 1+(1- 1)*2];
c[(k2)- 1+(l2- 1)*Ldc+ _c_offset] = x[(2)- 1+(2- 1)*2];
}              // Close else if()
// *
Dummy.label("Dtrsyl",50);
}              //  Close for() loop. 
}
// *
Dummy.label("Dtrsyl",60);
}              //  Close for() loop. 
}
// *
}              // Close if()
else if (!notrna && notrnb)  {
    // *
// *        Solve    A' *X + ISGN*X*B = scale*C.
// *
// *        The (K,L)th block of X is determined starting from
// *        upper-left corner column by column by
// *
// *          A(K,K)'*X(K,L) + ISGN*X(K,L)*B(L,L) = C(K,L) - R(K,L)
// *
// *        Where
// *                   K-1                        L-1
// *          R(K,L) = SUM [A(I,K)'*X(I,L)] +ISGN*SUM [X(K,J)*B(J,L)]
// *                   I=1                        J=1
// *
// *        Start column loop (index = L)
// *        L1 (L2): column index of the first (last) row of X(K,L)
// *
lnext = 1;
{
forloop120:
for (l = 1; l <= n; l++) {
if (l < lnext)  
    continue forloop120;
if (l == n)  {
    l1 = l;
l2 = l;
}              // Close if()
else  {
  if (b[(l+1)- 1+(l- 1)*ldb+ _b_offset] != zero)  {
    l1 = l;
l2 = l+1;
lnext = l+2;
}              // Close if()
else  {
  l1 = l;
l2 = l;
lnext = l+1;
}              //  Close else.
}              //  Close else.
// *
// *           Start row loop (index = K)
// *           K1 (K2): row index of the first (last) row of X(K,L)
// *
knext = 1;
{
forloop110:
for (k = 1; k <= m; k++) {
if (k < knext)  
    continue forloop110;
if (k == m)  {
    k1 = k;
k2 = k;
}              // Close if()
else  {
  if (a[(k+1)- 1+(k- 1)*lda+ _a_offset] != zero)  {
    k1 = k;
k2 = k+1;
knext = k+2;
}              // Close if()
else  {
  k1 = k;
k2 = k;
knext = k+1;
}              //  Close else.
}              //  Close else.
// *
if (l1 == l2 && k1 == k2)  {
    suml = Ddot.ddot(k1-1,a,(1)- 1+(k1- 1)*lda+ _a_offset,1,c,(1)- 1+(l1- 1)*Ldc+ _c_offset,1);
sumr = Ddot.ddot(l1-1,c,(k1)- 1+(1- 1)*Ldc+ _c_offset,Ldc,b,(1)- 1+(l1- 1)*ldb+ _b_offset,1);
vec[(1)- 1+(1- 1)*2] = c[(k1)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
scaloc.val = one;
// *
a11 = a[(k1)- 1+(k1- 1)*lda+ _a_offset]+sgn*b[(l1)- 1+(l1- 1)*ldb+ _b_offset];
da11 = Math.abs(a11);
if (da11 <= smin)  {
    a11 = smin;
da11 = smin;
info.val = 1;
}              // Close if()
db = Math.abs(vec[(1)- 1+(1- 1)*2]);
if (da11 < one && db > one)  {
    if (db > bignum.val*da11)  
    scaloc.val = one/db;
}              // Close if()
x[(1)- 1+(1- 1)*2] = (vec[(1)- 1+(1- 1)*2]*scaloc.val)/a11;
// *
if (scaloc.val != one)  {
    {
forloop70:
for (j = 1; j <= n; j++) {
Dscal.dscal(m,scaloc.val,c,(1)- 1+(j- 1)*Ldc+ _c_offset,1);
Dummy.label("Dtrsyl",70);
}              //  Close for() loop. 
}
scale.val = scale.val*scaloc.val;
}              // Close if()
c[(k1)- 1+(l1- 1)*Ldc+ _c_offset] = x[(1)- 1+(1- 1)*2];
// *
}              // Close if()
else if (l1 == l2 && k1 != k2)  {
    // *
suml = Ddot.ddot(k1-1,a,(1)- 1+(k1- 1)*lda+ _a_offset,1,c,(1)- 1+(l1- 1)*Ldc+ _c_offset,1);
sumr = Ddot.ddot(l1-1,c,(k1)- 1+(1- 1)*Ldc+ _c_offset,Ldc,b,(1)- 1+(l1- 1)*ldb+ _b_offset,1);
vec[(1)- 1+(1- 1)*2] = c[(k1)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
suml = Ddot.ddot(k1-1,a,(1)- 1+(k2- 1)*lda+ _a_offset,1,c,(1)- 1+(l1- 1)*Ldc+ _c_offset,1);
sumr = Ddot.ddot(l1-1,c,(k2)- 1+(1- 1)*Ldc+ _c_offset,Ldc,b,(1)- 1+(l1- 1)*ldb+ _b_offset,1);
vec[(2)- 1+(1- 1)*2] = c[(k2)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
Dlaln2.dlaln2(true,2,1,smin,one,a,(k1)- 1+(k1- 1)*lda+ _a_offset,lda,one,one,vec,0,2,-sgn*b[(l1)- 1+(l1- 1)*ldb+ _b_offset],zero,x,0,2,scaloc,xnorm,ierr);
if (ierr.val != 0)  
    info.val = 1;
// *
if (scaloc.val != one)  {
    {
forloop80:
for (j = 1; j <= n; j++) {
Dscal.dscal(m,scaloc.val,c,(1)- 1+(j- 1)*Ldc+ _c_offset,1);
Dummy.label("Dtrsyl",80);
}              //  Close for() loop. 
}
scale.val = scale.val*scaloc.val;
}              // Close if()
c[(k1)- 1+(l1- 1)*Ldc+ _c_offset] = x[(1)- 1+(1- 1)*2];
c[(k2)- 1+(l1- 1)*Ldc+ _c_offset] = x[(2)- 1+(1- 1)*2];
// *
}              // Close else if()
else if (l1 != l2 && k1 == k2)  {
    // *
suml = Ddot.ddot(k1-1,a,(1)- 1+(k1- 1)*lda+ _a_offset,1,c,(1)- 1+(l1- 1)*Ldc+ _c_offset,1);
sumr = Ddot.ddot(l1-1,c,(k1)- 1+(1- 1)*Ldc+ _c_offset,Ldc,b,(1)- 1+(l1- 1)*ldb+ _b_offset,1);
vec[(1)- 1+(1- 1)*2] = sgn*(c[(k1)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr));
// *
suml = Ddot.ddot(k1-1,a,(1)- 1+(k1- 1)*lda+ _a_offset,1,c,(1)- 1+(l2- 1)*Ldc+ _c_offset,1);
sumr = Ddot.ddot(l1-1,c,(k1)- 1+(1- 1)*Ldc+ _c_offset,Ldc,b,(1)- 1+(l2- 1)*ldb+ _b_offset,1);
vec[(2)- 1+(1- 1)*2] = sgn*(c[(k1)- 1+(l2- 1)*Ldc+ _c_offset]-(suml+sgn*sumr));
// *
Dlaln2.dlaln2(true,2,1,smin,one,b,(l1)- 1+(l1- 1)*ldb+ _b_offset,ldb,one,one,vec,0,2,-sgn*a[(k1)- 1+(k1- 1)*lda+ _a_offset],zero,x,0,2,scaloc,xnorm,ierr);
if (ierr.val != 0)  
    info.val = 1;
// *
if (scaloc.val != one)  {
    {
forloop90:
for (j = 1; j <= n; j++) {
Dscal.dscal(m,scaloc.val,c,(1)- 1+(j- 1)*Ldc+ _c_offset,1);
Dummy.label("Dtrsyl",90);
}              //  Close for() loop. 
}
scale.val = scale.val*scaloc.val;
}              // Close if()
c[(k1)- 1+(l1- 1)*Ldc+ _c_offset] = x[(1)- 1+(1- 1)*2];
c[(k1)- 1+(l2- 1)*Ldc+ _c_offset] = x[(2)- 1+(1- 1)*2];
// *
}              // Close else if()
else if (l1 != l2 && k1 != k2)  {
    // *
suml = Ddot.ddot(k1-1,a,(1)- 1+(k1- 1)*lda+ _a_offset,1,c,(1)- 1+(l1- 1)*Ldc+ _c_offset,1);
sumr = Ddot.ddot(l1-1,c,(k1)- 1+(1- 1)*Ldc+ _c_offset,Ldc,b,(1)- 1+(l1- 1)*ldb+ _b_offset,1);
vec[(1)- 1+(1- 1)*2] = c[(k1)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
suml = Ddot.ddot(k1-1,a,(1)- 1+(k1- 1)*lda+ _a_offset,1,c,(1)- 1+(l2- 1)*Ldc+ _c_offset,1);
sumr = Ddot.ddot(l1-1,c,(k1)- 1+(1- 1)*Ldc+ _c_offset,Ldc,b,(1)- 1+(l2- 1)*ldb+ _b_offset,1);
vec[(1)- 1+(2- 1)*2] = c[(k1)- 1+(l2- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
suml = Ddot.ddot(k1-1,a,(1)- 1+(k2- 1)*lda+ _a_offset,1,c,(1)- 1+(l1- 1)*Ldc+ _c_offset,1);
sumr = Ddot.ddot(l1-1,c,(k2)- 1+(1- 1)*Ldc+ _c_offset,Ldc,b,(1)- 1+(l1- 1)*ldb+ _b_offset,1);
vec[(2)- 1+(1- 1)*2] = c[(k2)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
suml = Ddot.ddot(k1-1,a,(1)- 1+(k2- 1)*lda+ _a_offset,1,c,(1)- 1+(l2- 1)*Ldc+ _c_offset,1);
sumr = Ddot.ddot(l1-1,c,(k2)- 1+(1- 1)*Ldc+ _c_offset,Ldc,b,(1)- 1+(l2- 1)*ldb+ _b_offset,1);
vec[(2)- 1+(2- 1)*2] = c[(k2)- 1+(l2- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
Dlasy2.dlasy2(true,false,isgn,2,2,a,(k1)- 1+(k1- 1)*lda+ _a_offset,lda,b,(l1)- 1+(l1- 1)*ldb+ _b_offset,ldb,vec,0,2,scaloc,x,0,2,xnorm,ierr);
if (ierr.val != 0)  
    info.val = 1;
// *
if (scaloc.val != one)  {
    {
forloop100:
for (j = 1; j <= n; j++) {
Dscal.dscal(m,scaloc.val,c,(1)- 1+(j- 1)*Ldc+ _c_offset,1);
Dummy.label("Dtrsyl",100);
}              //  Close for() loop. 
}
scale.val = scale.val*scaloc.val;
}              // Close if()
c[(k1)- 1+(l1- 1)*Ldc+ _c_offset] = x[(1)- 1+(1- 1)*2];
c[(k1)- 1+(l2- 1)*Ldc+ _c_offset] = x[(1)- 1+(2- 1)*2];
c[(k2)- 1+(l1- 1)*Ldc+ _c_offset] = x[(2)- 1+(1- 1)*2];
c[(k2)- 1+(l2- 1)*Ldc+ _c_offset] = x[(2)- 1+(2- 1)*2];
}              // Close else if()
// *
Dummy.label("Dtrsyl",110);
}              //  Close for() loop. 
}
Dummy.label("Dtrsyl",120);
}              //  Close for() loop. 
}
// *
}              // Close else if()
else if (!notrna && !notrnb)  {
    // *
// *        Solve    A'*X + ISGN*X*B' = scale*C.
// *
// *        The (K,L)th block of X is determined starting from
// *        top-right corner column by column by
// *
// *           A(K,K)'*X(K,L) + ISGN*X(K,L)*B(L,L)' = C(K,L) - R(K,L)
// *
// *        Where
// *                     K-1                          N
// *            R(K,L) = SUM [A(I,K)'*X(I,L)] + ISGN*SUM [X(K,J)*B(L,J)'].
// *                     I=1                        J=L+1
// *
// *        Start column loop (index = L)
// *        L1 (L2): column index of the first (last) row of X(K,L)
// *
lnext = n;
{
int _l_inc = -1;
forloop180:
for (l = n; l >= 1; l += _l_inc) {
if (l > lnext)  
    continue forloop180;
if (l == 1)  {
    l1 = l;
l2 = l;
}              // Close if()
else  {
  if (b[(l)- 1+(l-1- 1)*ldb+ _b_offset] != zero)  {
    l1 = l-1;
l2 = l;
lnext = l-2;
}              // Close if()
else  {
  l1 = l;
l2 = l;
lnext = l-1;
}              //  Close else.
}              //  Close else.
// *
// *           Start row loop (index = K)
// *           K1 (K2): row index of the first (last) row of X(K,L)
// *
knext = 1;
{
forloop170:
for (k = 1; k <= m; k++) {
if (k < knext)  
    continue forloop170;
if (k == m)  {
    k1 = k;
k2 = k;
}              // Close if()
else  {
  if (a[(k+1)- 1+(k- 1)*lda+ _a_offset] != zero)  {
    k1 = k;
k2 = k+1;
knext = k+2;
}              // Close if()
else  {
  k1 = k;
k2 = k;
knext = k+1;
}              //  Close else.
}              //  Close else.
// *
if (l1 == l2 && k1 == k2)  {
    suml = Ddot.ddot(k1-1,a,(1)- 1+(k1- 1)*lda+ _a_offset,1,c,(1)- 1+(l1- 1)*Ldc+ _c_offset,1);
sumr = Ddot.ddot(n-l1,c,(k1)- 1+(Math.min(l1+1, n) - 1)*Ldc+ _c_offset,Ldc,b,(l1)- 1+(Math.min(l1+1, n) - 1)*ldb+ _b_offset,ldb);
vec[(1)- 1+(1- 1)*2] = c[(k1)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
scaloc.val = one;
// *
a11 = a[(k1)- 1+(k1- 1)*lda+ _a_offset]+sgn*b[(l1)- 1+(l1- 1)*ldb+ _b_offset];
da11 = Math.abs(a11);
if (da11 <= smin)  {
    a11 = smin;
da11 = smin;
info.val = 1;
}              // Close if()
db = Math.abs(vec[(1)- 1+(1- 1)*2]);
if (da11 < one && db > one)  {
    if (db > bignum.val*da11)  
    scaloc.val = one/db;
}              // Close if()
x[(1)- 1+(1- 1)*2] = (vec[(1)- 1+(1- 1)*2]*scaloc.val)/a11;
// *
if (scaloc.val != one)  {
    {
forloop130:
for (j = 1; j <= n; j++) {
Dscal.dscal(m,scaloc.val,c,(1)- 1+(j- 1)*Ldc+ _c_offset,1);
Dummy.label("Dtrsyl",130);
}              //  Close for() loop. 
}
scale.val = scale.val*scaloc.val;
}              // Close if()
c[(k1)- 1+(l1- 1)*Ldc+ _c_offset] = x[(1)- 1+(1- 1)*2];
// *
}              // Close if()
else if (l1 == l2 && k1 != k2)  {
    // *
suml = Ddot.ddot(k1-1,a,(1)- 1+(k1- 1)*lda+ _a_offset,1,c,(1)- 1+(l1- 1)*Ldc+ _c_offset,1);
sumr = Ddot.ddot(n-l2,c,(k1)- 1+(Math.min(l2+1, n) - 1)*Ldc+ _c_offset,Ldc,b,(l1)- 1+(Math.min(l2+1, n) - 1)*ldb+ _b_offset,ldb);
vec[(1)- 1+(1- 1)*2] = c[(k1)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
suml = Ddot.ddot(k1-1,a,(1)- 1+(k2- 1)*lda+ _a_offset,1,c,(1)- 1+(l1- 1)*Ldc+ _c_offset,1);
sumr = Ddot.ddot(n-l2,c,(k2)- 1+(Math.min(l2+1, n) - 1)*Ldc+ _c_offset,Ldc,b,(l1)- 1+(Math.min(l2+1, n) - 1)*ldb+ _b_offset,ldb);
vec[(2)- 1+(1- 1)*2] = c[(k2)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
Dlaln2.dlaln2(true,2,1,smin,one,a,(k1)- 1+(k1- 1)*lda+ _a_offset,lda,one,one,vec,0,2,-sgn*b[(l1)- 1+(l1- 1)*ldb+ _b_offset],zero,x,0,2,scaloc,xnorm,ierr);
if (ierr.val != 0)  
    info.val = 1;
// *
if (scaloc.val != one)  {
    {
forloop140:
for (j = 1; j <= n; j++) {
Dscal.dscal(m,scaloc.val,c,(1)- 1+(j- 1)*Ldc+ _c_offset,1);
Dummy.label("Dtrsyl",140);
}              //  Close for() loop. 
}
scale.val = scale.val*scaloc.val;
}              // Close if()
c[(k1)- 1+(l1- 1)*Ldc+ _c_offset] = x[(1)- 1+(1- 1)*2];
c[(k2)- 1+(l1- 1)*Ldc+ _c_offset] = x[(2)- 1+(1- 1)*2];
// *
}              // Close else if()
else if (l1 != l2 && k1 == k2)  {
    // *
suml = Ddot.ddot(k1-1,a,(1)- 1+(k1- 1)*lda+ _a_offset,1,c,(1)- 1+(l1- 1)*Ldc+ _c_offset,1);
sumr = Ddot.ddot(n-l2,c,(k1)- 1+(Math.min(l2+1, n) - 1)*Ldc+ _c_offset,Ldc,b,(l1)- 1+(Math.min(l2+1, n) - 1)*ldb+ _b_offset,ldb);
vec[(1)- 1+(1- 1)*2] = sgn*(c[(k1)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr));
// *
suml = Ddot.ddot(k1-1,a,(1)- 1+(k1- 1)*lda+ _a_offset,1,c,(1)- 1+(l2- 1)*Ldc+ _c_offset,1);
sumr = Ddot.ddot(n-l2,c,(k1)- 1+(Math.min(l2+1, n) - 1)*Ldc+ _c_offset,Ldc,b,(l2)- 1+(Math.min(l2+1, n) - 1)*ldb+ _b_offset,ldb);
vec[(2)- 1+(1- 1)*2] = sgn*(c[(k1)- 1+(l2- 1)*Ldc+ _c_offset]-(suml+sgn*sumr));
// *
Dlaln2.dlaln2(false,2,1,smin,one,b,(l1)- 1+(l1- 1)*ldb+ _b_offset,ldb,one,one,vec,0,2,-sgn*a[(k1)- 1+(k1- 1)*lda+ _a_offset],zero,x,0,2,scaloc,xnorm,ierr);
if (ierr.val != 0)  
    info.val = 1;
// *
if (scaloc.val != one)  {
    {
forloop150:
for (j = 1; j <= n; j++) {
Dscal.dscal(m,scaloc.val,c,(1)- 1+(j- 1)*Ldc+ _c_offset,1);
Dummy.label("Dtrsyl",150);
}              //  Close for() loop. 
}
scale.val = scale.val*scaloc.val;
}              // Close if()
c[(k1)- 1+(l1- 1)*Ldc+ _c_offset] = x[(1)- 1+(1- 1)*2];
c[(k1)- 1+(l2- 1)*Ldc+ _c_offset] = x[(2)- 1+(1- 1)*2];
// *
}              // Close else if()
else if (l1 != l2 && k1 != k2)  {
    // *
suml = Ddot.ddot(k1-1,a,(1)- 1+(k1- 1)*lda+ _a_offset,1,c,(1)- 1+(l1- 1)*Ldc+ _c_offset,1);
sumr = Ddot.ddot(n-l2,c,(k1)- 1+(Math.min(l2+1, n) - 1)*Ldc+ _c_offset,Ldc,b,(l1)- 1+(Math.min(l2+1, n) - 1)*ldb+ _b_offset,ldb);
vec[(1)- 1+(1- 1)*2] = c[(k1)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
suml = Ddot.ddot(k1-1,a,(1)- 1+(k1- 1)*lda+ _a_offset,1,c,(1)- 1+(l2- 1)*Ldc+ _c_offset,1);
sumr = Ddot.ddot(n-l2,c,(k1)- 1+(Math.min(l2+1, n) - 1)*Ldc+ _c_offset,Ldc,b,(l2)- 1+(Math.min(l2+1, n) - 1)*ldb+ _b_offset,ldb);
vec[(1)- 1+(2- 1)*2] = c[(k1)- 1+(l2- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
suml = Ddot.ddot(k1-1,a,(1)- 1+(k2- 1)*lda+ _a_offset,1,c,(1)- 1+(l1- 1)*Ldc+ _c_offset,1);
sumr = Ddot.ddot(n-l2,c,(k2)- 1+(Math.min(l2+1, n) - 1)*Ldc+ _c_offset,Ldc,b,(l1)- 1+(Math.min(l2+1, n) - 1)*ldb+ _b_offset,ldb);
vec[(2)- 1+(1- 1)*2] = c[(k2)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
suml = Ddot.ddot(k1-1,a,(1)- 1+(k2- 1)*lda+ _a_offset,1,c,(1)- 1+(l2- 1)*Ldc+ _c_offset,1);
sumr = Ddot.ddot(n-l2,c,(k2)- 1+(Math.min(l2+1, n) - 1)*Ldc+ _c_offset,Ldc,b,(l2)- 1+(Math.min(l2+1, n) - 1)*ldb+ _b_offset,ldb);
vec[(2)- 1+(2- 1)*2] = c[(k2)- 1+(l2- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
Dlasy2.dlasy2(true,true,isgn,2,2,a,(k1)- 1+(k1- 1)*lda+ _a_offset,lda,b,(l1)- 1+(l1- 1)*ldb+ _b_offset,ldb,vec,0,2,scaloc,x,0,2,xnorm,ierr);
if (ierr.val != 0)  
    info.val = 1;
// *
if (scaloc.val != one)  {
    {
forloop160:
for (j = 1; j <= n; j++) {
Dscal.dscal(m,scaloc.val,c,(1)- 1+(j- 1)*Ldc+ _c_offset,1);
Dummy.label("Dtrsyl",160);
}              //  Close for() loop. 
}
scale.val = scale.val*scaloc.val;
}              // Close if()
c[(k1)- 1+(l1- 1)*Ldc+ _c_offset] = x[(1)- 1+(1- 1)*2];
c[(k1)- 1+(l2- 1)*Ldc+ _c_offset] = x[(1)- 1+(2- 1)*2];
c[(k2)- 1+(l1- 1)*Ldc+ _c_offset] = x[(2)- 1+(1- 1)*2];
c[(k2)- 1+(l2- 1)*Ldc+ _c_offset] = x[(2)- 1+(2- 1)*2];
}              // Close else if()
// *
Dummy.label("Dtrsyl",170);
}              //  Close for() loop. 
}
Dummy.label("Dtrsyl",180);
}              //  Close for() loop. 
}
// *
}              // Close else if()
else if (notrna && !notrnb)  {
    // *
// *        Solve    A*X + ISGN*X*B' = scale*C.
// *
// *        The (K,L)th block of X is determined starting from
// *        bottom-right corner column by column by
// *
// *            A(K,K)*X(K,L) + ISGN*X(K,L)*B(L,L)' = C(K,L) - R(K,L)
// *
// *        Where
// *                      M                          N
// *            R(K,L) = SUM [A(K,I)*X(I,L)] + ISGN*SUM [X(K,J)*B(L,J)'].
// *                    I=K+1                      J=L+1
// *
// *        Start column loop (index = L)
// *        L1 (L2): column index of the first (last) row of X(K,L)
// *
lnext = n;
{
int _l_inc = -1;
forloop240:
for (l = n; l >= 1; l += _l_inc) {
if (l > lnext)  
    continue forloop240;
if (l == 1)  {
    l1 = l;
l2 = l;
}              // Close if()
else  {
  if (b[(l)- 1+(l-1- 1)*ldb+ _b_offset] != zero)  {
    l1 = l-1;
l2 = l;
lnext = l-2;
}              // Close if()
else  {
  l1 = l;
l2 = l;
lnext = l-1;
}              //  Close else.
}              //  Close else.
// *
// *           Start row loop (index = K)
// *           K1 (K2): row index of the first (last) row of X(K,L)
// *
knext = m;
{
int _k_inc = -1;
forloop230:
for (k = m; k >= 1; k += _k_inc) {
if (k > knext)  
    continue forloop230;
if (k == 1)  {
    k1 = k;
k2 = k;
}              // Close if()
else  {
  if (a[(k)- 1+(k-1- 1)*lda+ _a_offset] != zero)  {
    k1 = k-1;
k2 = k;
knext = k-2;
}              // Close if()
else  {
  k1 = k;
k2 = k;
knext = k-1;
}              //  Close else.
}              //  Close else.
// *
if (l1 == l2 && k1 == k2)  {
    suml = Ddot.ddot(m-k1,a,(k1)- 1+(Math.min(k1+1, m) - 1)*lda+ _a_offset,lda,c,(int)((Math.min(k1+1, m) )- 1+(l1- 1)*Ldc+ _c_offset),1);
sumr = Ddot.ddot(n-l1,c,(k1)- 1+(Math.min(l1+1, n) - 1)*Ldc+ _c_offset,Ldc,b,(l1)- 1+(Math.min(l1+1, n) - 1)*ldb+ _b_offset,ldb);
vec[(1)- 1+(1- 1)*2] = c[(k1)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
scaloc.val = one;
// *
a11 = a[(k1)- 1+(k1- 1)*lda+ _a_offset]+sgn*b[(l1)- 1+(l1- 1)*ldb+ _b_offset];
da11 = Math.abs(a11);
if (da11 <= smin)  {
    a11 = smin;
da11 = smin;
info.val = 1;
}              // Close if()
db = Math.abs(vec[(1)- 1+(1- 1)*2]);
if (da11 < one && db > one)  {
    if (db > bignum.val*da11)  
    scaloc.val = one/db;
}              // Close if()
x[(1)- 1+(1- 1)*2] = (vec[(1)- 1+(1- 1)*2]*scaloc.val)/a11;
// *
if (scaloc.val != one)  {
    {
forloop190:
for (j = 1; j <= n; j++) {
Dscal.dscal(m,scaloc.val,c,(1)- 1+(j- 1)*Ldc+ _c_offset,1);
Dummy.label("Dtrsyl",190);
}              //  Close for() loop. 
}
scale.val = scale.val*scaloc.val;
}              // Close if()
c[(k1)- 1+(l1- 1)*Ldc+ _c_offset] = x[(1)- 1+(1- 1)*2];
// *
}              // Close if()
else if (l1 == l2 && k1 != k2)  {
    // *
suml = Ddot.ddot(m-k2,a,(k1)- 1+(Math.min(k2+1, m) - 1)*lda+ _a_offset,lda,c,(int)((Math.min(k2+1, m) )- 1+(l1- 1)*Ldc+ _c_offset),1);
sumr = Ddot.ddot(n-l2,c,(k1)- 1+(Math.min(l2+1, n) - 1)*Ldc+ _c_offset,Ldc,b,(l1)- 1+(Math.min(l2+1, n) - 1)*ldb+ _b_offset,ldb);
vec[(1)- 1+(1- 1)*2] = c[(k1)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
suml = Ddot.ddot(m-k2,a,(k2)- 1+(Math.min(k2+1, m) - 1)*lda+ _a_offset,lda,c,(int)((Math.min(k2+1, m) )- 1+(l1- 1)*Ldc+ _c_offset),1);
sumr = Ddot.ddot(n-l2,c,(k2)- 1+(Math.min(l2+1, n) - 1)*Ldc+ _c_offset,Ldc,b,(l1)- 1+(Math.min(l2+1, n) - 1)*ldb+ _b_offset,ldb);
vec[(2)- 1+(1- 1)*2] = c[(k2)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
Dlaln2.dlaln2(false,2,1,smin,one,a,(k1)- 1+(k1- 1)*lda+ _a_offset,lda,one,one,vec,0,2,-sgn*b[(l1)- 1+(l1- 1)*ldb+ _b_offset],zero,x,0,2,scaloc,xnorm,ierr);
if (ierr.val != 0)  
    info.val = 1;
// *
if (scaloc.val != one)  {
    {
forloop200:
for (j = 1; j <= n; j++) {
Dscal.dscal(m,scaloc.val,c,(1)- 1+(j- 1)*Ldc+ _c_offset,1);
Dummy.label("Dtrsyl",200);
}              //  Close for() loop. 
}
scale.val = scale.val*scaloc.val;
}              // Close if()
c[(k1)- 1+(l1- 1)*Ldc+ _c_offset] = x[(1)- 1+(1- 1)*2];
c[(k2)- 1+(l1- 1)*Ldc+ _c_offset] = x[(2)- 1+(1- 1)*2];
// *
}              // Close else if()
else if (l1 != l2 && k1 == k2)  {
    // *
suml = Ddot.ddot(m-k1,a,(k1)- 1+(Math.min(k1+1, m) - 1)*lda+ _a_offset,lda,c,(int)((Math.min(k1+1, m) )- 1+(l1- 1)*Ldc+ _c_offset),1);
sumr = Ddot.ddot(n-l2,c,(k1)- 1+(Math.min(l2+1, n) - 1)*Ldc+ _c_offset,Ldc,b,(l1)- 1+(Math.min(l2+1, n) - 1)*ldb+ _b_offset,ldb);
vec[(1)- 1+(1- 1)*2] = sgn*(c[(k1)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr));
// *
suml = Ddot.ddot(m-k1,a,(k1)- 1+(Math.min(k1+1, m) - 1)*lda+ _a_offset,lda,c,(int)((Math.min(k1+1, m) )- 1+(l2- 1)*Ldc+ _c_offset),1);
sumr = Ddot.ddot(n-l2,c,(k1)- 1+(Math.min(l2+1, n) - 1)*Ldc+ _c_offset,Ldc,b,(l2)- 1+(Math.min(l2+1, n) - 1)*ldb+ _b_offset,ldb);
vec[(2)- 1+(1- 1)*2] = sgn*(c[(k1)- 1+(l2- 1)*Ldc+ _c_offset]-(suml+sgn*sumr));
// *
Dlaln2.dlaln2(false,2,1,smin,one,b,(l1)- 1+(l1- 1)*ldb+ _b_offset,ldb,one,one,vec,0,2,-sgn*a[(k1)- 1+(k1- 1)*lda+ _a_offset],zero,x,0,2,scaloc,xnorm,ierr);
if (ierr.val != 0)  
    info.val = 1;
// *
if (scaloc.val != one)  {
    {
forloop210:
for (j = 1; j <= n; j++) {
Dscal.dscal(m,scaloc.val,c,(1)- 1+(j- 1)*Ldc+ _c_offset,1);
Dummy.label("Dtrsyl",210);
}              //  Close for() loop. 
}
scale.val = scale.val*scaloc.val;
}              // Close if()
c[(k1)- 1+(l1- 1)*Ldc+ _c_offset] = x[(1)- 1+(1- 1)*2];
c[(k1)- 1+(l2- 1)*Ldc+ _c_offset] = x[(2)- 1+(1- 1)*2];
// *
}              // Close else if()
else if (l1 != l2 && k1 != k2)  {
    // *
suml = Ddot.ddot(m-k2,a,(k1)- 1+(Math.min(k2+1, m) - 1)*lda+ _a_offset,lda,c,(int)((Math.min(k2+1, m) )- 1+(l1- 1)*Ldc+ _c_offset),1);
sumr = Ddot.ddot(n-l2,c,(k1)- 1+(Math.min(l2+1, n) - 1)*Ldc+ _c_offset,Ldc,b,(l1)- 1+(Math.min(l2+1, n) - 1)*ldb+ _b_offset,ldb);
vec[(1)- 1+(1- 1)*2] = c[(k1)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
suml = Ddot.ddot(m-k2,a,(k1)- 1+(Math.min(k2+1, m) - 1)*lda+ _a_offset,lda,c,(int)((Math.min(k2+1, m) )- 1+(l2- 1)*Ldc+ _c_offset),1);
sumr = Ddot.ddot(n-l2,c,(k1)- 1+(Math.min(l2+1, n) - 1)*Ldc+ _c_offset,Ldc,b,(l2)- 1+(Math.min(l2+1, n) - 1)*ldb+ _b_offset,ldb);
vec[(1)- 1+(2- 1)*2] = c[(k1)- 1+(l2- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
suml = Ddot.ddot(m-k2,a,(k2)- 1+(Math.min(k2+1, m) - 1)*lda+ _a_offset,lda,c,(int)((Math.min(k2+1, m) )- 1+(l1- 1)*Ldc+ _c_offset),1);
sumr = Ddot.ddot(n-l2,c,(k2)- 1+(Math.min(l2+1, n) - 1)*Ldc+ _c_offset,Ldc,b,(l1)- 1+(Math.min(l2+1, n) - 1)*ldb+ _b_offset,ldb);
vec[(2)- 1+(1- 1)*2] = c[(k2)- 1+(l1- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
suml = Ddot.ddot(m-k2,a,(k2)- 1+(Math.min(k2+1, m) - 1)*lda+ _a_offset,lda,c,(int)((Math.min(k2+1, m) )- 1+(l2- 1)*Ldc+ _c_offset),1);
sumr = Ddot.ddot(n-l2,c,(k2)- 1+(Math.min(l2+1, n) - 1)*Ldc+ _c_offset,Ldc,b,(l2)- 1+(Math.min(l2+1, n) - 1)*ldb+ _b_offset,ldb);
vec[(2)- 1+(2- 1)*2] = c[(k2)- 1+(l2- 1)*Ldc+ _c_offset]-(suml+sgn*sumr);
// *
Dlasy2.dlasy2(false,true,isgn,2,2,a,(k1)- 1+(k1- 1)*lda+ _a_offset,lda,b,(l1)- 1+(l1- 1)*ldb+ _b_offset,ldb,vec,0,2,scaloc,x,0,2,xnorm,ierr);
if (ierr.val != 0)  
    info.val = 1;
// *
if (scaloc.val != one)  {
    {
forloop220:
for (j = 1; j <= n; j++) {
Dscal.dscal(m,scaloc.val,c,(1)- 1+(j- 1)*Ldc+ _c_offset,1);
Dummy.label("Dtrsyl",220);
}              //  Close for() loop. 
}
scale.val = scale.val*scaloc.val;
}              // Close if()
c[(k1)- 1+(l1- 1)*Ldc+ _c_offset] = x[(1)- 1+(1- 1)*2];
c[(k1)- 1+(l2- 1)*Ldc+ _c_offset] = x[(1)- 1+(2- 1)*2];
c[(k2)- 1+(l1- 1)*Ldc+ _c_offset] = x[(2)- 1+(1- 1)*2];
c[(k2)- 1+(l2- 1)*Ldc+ _c_offset] = x[(2)- 1+(2- 1)*2];
}              // Close else if()
// *
Dummy.label("Dtrsyl",230);
}              //  Close for() loop. 
}
Dummy.label("Dtrsyl",240);
}              //  Close for() loop. 
}
// *
}              // Close else if()
// *
Dummy.go_to("Dtrsyl",999999);
// *
// *     End of DTRSYL
// *
Dummy.label("Dtrsyl",999999);
return;
   }
} // End class.
