/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: jlapack.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

package org.netlib.lapack;
import java.lang.*;
import org.netlib.util.*;



public class Ilaenv {

// *
// *  -- LAPACK auxiliary routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  ILAENV is called from the LAPACK routines to choose problem-dependent
// *  parameters for the local environment.  See ISPEC for a description of
// *  the parameters.
// *
// *  This version provides a set of parameters which should give good,
// *  but not optimal, performance on many of the currently available
// *  computers.  Users are encouraged to modify this subroutine to set
// *  the tuning parameters for their particular machine using the option
// *  and problem size information in the arguments.
// *
// *  This routine will not function correctly if it is converted to all
// *  lower case.  Converting it to all upper case is allowed.
// *
// *  Arguments
// *  =========
// *
// *  ISPEC   (input) INTEGER
// *          Specifies the parameter to be returned as the value of
// *          ILAENV.
// *          = 1: the optimal blocksize; if this value is 1, an unblocked
// *               algorithm will give the best performance.
// *          = 2: the minimum block size for which the block routine
// *               should be used; if the usable block size is less than
// *               this value, an unblocked routine should be used.
// *          = 3: the crossover point (in a block routine, for N less
// *               than this value, an unblocked routine should be used)
// *          = 4: the number of shifts, used in the nonsymmetric
// *               eigenvalue routines
// *          = 5: the minimum column dimension for blocking to be used;
// *               rectangular blocks must have dimension at least k by m,
// *               where k is given by ILAENV(2,...) and m by ILAENV(5,...)
// *          = 6: the crossover point for the SVD (when reducing an m by n
// *               matrix to bidiagonal form, if max(m,n)/min(m,n) exceeds
// *               this value, a QR factorization is used first to reduce
// *               the matrix to a triangular form.)
// *          = 7: the number of processors
// *          = 8: the crossover point for the multishift QR and QZ methods
// *               for nonsymmetric eigenvalue problems.
// *
// *  NAME    (input) CHARACTER*(*)
// *          The name of the calling subroutine, in either upper case or
// *          lower case.
// *
// *  OPTS    (input) CHARACTER*(*)
// *          The character options to the subroutine NAME, concatenated
// *          into a single character string.  For example, UPLO = 'U',
// *          TRANS = 'T', and DIAG = 'N' for a triangular routine would
// *          be specified as OPTS = 'UTN'.
// *
// *  N1      (input) INTEGER
// *  N2      (input) INTEGER
// *  N3      (input) INTEGER
// *  N4      (input) INTEGER
// *          Problem dimensions for the subroutine NAME; these may not all
// *          be required.
// *
// * (ILAENV) (output) INTEGER
// *          >= 0: the value of the parameter specified by ISPEC
// *          < 0:  if ILAENV = -k, the k-th argument had an illegal value.
// *
// *  Further Details
// *  ===============
// *
// *  The following conventions have been used when calling ILAENV from the
// *  LAPACK routines:
// *  1)  OPTS is a concatenation of all of the character options to
// *      subroutine NAME, in the same order that they appear in the
// *      argument list for NAME, even if they are not used in determining
// *      the value of the parameter specified by ISPEC.
// *  2)  The problem dimensions N1, N2, N3, N4 are specified in the order
// *      that they appear in the argument list for NAME.  N1 is used
// *      first, N2 second, and so on, and unused problem dimensions are
// *      passed a value of -1.
// *  3)  The parameter value returned by ILAENV is checked for validity in
// *      the calling subroutine.  For example, ILAENV is used to retrieve
// *      the optimal blocksize for STRTRI as follows:
// *
// *      NB = ILAENV( 1, 'STRTRI', UPLO // DIAG, N, -1, -1, -1 )
// *      IF( NB.LE.1 ) NB = MAX( 1, N )
// *
// *  =====================================================================
// *
// *     .. Local Scalars ..
static boolean cname= false;
static boolean sname= false;
static String c1= new String(" ");
static String c2= new String("  ");
static String c4= new String("  ");
static String c3= new String("   ");
static String subnam= new String("      ");
static int i= 0;
static int ic= 0;
static int iz= 0;
static int nb= 0;
static int nbmin= 0;
static int nx= 0;
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
static int ilaenv = 0;


public static int ilaenv (int ispec,
String name,
String opts,
int n1,
int n2,
int n3,
int n4)  {

if (ispec == 1) 
  Dummy.go_to("Ilaenv",100);
else if (ispec == 2) 
  Dummy.go_to("Ilaenv",100);
else if (ispec == 3) 
  Dummy.go_to("Ilaenv",100);
else if (ispec == 4) 
  Dummy.go_to("Ilaenv",400);
else if (ispec == 5) 
  Dummy.go_to("Ilaenv",500);
else if (ispec == 6) 
  Dummy.go_to("Ilaenv",600);
else if (ispec == 7) 
  Dummy.go_to("Ilaenv",700);
else if (ispec == 8) 
  Dummy.go_to("Ilaenv",800);
// *
// *     Invalid value for ISPEC
// *
ilaenv = -1;
Dummy.go_to("Ilaenv",999999);
// *
label100:
   Dummy.label("Ilaenv",100);
// *
// *     Convert NAME to upper case if the first character is lower case.
// *
ilaenv = 1;
subnam = name;
ic = (int)(subnam.substring((1)-1,1).charAt(0));
iz = (int)("Z".charAt(0));
if (iz == 90 || iz == 122)  {
    // *
// *        ASCII character set
// *
if (ic >= 97 && ic <= 122)  {
    {
  int E1, E2;
  E1 = 1;
  E2 = 1;
subnam = new String(subnam.substring(0,E1-1) + new Character((char)(ic-32)).toString().substring(0,E2-E1+1) + subnam.substring(E2,subnam.length()));
}
;
{
forloop10:
for (i = 2; i <= 6; i++) {
ic = (int)(subnam.substring((i)-1,i).charAt(0));
if (ic >= 97 && ic <= 122)  
    {
  int E1, E2;
  E1 = i;
  E2 = i;
subnam = new String(subnam.substring(0,E1-1) + new Character((char)(ic-32)).toString().substring(0,E2-E1+1) + subnam.substring(E2,subnam.length()));
}
;
Dummy.label("Ilaenv",10);
}              //  Close for() loop. 
}
}              // Close if()
// *
}              // Close if()
else if (iz == 233 || iz == 169)  {
    // *
// *        EBCDIC character set
// *
if ((ic >= 129 && ic <= 137) || (ic >= 145 && ic <= 153) || (ic >= 162 && ic <= 169))  {
    {
  int E1, E2;
  E1 = 1;
  E2 = 1;
subnam = new String(subnam.substring(0,E1-1) + new Character((char)(ic+64)).toString().substring(0,E2-E1+1) + subnam.substring(E2,subnam.length()));
}
;
{
forloop20:
for (i = 2; i <= 6; i++) {
ic = (int)(subnam.substring((i)-1,i).charAt(0));
if ((ic >= 129 && ic <= 137) || (ic >= 145 && ic <= 153) || (ic >= 162 && ic <= 169))  
    {
  int E1, E2;
  E1 = i;
  E2 = i;
subnam = new String(subnam.substring(0,E1-1) + new Character((char)(ic+64)).toString().substring(0,E2-E1+1) + subnam.substring(E2,subnam.length()));
}
;
Dummy.label("Ilaenv",20);
}              //  Close for() loop. 
}
}              // Close if()
// *
}              // Close else if()
else if (iz == 218 || iz == 250)  {
    // *
// *        Prime machines:  ASCII+128
// *
if (ic >= 225 && ic <= 250)  {
    {
  int E1, E2;
  E1 = 1;
  E2 = 1;
subnam = new String(subnam.substring(0,E1-1) + new Character((char)(ic-32)).toString().substring(0,E2-E1+1) + subnam.substring(E2,subnam.length()));
}
;
{
forloop30:
for (i = 2; i <= 6; i++) {
ic = (int)(subnam.substring((i)-1,i).charAt(0));
if (ic >= 225 && ic <= 250)  
    {
  int E1, E2;
  E1 = i;
  E2 = i;
subnam = new String(subnam.substring(0,E1-1) + new Character((char)(ic-32)).toString().substring(0,E2-E1+1) + subnam.substring(E2,subnam.length()));
}
;
Dummy.label("Ilaenv",30);
}              //  Close for() loop. 
}
}              // Close if()
}              // Close else if()
// *
c1 = subnam.substring((1)-1,1);
sname = c1.trim().equalsIgnoreCase("S".trim()) || c1.trim().equalsIgnoreCase("D".trim());
cname = c1.trim().equalsIgnoreCase("C".trim()) || c1.trim().equalsIgnoreCase("Z".trim());
if (!(cname || sname))  
    Dummy.go_to("Ilaenv",999999);
c2 = subnam.substring((2)-1,3);
c3 = subnam.substring((4)-1,6);
c4 = c3.substring((2)-1,3);
// *
if (ispec == 1) 
  Dummy.go_to("Ilaenv",110);
else if (ispec == 2) 
  Dummy.go_to("Ilaenv",200);
else if (ispec == 3) 
  Dummy.go_to("Ilaenv",300);
// *
label110:
   Dummy.label("Ilaenv",110);
// *
// *     ISPEC = 1:  block size
// *
// *     In these examples, separate code is provided for setting NB for
// *     real and complex.  We assume that NB will take the same value in
// *     single or double precision.
// *
nb = 1;
// *
if (c2.trim().equalsIgnoreCase("GE".trim()))  {
    if (c3.trim().equalsIgnoreCase("TRF".trim()))  {
    if (sname)  {
    nb = 64;
}              // Close if()
else  {
  nb = 64;
}              //  Close else.
}              // Close if()
else if (c3.trim().equalsIgnoreCase("QRF".trim()) || c3.trim().equalsIgnoreCase("RQF".trim()) || c3.trim().equalsIgnoreCase("LQF".trim()) || c3.trim().equalsIgnoreCase("QLF".trim()))  {
    if (sname)  {
    nb = 32;
}              // Close if()
else  {
  nb = 32;
}              //  Close else.
}              // Close else if()
else if (c3.trim().equalsIgnoreCase("HRD".trim()))  {
    if (sname)  {
    nb = 32;
}              // Close if()
else  {
  nb = 32;
}              //  Close else.
}              // Close else if()
else if (c3.trim().equalsIgnoreCase("BRD".trim()))  {
    if (sname)  {
    nb = 32;
}              // Close if()
else  {
  nb = 32;
}              //  Close else.
}              // Close else if()
else if (c3.trim().equalsIgnoreCase("TRI".trim()))  {
    if (sname)  {
    nb = 64;
}              // Close if()
else  {
  nb = 64;
}              //  Close else.
}              // Close else if()
}              // Close if()
else if (c2.trim().equalsIgnoreCase("PO".trim()))  {
    if (c3.trim().equalsIgnoreCase("TRF".trim()))  {
    if (sname)  {
    nb = 64;
}              // Close if()
else  {
  nb = 64;
}              //  Close else.
}              // Close if()
}              // Close else if()
else if (c2.trim().equalsIgnoreCase("SY".trim()))  {
    if (c3.trim().equalsIgnoreCase("TRF".trim()))  {
    if (sname)  {
    nb = 64;
}              // Close if()
else  {
  nb = 64;
}              //  Close else.
}              // Close if()
else if (sname && c3.trim().equalsIgnoreCase("TRD".trim()))  {
    nb = 1;
}              // Close else if()
else if (sname && c3.trim().equalsIgnoreCase("GST".trim()))  {
    nb = 64;
}              // Close else if()
}              // Close else if()
else if (cname && c2.trim().equalsIgnoreCase("HE".trim()))  {
    if (c3.trim().equalsIgnoreCase("TRF".trim()))  {
    nb = 64;
}              // Close if()
else if (c3.trim().equalsIgnoreCase("TRD".trim()))  {
    nb = 1;
}              // Close else if()
else if (c3.trim().equalsIgnoreCase("GST".trim()))  {
    nb = 64;
}              // Close else if()
}              // Close else if()
else if (sname && c2.trim().equalsIgnoreCase("OR".trim()))  {
    if (c3.substring((1)-1,1).trim().equalsIgnoreCase("G".trim()))  {
    if (c4.trim().equalsIgnoreCase("QR".trim()) || c4.trim().equalsIgnoreCase("RQ".trim()) || c4.trim().equalsIgnoreCase("LQ".trim()) || c4.trim().equalsIgnoreCase("QL".trim()) || c4.trim().equalsIgnoreCase("HR".trim()) || c4.trim().equalsIgnoreCase("TR".trim()) || c4.trim().equalsIgnoreCase("BR".trim()))  {
    nb = 32;
}              // Close if()
}              // Close if()
else if (c3.substring((1)-1,1).trim().equalsIgnoreCase("M".trim()))  {
    if (c4.trim().equalsIgnoreCase("QR".trim()) || c4.trim().equalsIgnoreCase("RQ".trim()) || c4.trim().equalsIgnoreCase("LQ".trim()) || c4.trim().equalsIgnoreCase("QL".trim()) || c4.trim().equalsIgnoreCase("HR".trim()) || c4.trim().equalsIgnoreCase("TR".trim()) || c4.trim().equalsIgnoreCase("BR".trim()))  {
    nb = 32;
}              // Close if()
}              // Close else if()
}              // Close else if()
else if (cname && c2.trim().equalsIgnoreCase("UN".trim()))  {
    if (c3.substring((1)-1,1).trim().equalsIgnoreCase("G".trim()))  {
    if (c4.trim().equalsIgnoreCase("QR".trim()) || c4.trim().equalsIgnoreCase("RQ".trim()) || c4.trim().equalsIgnoreCase("LQ".trim()) || c4.trim().equalsIgnoreCase("QL".trim()) || c4.trim().equalsIgnoreCase("HR".trim()) || c4.trim().equalsIgnoreCase("TR".trim()) || c4.trim().equalsIgnoreCase("BR".trim()))  {
    nb = 32;
}              // Close if()
}              // Close if()
else if (c3.substring((1)-1,1).trim().equalsIgnoreCase("M".trim()))  {
    if (c4.trim().equalsIgnoreCase("QR".trim()) || c4.trim().equalsIgnoreCase("RQ".trim()) || c4.trim().equalsIgnoreCase("LQ".trim()) || c4.trim().equalsIgnoreCase("QL".trim()) || c4.trim().equalsIgnoreCase("HR".trim()) || c4.trim().equalsIgnoreCase("TR".trim()) || c4.trim().equalsIgnoreCase("BR".trim()))  {
    nb = 32;
}              // Close if()
}              // Close else if()
}              // Close else if()
else if (c2.trim().equalsIgnoreCase("GB".trim()))  {
    if (c3.trim().equalsIgnoreCase("TRF".trim()))  {
    if (sname)  {
    if (n4 <= 64)  {
    nb = 1;
}              // Close if()
else  {
  nb = 32;
}              //  Close else.
}              // Close if()
else  {
  if (n4 <= 64)  {
    nb = 1;
}              // Close if()
else  {
  nb = 32;
}              //  Close else.
}              //  Close else.
}              // Close if()
}              // Close else if()
else if (c2.trim().equalsIgnoreCase("PB".trim()))  {
    if (c3.trim().equalsIgnoreCase("TRF".trim()))  {
    if (sname)  {
    if (n2 <= 64)  {
    nb = 1;
}              // Close if()
else  {
  nb = 32;
}              //  Close else.
}              // Close if()
else  {
  if (n2 <= 64)  {
    nb = 1;
}              // Close if()
else  {
  nb = 32;
}              //  Close else.
}              //  Close else.
}              // Close if()
}              // Close else if()
else if (c2.trim().equalsIgnoreCase("TR".trim()))  {
    if (c3.trim().equalsIgnoreCase("TRI".trim()))  {
    if (sname)  {
    nb = 64;
}              // Close if()
else  {
  nb = 64;
}              //  Close else.
}              // Close if()
}              // Close else if()
else if (c2.trim().equalsIgnoreCase("LA".trim()))  {
    if (c3.trim().equalsIgnoreCase("UUM".trim()))  {
    if (sname)  {
    nb = 64;
}              // Close if()
else  {
  nb = 64;
}              //  Close else.
}              // Close if()
}              // Close else if()
else if (sname && c2.trim().equalsIgnoreCase("ST".trim()))  {
    if (c3.trim().equalsIgnoreCase("EBZ".trim()))  {
    nb = 1;
}              // Close if()
}              // Close else if()
ilaenv = nb;
Dummy.go_to("Ilaenv",999999);
// *
label200:
   Dummy.label("Ilaenv",200);
// *
// *     ISPEC = 2:  minimum block size
// *
nbmin = 2;
if (c2.trim().equalsIgnoreCase("GE".trim()))  {
    if (c3.trim().equalsIgnoreCase("QRF".trim()) || c3.trim().equalsIgnoreCase("RQF".trim()) || c3.trim().equalsIgnoreCase("LQF".trim()) || c3.trim().equalsIgnoreCase("QLF".trim()))  {
    if (sname)  {
    nbmin = 2;
}              // Close if()
else  {
  nbmin = 2;
}              //  Close else.
}              // Close if()
else if (c3.trim().equalsIgnoreCase("HRD".trim()))  {
    if (sname)  {
    nbmin = 2;
}              // Close if()
else  {
  nbmin = 2;
}              //  Close else.
}              // Close else if()
else if (c3.trim().equalsIgnoreCase("BRD".trim()))  {
    if (sname)  {
    nbmin = 2;
}              // Close if()
else  {
  nbmin = 2;
}              //  Close else.
}              // Close else if()
else if (c3.trim().equalsIgnoreCase("TRI".trim()))  {
    if (sname)  {
    nbmin = 2;
}              // Close if()
else  {
  nbmin = 2;
}              //  Close else.
}              // Close else if()
}              // Close if()
else if (c2.trim().equalsIgnoreCase("SY".trim()))  {
    if (c3.trim().equalsIgnoreCase("TRF".trim()))  {
    if (sname)  {
    nbmin = 8;
}              // Close if()
else  {
  nbmin = 8;
}              //  Close else.
}              // Close if()
else if (sname && c3.trim().equalsIgnoreCase("TRD".trim()))  {
    nbmin = 2;
}              // Close else if()
}              // Close else if()
else if (cname && c2.trim().equalsIgnoreCase("HE".trim()))  {
    if (c3.trim().equalsIgnoreCase("TRD".trim()))  {
    nbmin = 2;
}              // Close if()
}              // Close else if()
else if (sname && c2.trim().equalsIgnoreCase("OR".trim()))  {
    if (c3.substring((1)-1,1).trim().equalsIgnoreCase("G".trim()))  {
    if (c4.trim().equalsIgnoreCase("QR".trim()) || c4.trim().equalsIgnoreCase("RQ".trim()) || c4.trim().equalsIgnoreCase("LQ".trim()) || c4.trim().equalsIgnoreCase("QL".trim()) || c4.trim().equalsIgnoreCase("HR".trim()) || c4.trim().equalsIgnoreCase("TR".trim()) || c4.trim().equalsIgnoreCase("BR".trim()))  {
    nbmin = 2;
}              // Close if()
}              // Close if()
else if (c3.substring((1)-1,1).trim().equalsIgnoreCase("M".trim()))  {
    if (c4.trim().equalsIgnoreCase("QR".trim()) || c4.trim().equalsIgnoreCase("RQ".trim()) || c4.trim().equalsIgnoreCase("LQ".trim()) || c4.trim().equalsIgnoreCase("QL".trim()) || c4.trim().equalsIgnoreCase("HR".trim()) || c4.trim().equalsIgnoreCase("TR".trim()) || c4.trim().equalsIgnoreCase("BR".trim()))  {
    nbmin = 2;
}              // Close if()
}              // Close else if()
}              // Close else if()
else if (cname && c2.trim().equalsIgnoreCase("UN".trim()))  {
    if (c3.substring((1)-1,1).trim().equalsIgnoreCase("G".trim()))  {
    if (c4.trim().equalsIgnoreCase("QR".trim()) || c4.trim().equalsIgnoreCase("RQ".trim()) || c4.trim().equalsIgnoreCase("LQ".trim()) || c4.trim().equalsIgnoreCase("QL".trim()) || c4.trim().equalsIgnoreCase("HR".trim()) || c4.trim().equalsIgnoreCase("TR".trim()) || c4.trim().equalsIgnoreCase("BR".trim()))  {
    nbmin = 2;
}              // Close if()
}              // Close if()
else if (c3.substring((1)-1,1).trim().equalsIgnoreCase("M".trim()))  {
    if (c4.trim().equalsIgnoreCase("QR".trim()) || c4.trim().equalsIgnoreCase("RQ".trim()) || c4.trim().equalsIgnoreCase("LQ".trim()) || c4.trim().equalsIgnoreCase("QL".trim()) || c4.trim().equalsIgnoreCase("HR".trim()) || c4.trim().equalsIgnoreCase("TR".trim()) || c4.trim().equalsIgnoreCase("BR".trim()))  {
    nbmin = 2;
}              // Close if()
}              // Close else if()
}              // Close else if()
ilaenv = nbmin;
Dummy.go_to("Ilaenv",999999);
// *
label300:
   Dummy.label("Ilaenv",300);
// *
// *     ISPEC = 3:  crossover point
// *
nx = 0;
if (c2.trim().equalsIgnoreCase("GE".trim()))  {
    if (c3.trim().equalsIgnoreCase("QRF".trim()) || c3.trim().equalsIgnoreCase("RQF".trim()) || c3.trim().equalsIgnoreCase("LQF".trim()) || c3.trim().equalsIgnoreCase("QLF".trim()))  {
    if (sname)  {
    nx = 128;
}              // Close if()
else  {
  nx = 128;
}              //  Close else.
}              // Close if()
else if (c3.trim().equalsIgnoreCase("HRD".trim()))  {
    if (sname)  {
    nx = 128;
}              // Close if()
else  {
  nx = 128;
}              //  Close else.
}              // Close else if()
else if (c3.trim().equalsIgnoreCase("BRD".trim()))  {
    if (sname)  {
    nx = 128;
}              // Close if()
else  {
  nx = 128;
}              //  Close else.
}              // Close else if()
}              // Close if()
else if (c2.trim().equalsIgnoreCase("SY".trim()))  {
    if (sname && c3.trim().equalsIgnoreCase("TRD".trim()))  {
    nx = 1;
}              // Close if()
}              // Close else if()
else if (cname && c2.trim().equalsIgnoreCase("HE".trim()))  {
    if (c3.trim().equalsIgnoreCase("TRD".trim()))  {
    nx = 1;
}              // Close if()
}              // Close else if()
else if (sname && c2.trim().equalsIgnoreCase("OR".trim()))  {
    if (c3.substring((1)-1,1).trim().equalsIgnoreCase("G".trim()))  {
    if (c4.trim().equalsIgnoreCase("QR".trim()) || c4.trim().equalsIgnoreCase("RQ".trim()) || c4.trim().equalsIgnoreCase("LQ".trim()) || c4.trim().equalsIgnoreCase("QL".trim()) || c4.trim().equalsIgnoreCase("HR".trim()) || c4.trim().equalsIgnoreCase("TR".trim()) || c4.trim().equalsIgnoreCase("BR".trim()))  {
    nx = 128;
}              // Close if()
}              // Close if()
}              // Close else if()
else if (cname && c2.trim().equalsIgnoreCase("UN".trim()))  {
    if (c3.substring((1)-1,1).trim().equalsIgnoreCase("G".trim()))  {
    if (c4.trim().equalsIgnoreCase("QR".trim()) || c4.trim().equalsIgnoreCase("RQ".trim()) || c4.trim().equalsIgnoreCase("LQ".trim()) || c4.trim().equalsIgnoreCase("QL".trim()) || c4.trim().equalsIgnoreCase("HR".trim()) || c4.trim().equalsIgnoreCase("TR".trim()) || c4.trim().equalsIgnoreCase("BR".trim()))  {
    nx = 128;
}              // Close if()
}              // Close if()
}              // Close else if()
ilaenv = nx;
Dummy.go_to("Ilaenv",999999);
// *
label400:
   Dummy.label("Ilaenv",400);
// *
// *     ISPEC = 4:  number of shifts (used by xHSEQR)
// *
ilaenv = 6;
Dummy.go_to("Ilaenv",999999);
// *
label500:
   Dummy.label("Ilaenv",500);
// *
// *     ISPEC = 5:  minimum column dimension (not used)
// *
ilaenv = 2;
Dummy.go_to("Ilaenv",999999);
// *
label600:
   Dummy.label("Ilaenv",600);
// *
// *     ISPEC = 6:  crossover point for SVD (used by xGELSS and xGESVD)
// *
ilaenv = (int)((double)(Math.min(n1, n2) )*1.6E0);
Dummy.go_to("Ilaenv",999999);
// *
label700:
   Dummy.label("Ilaenv",700);
// *
// *     ISPEC = 7:  number of processors (not used)
// *
ilaenv = 1;
Dummy.go_to("Ilaenv",999999);
// *
label800:
   Dummy.label("Ilaenv",800);
// *
// *     ISPEC = 8:  crossover point for multishift (used by xHSEQR)
// *
ilaenv = 50;
Dummy.go_to("Ilaenv",999999);
// *
// *     End of ILAENV
// *
Dummy.label("Ilaenv",999999);
return ilaenv;
   }
} // End class.
